#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from Oasys.AdSec import ILoad
from Oasys.Collections import IList


# noinspection PyPep8Naming
class ILoadCurve(metaclass=ABCMeta):
    """A curve formed from a ordered list of load points.

    See Glossary
    """

    @property
    def Points(self) -> IList[ILoad]:
        """The points in the curve.

        :exception System.ArgumentNullException: If Points is set to null
        """
        pass


# noinspection PyPep8Naming
class ILoadSurface(metaclass=ABCMeta):
    """A triangulated surface in a load coordinate system.
    Each vertex is a "Oasys.AdSec.ILoad".
    Each face is a "Oasys.AdSec.Mesh.ITriangleFace" which contains three references to
    vertices in "Oasys.AdSec.Mesh.ILoadSurface.Vertices".

    See Glossary
    """

    @property
    def Faces(self) -> IList[ITriangleFace]:
        """The faces of the surface, with consistent orientation.

        :exception System.ArgumentNullException: If Faces is set to null
        """
        pass

    @property
    def Vertices(self) -> IList[ILoad]:
        """The vertices of the surface.

        :exception System.ArgumentNullException: If Vertices is set to null
        """
        pass


# noinspection PyPep8Naming
class ITriangleFace(metaclass=ABCMeta):
    """A face in a triangulated surface.

    See Glossary
    Contains three vertex indices. A list of vertices that the indices refer to are
    typically provided along with the faces (e.g. in "Oasys.AdSec.Mesh.ILoadSurface").
    """

    @property
    def Vertex3(self) -> int:
        """The index of the third vertex.
        """
        pass

    @property
    def Vertex2(self) -> int:
        """The index of the second vertex.
        """
        pass

    @property
    def Vertex1(self) -> int:
        """The index of the first vertex.
        """
        pass
