#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from Oasys.Collections import IList
from OasysUnits import Angle
TPoint = typing.TypeVar('TPoint')


# noinspection PyPep8Naming
class IPath(typing.Generic[TPoint], metaclass=ABCMeta):

    @property
    def Segments(self) -> IList[IPathSegment[TPoint]]:
        """The segments that make up the path.

        :exception System.ArgumentNullException: If Segments is set to null
        """
        pass

    @property
    def StartPoint(self) -> TPoint:
        """The start point of the path.

        :exception System.ArgumentNullException: If StartPoint is set to null
        """
        pass


# noinspection PyPep8Naming
class IPathSegment(typing.Generic[TPoint], metaclass=ABCMeta):
    """A path segment used to define "Oasys.Geometry.Paths2D.IPath{TPoint}".
    """
    pass


# noinspection PyPep8Naming
class ILineSegment(IPathSegment[TPoint], typing.Generic[TPoint], metaclass=ABCMeta):
    """A line segment used to define "Oasys.Geometry.Paths2D.IPath{TPoint}".
    Start point of the segment is "Oasys.Geometry.Paths2D.IPath{TPoint}.StartPoint".
    In case the "Oasys.Geometry.Paths2D.IPath{TPoint}.Segments" has one or more segments,
    the end point of the previous segment defines the next segment's start point.
    """

    @property
    def NextPoint(self) -> TPoint:
        """Next point of the line segment.

        :exception System.ArgumentNullException: If NextPoint is set to null
        """
        pass


# noinspection PyPep8Naming
class IArcSegment(IPathSegment[TPoint], typing.Generic[TPoint], metaclass=ABCMeta):
    """An arc segment used to define "Oasys.Geometry.Paths2D.IPath{TPoint}".
    Start point of the segment is "Oasys.Geometry.Paths2D.IPath{TPoint}.StartPoint".
    In case the "Oasys.Geometry.Paths2D.IPath{TPoint}.Segments" has one or more segments,
    the end point of the previous segment defines the next segment's start point.
    """

    @property
    def SweepAngle(self) -> Angle:
        """Angle sweeped by the arc segment from its start point.
        Positive angle is considered anti-clockwise.
        """
        pass

    @property
    def Centre(self) -> TPoint:
        """Centre of the arc segment.

        :exception System.ArgumentNullException: If Centre is set to null
        """
        pass
