#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from OasysUnits.Units import AccelerationUnit, AmountOfSubstanceUnit, AmplitudeRatioUnit, AngleUnit, ApparentEnergyUnit, ApparentPowerUnit, AreaDensityUnit, AreaMomentOfInertiaUnit, AreaUnit, AxialStiffnessUnit, BendingStiffnessUnit, BitRateUnit, BrakeSpecificFuelConsumptionUnit, CapacitanceUnit, CoefficientOfThermalExpansionUnit, CompressibilityUnit, CurvatureUnit, DensityUnit, DurationUnit, DynamicViscosityUnit, ElectricAdmittanceUnit, ElectricChargeDensityUnit, ElectricChargeUnit, ElectricConductanceUnit, ElectricConductivityUnit, ElectricCurrentDensityUnit, ElectricCurrentGradientUnit, ElectricCurrentUnit, ElectricFieldUnit, ElectricInductanceUnit, ElectricPotentialAcUnit, ElectricPotentialChangeRateUnit, ElectricPotentialDcUnit, ElectricPotentialUnit, ElectricResistanceUnit, ElectricResistivityUnit, ElectricSurfaceChargeDensityUnit, EnergyUnit, EntropyUnit, ForceChangeRateUnit, ForcePerLengthUnit, ForceUnit, FrequencyUnit, FuelEfficiencyUnit, HeatFluxUnit, HeatTransferCoefficientUnit, IlluminanceUnit, InformationUnit, IrradianceUnit, IrradiationUnit, JerkUnit, KinematicViscosityUnit, LapseRateUnit, LengthUnit, LevelUnit, LinearDensityUnit, LinearPowerDensityUnit, LuminanceUnit, LuminosityUnit, LuminousFluxUnit, LuminousIntensityUnit, MagneticFieldUnit, MagneticFluxUnit, MagnetizationUnit, MassConcentrationUnit, MassFlowUnit, MassFluxUnit, MassFractionUnit, MassMomentOfInertiaUnit, MassUnit, MolarEnergyUnit, MolarEntropyUnit, MolarityUnit, MolarMassUnit, MomentUnit, PermeabilityUnit, PermittivityUnit, PorousMediumPermeabilityUnit, PowerDensityUnit, PowerRatioUnit, PowerUnit, PressureChangeRateUnit, PressureUnit, RatioChangeRateUnit, RatioUnit, ReactiveEnergyUnit, ReactivePowerUnit, ReciprocalAreaUnit, ReciprocalLengthUnit, RelativeHumidityUnit, RotationalAccelerationUnit, RotationalSpeedUnit, RotationalStiffnessPerLengthUnit, RotationalStiffnessUnit, ScalarUnit, SectionModulusUnit, SolidAngleUnit, SpecificEnergyUnit, SpecificEntropyUnit, SpecificFuelConsumptionUnit, SpecificVolumeUnit, SpecificWeightUnit, SpeedUnit, StandardVolumeFlowUnit, StrainUnit, TemperatureChangeRateUnit, TemperatureDeltaUnit, TemperatureGradientUnit, TemperatureUnit, ThermalConductivityUnit, ThermalResistanceUnit, TorquePerLengthUnit, TorqueUnit, TurbidityUnit, VitaminAUnit, VolumeConcentrationUnit, VolumeFlowPerAreaUnit, VolumeFlowUnit, VolumePerLengthUnit, VolumetricHeatCapacityUnit, VolumeUnit, WarpingMomentOfInertiaUnit
from System import Array, AsyncCallback, Attribute, Decimal, Enum, Exception, Func, IAsyncResult, ICloneable, IComparable, IConvertible, IEquatable, IFormatProvider, IFormattable, IntPtr, MulticastDelegate, TimeSpan, Type, ValueTuple, ValueType
from System.Collections.Generic import IDictionary, IEnumerable
from System.ComponentModel import ITypeDescriptorContext, TypeConverter
from System.Globalization import CultureInfo
from System.Runtime.Serialization import ISerializable
TQuantity = typing.TypeVar('TQuantity')
TUnit = typing.TypeVar('TUnit')
TUnitType = typing.TypeVar('TUnitType')


# noinspection PyPep8Naming
class AmbiguousUnitParseException(OasysUnitsException, ISerializable):
    """ Unable to parse because more than one unit of the given quantity type had this exact unit abbreviation.
     Example: Length.Parse("1 pt") will throw "AmbiguousUnitParseException", because both
     "Field DtpPoint" and
     "Field PrinterPoint" have "pt" as their abbreviation.
    """

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class BaseDimensions:
    """ Represents the base dimensions of a quantity.
    """

    @property
    def Length(self) -> int:
        """Gets the length dimensions (L).
        """
        pass

    @property
    def Mass(self) -> int:
        """Gets the mass dimensions (M).
        """
        pass

    @property
    def Time(self) -> int:
        """Gets the time dimensions (T).
        """
        pass

    @property
    def Current(self) -> int:
        """Gets the electric current dimensions (I).
        """
        pass

    @property
    def Temperature(self) -> int:
        """Gets the temperature dimensions (Θ).
        """
        pass

    @property
    def Amount(self) -> int:
        """Gets the amount of substance dimensions (N).
        """
        pass

    @property
    def LuminousIntensity(self) -> int:
        """Gets the luminous intensity dimensions (J).
        """
        pass

    Dimensionless: typing.ClassVar[BaseDimensions]

    def __init__(self, length: int, mass: int, time: int, current: int, temperature: int, amount: int, luminousIntensity: int) -> None:
        """
        """
        pass

    def IsBaseQuantity(self) -> bool:
        """Checks if the dimensions represent a base quantity.

        :return: True if the dimensions represent a base quantity, otherwise false.
        :rtype: bool
        """
        pass

    def IsDerivedQuantity(self) -> bool:
        """Checks if the dimensions represent a derived quantity.

        :return: True if the dimensions represent a derived quantity, otherwise false.
        :rtype: bool
        """
        pass

    def IsDimensionless(self) -> bool:
        """Checks if this base dimensions object represents a dimensionless quantity.

        :return: True if this object represents a dimensionless quantity, otherwise false.
        :rtype: bool
        """
        pass

    def Equals(self, obj: typing.Any) -> bool:
        """
        """
        pass

    def GetHashCode(self) -> int:
        """
        """
        pass

    def Multiply(self, right: BaseDimensions) -> BaseDimensions:
        """Get resulting dimensions after multiplying two dimensions, by performing addition of each dimension.

        :param right: Other dimensions.
        :type right: BaseDimensions
        :return: Resulting dimensions.
        :rtype: BaseDimensions
        """
        pass

    def Divide(self, right: BaseDimensions) -> BaseDimensions:
        """Get resulting dimensions after dividing two dimensions, by performing subtraction of each dimension.

        :param right: Other dimensions.
        :type right: BaseDimensions
        :return: Resulting dimensions.
        :rtype: BaseDimensions
        """
        pass

    def ToString(self) -> str:
        """
        """
        pass


# noinspection PyPep8Naming
class BaseUnits(IEquatable[BaseUnits]):
    """ Represents the base units for a quantity. All quantities, both base and derived, can be
     represented by a combination of these seven base units.
    """

    Undefined: typing.ClassVar[BaseUnits]

    @property
    def Length(self) -> LengthUnit:
        """Gets the length unit (L).
        """
        pass

    @property
    def Mass(self) -> MassUnit:
        """Gets the mass unit (M).
        """
        pass

    @property
    def Time(self) -> DurationUnit:
        """Gets the time unit (T).
        """
        pass

    @property
    def Current(self) -> ElectricCurrentUnit:
        """Gets the electric current unit (I).
        """
        pass

    @property
    def Temperature(self) -> TemperatureUnit:
        """Gets the temperature unit (Θ).
        """
        pass

    @property
    def Amount(self) -> AmountOfSubstanceUnit:
        """Gets the amount of substance unit (N).
        """
        pass

    @property
    def LuminousIntensity(self) -> LuminousIntensityUnit:
        """Gets the luminous intensity unit (J).
        """
        pass

    @property
    def IsFullyDefined(self) -> bool:
        """Gets whether or not all of the base units are defined.
        """
        pass

    def __init__(self, length: LengthUnit, mass: MassUnit, time: DurationUnit, current: ElectricCurrentUnit, temperature: TemperatureUnit, amount: AmountOfSubstanceUnit, luminousIntensity: LuminousIntensityUnit) -> None:
        """Creates an instance of if the base units class that represents the base units for a quantity.
        All quantities, both base and derived, can be represented by a combination of these seven base units.

        :param length: The length unit (L).
        :type length: LengthUnit
        :param mass: The mass unit (M).
        :type mass: MassUnit
        :param time: The time unit (T).
        :type time: DurationUnit
        :param current: The electric current unit (I).
        :type current: ElectricCurrentUnit
        :param temperature: The temperature unit (Θ).
        :type temperature: TemperatureUnit
        :param amount: The amount of substance unit (N).
        :type amount: AmountOfSubstanceUnit
        :param luminousIntensity: The luminous intensity unit (J).
        :type luminousIntensity: LuminousIntensityUnit
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """
        """
        pass

    @typing.overload
    def Equals(self, other: BaseUnits) -> bool:
        """Checks if all of the base units are equal to another instance's.

        :param other: The other instance to check if equal to.
        :type other: BaseUnits
        :return: True if equal, otherwise false.
        :rtype: bool
        """
        pass

    def IsSubsetOf(self, other: BaseUnits) -> bool:
        """Checks if the base units are a subset of another. Undefined base units are ignored.
        If all base united are undefined (equal to "Property Undefined"),
        IsSubsetOf will return true only if other is also equal to "Property Undefined".

        :param other: The other "BaseUnits" to compare to.
        :type other: BaseUnits
        :return: True if the base units are a subset of other, otherwise false.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """
        """
        pass

    def ToString(self) -> str:
        """
        """
        pass


# noinspection PyPep8Naming
class Comparison(metaclass=ABCMeta):
    """ Helper methods to perform relative and absolute comparison.
    """

    @staticmethod
    def Equals(referenceValue: float, otherValue: float, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Checks if two values are equal with a given relative or absolute tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between and as a percentage of . A relative tolerance of 0.01 means the absolute difference of and must be within +/- 1%. In this example, the two values will be equal if the value of b is within +/- 1% of a. Equals(a, b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between and as a fixed number. In this example, the two values will be equal if abs( - ) <= 0.01 Equals(a, b, 0.01, ComparisonType.Absolute);

        :param referenceValue: The reference value. If using relative tolerance, it is the value which the relative
        tolerance will be calculated against.
        :type referenceValue: float
        :param otherValue: The value to compare to.
        :type otherValue: float
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: Whether the tolerance is absolute or relative.
        :type comparisonType: ComparisonType
        :return:
        :rtype: bool
        """
        pass

    @staticmethod
    def EqualsRelative(referenceValue: float, otherValue: float, tolerance: float) -> bool:
        """ Checks if two values are equal with a given relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between and as a percentage of . A relative tolerance of 0.01 means the absolute difference of and must be within +/- 1%. In this example, the two values will be equal if the value of b is within +/- 1% of a. EqualsRelative(a, b, 0.01);

        :param referenceValue: The reference value which the tolerance will be calculated against.
        :type referenceValue: float
        :param otherValue: The value to compare to.
        :type otherValue: float
        :param tolerance: The relative tolerance. Must be greater than or equal to 0.
        :type tolerance: float
        :return: True if the two values are equal within the given relative tolerance, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    def EqualsAbsolute(value1: float, value2: float, tolerance: float) -> bool:
        """ Checks if two values are equal with a given absolute tolerance.

         Absolute tolerance is defined as the maximum allowable absolute difference between and as a fixed number. In this example, the two values will be equal if abs( - ) <= 0.01 Equals(a, b, 0.01, ComparisonType.Absolute);

        :param value1: The first value.
        :type value1: float
        :param value2: The second value.
        :type value2: float
        :param tolerance: The absolute tolerance. Must be greater than or equal to 0.
        :type tolerance: float
        :return: True if the two values are equal within the given absolute tolerance, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ComparisonType(Enum, IComparable, IFormattable, IConvertible):
    """Specifies if the comparison between numbers is absolute or relative.
    """

    value__: int = ...

    Relative: ComparisonType = ...
    """Error margin in relative size to a reference value.
    """

    Absolute: ComparisonType = ...
    """Error margin as absolute size.
    """


# noinspection PyPep8Naming
class GlobalConfiguration(metaclass=ABCMeta):
    """ Global configuration for culture, used as default culture in methods like "Function ToString" and
     "Function String)".
    """

    DefaultCulture: typing.ClassVar[IFormatProvider]


# noinspection PyPep8Naming
class Acceleration(ValueType, IQuantity[AccelerationUnit], IQuantity, IFormattable, IEquatable[Acceleration], IComparable, IComparable[Acceleration], IConvertible):
    """ Acceleration, in physics, is the rate at which the velocity of an object changes over time. An object's acceleration is the net result of any and all forces acting on the object, as described by Newton's Second Law. The SI unit for acceleration is the Meter per second squared (m/s²). Accelerations are vector quantities (they have magnitude and direction) and add according to the parallelogram law. As a vector, the calculated net force is equal to the product of the object's mass (a scalar quantity) and the acceleration.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AccelerationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AccelerationUnit]

    MaxValue: typing.ClassVar[Acceleration]

    MinValue: typing.ClassVar[Acceleration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AccelerationUnit]]

    Zero: typing.ClassVar[Acceleration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AccelerationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AccelerationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterPerSecondSquared"
        """
        pass

    @property
    def DecimetersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimeterPerSecondSquared"
        """
        pass

    @property
    def FeetPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootPerSecondSquared"
        """
        pass

    @property
    def InchesPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchPerSecondSquared"
        """
        pass

    @property
    def KilometersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilometerPerSecondSquared"
        """
        pass

    @property
    def KnotsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KnotPerHour"
        """
        pass

    @property
    def KnotsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KnotPerMinute"
        """
        pass

    @property
    def KnotsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KnotPerSecond"
        """
        pass

    @property
    def MetersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterPerSecondSquared"
        """
        pass

    @property
    def MicrometersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrometerPerSecondSquared"
        """
        pass

    @property
    def MillimetersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterPerSecondSquared"
        """
        pass

    @property
    def MillistandardGravity(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillistandardGravity"
        """
        pass

    @property
    def NanometersPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanometerPerSecondSquared"
        """
        pass

    @property
    def StandardGravity(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardGravity"
        """
        pass

    def __init__(self, value: float, unit: AccelerationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AccelerationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, other: Acceleration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Acceleration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Acceleration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Acceleration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Acceleration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Acceleration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AccelerationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AccelerationUnit) -> Acceleration:
        """ Converts this Acceleration to another Acceleration with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AccelerationUnit
        :return: A Acceleration with the specified unit.
        :rtype: Acceleration
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AccelerationUnit, unitConverter: UnitConverter) -> Acceleration:
        """ Converts this "Acceleration" to another "Acceleration" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AccelerationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Acceleration with the specified unit.
        :rtype: Acceleration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Acceleration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AccelerationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AccelerationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AccelerationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AccelerationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersPerSecondSquared(centimeterspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field CentimeterPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerSecondSquared(decimeterspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field DecimeterPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerSecondSquared(feetpersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field FootPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerSecondSquared(inchespersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field InchPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerSecondSquared(kilometerspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field KilometerPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnotsPerHour(knotsperhour: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field KnotPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnotsPerMinute(knotsperminute: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field KnotPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnotsPerSecond(knotspersecond: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field KnotPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerSecondSquared(meterspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field MeterPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerSecondSquared(micrometerspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field MicrometerPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerSecondSquared(millimeterspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field MillimeterPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillistandardGravity(millistandardgravity: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field MillistandardGravity".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerSecondSquared(nanometerspersecondsquared: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field NanometerPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardGravity(standardgravity: QuantityValue) -> Acceleration:
        """ Creates a "Acceleration" from "Field StandardGravity".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AccelerationUnit) -> Acceleration:
        """ Dynamically convert from value and unit enum "AccelerationUnit" to "Acceleration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AccelerationUnit
        :return: Acceleration unit value.
        :rtype: Acceleration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Acceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Acceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Acceleration) -> typing.Tuple[Acceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Acceleration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Acceleration) -> typing.Tuple[Acceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Acceleration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AccelerationUnit) -> typing.Tuple[AccelerationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AccelerationUnit) -> typing.Tuple[AccelerationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AccelerationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class AmountOfSubstance(ValueType, IQuantity[AmountOfSubstanceUnit], IQuantity, IFormattable, IEquatable[AmountOfSubstance], IComparable, IComparable[AmountOfSubstance], IConvertible):
    """ Mole is the amount of substance containing Avagadro's Number (6.02 x 10 ^ 23) of real particles such as molecules,atoms, ions or radicals.
    """

    AvogadroConstant: typing.ClassVar[float]

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AmountOfSubstanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AmountOfSubstanceUnit]

    MaxValue: typing.ClassVar[AmountOfSubstance]

    MinValue: typing.ClassVar[AmountOfSubstance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AmountOfSubstanceUnit]]

    Zero: typing.ClassVar[AmountOfSubstance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AmountOfSubstanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AmountOfSubstanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centimoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centimole"
        """
        pass

    @property
    def CentipoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentipoundMole"
        """
        pass

    @property
    def Decimoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decimole"
        """
        pass

    @property
    def DecipoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecipoundMole"
        """
        pass

    @property
    def Kilomoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilomole"
        """
        pass

    @property
    def KilopoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundMole"
        """
        pass

    @property
    def Megamoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megamole"
        """
        pass

    @property
    def Micromoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Micromole"
        """
        pass

    @property
    def MicropoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicropoundMole"
        """
        pass

    @property
    def Millimoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millimole"
        """
        pass

    @property
    def MillipoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillipoundMole"
        """
        pass

    @property
    def Moles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Mole"
        """
        pass

    @property
    def Nanomoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanomole"
        """
        pass

    @property
    def NanopoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanopoundMole"
        """
        pass

    @property
    def PoundMoles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundMole"
        """
        pass

    def __init__(self, value: float, unit: AmountOfSubstanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AmountOfSubstanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AmountOfSubstance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmountOfSubstance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmountOfSubstance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AmountOfSubstance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AmountOfSubstance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AmountOfSubstance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AmountOfSubstanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AmountOfSubstanceUnit) -> AmountOfSubstance:
        """ Converts this AmountOfSubstance to another AmountOfSubstance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AmountOfSubstanceUnit
        :return: A AmountOfSubstance with the specified unit.
        :rtype: AmountOfSubstance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AmountOfSubstanceUnit, unitConverter: UnitConverter) -> AmountOfSubstance:
        """ Converts this "AmountOfSubstance" to another "AmountOfSubstance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AmountOfSubstanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A AmountOfSubstance with the specified unit.
        :rtype: AmountOfSubstance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AmountOfSubstance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def NumberOfParticles(self) -> float:
        """Calculates the number of particles (atoms or molecules) in this amount of substance using the "Property AvogadroConstant".

        :return: The number of particles (atoms or molecules) in this amount of substance.
        :rtype: float
        """
        pass

    @staticmethod
    def FromMass(mass: Mass, molarMass: MolarMass) -> AmountOfSubstance:
        """Get "AmountOfSubstance" from "Mass" and a given "MolarMass".
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmountOfSubstanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmountOfSubstanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmountOfSubstanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmountOfSubstanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimoles(centimoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Centimole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentipoundMoles(centipoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field CentipoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimoles(decimoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Decimole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecipoundMoles(decipoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field DecipoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilomoles(kilomoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Kilomole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundMoles(kilopoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field KilopoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegamoles(megamoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Megamole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicromoles(micromoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Micromole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicropoundMoles(micropoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field MicropoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimoles(millimoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Millimole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillipoundMoles(millipoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field MillipoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMoles(moles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Mole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanomoles(nanomoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field Nanomole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanopoundMoles(nanopoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field NanopoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundMoles(poundmoles: QuantityValue) -> AmountOfSubstance:
        """ Creates a "AmountOfSubstance" from "Field PoundMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AmountOfSubstanceUnit) -> AmountOfSubstance:
        """ Dynamically convert from value and unit enum "AmountOfSubstanceUnit" to "AmountOfSubstance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AmountOfSubstanceUnit
        :return: AmountOfSubstance unit value.
        :rtype: AmountOfSubstance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AmountOfSubstance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AmountOfSubstance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AmountOfSubstance) -> typing.Tuple[AmountOfSubstance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmountOfSubstance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AmountOfSubstance) -> typing.Tuple[AmountOfSubstance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmountOfSubstance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AmountOfSubstanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AmountOfSubstanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AmountOfSubstanceUnit) -> typing.Tuple[AmountOfSubstanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AmountOfSubstanceUnit) -> typing.Tuple[AmountOfSubstanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AmountOfSubstanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class AmplitudeRatio(ValueType, IQuantity[AmplitudeRatioUnit], IQuantity, IFormattable, IEquatable[AmplitudeRatio], IComparable, IComparable[AmplitudeRatio], IConvertible):
    """ The strength of a signal expressed in decibels (dB) relative to one volt RMS.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AmplitudeRatioUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AmplitudeRatioUnit]

    MaxValue: typing.ClassVar[AmplitudeRatio]

    MinValue: typing.ClassVar[AmplitudeRatio]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AmplitudeRatioUnit]]

    Zero: typing.ClassVar[AmplitudeRatio]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AmplitudeRatioUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AmplitudeRatioUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecibelMicrovolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecibelMicrovolt"
        """
        pass

    @property
    def DecibelMillivolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecibelMillivolt"
        """
        pass

    @property
    def DecibelsUnloaded(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecibelUnloaded"
        """
        pass

    @property
    def DecibelVolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecibelVolt"
        """
        pass

    def __init__(self, voltage: ElectricPotential) -> None:
        """ Initializes a new instance of the "AmplitudeRatio" struct from the specified electric potential
         referenced to one volt RMS. This assumes both the specified electric potential and the one volt reference have the
         same
         resistance.

        :param voltage: The electric potential referenced to one volt.
        :type voltage: ElectricPotential
        """
        pass

    def __init__(self, value: float, unit: AmplitudeRatioUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AmplitudeRatioUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AmplitudeRatio:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToElectricPotential(self) -> ElectricPotential:
        """ Gets an "ElectricPotential" from this "AmplitudeRatio".
         Provides a nicer syntax for converting an amplitude ratio back to a voltage.
         var voltage = voltageRatio.ToElectricPotential();
        """
        pass

    def ToPowerRatio(self, impedance: ElectricResistance) -> PowerRatio:
        """ Converts this "AmplitudeRatio" to a "PowerRatio".
        http://www.maximintegrated.com/en/app-notes/index.mvp/id/808

        :param impedance: The input impedance of the load. This is usually 50, 75 or 600 ohms.
        :type impedance: ElectricResistance
        """
        pass

    @staticmethod
    def FromElectricPotential(voltage: ElectricPotential) -> AmplitudeRatio:
        """ Gets an "AmplitudeRatio" in decibels (dB) relative to 1 volt RMS from an
         "ElectricPotential".

        :param voltage: The voltage (electric potential) relative to one volt RMS.
        :type voltage: ElectricPotential
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmplitudeRatioUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmplitudeRatioUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmplitudeRatioUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmplitudeRatioUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecibelMicrovolts(decibelmicrovolts: QuantityValue) -> AmplitudeRatio:
        """ Creates a "AmplitudeRatio" from "Field DecibelMicrovolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelMillivolts(decibelmillivolts: QuantityValue) -> AmplitudeRatio:
        """ Creates a "AmplitudeRatio" from "Field DecibelMillivolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelsUnloaded(decibelsunloaded: QuantityValue) -> AmplitudeRatio:
        """ Creates a "AmplitudeRatio" from "Field DecibelUnloaded".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelVolts(decibelvolts: QuantityValue) -> AmplitudeRatio:
        """ Creates a "AmplitudeRatio" from "Field DecibelVolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AmplitudeRatioUnit) -> AmplitudeRatio:
        """ Dynamically convert from value and unit enum "AmplitudeRatioUnit" to "AmplitudeRatio".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AmplitudeRatioUnit
        :return: AmplitudeRatio unit value.
        :rtype: AmplitudeRatio
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AmplitudeRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AmplitudeRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AmplitudeRatio) -> typing.Tuple[AmplitudeRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmplitudeRatio
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AmplitudeRatio) -> typing.Tuple[AmplitudeRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmplitudeRatio
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AmplitudeRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AmplitudeRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AmplitudeRatioUnit) -> typing.Tuple[AmplitudeRatioUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AmplitudeRatioUnit) -> typing.Tuple[AmplitudeRatioUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AmplitudeRatioUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AmplitudeRatio) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmplitudeRatio) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmplitudeRatio, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AmplitudeRatio within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AmplitudeRatio
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AmplitudeRatio.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AmplitudeRatioUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AmplitudeRatioUnit) -> AmplitudeRatio:
        """ Converts this AmplitudeRatio to another AmplitudeRatio with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AmplitudeRatioUnit
        :return: A AmplitudeRatio with the specified unit.
        :rtype: AmplitudeRatio
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AmplitudeRatioUnit, unitConverter: UnitConverter) -> AmplitudeRatio:
        """ Converts this "AmplitudeRatio" to another "AmplitudeRatio" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AmplitudeRatioUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A AmplitudeRatio with the specified unit.
        :rtype: AmplitudeRatio
        """
        pass


# noinspection PyPep8Naming
class Angle(ValueType, IQuantity[AngleUnit], IQuantity, IFormattable, IEquatable[Angle], IComparable, IComparable[Angle], IConvertible):
    """ In geometry, an angle is the figure formed by two rays, called the sides of the angle, sharing a common endpoint, called the vertex of the angle.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AngleUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AngleUnit]

    MaxValue: typing.ClassVar[Angle]

    MinValue: typing.ClassVar[Angle]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AngleUnit]]

    Zero: typing.ClassVar[Angle]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AngleUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AngleUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Arcminutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Arcminute"
        """
        pass

    @property
    def Arcseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Arcsecond"
        """
        pass

    @property
    def Centiradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centiradian"
        """
        pass

    @property
    def Deciradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Deciradian"
        """
        pass

    @property
    def Degrees(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Degree"
        """
        pass

    @property
    def Gradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gradian"
        """
        pass

    @property
    def Microdegrees(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microdegree"
        """
        pass

    @property
    def Microradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microradian"
        """
        pass

    @property
    def Millidegrees(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millidegree"
        """
        pass

    @property
    def Milliradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milliradian"
        """
        pass

    @property
    def Nanodegrees(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanodegree"
        """
        pass

    @property
    def Nanoradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanoradian"
        """
        pass

    @property
    def NatoMils(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NatoMil"
        """
        pass

    @property
    def Radians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Radian"
        """
        pass

    @property
    def Revolutions(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Revolution"
        """
        pass

    @property
    def Tilt(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Tilt"
        """
        pass

    def __init__(self, value: float, unit: AngleUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AngleUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Angle) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Angle) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Angle, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Angle within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Angle
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Angle.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AngleUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AngleUnit) -> Angle:
        """ Converts this Angle to another Angle with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AngleUnit
        :return: A Angle with the specified unit.
        :rtype: Angle
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AngleUnit, unitConverter: UnitConverter) -> Angle:
        """ Converts this "Angle" to another "Angle" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AngleUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Angle with the specified unit.
        :rtype: Angle
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Angle:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AngleUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AngleUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AngleUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AngleUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromArcminutes(arcminutes: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Arcminute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromArcseconds(arcseconds: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Arcsecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiradians(centiradians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Centiradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciradians(deciradians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Deciradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegrees(degrees: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Degree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGradians(gradians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Gradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodegrees(microdegrees: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Microdegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroradians(microradians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Microradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegrees(millidegrees: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Millidegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliradians(milliradians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Milliradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanodegrees(nanodegrees: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Nanodegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoradians(nanoradians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Nanoradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNatoMils(natomils: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field NatoMil".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadians(radians: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Radian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutions(revolutions: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Revolution".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTilt(tilt: QuantityValue) -> Angle:
        """ Creates a "Angle" from "Field Tilt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AngleUnit) -> Angle:
        """ Dynamically convert from value and unit enum "AngleUnit" to "Angle".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AngleUnit
        :return: Angle unit value.
        :rtype: Angle
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Angle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Angle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Angle) -> typing.Tuple[Angle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Angle
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Angle) -> typing.Tuple[Angle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Angle
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AngleUnit) -> typing.Tuple[AngleUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AngleUnit) -> typing.Tuple[AngleUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AngleUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Area(ValueType, IQuantity[AreaUnit], IQuantity, IFormattable, IEquatable[Area], IComparable, IComparable[Area], IConvertible):
    """ Area is a quantity that expresses the extent of a two-dimensional surface or shape, or planar lamina, in the plane. Area can be understood as the amount of material with a given thickness that would be necessary to fashion a model of the shape, or the amount of paint necessary to cover the surface with a single coat.[1] It is the two-dimensional analog of the length of a curve (a one-dimensional concept) or the volume of a solid (a three-dimensional concept).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AreaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AreaUnit]

    MaxValue: typing.ClassVar[Area]

    MinValue: typing.ClassVar[Area]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AreaUnit]]

    Zero: typing.ClassVar[Area]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AreaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AreaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Acres(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Acre"
        """
        pass

    @property
    def Hectares(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hectare"
        """
        pass

    @property
    def SquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareCentimeter"
        """
        pass

    @property
    def SquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareDecimeter"
        """
        pass

    @property
    def SquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareFoot"
        """
        pass

    @property
    def SquareInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareInch"
        """
        pass

    @property
    def SquareKilometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareKilometer"
        """
        pass

    @property
    def SquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMeter"
        """
        pass

    @property
    def SquareMicrometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMicrometer"
        """
        pass

    @property
    def SquareMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMile"
        """
        pass

    @property
    def SquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMillimeter"
        """
        pass

    @property
    def SquareNauticalMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareNauticalMile"
        """
        pass

    @property
    def SquareYards(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareYard"
        """
        pass

    @property
    def UsSurveySquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsSurveySquareFoot"
        """
        pass

    def __init__(self, value: float, unit: AreaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AreaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Area) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Area) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Area, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Area within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Area
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Area.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AreaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaUnit) -> Area:
        """ Converts this Area to another Area with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AreaUnit
        :return: A Area with the specified unit.
        :rtype: Area
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaUnit, unitConverter: UnitConverter) -> Area:
        """ Converts this "Area" to another "Area" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AreaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Area with the specified unit.
        :rtype: Area
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Area:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCircleDiameter(diameter: Length) -> Area:
        """Get circle area from a diameter.
        """
        pass

    @staticmethod
    def FromCircleRadius(radius: Length) -> Area:
        """Get circle area from a radius.
        """
        pass

    def Inverse(self) -> ReciprocalArea:
        """Calculates the inverse of this quantity.

        :return: The corresponding inverse quantity, "ReciprocalArea".
        :rtype: ReciprocalArea
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAcres(acres: QuantityValue) -> Area:
        """ Creates a "Area" from "Field Acre".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectares(hectares: QuantityValue) -> Area:
        """ Creates a "Area" from "Field Hectare".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeters(squarecentimeters: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareDecimeters(squaredecimeters: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareFeet(squarefeet: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareInches(squareinches: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareKilometers(squarekilometers: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareKilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeters(squaremeters: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMicrometers(squaremicrometers: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareMicrometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMiles(squaremiles: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMillimeters(squaremillimeters: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareNauticalMiles(squarenauticalmiles: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareNauticalMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareYards(squareyards: QuantityValue) -> Area:
        """ Creates a "Area" from "Field SquareYard".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveySquareFeet(ussurveysquarefeet: QuantityValue) -> Area:
        """ Creates a "Area" from "Field UsSurveySquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AreaUnit) -> Area:
        """ Dynamically convert from value and unit enum "AreaUnit" to "Area".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AreaUnit
        :return: Area unit value.
        :rtype: Area
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Area:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Area:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Area) -> typing.Tuple[Area, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Area
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Area) -> typing.Tuple[Area, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Area
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AreaUnit) -> typing.Tuple[AreaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AreaUnit) -> typing.Tuple[AreaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AreaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class AreaMomentOfInertia(ValueType, IQuantity[AreaMomentOfInertiaUnit], IQuantity, IFormattable, IEquatable[AreaMomentOfInertia], IComparable, IComparable[AreaMomentOfInertia], IConvertible):
    """ A geometric property of an area that reflects how its points are distributed with regard to an axis.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AreaMomentOfInertiaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AreaMomentOfInertiaUnit]

    MaxValue: typing.ClassVar[AreaMomentOfInertia]

    MinValue: typing.ClassVar[AreaMomentOfInertia]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AreaMomentOfInertiaUnit]]

    Zero: typing.ClassVar[AreaMomentOfInertia]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AreaMomentOfInertiaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AreaMomentOfInertiaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersToTheFourth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterToTheFourth"
        """
        pass

    @property
    def DecimetersToTheFourth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimeterToTheFourth"
        """
        pass

    @property
    def FeetToTheFourth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootToTheFourth"
        """
        pass

    @property
    def InchesToTheFourth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchToTheFourth"
        """
        pass

    @property
    def MetersToTheFourth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterToTheFourth"
        """
        pass

    @property
    def MillimetersToTheFourth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterToTheFourth"
        """
        pass

    def __init__(self, value: float, unit: AreaMomentOfInertiaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AreaMomentOfInertiaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AreaMomentOfInertia:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaMomentOfInertiaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaMomentOfInertiaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaMomentOfInertiaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaMomentOfInertiaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersToTheFourth(centimeterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Creates a "AreaMomentOfInertia" from "Field CentimeterToTheFourth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersToTheFourth(decimeterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Creates a "AreaMomentOfInertia" from "Field DecimeterToTheFourth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetToTheFourth(feettothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Creates a "AreaMomentOfInertia" from "Field FootToTheFourth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesToTheFourth(inchestothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Creates a "AreaMomentOfInertia" from "Field InchToTheFourth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersToTheFourth(meterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Creates a "AreaMomentOfInertia" from "Field MeterToTheFourth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersToTheFourth(millimeterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Creates a "AreaMomentOfInertia" from "Field MillimeterToTheFourth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AreaMomentOfInertiaUnit) -> AreaMomentOfInertia:
        """ Dynamically convert from value and unit enum "AreaMomentOfInertiaUnit" to "AreaMomentOfInertia".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AreaMomentOfInertiaUnit
        :return: AreaMomentOfInertia unit value.
        :rtype: AreaMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AreaMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AreaMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AreaMomentOfInertia) -> typing.Tuple[AreaMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AreaMomentOfInertia) -> typing.Tuple[AreaMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaMomentOfInertia
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AreaMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AreaMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AreaMomentOfInertiaUnit) -> typing.Tuple[AreaMomentOfInertiaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AreaMomentOfInertiaUnit) -> typing.Tuple[AreaMomentOfInertiaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AreaMomentOfInertiaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AreaMomentOfInertia) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaMomentOfInertia) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaMomentOfInertia, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AreaMomentOfInertia within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AreaMomentOfInertia
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AreaMomentOfInertia.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AreaMomentOfInertiaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaMomentOfInertiaUnit) -> AreaMomentOfInertia:
        """ Converts this AreaMomentOfInertia to another AreaMomentOfInertia with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AreaMomentOfInertiaUnit
        :return: A AreaMomentOfInertia with the specified unit.
        :rtype: AreaMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaMomentOfInertiaUnit, unitConverter: UnitConverter) -> AreaMomentOfInertia:
        """ Converts this "AreaMomentOfInertia" to another "AreaMomentOfInertia" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AreaMomentOfInertiaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A AreaMomentOfInertia with the specified unit.
        :rtype: AreaMomentOfInertia
        """
        pass


# noinspection PyPep8Naming
class AxialStiffness(ValueType, IQuantity[AxialStiffnessUnit], IQuantity, IFormattable, IEquatable[AxialStiffness], IComparable, IComparable[AxialStiffness], IConvertible):
    """ .
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AxialStiffnessUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AxialStiffnessUnit]

    MaxValue: typing.ClassVar[AxialStiffness]

    MinValue: typing.ClassVar[AxialStiffness]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AxialStiffnessUnit]]

    Zero: typing.ClassVar[AxialStiffness]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AxialStiffnessUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AxialStiffnessUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decanewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decanewton"
        """
        pass

    @property
    def Dyne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Dyn"
        """
        pass

    @property
    def KilogramsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForce"
        """
        pass

    @property
    def Kilonewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilonewton"
        """
        pass

    @property
    def KiloPonds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloPond"
        """
        pass

    @property
    def KilopoundsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForce"
        """
        pass

    @property
    def Meganewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Meganewton"
        """
        pass

    @property
    def Micronewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Micronewton"
        """
        pass

    @property
    def Millinewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millinewton"
        """
        pass

    @property
    def Newtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Newton"
        """
        pass

    @property
    def OunceForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OunceForce"
        """
        pass

    @property
    def Poundals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Poundal"
        """
        pass

    @property
    def PoundsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForce"
        """
        pass

    @property
    def ShortTonsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ShortTonForce"
        """
        pass

    @property
    def TonnesForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForce"
        """
        pass

    def __init__(self, value: float, unit: AxialStiffnessUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AxialStiffnessUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AxialStiffness) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AxialStiffness) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AxialStiffness, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AxialStiffness within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AxialStiffness
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AxialStiffness.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AxialStiffnessUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AxialStiffnessUnit) -> AxialStiffness:
        """ Converts this AxialStiffness to another AxialStiffness with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AxialStiffnessUnit
        :return: A AxialStiffness with the specified unit.
        :rtype: AxialStiffness
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AxialStiffnessUnit, unitConverter: UnitConverter) -> AxialStiffness:
        """ Converts this "AxialStiffness" to another "AxialStiffness" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AxialStiffnessUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A AxialStiffness with the specified unit.
        :rtype: AxialStiffness
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AxialStiffness:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AxialStiffnessUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AxialStiffnessUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AxialStiffnessUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AxialStiffnessUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecanewtons(decanewtons: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Decanewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDyne(dyne: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Dyn".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForce(kilogramsforce: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field KilogramForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtons(kilonewtons: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Kilonewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloPonds(kiloponds: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field KiloPond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForce(kilopoundsforce: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field KilopoundForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtons(meganewtons: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Meganewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtons(micronewtons: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Micronewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtons(millinewtons: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Millinewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtons(newtons: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Newton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOunceForce(ounceforce: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field OunceForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundals(poundals: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field Poundal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForce(poundsforce: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field PoundForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortTonsForce(shorttonsforce: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field ShortTonForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForce(tonnesforce: QuantityValue) -> AxialStiffness:
        """ Creates a "AxialStiffness" from "Field TonneForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AxialStiffnessUnit) -> AxialStiffness:
        """ Dynamically convert from value and unit enum "AxialStiffnessUnit" to "AxialStiffness".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AxialStiffnessUnit
        :return: AxialStiffness unit value.
        :rtype: AxialStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AxialStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AxialStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AxialStiffness) -> typing.Tuple[AxialStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AxialStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AxialStiffness) -> typing.Tuple[AxialStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AxialStiffness
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AxialStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AxialStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AxialStiffnessUnit) -> typing.Tuple[AxialStiffnessUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AxialStiffnessUnit) -> typing.Tuple[AxialStiffnessUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AxialStiffnessUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class BendingStiffness(ValueType, IQuantity[BendingStiffnessUnit], IQuantity, IFormattable, IEquatable[BendingStiffness], IComparable, IComparable[BendingStiffness], IConvertible):
    """ .
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[BendingStiffnessUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[BendingStiffnessUnit]

    MaxValue: typing.ClassVar[BendingStiffness]

    MinValue: typing.ClassVar[BendingStiffness]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[BendingStiffnessUnit]]

    Zero: typing.ClassVar[BendingStiffness]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> BendingStiffnessUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[BendingStiffnessUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilonewtonSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonSquareMeter"
        """
        pass

    @property
    def KilonewtonSquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonSquareMillimeter"
        """
        pass

    @property
    def NewtonSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonSquareMeter"
        """
        pass

    @property
    def NewtonSquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonSquareMillimeter"
        """
        pass

    @property
    def PoundsForceSquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceSquareFoot"
        """
        pass

    @property
    def PoundsForceSquareInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceSquareInch"
        """
        pass

    def __init__(self, value: float, unit: BendingStiffnessUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: BendingStiffnessUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> BendingStiffness:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BendingStiffnessUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BendingStiffnessUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BendingStiffnessUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BendingStiffnessUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilonewtonSquareMeters(kilonewtonsquaremeters: QuantityValue) -> BendingStiffness:
        """ Creates a "BendingStiffness" from "Field KilonewtonSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonSquareMillimeters(kilonewtonsquaremillimeters: QuantityValue) -> BendingStiffness:
        """ Creates a "BendingStiffness" from "Field KilonewtonSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonSquareMeters(newtonsquaremeters: QuantityValue) -> BendingStiffness:
        """ Creates a "BendingStiffness" from "Field NewtonSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonSquareMillimeters(newtonsquaremillimeters: QuantityValue) -> BendingStiffness:
        """ Creates a "BendingStiffness" from "Field NewtonSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForceSquareFeet(poundsforcesquarefeet: QuantityValue) -> BendingStiffness:
        """ Creates a "BendingStiffness" from "Field PoundForceSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForceSquareInches(poundsforcesquareinches: QuantityValue) -> BendingStiffness:
        """ Creates a "BendingStiffness" from "Field PoundForceSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: BendingStiffnessUnit) -> BendingStiffness:
        """ Dynamically convert from value and unit enum "BendingStiffnessUnit" to "BendingStiffness".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: BendingStiffnessUnit
        :return: BendingStiffness unit value.
        :rtype: BendingStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> BendingStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> BendingStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: BendingStiffness) -> typing.Tuple[BendingStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BendingStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: BendingStiffness) -> typing.Tuple[BendingStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BendingStiffness
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> BendingStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> BendingStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: BendingStiffnessUnit) -> typing.Tuple[BendingStiffnessUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: BendingStiffnessUnit) -> typing.Tuple[BendingStiffnessUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: BendingStiffnessUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: BendingStiffness) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BendingStiffness) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BendingStiffness, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another BendingStiffness within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: BendingStiffness
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current BendingStiffness.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: BendingStiffnessUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BendingStiffnessUnit) -> BendingStiffness:
        """ Converts this BendingStiffness to another BendingStiffness with the unit representation .

        :param unit: The unit to convert to.
        :type unit: BendingStiffnessUnit
        :return: A BendingStiffness with the specified unit.
        :rtype: BendingStiffness
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BendingStiffnessUnit, unitConverter: UnitConverter) -> BendingStiffness:
        """ Converts this "BendingStiffness" to another "BendingStiffness" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: BendingStiffnessUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A BendingStiffness with the specified unit.
        :rtype: BendingStiffness
        """
        pass


# noinspection PyPep8Naming
class BrakeSpecificFuelConsumption(ValueType, IQuantity[BrakeSpecificFuelConsumptionUnit], IQuantity, IFormattable, IEquatable[BrakeSpecificFuelConsumption], IComparable, IComparable[BrakeSpecificFuelConsumption], IConvertible):
    """ Brake specific fuel consumption (BSFC) is a measure of the fuel efficiency of any prime mover that burns fuel and produces rotational, or shaft, power. It is typically used for comparing the efficiency of internal combustion engines with a shaft output.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[BrakeSpecificFuelConsumptionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[BrakeSpecificFuelConsumptionUnit]

    MaxValue: typing.ClassVar[BrakeSpecificFuelConsumption]

    MinValue: typing.ClassVar[BrakeSpecificFuelConsumption]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[BrakeSpecificFuelConsumptionUnit]]

    Zero: typing.ClassVar[BrakeSpecificFuelConsumption]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> BrakeSpecificFuelConsumptionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[BrakeSpecificFuelConsumptionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerKiloWattHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerKiloWattHour"
        """
        pass

    @property
    def KilogramsPerJoule(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerJoule"
        """
        pass

    @property
    def PoundsPerMechanicalHorsepowerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerMechanicalHorsepowerHour"
        """
        pass

    def __init__(self, value: float, unit: BrakeSpecificFuelConsumptionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: BrakeSpecificFuelConsumptionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BrakeSpecificFuelConsumptionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BrakeSpecificFuelConsumptionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerKiloWattHour(gramsperkilowatthour: QuantityValue) -> BrakeSpecificFuelConsumption:
        """ Creates a "BrakeSpecificFuelConsumption" from "Field GramPerKiloWattHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerJoule(kilogramsperjoule: QuantityValue) -> BrakeSpecificFuelConsumption:
        """ Creates a "BrakeSpecificFuelConsumption" from "Field KilogramPerJoule".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerMechanicalHorsepowerHour(poundspermechanicalhorsepowerhour: QuantityValue) -> BrakeSpecificFuelConsumption:
        """ Creates a "BrakeSpecificFuelConsumption" from "Field PoundPerMechanicalHorsepowerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: BrakeSpecificFuelConsumptionUnit) -> BrakeSpecificFuelConsumption:
        """ Dynamically convert from value and unit enum "BrakeSpecificFuelConsumptionUnit" to "BrakeSpecificFuelConsumption".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: BrakeSpecificFuelConsumptionUnit
        :return: BrakeSpecificFuelConsumption unit value.
        :rtype: BrakeSpecificFuelConsumption
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> BrakeSpecificFuelConsumption:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> BrakeSpecificFuelConsumption:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: BrakeSpecificFuelConsumption) -> typing.Tuple[BrakeSpecificFuelConsumption, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BrakeSpecificFuelConsumption
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: BrakeSpecificFuelConsumption) -> typing.Tuple[BrakeSpecificFuelConsumption, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BrakeSpecificFuelConsumption
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> BrakeSpecificFuelConsumptionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> BrakeSpecificFuelConsumptionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: BrakeSpecificFuelConsumptionUnit) -> typing.Tuple[BrakeSpecificFuelConsumptionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: BrakeSpecificFuelConsumptionUnit) -> typing.Tuple[BrakeSpecificFuelConsumptionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: BrakeSpecificFuelConsumption) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BrakeSpecificFuelConsumption) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BrakeSpecificFuelConsumption, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another BrakeSpecificFuelConsumption within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: BrakeSpecificFuelConsumption
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current BrakeSpecificFuelConsumption.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: BrakeSpecificFuelConsumptionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BrakeSpecificFuelConsumptionUnit) -> BrakeSpecificFuelConsumption:
        """ Converts this BrakeSpecificFuelConsumption to another BrakeSpecificFuelConsumption with the unit representation .

        :param unit: The unit to convert to.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :return: A BrakeSpecificFuelConsumption with the specified unit.
        :rtype: BrakeSpecificFuelConsumption
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BrakeSpecificFuelConsumptionUnit, unitConverter: UnitConverter) -> BrakeSpecificFuelConsumption:
        """ Converts this "BrakeSpecificFuelConsumption" to another "BrakeSpecificFuelConsumption" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A BrakeSpecificFuelConsumption with the specified unit.
        :rtype: BrakeSpecificFuelConsumption
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> BrakeSpecificFuelConsumption:
        """
        """
        pass


# noinspection PyPep8Naming
class Density(ValueType, IQuantity[DensityUnit], IQuantity, IFormattable, IEquatable[Density], IComparable, IComparable[Density], IConvertible):
    """ The density, or more precisely, the volumetric mass density, of a substance is its mass per unit volume.
     http://en.wikipedia.org/wiki/Density
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[DensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[DensityUnit]

    MaxValue: typing.ClassVar[Density]

    MinValue: typing.ClassVar[Density]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[DensityUnit]]

    Zero: typing.ClassVar[Density]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> DensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[DensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerDeciliter"
        """
        pass

    @property
    def CentigramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerLiter"
        """
        pass

    @property
    def CentigramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerMilliliter"
        """
        pass

    @property
    def DecigramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerDeciliter"
        """
        pass

    @property
    def DecigramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerLiter"
        """
        pass

    @property
    def DecigramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerMilliliter"
        """
        pass

    @property
    def GramsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicCentimeter"
        """
        pass

    @property
    def GramsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicFoot"
        """
        pass

    @property
    def GramsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicInch"
        """
        pass

    @property
    def GramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicMeter"
        """
        pass

    @property
    def GramsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicMillimeter"
        """
        pass

    @property
    def GramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerDeciliter"
        """
        pass

    @property
    def GramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerLiter"
        """
        pass

    @property
    def GramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerMilliliter"
        """
        pass

    @property
    def KilogramsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCubicCentimeter"
        """
        pass

    @property
    def KilogramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCubicMeter"
        """
        pass

    @property
    def KilogramsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCubicMillimeter"
        """
        pass

    @property
    def KilogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerLiter"
        """
        pass

    @property
    def KilopoundsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundPerCubicFoot"
        """
        pass

    @property
    def KilopoundsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundPerCubicInch"
        """
        pass

    @property
    def MicrogramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerCubicMeter"
        """
        pass

    @property
    def MicrogramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerDeciliter"
        """
        pass

    @property
    def MicrogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerLiter"
        """
        pass

    @property
    def MicrogramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerMilliliter"
        """
        pass

    @property
    def MilligramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerCubicMeter"
        """
        pass

    @property
    def MilligramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerDeciliter"
        """
        pass

    @property
    def MilligramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerLiter"
        """
        pass

    @property
    def MilligramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerMilliliter"
        """
        pass

    @property
    def NanogramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerDeciliter"
        """
        pass

    @property
    def NanogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerLiter"
        """
        pass

    @property
    def NanogramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerMilliliter"
        """
        pass

    @property
    def PicogramsPerDeciLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerDeciliter"
        """
        pass

    @property
    def PicogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerLiter"
        """
        pass

    @property
    def PicogramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerMilliliter"
        """
        pass

    @property
    def PoundsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicCentimeter"
        """
        pass

    @property
    def PoundsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicFoot"
        """
        pass

    @property
    def PoundsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicInch"
        """
        pass

    @property
    def PoundsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicMeter"
        """
        pass

    @property
    def PoundsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicMillimeter"
        """
        pass

    @property
    def PoundsPerImperialGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerImperialGallon"
        """
        pass

    @property
    def PoundsPerUSGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerUSGallon"
        """
        pass

    @property
    def SlugsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugPerCubicCentimeter"
        """
        pass

    @property
    def SlugsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugPerCubicFoot"
        """
        pass

    @property
    def SlugsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugPerCubicInch"
        """
        pass

    @property
    def SlugsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugPerCubicMeter"
        """
        pass

    @property
    def SlugsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugPerCubicMillimeter"
        """
        pass

    @property
    def TonnesPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicCentimeter"
        """
        pass

    @property
    def TonnesPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicFoot"
        """
        pass

    @property
    def TonnesPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicInch"
        """
        pass

    @property
    def TonnesPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicMeter"
        """
        pass

    @property
    def TonnesPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicMillimeter"
        """
        pass

    def __init__(self, value: float, unit: DensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: DensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: Density, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Density within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Density
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Density.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: DensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DensityUnit) -> Density:
        """ Converts this Density to another Density with the unit representation .

        :param unit: The unit to convert to.
        :type unit: DensityUnit
        :return: A Density with the specified unit.
        :rtype: Density
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DensityUnit, unitConverter: UnitConverter) -> Density:
        """ Converts this "Density" to another "Density" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: DensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Density with the specified unit.
        :rtype: Density
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Density:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerDeciLiter(centigramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field CentigramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerLiter(centigramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field CentigramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerMilliliter(centigramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field CentigramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerDeciLiter(decigramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field DecigramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerLiter(decigramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field DecigramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMilliliter(decigramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field DecigramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicCentimeter(gramspercubiccentimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicFoot(gramspercubicfoot: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicInch(gramspercubicinch: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMeter(gramspercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMillimeter(gramspercubicmillimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerDeciLiter(gramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerLiter(gramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMilliliter(gramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field GramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicCentimeter(kilogramspercubiccentimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field KilogramPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMeter(kilogramspercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field KilogramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMillimeter(kilogramspercubicmillimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field KilogramPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerLiter(kilogramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field KilogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicFoot(kilopoundspercubicfoot: QuantityValue) -> Density:
        """ Creates a "Density" from "Field KilopoundPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicInch(kilopoundspercubicinch: QuantityValue) -> Density:
        """ Creates a "Density" from "Field KilopoundPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerCubicMeter(microgramspercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MicrogramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerDeciLiter(microgramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MicrogramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerLiter(microgramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MicrogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMilliliter(microgramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MicrogramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerCubicMeter(milligramspercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MilligramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerDeciLiter(milligramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MilligramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerLiter(milligramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MilligramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMilliliter(milligramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field MilligramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerDeciLiter(nanogramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field NanogramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerLiter(nanogramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field NanogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMilliliter(nanogramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field NanogramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerDeciLiter(picogramsperdeciliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PicogramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerLiter(picogramsperliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PicogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerMilliliter(picogramspermilliliter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PicogramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicCentimeter(poundspercubiccentimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicFoot(poundspercubicfoot: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicInch(poundspercubicinch: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicMeter(poundspercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicMillimeter(poundspercubicmillimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerImperialGallon(poundsperimperialgallon: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerImperialGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerUSGallon(poundsperusgallon: QuantityValue) -> Density:
        """ Creates a "Density" from "Field PoundPerUSGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicCentimeter(slugspercubiccentimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field SlugPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicFoot(slugspercubicfoot: QuantityValue) -> Density:
        """ Creates a "Density" from "Field SlugPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicInch(slugspercubicinch: QuantityValue) -> Density:
        """ Creates a "Density" from "Field SlugPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicMeter(slugspercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field SlugPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicMillimeter(slugspercubicmillimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field SlugPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicCentimeter(tonnespercubiccentimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field TonnePerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicFoot(tonnespercubicfoot: QuantityValue) -> Density:
        """ Creates a "Density" from "Field TonnePerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicInch(tonnespercubicinch: QuantityValue) -> Density:
        """ Creates a "Density" from "Field TonnePerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMeter(tonnespercubicmeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field TonnePerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMillimeter(tonnespercubicmillimeter: QuantityValue) -> Density:
        """ Creates a "Density" from "Field TonnePerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: DensityUnit) -> Density:
        """ Dynamically convert from value and unit enum "DensityUnit" to "Density".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: DensityUnit
        :return: Density unit value.
        :rtype: Density
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Density:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Density:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Density) -> typing.Tuple[Density, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Density
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Density) -> typing.Tuple[Density, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Density
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> DensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> DensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: DensityUnit) -> typing.Tuple[DensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: DensityUnit) -> typing.Tuple[DensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: DensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Density) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Density) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    def ToMolarity(self, molecularWeight: Mass) -> Molarity:
        """ Gets "Molarity" from this "Density".

        :param molecularWeight:
        :type molecularWeight: Mass
        """
        pass

    @staticmethod
    def FromMolarity(molarity: Molarity, molecularWeight: Mass) -> Density:
        """ Get "Density" from "Molarity".
        """
        pass


# noinspection PyPep8Naming
class Duration(ValueType, IQuantity[DurationUnit], IQuantity, IFormattable, IEquatable[Duration], IComparable, IComparable[Duration], IConvertible):
    """ Time is a dimension in which events can be ordered from the past through the present into the future, and also the measure of durations of events and the intervals between them.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[DurationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[DurationUnit]

    MaxValue: typing.ClassVar[Duration]

    MinValue: typing.ClassVar[Duration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[DurationUnit]]

    Zero: typing.ClassVar[Duration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> DurationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[DurationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Days(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Day"
        """
        pass

    @property
    def Hours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hour"
        """
        pass

    @property
    def JulianYears(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JulianYear"
        """
        pass

    @property
    def Microseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microsecond"
        """
        pass

    @property
    def Milliseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millisecond"
        """
        pass

    @property
    def Minutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Minute"
        """
        pass

    @property
    def Months30(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Month30"
        """
        pass

    @property
    def Nanoseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanosecond"
        """
        pass

    @property
    def Seconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Second"
        """
        pass

    @property
    def Weeks(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Week"
        """
        pass

    @property
    def Years365(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Year365"
        """
        pass

    def __init__(self, value: float, unit: DurationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: DurationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Duration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Duration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Duration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Duration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Duration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Duration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: DurationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DurationUnit) -> Duration:
        """ Converts this Duration to another Duration with the unit representation .

        :param unit: The unit to convert to.
        :type unit: DurationUnit
        :return: A Duration with the specified unit.
        :rtype: Duration
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DurationUnit, unitConverter: UnitConverter) -> Duration:
        """ Converts this "Duration" to another "Duration" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: DurationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Duration with the specified unit.
        :rtype: Duration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Duration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToTimeSpan(self) -> TimeSpan:
        """ Convert a Duration to a TimeSpan.

        :return: The TimeSpan with the same time as the duration
        :rtype: TimeSpan

        :exception ArgumentOutOfRangeException: Throws if the TimeSpan can't represent the Duration exactly
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DurationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DurationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DurationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DurationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDays(days: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Day".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHours(hours: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Hour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJulianYears(julianyears: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field JulianYear".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroseconds(microseconds: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Microsecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliseconds(milliseconds: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Millisecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMinutes(minutes: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Minute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMonths30(months30: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Month30".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoseconds(nanoseconds: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Nanosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSeconds(seconds: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Second".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWeeks(weeks: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Week".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYears365(years365: QuantityValue) -> Duration:
        """ Creates a "Duration" from "Field Year365".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: DurationUnit) -> Duration:
        """ Dynamically convert from value and unit enum "DurationUnit" to "Duration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: DurationUnit
        :return: Duration unit value.
        :rtype: Duration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Duration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Duration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Duration) -> typing.Tuple[Duration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Duration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Duration) -> typing.Tuple[Duration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Duration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> DurationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> DurationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: DurationUnit) -> typing.Tuple[DurationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: DurationUnit) -> typing.Tuple[DurationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: DurationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class DynamicViscosity(ValueType, IQuantity[DynamicViscosityUnit], IQuantity, IFormattable, IEquatable[DynamicViscosity], IComparable, IComparable[DynamicViscosity], IConvertible):
    """ The dynamic (shear) viscosity of a fluid expresses its resistance to shearing flows, where adjacent layers move parallel to each other with different speeds
     https://en.wikipedia.org/wiki/Viscosity#Dynamic_.28shear.29_viscosity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[DynamicViscosityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[DynamicViscosityUnit]

    MaxValue: typing.ClassVar[DynamicViscosity]

    MinValue: typing.ClassVar[DynamicViscosity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[DynamicViscosityUnit]]

    Zero: typing.ClassVar[DynamicViscosity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> DynamicViscosityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[DynamicViscosityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centipoise(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centipoise"
        """
        pass

    @property
    def MicropascalSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicropascalSecond"
        """
        pass

    @property
    def MillipascalSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillipascalSecond"
        """
        pass

    @property
    def NewtonSecondsPerMeterSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonSecondPerMeterSquared"
        """
        pass

    @property
    def PascalSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PascalSecond"
        """
        pass

    @property
    def Poise(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Poise"
        """
        pass

    @property
    def PoundsForceSecondPerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceSecondPerSquareFoot"
        """
        pass

    @property
    def PoundsForceSecondPerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceSecondPerSquareInch"
        """
        pass

    @property
    def PoundsPerFootSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerFootSecond"
        """
        pass

    @property
    def Reyns(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Reyn"
        """
        pass

    def __init__(self, value: float, unit: DynamicViscosityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: DynamicViscosityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DynamicViscosityUnit) -> DynamicViscosity:
        """ Converts this DynamicViscosity to another DynamicViscosity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: DynamicViscosityUnit
        :return: A DynamicViscosity with the specified unit.
        :rtype: DynamicViscosity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DynamicViscosityUnit, unitConverter: UnitConverter) -> DynamicViscosity:
        """ Converts this "DynamicViscosity" to another "DynamicViscosity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: DynamicViscosityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A DynamicViscosity with the specified unit.
        :rtype: DynamicViscosity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> DynamicViscosity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DynamicViscosityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DynamicViscosityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DynamicViscosityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DynamicViscosityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentipoise(centipoise: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field Centipoise".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicropascalSeconds(micropascalseconds: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field MicropascalSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillipascalSeconds(millipascalseconds: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field MillipascalSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonSecondsPerMeterSquared(newtonsecondspermetersquared: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field NewtonSecondPerMeterSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascalSeconds(pascalseconds: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field PascalSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoise(poise: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field Poise".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForceSecondPerSquareFoot(poundsforcesecondpersquarefoot: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field PoundForceSecondPerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForceSecondPerSquareInch(poundsforcesecondpersquareinch: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field PoundForceSecondPerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerFootSecond(poundsperfootsecond: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field PoundPerFootSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromReyns(reyns: QuantityValue) -> DynamicViscosity:
        """ Creates a "DynamicViscosity" from "Field Reyn".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: DynamicViscosityUnit) -> DynamicViscosity:
        """ Dynamically convert from value and unit enum "DynamicViscosityUnit" to "DynamicViscosity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: DynamicViscosityUnit
        :return: DynamicViscosity unit value.
        :rtype: DynamicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> DynamicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> DynamicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: DynamicViscosity) -> typing.Tuple[DynamicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: DynamicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: DynamicViscosity) -> typing.Tuple[DynamicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: DynamicViscosity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> DynamicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> DynamicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: DynamicViscosityUnit) -> typing.Tuple[DynamicViscosityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: DynamicViscosityUnit) -> typing.Tuple[DynamicViscosityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: DynamicViscosityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: DynamicViscosity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: DynamicViscosity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: DynamicViscosity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another DynamicViscosity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: DynamicViscosity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current DynamicViscosity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: DynamicViscosityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass


# noinspection PyPep8Naming
class ElectricCharge(ValueType, IQuantity[ElectricChargeUnit], IQuantity, IFormattable, IEquatable[ElectricCharge], IComparable, IComparable[ElectricCharge], IConvertible):
    """ Electric charge is the physical property of matter that causes it to experience a force when placed in an electromagnetic field.
     https://en.wikipedia.org/wiki/Electric_charge
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricChargeUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricChargeUnit]

    MaxValue: typing.ClassVar[ElectricCharge]

    MinValue: typing.ClassVar[ElectricCharge]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricChargeUnit]]

    Zero: typing.ClassVar[ElectricCharge]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricChargeUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricChargeUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmpereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmpereHour"
        """
        pass

    @property
    def Coulombs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Coulomb"
        """
        pass

    @property
    def KiloampereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloampereHour"
        """
        pass

    @property
    def MegaampereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaampereHour"
        """
        pass

    @property
    def MilliampereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliampereHour"
        """
        pass

    def __init__(self, value: float, unit: ElectricChargeUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricChargeUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCharge:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmpereHours(amperehours: QuantityValue) -> ElectricCharge:
        """ Creates a "ElectricCharge" from "Field AmpereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCoulombs(coulombs: QuantityValue) -> ElectricCharge:
        """ Creates a "ElectricCharge" from "Field Coulomb".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloampereHours(kiloamperehours: QuantityValue) -> ElectricCharge:
        """ Creates a "ElectricCharge" from "Field KiloampereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaampereHours(megaamperehours: QuantityValue) -> ElectricCharge:
        """ Creates a "ElectricCharge" from "Field MegaampereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliampereHours(milliamperehours: QuantityValue) -> ElectricCharge:
        """ Creates a "ElectricCharge" from "Field MilliampereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricChargeUnit) -> ElectricCharge:
        """ Dynamically convert from value and unit enum "ElectricChargeUnit" to "ElectricCharge".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricChargeUnit
        :return: ElectricCharge unit value.
        :rtype: ElectricCharge
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCharge:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCharge:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCharge) -> typing.Tuple[ElectricCharge, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCharge
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCharge) -> typing.Tuple[ElectricCharge, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCharge
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricChargeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricChargeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricChargeUnit) -> typing.Tuple[ElectricChargeUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricChargeUnit) -> typing.Tuple[ElectricChargeUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricChargeUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCharge) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCharge) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCharge, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCharge within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCharge
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCharge.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricChargeUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricChargeUnit) -> ElectricCharge:
        """ Converts this ElectricCharge to another ElectricCharge with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricChargeUnit
        :return: A ElectricCharge with the specified unit.
        :rtype: ElectricCharge
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricChargeUnit, unitConverter: UnitConverter) -> ElectricCharge:
        """ Converts this "ElectricCharge" to another "ElectricCharge" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricChargeUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricCharge with the specified unit.
        :rtype: ElectricCharge
        """
        pass


# noinspection PyPep8Naming
class ElectricConductivity(ValueType, IQuantity[ElectricConductivityUnit], IQuantity, IFormattable, IEquatable[ElectricConductivity], IComparable, IComparable[ElectricConductivity], IConvertible):
    """ Electrical conductivity or specific conductance is the reciprocal of electrical resistivity, and measures a material's ability to conduct an electric current.
     https://en.wikipedia.org/wiki/Electrical_resistivity_and_conductivity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricConductivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricConductivityUnit]

    MaxValue: typing.ClassVar[ElectricConductivity]

    MinValue: typing.ClassVar[ElectricConductivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricConductivityUnit]]

    Zero: typing.ClassVar[ElectricConductivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricConductivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricConductivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def MicrosiemensPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrosiemensPerCentimeter"
        """
        pass

    @property
    def MillisiemensPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillisiemensPerCentimeter"
        """
        pass

    @property
    def SiemensPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SiemensPerCentimeter"
        """
        pass

    @property
    def SiemensPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SiemensPerFoot"
        """
        pass

    @property
    def SiemensPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SiemensPerInch"
        """
        pass

    @property
    def SiemensPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SiemensPerMeter"
        """
        pass

    def __init__(self, value: float, unit: ElectricConductivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricConductivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricConductivity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def Inverse(self) -> ElectricResistivity:
        """Calculates the inverse or "ElectricResistivity" of this unit.

        :return: The inverse or "ElectricResistivity" of this unit.
        :rtype: ElectricResistivity
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromMicrosiemensPerCentimeter(microsiemenspercentimeter: QuantityValue) -> ElectricConductivity:
        """ Creates a "ElectricConductivity" from "Field MicrosiemensPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillisiemensPerCentimeter(millisiemenspercentimeter: QuantityValue) -> ElectricConductivity:
        """ Creates a "ElectricConductivity" from "Field MillisiemensPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemensPerCentimeter(siemenspercentimeter: QuantityValue) -> ElectricConductivity:
        """ Creates a "ElectricConductivity" from "Field SiemensPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemensPerFoot(siemensperfoot: QuantityValue) -> ElectricConductivity:
        """ Creates a "ElectricConductivity" from "Field SiemensPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemensPerInch(siemensperinch: QuantityValue) -> ElectricConductivity:
        """ Creates a "ElectricConductivity" from "Field SiemensPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemensPerMeter(siemenspermeter: QuantityValue) -> ElectricConductivity:
        """ Creates a "ElectricConductivity" from "Field SiemensPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricConductivityUnit) -> ElectricConductivity:
        """ Dynamically convert from value and unit enum "ElectricConductivityUnit" to "ElectricConductivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricConductivityUnit
        :return: ElectricConductivity unit value.
        :rtype: ElectricConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricConductivity) -> typing.Tuple[ElectricConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricConductivity) -> typing.Tuple[ElectricConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricConductivityUnit) -> typing.Tuple[ElectricConductivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricConductivityUnit) -> typing.Tuple[ElectricConductivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricConductivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricConductivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricConductivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricConductivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricConductivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricConductivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricConductivityUnit) -> ElectricConductivity:
        """ Converts this ElectricConductivity to another ElectricConductivity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricConductivityUnit
        :return: A ElectricConductivity with the specified unit.
        :rtype: ElectricConductivity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricConductivityUnit, unitConverter: UnitConverter) -> ElectricConductivity:
        """ Converts this "ElectricConductivity" to another "ElectricConductivity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricConductivityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricConductivity with the specified unit.
        :rtype: ElectricConductivity
        """
        pass


# noinspection PyPep8Naming
class ElectricCurrent(ValueType, IQuantity[ElectricCurrentUnit], IQuantity, IFormattable, IEquatable[ElectricCurrent], IComparable, IComparable[ElectricCurrent], IConvertible):
    """ An electric current is a flow of electric charge. In electric circuits this charge is often carried by moving electrons in a wire. It can also be carried by ions in an electrolyte, or by both ions and electrons such as in a plasma.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricCurrentUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricCurrentUnit]

    MaxValue: typing.ClassVar[ElectricCurrent]

    MinValue: typing.ClassVar[ElectricCurrent]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricCurrentUnit]]

    Zero: typing.ClassVar[ElectricCurrent]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricCurrentUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricCurrentUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Amperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Ampere"
        """
        pass

    @property
    def Centiamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centiampere"
        """
        pass

    @property
    def Kiloamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kiloampere"
        """
        pass

    @property
    def Megaamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megaampere"
        """
        pass

    @property
    def Microamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microampere"
        """
        pass

    @property
    def Milliamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milliampere"
        """
        pass

    @property
    def Nanoamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanoampere"
        """
        pass

    @property
    def Picoamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Picoampere"
        """
        pass

    def __init__(self, value: float, unit: ElectricCurrentUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricCurrentUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentUnit) -> ElectricCurrent:
        """ Converts this ElectricCurrent to another ElectricCurrent with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricCurrentUnit
        :return: A ElectricCurrent with the specified unit.
        :rtype: ElectricCurrent
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentUnit, unitConverter: UnitConverter) -> ElectricCurrent:
        """ Converts this "ElectricCurrent" to another "ElectricCurrent" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricCurrentUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricCurrent with the specified unit.
        :rtype: ElectricCurrent
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCurrent:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperes(amperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Ampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiamperes(centiamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Centiampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloamperes(kiloamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Kiloampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaamperes(megaamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Megaampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroamperes(microamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Microampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliamperes(milliamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Milliampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoamperes(nanoamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Nanoampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicoamperes(picoamperes: QuantityValue) -> ElectricCurrent:
        """ Creates a "ElectricCurrent" from "Field Picoampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricCurrentUnit) -> ElectricCurrent:
        """ Dynamically convert from value and unit enum "ElectricCurrentUnit" to "ElectricCurrent".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricCurrentUnit
        :return: ElectricCurrent unit value.
        :rtype: ElectricCurrent
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCurrent:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCurrent:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCurrent) -> typing.Tuple[ElectricCurrent, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrent
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCurrent) -> typing.Tuple[ElectricCurrent, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrent
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricCurrentUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricCurrentUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricCurrentUnit) -> typing.Tuple[ElectricCurrentUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricCurrentUnit) -> typing.Tuple[ElectricCurrentUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricCurrentUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCurrent) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrent) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrent, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCurrent within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCurrent
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCurrent.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricCurrentUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricPotential(ValueType, IQuantity[ElectricPotentialUnit], IQuantity, IFormattable, IEquatable[ElectricPotential], IComparable, IComparable[ElectricPotential], IConvertible):
    """ In classical electromagnetism, the electric potential (a scalar quantity denoted by Φ, ΦE or V and also called the electric field potential or the electrostatic potential) at a point is the amount of electric potential energy that a unitary point charge would have when located at that point.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialUnit]

    MaxValue: typing.ClassVar[ElectricPotential]

    MinValue: typing.ClassVar[ElectricPotential]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialUnit]]

    Zero: typing.ClassVar[ElectricPotential]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Kilovolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilovolt"
        """
        pass

    @property
    def Megavolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megavolt"
        """
        pass

    @property
    def Microvolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microvolt"
        """
        pass

    @property
    def Millivolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millivolt"
        """
        pass

    @property
    def Volts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Volt"
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotential:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToAmplitudeRatio(self) -> AmplitudeRatio:
        """ Gets an "AmplitudeRatio" in decibels (dB) relative to 1 volt RMS from this "ElectricPotential".
         Provides a nicer syntax for converting a voltage to an amplitude ratio (relative to 1 volt RMS).
         var voltageRatio = voltage.ToAmplitudeRatio();
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovolts(kilovolts: QuantityValue) -> ElectricPotential:
        """ Creates a "ElectricPotential" from "Field Kilovolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavolts(megavolts: QuantityValue) -> ElectricPotential:
        """ Creates a "ElectricPotential" from "Field Megavolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovolts(microvolts: QuantityValue) -> ElectricPotential:
        """ Creates a "ElectricPotential" from "Field Microvolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivolts(millivolts: QuantityValue) -> ElectricPotential:
        """ Creates a "ElectricPotential" from "Field Millivolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVolts(volts: QuantityValue) -> ElectricPotential:
        """ Creates a "ElectricPotential" from "Field Volt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialUnit) -> ElectricPotential:
        """ Dynamically convert from value and unit enum "ElectricPotentialUnit" to "ElectricPotential".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialUnit
        :return: ElectricPotential unit value.
        :rtype: ElectricPotential
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotential:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotential:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotential) -> typing.Tuple[ElectricPotential, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotential
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotential) -> typing.Tuple[ElectricPotential, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotential
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialUnit) -> typing.Tuple[ElectricPotentialUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialUnit) -> typing.Tuple[ElectricPotentialUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotential) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotential) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotential, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotential within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotential
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotential.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialUnit) -> ElectricPotential:
        """ Converts this ElectricPotential to another ElectricPotential with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialUnit
        :return: A ElectricPotential with the specified unit.
        :rtype: ElectricPotential
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialUnit, unitConverter: UnitConverter) -> ElectricPotential:
        """ Converts this "ElectricPotential" to another "ElectricPotential" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricPotential with the specified unit.
        :rtype: ElectricPotential
        """
        pass


# noinspection PyPep8Naming
class ElectricResistance(ValueType, IQuantity[ElectricResistanceUnit], IQuantity, IFormattable, IEquatable[ElectricResistance], IComparable, IComparable[ElectricResistance], IConvertible):
    """ The electrical resistance of an electrical conductor is the opposition to the passage of an electric current through that conductor.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricResistanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricResistanceUnit]

    MaxValue: typing.ClassVar[ElectricResistance]

    MinValue: typing.ClassVar[ElectricResistance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricResistanceUnit]]

    Zero: typing.ClassVar[ElectricResistance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricResistanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricResistanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Gigaohms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigaohm"
        """
        pass

    @property
    def Kiloohms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kiloohm"
        """
        pass

    @property
    def Megaohms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megaohm"
        """
        pass

    @property
    def Microohms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microohm"
        """
        pass

    @property
    def Milliohms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milliohm"
        """
        pass

    @property
    def Ohms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Ohm"
        """
        pass

    def __init__(self, value: float, unit: ElectricResistanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricResistanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricResistance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigaohms(gigaohms: QuantityValue) -> ElectricResistance:
        """ Creates a "ElectricResistance" from "Field Gigaohm".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloohms(kiloohms: QuantityValue) -> ElectricResistance:
        """ Creates a "ElectricResistance" from "Field Kiloohm".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaohms(megaohms: QuantityValue) -> ElectricResistance:
        """ Creates a "ElectricResistance" from "Field Megaohm".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroohms(microohms: QuantityValue) -> ElectricResistance:
        """ Creates a "ElectricResistance" from "Field Microohm".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliohms(milliohms: QuantityValue) -> ElectricResistance:
        """ Creates a "ElectricResistance" from "Field Milliohm".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOhms(ohms: QuantityValue) -> ElectricResistance:
        """ Creates a "ElectricResistance" from "Field Ohm".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricResistanceUnit) -> ElectricResistance:
        """ Dynamically convert from value and unit enum "ElectricResistanceUnit" to "ElectricResistance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricResistanceUnit
        :return: ElectricResistance unit value.
        :rtype: ElectricResistance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricResistance) -> typing.Tuple[ElectricResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricResistance) -> typing.Tuple[ElectricResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricResistanceUnit) -> typing.Tuple[ElectricResistanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricResistanceUnit) -> typing.Tuple[ElectricResistanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricResistanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricResistance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricResistance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricResistance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricResistance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricResistanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricResistanceUnit) -> ElectricResistance:
        """ Converts this ElectricResistance to another ElectricResistance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricResistanceUnit
        :return: A ElectricResistance with the specified unit.
        :rtype: ElectricResistance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricResistanceUnit, unitConverter: UnitConverter) -> ElectricResistance:
        """ Converts this "ElectricResistance" to another "ElectricResistance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricResistanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricResistance with the specified unit.
        :rtype: ElectricResistance
        """
        pass


# noinspection PyPep8Naming
class ElectricResistivity(ValueType, IQuantity[ElectricResistivityUnit], IQuantity, IFormattable, IEquatable[ElectricResistivity], IComparable, IComparable[ElectricResistivity], IConvertible):
    """ Electrical resistivity (also known as resistivity, specific electrical resistance, or volume resistivity) is a fundamental property that quantifies how strongly a given material opposes the flow of electric current.
     https://en.wikipedia.org/wiki/Electrical_resistivity_and_conductivity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricResistivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricResistivityUnit]

    MaxValue: typing.ClassVar[ElectricResistivity]

    MinValue: typing.ClassVar[ElectricResistivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricResistivityUnit]]

    Zero: typing.ClassVar[ElectricResistivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricResistivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricResistivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KiloohmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloohmCentimeter"
        """
        pass

    @property
    def KiloohmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloohmMeter"
        """
        pass

    @property
    def MegaohmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaohmCentimeter"
        """
        pass

    @property
    def MegaohmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaohmMeter"
        """
        pass

    @property
    def MicroohmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroohmCentimeter"
        """
        pass

    @property
    def MicroohmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroohmMeter"
        """
        pass

    @property
    def MilliohmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliohmCentimeter"
        """
        pass

    @property
    def MilliohmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliohmMeter"
        """
        pass

    @property
    def NanoohmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoohmCentimeter"
        """
        pass

    @property
    def NanoohmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoohmMeter"
        """
        pass

    @property
    def OhmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OhmCentimeter"
        """
        pass

    @property
    def OhmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OhmMeter"
        """
        pass

    @property
    def PicoohmsCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicoohmCentimeter"
        """
        pass

    @property
    def PicoohmMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicoohmMeter"
        """
        pass

    def __init__(self, value: float, unit: ElectricResistivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricResistivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricResistivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricResistivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricResistivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricResistivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricResistivityUnit) -> ElectricResistivity:
        """ Converts this ElectricResistivity to another ElectricResistivity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricResistivityUnit
        :return: A ElectricResistivity with the specified unit.
        :rtype: ElectricResistivity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricResistivityUnit, unitConverter: UnitConverter) -> ElectricResistivity:
        """ Converts this "ElectricResistivity" to another "ElectricResistivity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricResistivityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricResistivity with the specified unit.
        :rtype: ElectricResistivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricResistivity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def Inverse(self) -> ElectricConductivity:
        """Calculates the inverse or "ElectricConductivity" of this unit.

        :return: The inverse or "ElectricConductivity" of this unit.
        :rtype: ElectricConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKiloohmsCentimeter(kiloohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field KiloohmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloohmMeters(kiloohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field KiloohmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaohmsCentimeter(megaohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field MegaohmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaohmMeters(megaohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field MegaohmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroohmsCentimeter(microohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field MicroohmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroohmMeters(microohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field MicroohmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliohmsCentimeter(milliohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field MilliohmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliohmMeters(milliohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field MilliohmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoohmsCentimeter(nanoohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field NanoohmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoohmMeters(nanoohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field NanoohmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOhmsCentimeter(ohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field OhmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOhmMeters(ohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field OhmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicoohmsCentimeter(picoohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field PicoohmCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicoohmMeters(picoohmmeters: QuantityValue) -> ElectricResistivity:
        """ Creates a "ElectricResistivity" from "Field PicoohmMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricResistivityUnit) -> ElectricResistivity:
        """ Dynamically convert from value and unit enum "ElectricResistivityUnit" to "ElectricResistivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricResistivityUnit
        :return: ElectricResistivity unit value.
        :rtype: ElectricResistivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricResistivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricResistivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricResistivity) -> typing.Tuple[ElectricResistivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricResistivity) -> typing.Tuple[ElectricResistivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricResistivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricResistivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricResistivityUnit) -> typing.Tuple[ElectricResistivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricResistivityUnit) -> typing.Tuple[ElectricResistivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricResistivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricResistivity) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class Energy(ValueType, IQuantity[EnergyUnit], IQuantity, IFormattable, IEquatable[Energy], IComparable, IComparable[Energy], IConvertible):
    """ The joule, symbol J, is a derived unit of energy, work, or amount of heat in the International System of Units. It is equal to the energy transferred (or work done) when applying a force of one newton through a distance of one metre (1 newton metre or N·m), or in passing an electric current of one ampere through a resistance of one ohm for one second. Many other units of energy are included. Please do not confuse this definition of the calorie with the one colloquially used by the food industry, the large calorie, which is equivalent to 1 kcal. Thermochemical definition of the calorie is used. For BTU, the IT definition is used.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[EnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[EnergyUnit]

    MaxValue: typing.ClassVar[Energy]

    MinValue: typing.ClassVar[Energy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[EnergyUnit]]

    Zero: typing.ClassVar[Energy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> EnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[EnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BritishThermalUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BritishThermalUnit"
        """
        pass

    @property
    def Calories(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Calorie"
        """
        pass

    @property
    def DecathermsEc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecathermEc"
        """
        pass

    @property
    def DecathermsImperial(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecathermImperial"
        """
        pass

    @property
    def DecathermsUs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecathermUs"
        """
        pass

    @property
    def ElectronVolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ElectronVolt"
        """
        pass

    @property
    def Ergs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Erg"
        """
        pass

    @property
    def FootPounds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootPound"
        """
        pass

    @property
    def GigabritishThermalUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigabritishThermalUnit"
        """
        pass

    @property
    def GigaelectronVolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigaelectronVolt"
        """
        pass

    @property
    def Gigajoules(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigajoule"
        """
        pass

    @property
    def GigawattDays(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattDay"
        """
        pass

    @property
    def GigawattHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattHour"
        """
        pass

    @property
    def HorsepowerHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HorsepowerHour"
        """
        pass

    @property
    def Joules(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Joule"
        """
        pass

    @property
    def KilobritishThermalUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilobritishThermalUnit"
        """
        pass

    @property
    def Kilocalories(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilocalorie"
        """
        pass

    @property
    def KiloelectronVolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloelectronVolt"
        """
        pass

    @property
    def Kilojoules(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilojoule"
        """
        pass

    @property
    def KilowattDays(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattDay"
        """
        pass

    @property
    def KilowattHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattHour"
        """
        pass

    @property
    def MegabritishThermalUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegabritishThermalUnit"
        """
        pass

    @property
    def Megacalories(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megacalorie"
        """
        pass

    @property
    def MegaelectronVolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaelectronVolt"
        """
        pass

    @property
    def Megajoules(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megajoule"
        """
        pass

    @property
    def MegawattDays(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattDay"
        """
        pass

    @property
    def MegawattHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattHour"
        """
        pass

    @property
    def Millijoules(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millijoule"
        """
        pass

    @property
    def TeraelectronVolts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TeraelectronVolt"
        """
        pass

    @property
    def TerawattDays(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattDay"
        """
        pass

    @property
    def TerawattHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattHour"
        """
        pass

    @property
    def ThermsEc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ThermEc"
        """
        pass

    @property
    def ThermsImperial(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ThermImperial"
        """
        pass

    @property
    def ThermsUs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ThermUs"
        """
        pass

    @property
    def WattDays(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattDay"
        """
        pass

    @property
    def WattHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattHour"
        """
        pass

    def __init__(self, value: float, unit: EnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: EnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigajoules(gigajoules: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Gigajoule".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDays(gigawattdays: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field GigawattDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattHours(gigawatthours: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field GigawattHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHorsepowerHours(horsepowerhours: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field HorsepowerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoules(joules: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Joule".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobritishThermalUnits(kilobritishthermalunits: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field KilobritishThermalUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocalories(kilocalories: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Kilocalorie".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloelectronVolts(kiloelectronvolts: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field KiloelectronVolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoules(kilojoules: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Kilojoule".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDays(kilowattdays: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field KilowattDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHours(kilowatthours: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field KilowattHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabritishThermalUnits(megabritishthermalunits: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field MegabritishThermalUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegacalories(megacalories: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Megacalorie".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaelectronVolts(megaelectronvolts: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field MegaelectronVolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoules(megajoules: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Megajoule".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDays(megawattdays: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field MegawattDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattHours(megawatthours: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field MegawattHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillijoules(millijoules: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Millijoule".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTeraelectronVolts(teraelectronvolts: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field TeraelectronVolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDays(terawattdays: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field TerawattDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattHours(terawatthours: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field TerawattHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromThermsEc(thermsec: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field ThermEc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromThermsImperial(thermsimperial: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field ThermImperial".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromThermsUs(thermsus: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field ThermUs".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDays(wattdays: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field WattDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHours(watthours: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field WattHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: EnergyUnit) -> Energy:
        """ Dynamically convert from value and unit enum "EnergyUnit" to "Energy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: EnergyUnit
        :return: Energy unit value.
        :rtype: Energy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Energy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Energy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Energy) -> typing.Tuple[Energy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Energy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Energy) -> typing.Tuple[Energy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Energy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> EnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> EnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: EnergyUnit) -> typing.Tuple[EnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: EnergyUnit) -> typing.Tuple[EnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: EnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Energy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Energy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Energy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Energy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Energy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Energy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: EnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: EnergyUnit) -> Energy:
        """ Converts this Energy to another Energy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: EnergyUnit
        :return: A Energy with the specified unit.
        :rtype: Energy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: EnergyUnit, unitConverter: UnitConverter) -> Energy:
        """ Converts this "Energy" to another "Energy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: EnergyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Energy with the specified unit.
        :rtype: Energy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Energy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBritishThermalUnits(britishthermalunits: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field BritishThermalUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCalories(calories: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Calorie".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecathermsEc(decathermsec: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field DecathermEc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecathermsImperial(decathermsimperial: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field DecathermImperial".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecathermsUs(decathermsus: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field DecathermUs".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromElectronVolts(electronvolts: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field ElectronVolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromErgs(ergs: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field Erg".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFootPounds(footpounds: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field FootPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabritishThermalUnits(gigabritishthermalunits: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field GigabritishThermalUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigaelectronVolts(gigaelectronvolts: QuantityValue) -> Energy:
        """ Creates a "Energy" from "Field GigaelectronVolt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Entropy(ValueType, IQuantity[EntropyUnit], IQuantity, IFormattable, IEquatable[Entropy], IComparable, IComparable[Entropy], IConvertible):
    """ Entropy is an important concept in the branch of science known as thermodynamics. The idea of "irreversibility" is central to the understanding of entropy. It is often said that entropy is an expression of the disorder, or randomness of a system, or of our lack of information about it. Entropy is an extensive property. It has the dimension of energy divided by temperature, which has a unit of joules per kelvin (J/K) in the International System of Units
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[EntropyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[EntropyUnit]

    MaxValue: typing.ClassVar[Entropy]

    MinValue: typing.ClassVar[Entropy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[EntropyUnit]]

    Zero: typing.ClassVar[Entropy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> EntropyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[EntropyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CaloriesPerKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CaloriePerKelvin"
        """
        pass

    @property
    def JoulesPerDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerDegreeCelsius"
        """
        pass

    @property
    def JoulesPerKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerKelvin"
        """
        pass

    @property
    def KilocaloriesPerKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocaloriePerKelvin"
        """
        pass

    @property
    def KilojoulesPerDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerDegreeCelsius"
        """
        pass

    @property
    def KilojoulesPerKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerKelvin"
        """
        pass

    @property
    def MegajoulesPerKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerKelvin"
        """
        pass

    def __init__(self, value: float, unit: EntropyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: EntropyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Entropy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EntropyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EntropyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EntropyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EntropyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCaloriesPerKelvin(caloriesperkelvin: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field CaloriePerKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerDegreeCelsius(joulesperdegreecelsius: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field JoulePerDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKelvin(joulesperkelvin: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field JoulePerKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerKelvin(kilocaloriesperkelvin: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field KilocaloriePerKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerDegreeCelsius(kilojoulesperdegreecelsius: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field KilojoulePerDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKelvin(kilojoulesperkelvin: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field KilojoulePerKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKelvin(megajoulesperkelvin: QuantityValue) -> Entropy:
        """ Creates a "Entropy" from "Field MegajoulePerKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: EntropyUnit) -> Entropy:
        """ Dynamically convert from value and unit enum "EntropyUnit" to "Entropy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: EntropyUnit
        :return: Entropy unit value.
        :rtype: Entropy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Entropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Entropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Entropy) -> typing.Tuple[Entropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Entropy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Entropy) -> typing.Tuple[Entropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Entropy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> EntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> EntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: EntropyUnit) -> typing.Tuple[EntropyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: EntropyUnit) -> typing.Tuple[EntropyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: EntropyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Entropy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Entropy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Entropy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Entropy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Entropy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Entropy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: EntropyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: EntropyUnit) -> Entropy:
        """ Converts this Entropy to another Entropy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: EntropyUnit
        :return: A Entropy with the specified unit.
        :rtype: Entropy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: EntropyUnit, unitConverter: UnitConverter) -> Entropy:
        """ Converts this "Entropy" to another "Entropy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: EntropyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Entropy with the specified unit.
        :rtype: Entropy
        """
        pass


# noinspection PyPep8Naming
class Force(ValueType, IQuantity[ForceUnit], IQuantity, IFormattable, IEquatable[Force], IComparable, IComparable[Force], IConvertible):
    """ In physics, a force is any influence that causes an object to undergo a certain change, either concerning its movement, direction, or geometrical construction. In other words, a force can cause an object with mass to change its velocity (which includes to begin moving from a state of rest), i.e., to accelerate, or a flexible object to deform, or both. Force can also be described by intuitive concepts such as a push or a pull. A force has both magnitude and direction, making it a vector quantity. It is measured in the SI unit of newtons and represented by the symbol F.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ForceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ForceUnit]

    MaxValue: typing.ClassVar[Force]

    MinValue: typing.ClassVar[Force]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ForceUnit]]

    Zero: typing.ClassVar[Force]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ForceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ForceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decanewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decanewton"
        """
        pass

    @property
    def Dyne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Dyn"
        """
        pass

    @property
    def KilogramsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForce"
        """
        pass

    @property
    def Kilonewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilonewton"
        """
        pass

    @property
    def KiloPonds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloPond"
        """
        pass

    @property
    def KilopoundsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForce"
        """
        pass

    @property
    def Meganewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Meganewton"
        """
        pass

    @property
    def Micronewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Micronewton"
        """
        pass

    @property
    def Millinewtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millinewton"
        """
        pass

    @property
    def Newtons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Newton"
        """
        pass

    @property
    def OunceForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OunceForce"
        """
        pass

    @property
    def Poundals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Poundal"
        """
        pass

    @property
    def PoundsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForce"
        """
        pass

    @property
    def ShortTonsForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ShortTonForce"
        """
        pass

    @property
    def TonnesForce(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForce"
        """
        pass

    def __init__(self, value: float, unit: ForceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ForceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Force) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Force) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Force, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Force within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Force
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Force.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ForceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForceUnit) -> Force:
        """ Converts this Force to another Force with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ForceUnit
        :return: A Force with the specified unit.
        :rtype: Force
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForceUnit, unitConverter: UnitConverter) -> Force:
        """ Converts this "Force" to another "Force" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ForceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Force with the specified unit.
        :rtype: Force
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Force:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromPressureByArea(p: Pressure, area: Area) -> Force:
        """Get "Force" from "Pressure" divided by "Area".
        """
        pass

    @staticmethod
    def FromMassByAcceleration(mass: Mass, acceleration: Acceleration) -> Force:
        """Get "Force" from "Mass" times "Acceleration".
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecanewtons(decanewtons: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Decanewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDyne(dyne: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Dyn".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForce(kilogramsforce: QuantityValue) -> Force:
        """ Creates a "Force" from "Field KilogramForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtons(kilonewtons: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Kilonewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloPonds(kiloponds: QuantityValue) -> Force:
        """ Creates a "Force" from "Field KiloPond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForce(kilopoundsforce: QuantityValue) -> Force:
        """ Creates a "Force" from "Field KilopoundForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtons(meganewtons: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Meganewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtons(micronewtons: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Micronewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtons(millinewtons: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Millinewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtons(newtons: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Newton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOunceForce(ounceforce: QuantityValue) -> Force:
        """ Creates a "Force" from "Field OunceForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundals(poundals: QuantityValue) -> Force:
        """ Creates a "Force" from "Field Poundal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForce(poundsforce: QuantityValue) -> Force:
        """ Creates a "Force" from "Field PoundForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortTonsForce(shorttonsforce: QuantityValue) -> Force:
        """ Creates a "Force" from "Field ShortTonForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForce(tonnesforce: QuantityValue) -> Force:
        """ Creates a "Force" from "Field TonneForce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ForceUnit) -> Force:
        """ Dynamically convert from value and unit enum "ForceUnit" to "Force".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ForceUnit
        :return: Force unit value.
        :rtype: Force
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Force:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Force:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Force) -> typing.Tuple[Force, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Force
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Force) -> typing.Tuple[Force, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Force
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ForceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ForceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ForceUnit) -> typing.Tuple[ForceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ForceUnit) -> typing.Tuple[ForceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ForceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ForceChangeRate(ValueType, IQuantity[ForceChangeRateUnit], IQuantity, IFormattable, IEquatable[ForceChangeRate], IComparable, IComparable[ForceChangeRate], IConvertible):
    """ Force change rate is the ratio of the force change to the time during which the change occurred (value of force changes per unit time).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ForceChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ForceChangeRateUnit]

    MaxValue: typing.ClassVar[ForceChangeRate]

    MinValue: typing.ClassVar[ForceChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ForceChangeRateUnit]]

    Zero: typing.ClassVar[ForceChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ForceChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ForceChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentinewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonPerSecond"
        """
        pass

    @property
    def DecanewtonsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonPerMinute"
        """
        pass

    @property
    def DecanewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonPerSecond"
        """
        pass

    @property
    def DecinewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonPerSecond"
        """
        pass

    @property
    def KilonewtonsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerMinute"
        """
        pass

    @property
    def KilonewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerSecond"
        """
        pass

    @property
    def KilopoundsForcePerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerMinute"
        """
        pass

    @property
    def KilopoundsForcePerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerSecond"
        """
        pass

    @property
    def MicronewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonPerSecond"
        """
        pass

    @property
    def MillinewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonPerSecond"
        """
        pass

    @property
    def NanonewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonPerSecond"
        """
        pass

    @property
    def NewtonsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerMinute"
        """
        pass

    @property
    def NewtonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerSecond"
        """
        pass

    @property
    def PoundsForcePerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerMinute"
        """
        pass

    @property
    def PoundsForcePerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerSecond"
        """
        pass

    def __init__(self, value: float, unit: ForceChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ForceChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, other: ForceChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForceChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForceChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ForceChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ForceChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ForceChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ForceChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForceChangeRateUnit) -> ForceChangeRate:
        """ Converts this ForceChangeRate to another ForceChangeRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ForceChangeRateUnit
        :return: A ForceChangeRate with the specified unit.
        :rtype: ForceChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForceChangeRateUnit, unitConverter: UnitConverter) -> ForceChangeRate:
        """ Converts this "ForceChangeRate" to another "ForceChangeRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ForceChangeRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ForceChangeRate with the specified unit.
        :rtype: ForceChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ForceChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentinewtonsPerSecond(centinewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field CentinewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerMinute(decanewtonsperminute: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field DecanewtonPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerSecond(decanewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field DecanewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerSecond(decinewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field DecinewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerMinute(kilonewtonsperminute: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field KilonewtonPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSecond(kilonewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field KilonewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerMinute(kilopoundsforceperminute: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field KilopoundForcePerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSecond(kilopoundsforcepersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field KilopoundForcePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerSecond(micronewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field MicronewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerSecond(millinewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field MillinewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerSecond(nanonewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field NanonewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerMinute(newtonsperminute: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field NewtonPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSecond(newtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field NewtonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerMinute(poundsforceperminute: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field PoundForcePerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSecond(poundsforcepersecond: QuantityValue) -> ForceChangeRate:
        """ Creates a "ForceChangeRate" from "Field PoundForcePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ForceChangeRateUnit) -> ForceChangeRate:
        """ Dynamically convert from value and unit enum "ForceChangeRateUnit" to "ForceChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ForceChangeRateUnit
        :return: ForceChangeRate unit value.
        :rtype: ForceChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ForceChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ForceChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ForceChangeRate) -> typing.Tuple[ForceChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForceChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ForceChangeRate) -> typing.Tuple[ForceChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForceChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ForceChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ForceChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ForceChangeRateUnit) -> typing.Tuple[ForceChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ForceChangeRateUnit) -> typing.Tuple[ForceChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ForceChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class ForcePerLength(ValueType, IQuantity[ForcePerLengthUnit], IQuantity, IFormattable, IEquatable[ForcePerLength], IComparable, IComparable[ForcePerLength], IConvertible):
    """ The magnitude of force per unit length.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ForcePerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ForcePerLengthUnit]

    MaxValue: typing.ClassVar[ForcePerLength]

    MinValue: typing.ClassVar[ForcePerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ForcePerLengthUnit]]

    Zero: typing.ClassVar[ForcePerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ForcePerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ForcePerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentinewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonPerCentimeter"
        """
        pass

    @property
    def CentinewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonPerMeter"
        """
        pass

    @property
    def CentinewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonPerMillimeter"
        """
        pass

    @property
    def DecanewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonPerCentimeter"
        """
        pass

    @property
    def DecanewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonPerMeter"
        """
        pass

    @property
    def DecanewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonPerMillimeter"
        """
        pass

    @property
    def DecinewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonPerCentimeter"
        """
        pass

    @property
    def DecinewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonPerMeter"
        """
        pass

    @property
    def DecinewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonPerMillimeter"
        """
        pass

    @property
    def KilogramsForcePerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerCentimeter"
        """
        pass

    @property
    def KilogramsForcePerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerMeter"
        """
        pass

    @property
    def KilogramsForcePerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerMillimeter"
        """
        pass

    @property
    def KilonewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerCentimeter"
        """
        pass

    @property
    def KilonewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerMeter"
        """
        pass

    @property
    def KilonewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerMillimeter"
        """
        pass

    @property
    def KilopoundsForcePerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerFoot"
        """
        pass

    @property
    def KilopoundsForcePerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerInch"
        """
        pass

    @property
    def MeganewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonPerCentimeter"
        """
        pass

    @property
    def MeganewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonPerMeter"
        """
        pass

    @property
    def MeganewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonPerMillimeter"
        """
        pass

    @property
    def MicronewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonPerCentimeter"
        """
        pass

    @property
    def MicronewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonPerMeter"
        """
        pass

    @property
    def MicronewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonPerMillimeter"
        """
        pass

    @property
    def MillinewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonPerCentimeter"
        """
        pass

    @property
    def MillinewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonPerMeter"
        """
        pass

    @property
    def MillinewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonPerMillimeter"
        """
        pass

    @property
    def NanonewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonPerCentimeter"
        """
        pass

    @property
    def NanonewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonPerMeter"
        """
        pass

    @property
    def NanonewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonPerMillimeter"
        """
        pass

    @property
    def NewtonsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerCentimeter"
        """
        pass

    @property
    def NewtonsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerMeter"
        """
        pass

    @property
    def NewtonsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerMillimeter"
        """
        pass

    @property
    def PoundsForcePerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerFoot"
        """
        pass

    @property
    def PoundsForcePerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerInch"
        """
        pass

    @property
    def PoundsForcePerYard(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerYard"
        """
        pass

    @property
    def TonnesForcePerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerCentimeter"
        """
        pass

    @property
    def TonnesForcePerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerMeter"
        """
        pass

    @property
    def TonnesForcePerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerMillimeter"
        """
        pass

    def __init__(self, value: float, unit: ForcePerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ForcePerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramsForcePerMillimeter(kilogramsforcepermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilogramForcePerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCentimeter(kilonewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilonewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerMeter(kilonewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilonewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerMillimeter(kilonewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilonewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerFoot(kilopoundsforceperfoot: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilopoundForcePerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerInch(kilopoundsforceperinch: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilopoundForcePerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerCentimeter(meganewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MeganewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerMeter(meganewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MeganewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerMillimeter(meganewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MeganewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerCentimeter(micronewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MicronewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerMeter(micronewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MicronewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerMillimeter(micronewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MicronewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerCentimeter(millinewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MillinewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerMeter(millinewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MillinewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerMillimeter(millinewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field MillinewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerCentimeter(nanonewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field NanonewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerMeter(nanonewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field NanonewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerMillimeter(nanonewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field NanonewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCentimeter(newtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field NewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerMeter(newtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field NewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerMillimeter(newtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field NewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerFoot(poundsforceperfoot: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field PoundForcePerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerInch(poundsforceperinch: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field PoundForcePerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerYard(poundsforceperyard: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field PoundForcePerYard".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCentimeter(tonnesforcepercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field TonneForcePerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerMeter(tonnesforcepermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field TonneForcePerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerMillimeter(tonnesforcepermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field TonneForcePerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ForcePerLengthUnit) -> ForcePerLength:
        """ Dynamically convert from value and unit enum "ForcePerLengthUnit" to "ForcePerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ForcePerLengthUnit
        :return: ForcePerLength unit value.
        :rtype: ForcePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ForcePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ForcePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ForcePerLength) -> typing.Tuple[ForcePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForcePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ForcePerLength) -> typing.Tuple[ForcePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForcePerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ForcePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ForcePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ForcePerLengthUnit) -> typing.Tuple[ForcePerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ForcePerLengthUnit) -> typing.Tuple[ForcePerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ForcePerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ForcePerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForcePerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForcePerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ForcePerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ForcePerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ForcePerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ForcePerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForcePerLengthUnit) -> ForcePerLength:
        """ Converts this ForcePerLength to another ForcePerLength with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ForcePerLengthUnit
        :return: A ForcePerLength with the specified unit.
        :rtype: ForcePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForcePerLengthUnit, unitConverter: UnitConverter) -> ForcePerLength:
        """ Converts this "ForcePerLength" to another "ForcePerLength" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ForcePerLengthUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ForcePerLength with the specified unit.
        :rtype: ForcePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ForcePerLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForcePerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForcePerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForcePerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForcePerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentinewtonsPerCentimeter(centinewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field CentinewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonsPerMeter(centinewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field CentinewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonsPerMillimeter(centinewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field CentinewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerCentimeter(decanewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field DecanewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerMeter(decanewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field DecanewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerMillimeter(decanewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field DecanewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerCentimeter(decinewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field DecinewtonPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerMeter(decinewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field DecinewtonPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerMillimeter(decinewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field DecinewtonPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCentimeter(kilogramsforcepercentimeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilogramForcePerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerMeter(kilogramsforcepermeter: QuantityValue) -> ForcePerLength:
        """ Creates a "ForcePerLength" from "Field KilogramForcePerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class HeatFlux(ValueType, IQuantity[HeatFluxUnit], IQuantity, IFormattable, IEquatable[HeatFlux], IComparable, IComparable[HeatFlux], IConvertible):
    """ Heat flux is the flow of energy per unit of area per unit of time
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[HeatFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[HeatFluxUnit]

    MaxValue: typing.ClassVar[HeatFlux]

    MinValue: typing.ClassVar[HeatFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[HeatFluxUnit]]

    Zero: typing.ClassVar[HeatFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> HeatFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[HeatFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerHourSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerHourSquareFoot"
        """
        pass

    @property
    def BtusPerMinuteSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerMinuteSquareFoot"
        """
        pass

    @property
    def BtusPerSecondSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerSecondSquareFoot"
        """
        pass

    @property
    def BtusPerSecondSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerSecondSquareInch"
        """
        pass

    @property
    def CaloriesPerSecondSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CaloriePerSecondSquareCentimeter"
        """
        pass

    @property
    def CentiwattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentiwattPerSquareMeter"
        """
        pass

    @property
    def DeciwattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciwattPerSquareMeter"
        """
        pass

    @property
    def KilocaloriesPerHourSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocaloriePerHourSquareMeter"
        """
        pass

    @property
    def KilocaloriesPerSecondSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocaloriePerSecondSquareCentimeter"
        """
        pass

    @property
    def KilowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerSquareMeter"
        """
        pass

    @property
    def MicrowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerSquareMeter"
        """
        pass

    @property
    def MilliwattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerSquareMeter"
        """
        pass

    @property
    def NanowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerSquareMeter"
        """
        pass

    @property
    def PoundsForcePerFootSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerFootSecond"
        """
        pass

    @property
    def PoundsPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerSecondCubed"
        """
        pass

    @property
    def WattsPerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareFoot"
        """
        pass

    @property
    def WattsPerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareInch"
        """
        pass

    @property
    def WattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: HeatFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: HeatFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: HeatFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another HeatFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: HeatFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current HeatFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: HeatFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: HeatFluxUnit) -> HeatFlux:
        """ Converts this HeatFlux to another HeatFlux with the unit representation .

        :param unit: The unit to convert to.
        :type unit: HeatFluxUnit
        :return: A HeatFlux with the specified unit.
        :rtype: HeatFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unit: HeatFluxUnit, unitConverter: UnitConverter) -> HeatFlux:
        """ Converts this "HeatFlux" to another "HeatFlux" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: HeatFluxUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A HeatFlux with the specified unit.
        :rtype: HeatFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> HeatFlux:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerHourSquareFoot(btusperhoursquarefoot: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field BtuPerHourSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBtusPerMinuteSquareFoot(btusperminutesquarefoot: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field BtuPerMinuteSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBtusPerSecondSquareFoot(btuspersecondsquarefoot: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field BtuPerSecondSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBtusPerSecondSquareInch(btuspersecondsquareinch: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field BtuPerSecondSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerSecondSquareCentimeter(caloriespersecondsquarecentimeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field CaloriePerSecondSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiwattsPerSquareMeter(centiwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field CentiwattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerSquareMeter(deciwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field DeciwattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerHourSquareMeter(kilocaloriesperhoursquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field KilocaloriePerHourSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerSecondSquareCentimeter(kilocaloriespersecondsquarecentimeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field KilocaloriePerSecondSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerSquareMeter(kilowattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field KilowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerSquareMeter(microwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field MicrowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerSquareMeter(milliwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field MilliwattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerSquareMeter(nanowattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field NanowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerFootSecond(poundsforceperfootsecond: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field PoundForcePerFootSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerSecondCubed(poundspersecondcubed: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field PoundPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareFoot(wattspersquarefoot: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field WattPerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareInch(wattspersquareinch: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field WattPerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeter(wattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Creates a "HeatFlux" from "Field WattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: HeatFluxUnit) -> HeatFlux:
        """ Dynamically convert from value and unit enum "HeatFluxUnit" to "HeatFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: HeatFluxUnit
        :return: HeatFlux unit value.
        :rtype: HeatFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> HeatFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> HeatFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: HeatFlux) -> typing.Tuple[HeatFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: HeatFlux) -> typing.Tuple[HeatFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> HeatFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> HeatFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: HeatFluxUnit) -> typing.Tuple[HeatFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: HeatFluxUnit) -> typing.Tuple[HeatFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: HeatFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class KinematicViscosity(ValueType, IQuantity[KinematicViscosityUnit], IQuantity, IFormattable, IEquatable[KinematicViscosity], IComparable, IComparable[KinematicViscosity], IConvertible):
    """ The viscosity of a fluid is a measure of its resistance to gradual deformation by shear stress or tensile stress.
     http://en.wikipedia.org/wiki/Viscosity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[KinematicViscosityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[KinematicViscosityUnit]

    MaxValue: typing.ClassVar[KinematicViscosity]

    MinValue: typing.ClassVar[KinematicViscosity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[KinematicViscosityUnit]]

    Zero: typing.ClassVar[KinematicViscosity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> KinematicViscosityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[KinematicViscosityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centistokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centistokes"
        """
        pass

    @property
    def Decistokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decistokes"
        """
        pass

    @property
    def Kilostokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilostokes"
        """
        pass

    @property
    def Microstokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microstokes"
        """
        pass

    @property
    def Millistokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millistokes"
        """
        pass

    @property
    def Nanostokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanostokes"
        """
        pass

    @property
    def SquareFeetPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareFootPerSecond"
        """
        pass

    @property
    def SquareMetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMeterPerSecond"
        """
        pass

    @property
    def Stokes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Stokes"
        """
        pass

    def __init__(self, value: float, unit: KinematicViscosityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: KinematicViscosityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: KinematicViscosityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: KinematicViscosityUnit) -> KinematicViscosity:
        """ Converts this KinematicViscosity to another KinematicViscosity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: KinematicViscosityUnit
        :return: A KinematicViscosity with the specified unit.
        :rtype: KinematicViscosity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: KinematicViscosityUnit, unitConverter: UnitConverter) -> KinematicViscosity:
        """ Converts this "KinematicViscosity" to another "KinematicViscosity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: KinematicViscosityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A KinematicViscosity with the specified unit.
        :rtype: KinematicViscosity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> KinematicViscosity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: KinematicViscosityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: KinematicViscosityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: KinematicViscosityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: KinematicViscosityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentistokes(centistokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Centistokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecistokes(decistokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Decistokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilostokes(kilostokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Kilostokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrostokes(microstokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Microstokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillistokes(millistokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Millistokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanostokes(nanostokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Nanostokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareFeetPerSecond(squarefeetpersecond: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field SquareFootPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMetersPerSecond(squaremeterspersecond: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field SquareMeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStokes(stokes: QuantityValue) -> KinematicViscosity:
        """ Creates a "KinematicViscosity" from "Field Stokes".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: KinematicViscosityUnit) -> KinematicViscosity:
        """ Dynamically convert from value and unit enum "KinematicViscosityUnit" to "KinematicViscosity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: KinematicViscosityUnit
        :return: KinematicViscosity unit value.
        :rtype: KinematicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> KinematicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> KinematicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: KinematicViscosity) -> typing.Tuple[KinematicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: KinematicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: KinematicViscosity) -> typing.Tuple[KinematicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: KinematicViscosity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> KinematicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> KinematicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: KinematicViscosityUnit) -> typing.Tuple[KinematicViscosityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: KinematicViscosityUnit) -> typing.Tuple[KinematicViscosityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: KinematicViscosityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: KinematicViscosity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: KinematicViscosity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: KinematicViscosity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another KinematicViscosity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: KinematicViscosity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current KinematicViscosity.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class LapseRate(ValueType, IQuantity[LapseRateUnit], IQuantity, IFormattable, IEquatable[LapseRate], IComparable, IComparable[LapseRate], IConvertible):
    """ Lapse rate is the rate at which Earth's atmospheric temperature decreases with an increase in altitude, or increases with the decrease in altitude.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LapseRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LapseRateUnit]

    MaxValue: typing.ClassVar[LapseRate]

    MinValue: typing.ClassVar[LapseRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LapseRateUnit]]

    Zero: typing.ClassVar[LapseRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LapseRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LapseRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelciusPerKilometer(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsiusPerKilometer"
        """
        pass

    def __init__(self, value: float, unit: LapseRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LapseRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LapseRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LapseRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LapseRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LapseRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelciusPerKilometer(degreescelciusperkilometer: QuantityValue) -> LapseRate:
        """ Creates a "LapseRate" from "Field DegreeCelsiusPerKilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LapseRateUnit) -> LapseRate:
        """ Dynamically convert from value and unit enum "LapseRateUnit" to "LapseRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LapseRateUnit
        :return: LapseRate unit value.
        :rtype: LapseRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LapseRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LapseRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LapseRate) -> typing.Tuple[LapseRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LapseRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LapseRate) -> typing.Tuple[LapseRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LapseRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LapseRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LapseRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LapseRateUnit) -> typing.Tuple[LapseRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LapseRateUnit) -> typing.Tuple[LapseRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LapseRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LapseRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LapseRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LapseRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LapseRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LapseRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LapseRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LapseRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LapseRateUnit) -> LapseRate:
        """ Converts this LapseRate to another LapseRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LapseRateUnit
        :return: A LapseRate with the specified unit.
        :rtype: LapseRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LapseRateUnit, unitConverter: UnitConverter) -> LapseRate:
        """ Converts this "LapseRate" to another "LapseRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LapseRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A LapseRate with the specified unit.
        :rtype: LapseRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LapseRate:
        """
        """
        pass


# noinspection PyPep8Naming
class Length(ValueType, IQuantity[LengthUnit], IQuantity, IFormattable, IEquatable[Length], IComparable, IComparable[Length], IConvertible):
    """ Many different units of length have been used around the world. The main units in modern use are U.S. customary units in the United States and the Metric system elsewhere. British Imperial units are still used for some purposes in the United Kingdom and some other countries. The metric system is sub-divided into SI and non-SI units.
    """

    @property
    def FeetInches(self) -> FeetInches:
        """ Converts the length to a customary feet/inches combination.
        """
        pass

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LengthUnit]

    MaxValue: typing.ClassVar[Length]

    MinValue: typing.ClassVar[Length]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LengthUnit]]

    Zero: typing.ClassVar[Length]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Angstroms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Angstrom"
        """
        pass

    @property
    def AstronomicalUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AstronomicalUnit"
        """
        pass

    @property
    def Centimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centimeter"
        """
        pass

    @property
    def Chains(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Chain"
        """
        pass

    @property
    def DataMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DataMile"
        """
        pass

    @property
    def Decameters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decameter"
        """
        pass

    @property
    def Decimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decimeter"
        """
        pass

    @property
    def DtpPicas(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DtpPica"
        """
        pass

    @property
    def DtpPoints(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DtpPoint"
        """
        pass

    @property
    def Fathoms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Fathom"
        """
        pass

    @property
    def Feet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Foot"
        """
        pass

    @property
    def Hands(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hand"
        """
        pass

    @property
    def Hectometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hectometer"
        """
        pass

    @property
    def Inches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Inch"
        """
        pass

    @property
    def KilolightYears(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilolightYear"
        """
        pass

    @property
    def Kilometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilometer"
        """
        pass

    @property
    def Kiloparsecs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kiloparsec"
        """
        pass

    @property
    def LightYears(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LightYear"
        """
        pass

    @property
    def MegalightYears(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegalightYear"
        """
        pass

    @property
    def Megaparsecs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megaparsec"
        """
        pass

    @property
    def Meters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Meter"
        """
        pass

    @property
    def Microinches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microinch"
        """
        pass

    @property
    def Micrometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Micrometer"
        """
        pass

    @property
    def Mils(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Mil"
        """
        pass

    @property
    def Miles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Mile"
        """
        pass

    @property
    def Millimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millimeter"
        """
        pass

    @property
    def Nanometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanometer"
        """
        pass

    @property
    def NauticalMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NauticalMile"
        """
        pass

    @property
    def Parsecs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Parsec"
        """
        pass

    @property
    def PrinterPicas(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PrinterPica"
        """
        pass

    @property
    def PrinterPoints(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PrinterPoint"
        """
        pass

    @property
    def Shackles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Shackle"
        """
        pass

    @property
    def SolarRadiuses(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SolarRadius"
        """
        pass

    @property
    def Twips(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Twip"
        """
        pass

    @property
    def UsSurveyFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsSurveyFoot"
        """
        pass

    @property
    def Yards(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Yard"
        """
        pass

    def __init__(self, value: float, unit: LengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDataMiles(datamiles: QuantityValue) -> Length:
        """ Creates a "Length" from "Field DataMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecameters(decameters: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Decameter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimeters(decimeters: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Decimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDtpPicas(dtppicas: QuantityValue) -> Length:
        """ Creates a "Length" from "Field DtpPica".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDtpPoints(dtppoints: QuantityValue) -> Length:
        """ Creates a "Length" from "Field DtpPoint".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFathoms(fathoms: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Fathom".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeet(feet: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Foot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHands(hands: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Hand".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectometers(hectometers: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Hectometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInches(inches: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Inch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolightYears(kilolightyears: QuantityValue) -> Length:
        """ Creates a "Length" from "Field KilolightYear".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometers(kilometers: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Kilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloparsecs(kiloparsecs: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Kiloparsec".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLightYears(lightyears: QuantityValue) -> Length:
        """ Creates a "Length" from "Field LightYear".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegalightYears(megalightyears: QuantityValue) -> Length:
        """ Creates a "Length" from "Field MegalightYear".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaparsecs(megaparsecs: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Megaparsec".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeters(meters: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Meter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroinches(microinches: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Microinch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometers(micrometers: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Micrometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMils(mils: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Mil".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMiles(miles: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Mile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimeters(millimeters: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Millimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometers(nanometers: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Nanometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNauticalMiles(nauticalmiles: QuantityValue) -> Length:
        """ Creates a "Length" from "Field NauticalMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromParsecs(parsecs: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Parsec".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPrinterPicas(printerpicas: QuantityValue) -> Length:
        """ Creates a "Length" from "Field PrinterPica".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPrinterPoints(printerpoints: QuantityValue) -> Length:
        """ Creates a "Length" from "Field PrinterPoint".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShackles(shackles: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Shackle".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarRadiuses(solarradiuses: QuantityValue) -> Length:
        """ Creates a "Length" from "Field SolarRadius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTwips(twips: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Twip".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeet(ussurveyfeet: QuantityValue) -> Length:
        """ Creates a "Length" from "Field UsSurveyFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYards(yards: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Yard".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LengthUnit) -> Length:
        """ Dynamically convert from value and unit enum "LengthUnit" to "Length".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LengthUnit
        :return: Length unit value.
        :rtype: Length
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Length:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Length:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Length) -> typing.Tuple[Length, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Length
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Length) -> typing.Tuple[Length, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Length
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LengthUnit) -> typing.Tuple[LengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LengthUnit) -> typing.Tuple[LengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Length) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Length) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Length, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Length within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Length
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Length.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LengthUnit) -> Length:
        """ Converts this Length to another Length with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LengthUnit
        :return: A Length with the specified unit.
        :rtype: Length
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LengthUnit, unitConverter: UnitConverter) -> Length:
        """ Converts this "Length" to another "Length" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LengthUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Length with the specified unit.
        :rtype: Length
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Length:
        """
        """
        pass

    def Inverse(self) -> ReciprocalLength:
        """Calculates the inverse of this unit.

        :return: The inverse of this unit as "ReciprocalLength".
        :rtype: ReciprocalLength
        """
        pass

    @staticmethod
    def FromFeetInches(feet: float, inches: float) -> Length:
        """ Get length from combination of feet and inches.
        """
        pass

    @staticmethod
    def ParseFeetInches(str: str, formatProvider: IFormatProvider) -> Length:
        """Special parsing of feet/inches strings, commonly used.
        2 feet 4 inches is sometimes denoted as 2′−4″, 2′ 4″, 2′4″, 2 ft 4 in.
        The apostrophe can be ′ and '.
        The double prime can be ″ and ".
        https://en.wikipedia.org/wiki/Foot_(unit)

        :param str:
        :type str: str
        :param formatProvider: Optionally specify the culture format numbers and localize unit abbreviations. Defaults to thread's culture.
        :type formatProvider: IFormatProvider
        :return: Parsed length.
        :rtype: Length
        """
        pass

    @staticmethod
    def TryParseFeetInches(str: str, result: Length, formatProvider: IFormatProvider) -> typing.Tuple[Length, bool]:
        """Special parsing of feet/inches strings, commonly used.
        2 feet 4 inches is sometimes denoted as 2′−4″, 2′ 4″, 2′4″, 2 ft 4 in.
        The apostrophe can be ′ and '.
        The double prime can be ″ and ".
        https://en.wikipedia.org/wiki/Foot_(unit)

        :param str:
        :type str: str
        :param result: Parsed length.
        :type result: Length
        :param formatProvider: Optionally specify the culture format numbers and localize unit abbreviations. Defaults to thread's culture.
        :type formatProvider: IFormatProvider
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAngstroms(angstroms: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Angstrom".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAstronomicalUnits(astronomicalunits: QuantityValue) -> Length:
        """ Creates a "Length" from "Field AstronomicalUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentimeters(centimeters: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Centimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromChains(chains: QuantityValue) -> Length:
        """ Creates a "Length" from "Field Chain".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class FeetInches:
    """ Representation of feet and inches, used to preserve the original values when constructing "Length" by
     "Function Double)" and later output them unaltered with "Function ToString".
    """

    @property
    def Feet(self) -> float:
        """ The feet value it was constructed with.
        """
        pass

    @property
    def Inches(self) -> float:
        """ The inches value it was constructed with.
        """
        pass

    def __init__(self, feet: float, inches: float) -> None:
        """ Construct from feet and inches.
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """
        """
        pass

    @typing.overload
    def ToString(self, cultureInfo: IFormatProvider) -> str:
        """ Outputs feet and inches on the format: {feetValue} {feetUnit} {inchesValue} {inchesUnit}

        :param cultureInfo: Optional culture to format number and localize unit abbreviations.
        If null, defaults to "Property CurrentUICulture".
        :type cultureInfo: IFormatProvider
        """
        pass

    def ToArchitecturalString(self, fractionDenominator: int) -> str:
        """ Outputs feet and inches on the format: {feetValue}' - {inchesValueIntegral}[ / {inchesValueFractional}]"
         The inches are rounded to the nearest fraction of the fractionDenominator argument and reduced over the greatest common divisor.
         The fractional inch value is omitted if the numerator is 0 after rounding, or if the provided denominator is 1.

        :param fractionDenominator: The maximum precision to express the rounded inch fraction part. Use 1 to round to nearest integer, with no fraction.
        :type fractionDenominator: int

        :exception ArgumentOutOfRangeException: Denominator for fractional inch must be greater than zero.
        """
        pass


# noinspection PyPep8Naming
class Level(ValueType, IQuantity[LevelUnit], IQuantity, IFormattable, IEquatable[Level], IComparable, IComparable[Level], IConvertible):
    """ Level is the logarithm of the ratio of a quantity Q to a reference value of that quantity, Q₀, expressed in dimensionless units.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LevelUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LevelUnit]

    MaxValue: typing.ClassVar[Level]

    MinValue: typing.ClassVar[Level]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LevelUnit]]

    Zero: typing.ClassVar[Level]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LevelUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LevelUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decibels(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decibel"
        """
        pass

    @property
    def Nepers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Neper"
        """
        pass

    def __init__(self, quantity: float, reference: float) -> None:
        """ Initializes a new instance of the logarithmic "Level" struct which is the ratio of a quantity Q to a
         reference value of that quantity Q0.

        :param quantity: The quantity.
        :type quantity: float
        :param reference: The reference value that is compared to.
        :type reference: float
        """
        pass

    def __init__(self, value: float, unit: LevelUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LevelUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LevelUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LevelUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LevelUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LevelUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecibels(decibels: QuantityValue) -> Level:
        """ Creates a "Level" from "Field Decibel".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNepers(nepers: QuantityValue) -> Level:
        """ Creates a "Level" from "Field Neper".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LevelUnit) -> Level:
        """ Dynamically convert from value and unit enum "LevelUnit" to "Level".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LevelUnit
        :return: Level unit value.
        :rtype: Level
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Level:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Level:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Level) -> typing.Tuple[Level, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Level
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Level) -> typing.Tuple[Level, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Level
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LevelUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LevelUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LevelUnit) -> typing.Tuple[LevelUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LevelUnit) -> typing.Tuple[LevelUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LevelUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Level) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Level) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Level, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Level within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Level
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Level.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LevelUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LevelUnit) -> Level:
        """ Converts this Level to another Level with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LevelUnit
        :return: A Level with the specified unit.
        :rtype: Level
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LevelUnit, unitConverter: UnitConverter) -> Level:
        """ Converts this "Level" to another "Level" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LevelUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Level with the specified unit.
        :rtype: Level
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Level:
        """
        """
        pass


# noinspection PyPep8Naming
class LinearDensity(ValueType, IQuantity[LinearDensityUnit], IQuantity, IFormattable, IEquatable[LinearDensity], IComparable, IComparable[LinearDensity], IConvertible):
    """ The Linear Density, or more precisely, the linear mass density, of a substance is its mass per unit length. The term linear density is most often used when describing the characteristics of one-dimensional objects, although linear density can also be used to describe the density of a three-dimensional quantity along one particular dimension.
     http://en.wikipedia.org/wiki/Linear_density
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LinearDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LinearDensityUnit]

    MaxValue: typing.ClassVar[LinearDensity]

    MinValue: typing.ClassVar[LinearDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LinearDensityUnit]]

    Zero: typing.ClassVar[LinearDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LinearDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LinearDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCentimeter"
        """
        pass

    @property
    def GramsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerMeter"
        """
        pass

    @property
    def GramsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerMillimeter"
        """
        pass

    @property
    def KilogramsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCentimeter"
        """
        pass

    @property
    def KilogramsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerMeter"
        """
        pass

    @property
    def KilogramsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerMillimeter"
        """
        pass

    @property
    def MicrogramsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerCentimeter"
        """
        pass

    @property
    def MicrogramsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerMeter"
        """
        pass

    @property
    def MicrogramsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerMillimeter"
        """
        pass

    @property
    def MilligramsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerCentimeter"
        """
        pass

    @property
    def MilligramsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerMeter"
        """
        pass

    @property
    def MilligramsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerMillimeter"
        """
        pass

    @property
    def PoundsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerFoot"
        """
        pass

    @property
    def PoundsPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerInch"
        """
        pass

    def __init__(self, value: float, unit: LinearDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LinearDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LinearDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LinearDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LinearDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LinearDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LinearDensityUnit) -> LinearDensity:
        """ Converts this LinearDensity to another LinearDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LinearDensityUnit
        :return: A LinearDensity with the specified unit.
        :rtype: LinearDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LinearDensityUnit, unitConverter: UnitConverter) -> LinearDensity:
        """ Converts this "LinearDensity" to another "LinearDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LinearDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A LinearDensity with the specified unit.
        :rtype: LinearDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LinearDensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerCentimeter(gramspercentimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field GramPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMeter(gramspermeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field GramPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMillimeter(gramspermillimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field GramPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCentimeter(kilogramspercentimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field KilogramPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMeter(kilogramspermeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field KilogramPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMillimeter(kilogramspermillimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field KilogramPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerCentimeter(microgramspercentimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field MicrogramPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMeter(microgramspermeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field MicrogramPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMillimeter(microgramspermillimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field MicrogramPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerCentimeter(milligramspercentimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field MilligramPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMeter(milligramspermeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field MilligramPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMillimeter(milligramspermillimeter: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field MilligramPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerFoot(poundsperfoot: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field PoundPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerInch(poundsperinch: QuantityValue) -> LinearDensity:
        """ Creates a "LinearDensity" from "Field PoundPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LinearDensityUnit) -> LinearDensity:
        """ Dynamically convert from value and unit enum "LinearDensityUnit" to "LinearDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LinearDensityUnit
        :return: LinearDensity unit value.
        :rtype: LinearDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LinearDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LinearDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LinearDensity) -> typing.Tuple[LinearDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LinearDensity) -> typing.Tuple[LinearDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LinearDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LinearDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LinearDensityUnit) -> typing.Tuple[LinearDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LinearDensityUnit) -> typing.Tuple[LinearDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LinearDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LinearDensity) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class Luminance(ValueType, IQuantity[LuminanceUnit], IQuantity, IFormattable, IEquatable[Luminance], IComparable, IComparable[Luminance], IConvertible):
    """ Luminance is a photometric measure of the luminous intensity per unit area of light travelling in a given direction.
     https://en.wikipedia.org/wiki/Luminance
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LuminanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminanceUnit]

    MaxValue: typing.ClassVar[Luminance]

    MinValue: typing.ClassVar[Luminance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminanceUnit]]

    Zero: typing.ClassVar[Luminance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CandelasPerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CandelaPerSquareFoot"
        """
        pass

    @property
    def CandelasPerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CandelaPerSquareInch"
        """
        pass

    @property
    def CandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CandelaPerSquareMeter"
        """
        pass

    @property
    def CenticandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CenticandelaPerSquareMeter"
        """
        pass

    @property
    def DecicandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecicandelaPerSquareMeter"
        """
        pass

    @property
    def KilocandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocandelaPerSquareMeter"
        """
        pass

    @property
    def MicrocandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrocandelaPerSquareMeter"
        """
        pass

    @property
    def MillicandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillicandelaPerSquareMeter"
        """
        pass

    @property
    def NanocandelasPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanocandelaPerSquareMeter"
        """
        pass

    @property
    def Nits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nit"
        """
        pass

    def __init__(self, value: float, unit: LuminanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminanceUnit) -> Luminance:
        """ Converts this Luminance to another Luminance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminanceUnit
        :return: A Luminance with the specified unit.
        :rtype: Luminance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminanceUnit, unitConverter: UnitConverter) -> Luminance:
        """ Converts this "Luminance" to another "Luminance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Luminance with the specified unit.
        :rtype: Luminance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Luminance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCandelasPerSquareFoot(candelaspersquarefoot: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field CandelaPerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCandelasPerSquareInch(candelaspersquareinch: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field CandelaPerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCandelasPerSquareMeter(candelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field CandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCenticandelasPerSquareMeter(centicandelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field CenticandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecicandelasPerSquareMeter(decicandelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field DecicandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocandelasPerSquareMeter(kilocandelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field KilocandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrocandelasPerSquareMeter(microcandelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field MicrocandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillicandelasPerSquareMeter(millicandelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field MillicandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanocandelasPerSquareMeter(nanocandelaspersquaremeter: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field NanocandelaPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNits(nits: QuantityValue) -> Luminance:
        """ Creates a "Luminance" from "Field Nit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminanceUnit) -> Luminance:
        """ Dynamically convert from value and unit enum "LuminanceUnit" to "Luminance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminanceUnit
        :return: Luminance unit value.
        :rtype: Luminance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Luminance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Luminance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Luminance) -> typing.Tuple[Luminance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Luminance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Luminance) -> typing.Tuple[Luminance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Luminance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminanceUnit) -> typing.Tuple[LuminanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminanceUnit) -> typing.Tuple[LuminanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Luminance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Luminance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Luminance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Luminance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Luminance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Luminance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass


# noinspection PyPep8Naming
class LuminousIntensity(ValueType, IQuantity[LuminousIntensityUnit], IQuantity, IFormattable, IEquatable[LuminousIntensity], IComparable, IComparable[LuminousIntensity], IConvertible):
    """ In photometry, luminous intensity is a measure of the wavelength-weighted power emitted by a light source in a particular direction per unit solid angle, based on the luminosity function, a standardized model of the sensitivity of the human eye.
     https://en.wikipedia.org/wiki/Luminous_intensity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LuminousIntensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminousIntensityUnit]

    MaxValue: typing.ClassVar[LuminousIntensity]

    MinValue: typing.ClassVar[LuminousIntensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminousIntensityUnit]]

    Zero: typing.ClassVar[LuminousIntensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminousIntensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminousIntensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Candela(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Candela"
        """
        pass

    def __init__(self, value: float, unit: LuminousIntensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminousIntensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousIntensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousIntensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousIntensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousIntensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCandela(candela: QuantityValue) -> LuminousIntensity:
        """ Creates a "LuminousIntensity" from "Field Candela".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminousIntensityUnit) -> LuminousIntensity:
        """ Dynamically convert from value and unit enum "LuminousIntensityUnit" to "LuminousIntensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminousIntensityUnit
        :return: LuminousIntensity unit value.
        :rtype: LuminousIntensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LuminousIntensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LuminousIntensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LuminousIntensity) -> typing.Tuple[LuminousIntensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousIntensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LuminousIntensity) -> typing.Tuple[LuminousIntensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousIntensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminousIntensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminousIntensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminousIntensityUnit) -> typing.Tuple[LuminousIntensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminousIntensityUnit) -> typing.Tuple[LuminousIntensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminousIntensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LuminousIntensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousIntensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousIntensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LuminousIntensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LuminousIntensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LuminousIntensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminousIntensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminousIntensityUnit) -> LuminousIntensity:
        """ Converts this LuminousIntensity to another LuminousIntensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminousIntensityUnit
        :return: A LuminousIntensity with the specified unit.
        :rtype: LuminousIntensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminousIntensityUnit, unitConverter: UnitConverter) -> LuminousIntensity:
        """ Converts this "LuminousIntensity" to another "LuminousIntensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminousIntensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A LuminousIntensity with the specified unit.
        :rtype: LuminousIntensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LuminousIntensity:
        """
        """
        pass


# noinspection PyPep8Naming
class Mass(ValueType, IQuantity[MassUnit], IQuantity, IFormattable, IEquatable[Mass], IComparable, IComparable[Mass], IConvertible):
    """ In physics, mass (from Greek μᾶζα "barley cake, lump [of dough]") is a property of a physical system or body, giving rise to the phenomena of the body's resistance to being accelerated by a force and the strength of its mutual gravitational attraction with other bodies. Instruments such as mass balances or scales use those phenomena to measure mass. The SI unit of mass is the kilogram (kg).
    """

    @property
    def StonePounds(self) -> StonePounds:
        """ Converts the mass to a customary stone/pounds combination.
        """
        pass

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MassUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassUnit]

    MaxValue: typing.ClassVar[Mass]

    MinValue: typing.ClassVar[Mass]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassUnit]]

    Zero: typing.ClassVar[Mass]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centigrams(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centigram"
        """
        pass

    @property
    def Decagrams(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decagram"
        """
        pass

    @property
    def Decigrams(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decigram"
        """
        pass

    @property
    def EarthMasses(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field EarthMass"
        """
        pass

    @property
    def Grains(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Grain"
        """
        pass

    @property
    def Grams(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gram"
        """
        pass

    @property
    def Hectograms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hectogram"
        """
        pass

    @property
    def Kilograms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilogram"
        """
        pass

    @property
    def Kilopounds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilopound"
        """
        pass

    @property
    def Kilotonnes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilotonne"
        """
        pass

    @property
    def LongHundredweight(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LongHundredweight"
        """
        pass

    @property
    def LongTons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LongTon"
        """
        pass

    @property
    def Megapounds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megapound"
        """
        pass

    @property
    def Megatonnes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megatonne"
        """
        pass

    @property
    def Micrograms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microgram"
        """
        pass

    @property
    def Milligrams(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milligram"
        """
        pass

    @property
    def Nanograms(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanogram"
        """
        pass

    @property
    def Ounces(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Ounce"
        """
        pass

    @property
    def Pounds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Pound"
        """
        pass

    @property
    def ShortHundredweight(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ShortHundredweight"
        """
        pass

    @property
    def ShortTons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ShortTon"
        """
        pass

    @property
    def Slugs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Slug"
        """
        pass

    @property
    def SolarMasses(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SolarMass"
        """
        pass

    @property
    def Stone(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Stone"
        """
        pass

    @property
    def Tonnes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Tonne"
        """
        pass

    def __init__(self, value: float, unit: MassUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromShortTons(shorttons: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field ShortTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugs(slugs: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Slug".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarMasses(solarmasses: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field SolarMass".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStone(stone: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Stone".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnes(tonnes: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Tonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassUnit) -> Mass:
        """ Dynamically convert from value and unit enum "MassUnit" to "Mass".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassUnit
        :return: Mass unit value.
        :rtype: Mass
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Mass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Mass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Mass) -> typing.Tuple[Mass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Mass
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Mass) -> typing.Tuple[Mass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Mass
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassUnit) -> typing.Tuple[MassUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassUnit) -> typing.Tuple[MassUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Mass) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Mass) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Mass, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Mass within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Mass
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Mass.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassUnit) -> Mass:
        """ Converts this Mass to another Mass with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassUnit
        :return: A Mass with the specified unit.
        :rtype: Mass
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassUnit, unitConverter: UnitConverter) -> Mass:
        """ Converts this "Mass" to another "Mass" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Mass with the specified unit.
        :rtype: Mass
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Mass:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGravitationalForce(f: Force) -> Mass:
        """Get "Mass" from "Force" of gravity.
        """
        pass

    @staticmethod
    def FromStonePounds(stone: float, pounds: float) -> Mass:
        """ Get Mass from combination of stone and pounds.
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigrams(centigrams: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Centigram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagrams(decagrams: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Decagram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigrams(decigrams: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Decigram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromEarthMasses(earthmasses: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field EarthMass".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGrains(grains: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Grain".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGrams(grams: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Gram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectograms(hectograms: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Hectogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilograms(kilograms: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Kilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopounds(kilopounds: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Kilopound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonnes(kilotonnes: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Kilotonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLongHundredweight(longhundredweight: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field LongHundredweight".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLongTons(longtons: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field LongTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapounds(megapounds: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Megapound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonnes(megatonnes: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Megatonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrograms(micrograms: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Microgram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligrams(milligrams: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Milligram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanograms(nanograms: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Nanogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOunces(ounces: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Ounce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPounds(pounds: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field Pound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortHundredweight(shorthundredweight: QuantityValue) -> Mass:
        """ Creates a "Mass" from "Field ShortHundredweight".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class StonePounds:
    """ Representation of stone and pounds, used to preserve the original values when constructing "Mass" by
     "Function Double)" and later output them unaltered with "Function ToString".
    """

    @property
    def Stone(self) -> float:
        """ The stone value it was created with.
        """
        pass

    @property
    def Pounds(self) -> float:
        """ The pounds value it was created with.
        """
        pass

    def __init__(self, stone: float, pounds: float) -> None:
        """ Construct from stone and pounds.
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """
        """
        pass

    @typing.overload
    def ToString(self, cultureInfo: IFormatProvider) -> str:
        """ Outputs stone and pounds on the format: {stoneValue} {stoneUnit} {poundsValue} {poundsUnit}

        :param cultureInfo: Optional culture to format number and localize unit abbreviations.
        If null, defaults to "Property CurrentUICulture".
        :type cultureInfo: IFormatProvider
        """
        pass


# noinspection PyPep8Naming
class MassConcentration(ValueType, IQuantity[MassConcentrationUnit], IQuantity, IFormattable, IEquatable[MassConcentration], IComparable, IComparable[MassConcentration], IConvertible):
    """ In chemistry, the mass concentration ρi (or γi) is defined as the mass of a constituent mi divided by the volume of the mixture V
     https://en.wikipedia.org/wiki/Mass_concentration_(chemistry)
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MassConcentrationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassConcentrationUnit]

    MaxValue: typing.ClassVar[MassConcentration]

    MinValue: typing.ClassVar[MassConcentration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassConcentrationUnit]]

    Zero: typing.ClassVar[MassConcentration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassConcentrationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassConcentrationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerDeciliter"
        """
        pass

    @property
    def CentigramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerLiter"
        """
        pass

    @property
    def CentigramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerMicroliter"
        """
        pass

    @property
    def CentigramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerMilliliter"
        """
        pass

    @property
    def DecigramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerDeciliter"
        """
        pass

    @property
    def DecigramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerLiter"
        """
        pass

    @property
    def DecigramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerMicroliter"
        """
        pass

    @property
    def DecigramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerMilliliter"
        """
        pass

    @property
    def GramsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicCentimeter"
        """
        pass

    @property
    def GramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicMeter"
        """
        pass

    @property
    def GramsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerCubicMillimeter"
        """
        pass

    @property
    def GramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerDeciliter"
        """
        pass

    @property
    def GramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerLiter"
        """
        pass

    @property
    def GramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerMicroliter"
        """
        pass

    @property
    def GramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerMilliliter"
        """
        pass

    @property
    def KilogramsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCubicCentimeter"
        """
        pass

    @property
    def KilogramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCubicMeter"
        """
        pass

    @property
    def KilogramsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerCubicMillimeter"
        """
        pass

    @property
    def KilogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerLiter"
        """
        pass

    @property
    def KilopoundsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundPerCubicFoot"
        """
        pass

    @property
    def KilopoundsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundPerCubicInch"
        """
        pass

    @property
    def MicrogramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerCubicMeter"
        """
        pass

    @property
    def MicrogramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerDeciliter"
        """
        pass

    @property
    def MicrogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerLiter"
        """
        pass

    @property
    def MicrogramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerMicroliter"
        """
        pass

    @property
    def MicrogramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerMilliliter"
        """
        pass

    @property
    def MilligramsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerCubicMeter"
        """
        pass

    @property
    def MilligramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerDeciliter"
        """
        pass

    @property
    def MilligramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerLiter"
        """
        pass

    @property
    def MilligramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerMicroliter"
        """
        pass

    @property
    def MilligramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerMilliliter"
        """
        pass

    @property
    def NanogramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerDeciliter"
        """
        pass

    @property
    def NanogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerLiter"
        """
        pass

    @property
    def NanogramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerMicroliter"
        """
        pass

    @property
    def NanogramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerMilliliter"
        """
        pass

    @property
    def OuncesPerImperialGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OuncePerImperialGallon"
        """
        pass

    @property
    def OuncesPerUSGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OuncePerUSGallon"
        """
        pass

    @property
    def PicogramsPerDeciliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerDeciliter"
        """
        pass

    @property
    def PicogramsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerLiter"
        """
        pass

    @property
    def PicogramsPerMicroliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerMicroliter"
        """
        pass

    @property
    def PicogramsPerMilliliter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicogramPerMilliliter"
        """
        pass

    @property
    def PoundsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicFoot"
        """
        pass

    @property
    def PoundsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerCubicInch"
        """
        pass

    @property
    def PoundsPerImperialGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerImperialGallon"
        """
        pass

    @property
    def PoundsPerUSGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerUSGallon"
        """
        pass

    @property
    def SlugsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugPerCubicFoot"
        """
        pass

    @property
    def TonnesPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicCentimeter"
        """
        pass

    @property
    def TonnesPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicMeter"
        """
        pass

    @property
    def TonnesPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerCubicMillimeter"
        """
        pass

    def __init__(self, value: float, unit: MassConcentrationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassConcentrationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassConcentrationUnit) -> MassConcentration:
        """ Converts this MassConcentration to another MassConcentration with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassConcentrationUnit
        :return: A MassConcentration with the specified unit.
        :rtype: MassConcentration
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassConcentrationUnit, unitConverter: UnitConverter) -> MassConcentration:
        """ Converts this "MassConcentration" to another "MassConcentration" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassConcentrationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MassConcentration with the specified unit.
        :rtype: MassConcentration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassConcentration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassConcentrationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassConcentrationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassConcentrationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassConcentrationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerDeciliter(centigramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field CentigramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerLiter(centigramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field CentigramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerMicroliter(centigramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field CentigramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerMilliliter(centigramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field CentigramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerDeciliter(decigramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field DecigramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerLiter(decigramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field DecigramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMicroliter(decigramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field DecigramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMilliliter(decigramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field DecigramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicCentimeter(gramspercubiccentimeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMeter(gramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMillimeter(gramspercubicmillimeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerDeciliter(gramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerLiter(gramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMicroliter(gramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMilliliter(gramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field GramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicCentimeter(kilogramspercubiccentimeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field KilogramPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMeter(kilogramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field KilogramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMillimeter(kilogramspercubicmillimeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field KilogramPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerLiter(kilogramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field KilogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicFoot(kilopoundspercubicfoot: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field KilopoundPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicInch(kilopoundspercubicinch: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field KilopoundPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerCubicMeter(microgramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MicrogramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerDeciliter(microgramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MicrogramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerLiter(microgramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MicrogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMicroliter(microgramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MicrogramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMilliliter(microgramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MicrogramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerCubicMeter(milligramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MilligramPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerDeciliter(milligramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MilligramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerLiter(milligramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MilligramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMicroliter(milligramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MilligramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMilliliter(milligramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field MilligramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerDeciliter(nanogramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field NanogramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerLiter(nanogramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field NanogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMicroliter(nanogramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field NanogramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMilliliter(nanogramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field NanogramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOuncesPerImperialGallon(ouncesperimperialgallon: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field OuncePerImperialGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOuncesPerUSGallon(ouncesperusgallon: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field OuncePerUSGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerDeciliter(picogramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PicogramPerDeciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerLiter(picogramsperliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PicogramPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerMicroliter(picogramspermicroliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PicogramPerMicroliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerMilliliter(picogramspermilliliter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PicogramPerMilliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicFoot(poundspercubicfoot: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PoundPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicInch(poundspercubicinch: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PoundPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerImperialGallon(poundsperimperialgallon: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PoundPerImperialGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerUSGallon(poundsperusgallon: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field PoundPerUSGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicFoot(slugspercubicfoot: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field SlugPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicCentimeter(tonnespercubiccentimeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field TonnePerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMeter(tonnespercubicmeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field TonnePerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMillimeter(tonnespercubicmillimeter: QuantityValue) -> MassConcentration:
        """ Creates a "MassConcentration" from "Field TonnePerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassConcentrationUnit) -> MassConcentration:
        """ Dynamically convert from value and unit enum "MassConcentrationUnit" to "MassConcentration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassConcentrationUnit
        :return: MassConcentration unit value.
        :rtype: MassConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassConcentration) -> typing.Tuple[MassConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassConcentration) -> typing.Tuple[MassConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassConcentration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassConcentrationUnit) -> typing.Tuple[MassConcentrationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassConcentrationUnit) -> typing.Tuple[MassConcentrationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassConcentrationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassConcentration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassConcentration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassConcentration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassConcentration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassConcentration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassConcentration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassConcentrationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    def ToMolarity(self, molecularWeight: MolarMass) -> Molarity:
        """ Get "Molarity" from this "MassConcentration" using the known component "MolarMass".

        :param molecularWeight:
        :type molecularWeight: MolarMass
        """
        pass

    def ToVolumeConcentration(self, componentDensity: Density) -> VolumeConcentration:
        """ Get "VolumeConcentration" from this "MassConcentration" using the known component "Density".

        :param componentDensity:
        :type componentDensity: Density
        :return:
        :rtype: VolumeConcentration
        """
        pass

    @staticmethod
    def FromMolarity(molarity: Molarity, mass: MolarMass) -> MassConcentration:
        """ Get "MassConcentration" from "Molarity".
        """
        pass

    @staticmethod
    def FromVolumeConcentration(volumeConcentration: VolumeConcentration, componentDensity: Density) -> MassConcentration:
        """ Get "MassConcentration" from "VolumeConcentration" and component "Density".
        """
        pass


# noinspection PyPep8Naming
class MassFlow(ValueType, IQuantity[MassFlowUnit], IQuantity, IFormattable, IEquatable[MassFlow], IComparable, IComparable[MassFlow], IConvertible):
    """ Mass flow is the ratio of the mass change to the time during which the change occurred (value of mass changes per unit time).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MassFlowUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassFlowUnit]

    MaxValue: typing.ClassVar[MassFlow]

    MinValue: typing.ClassVar[MassFlow]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassFlowUnit]]

    Zero: typing.ClassVar[MassFlow]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassFlowUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassFlowUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerDay"
        """
        pass

    @property
    def CentigramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerSecond"
        """
        pass

    @property
    def DecagramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecagramPerDay"
        """
        pass

    @property
    def DecagramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecagramPerSecond"
        """
        pass

    @property
    def DecigramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerDay"
        """
        pass

    @property
    def DecigramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerSecond"
        """
        pass

    @property
    def GramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerDay"
        """
        pass

    @property
    def GramsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerHour"
        """
        pass

    @property
    def GramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerSecond"
        """
        pass

    @property
    def HectogramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectogramPerDay"
        """
        pass

    @property
    def HectogramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectogramPerSecond"
        """
        pass

    @property
    def KilogramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerDay"
        """
        pass

    @property
    def KilogramsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerHour"
        """
        pass

    @property
    def KilogramsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerMinute"
        """
        pass

    @property
    def KilogramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerSecond"
        """
        pass

    @property
    def MegagramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegagramPerDay"
        """
        pass

    @property
    def MegapoundsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundPerDay"
        """
        pass

    @property
    def MegapoundsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundPerHour"
        """
        pass

    @property
    def MegapoundsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundPerMinute"
        """
        pass

    @property
    def MegapoundsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundPerSecond"
        """
        pass

    @property
    def MicrogramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerDay"
        """
        pass

    @property
    def MicrogramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerSecond"
        """
        pass

    @property
    def MilligramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerDay"
        """
        pass

    @property
    def MilligramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerSecond"
        """
        pass

    @property
    def NanogramsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerDay"
        """
        pass

    @property
    def NanogramsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerSecond"
        """
        pass

    @property
    def PoundsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerDay"
        """
        pass

    @property
    def PoundsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerHour"
        """
        pass

    @property
    def PoundsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerMinute"
        """
        pass

    @property
    def PoundsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerSecond"
        """
        pass

    @property
    def ShortTonsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ShortTonPerHour"
        """
        pass

    @property
    def TonnesPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerDay"
        """
        pass

    @property
    def TonnesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonnePerHour"
        """
        pass

    def __init__(self, value: float, unit: MassFlowUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassFlowUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromKilogramsPerDay(kilogramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field KilogramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHour(kilogramsperhour: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field KilogramPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMinute(kilogramsperminute: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field KilogramPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecond(kilogramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field KilogramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegagramsPerDay(megagramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MegagramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerDay(megapoundsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MegapoundPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerHour(megapoundsperhour: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MegapoundPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerMinute(megapoundsperminute: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MegapoundPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerSecond(megapoundspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MegapoundPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerDay(microgramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MicrogramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerSecond(microgramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MicrogramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerDay(milligramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MilligramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerSecond(milligramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field MilligramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerDay(nanogramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field NanogramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerSecond(nanogramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field NanogramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerDay(poundsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field PoundPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerHour(poundsperhour: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field PoundPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerMinute(poundsperminute: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field PoundPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerSecond(poundspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field PoundPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortTonsPerHour(shorttonsperhour: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field ShortTonPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerDay(tonnesperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field TonnePerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerHour(tonnesperhour: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field TonnePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassFlowUnit) -> MassFlow:
        """ Dynamically convert from value and unit enum "MassFlowUnit" to "MassFlow".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassFlowUnit
        :return: MassFlow unit value.
        :rtype: MassFlow
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassFlow) -> typing.Tuple[MassFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlow
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassFlow) -> typing.Tuple[MassFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlow
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassFlowUnit) -> typing.Tuple[MassFlowUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassFlowUnit) -> typing.Tuple[MassFlowUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassFlowUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassFlow) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlow) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlow, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassFlow within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassFlow
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassFlow.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassFlowUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFlowUnit) -> MassFlow:
        """ Converts this MassFlow to another MassFlow with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassFlowUnit
        :return: A MassFlow with the specified unit.
        :rtype: MassFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFlowUnit, unitConverter: UnitConverter) -> MassFlow:
        """ Converts this "MassFlow" to another "MassFlow" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassFlowUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MassFlow with the specified unit.
        :rtype: MassFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassFlow:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFlowUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFlowUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFlowUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFlowUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerDay(centigramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field CentigramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerSecond(centigramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field CentigramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerDay(decagramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field DecagramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerSecond(decagramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field DecagramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerDay(decigramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field DecigramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerSecond(decigramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field DecigramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerDay(gramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field GramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerHour(gramsperhour: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field GramPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecond(gramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field GramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerDay(hectogramsperday: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field HectogramPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerSecond(hectogramspersecond: QuantityValue) -> MassFlow:
        """ Creates a "MassFlow" from "Field HectogramPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class MassFlux(ValueType, IQuantity[MassFluxUnit], IQuantity, IFormattable, IEquatable[MassFlux], IComparable, IComparable[MassFlux], IConvertible):
    """ Mass flux is the mass flow rate per unit area.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MassFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassFluxUnit]

    MaxValue: typing.ClassVar[MassFlux]

    MinValue: typing.ClassVar[MassFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassFluxUnit]]

    Zero: typing.ClassVar[MassFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerHourPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerHourPerSquareCentimeter"
        """
        pass

    @property
    def GramsPerHourPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerHourPerSquareMeter"
        """
        pass

    @property
    def GramsPerHourPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerHourPerSquareMillimeter"
        """
        pass

    @property
    def GramsPerSecondPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerSecondPerSquareCentimeter"
        """
        pass

    @property
    def GramsPerSecondPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerSecondPerSquareMeter"
        """
        pass

    @property
    def GramsPerSecondPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerSecondPerSquareMillimeter"
        """
        pass

    @property
    def KilogramsPerHourPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerHourPerSquareCentimeter"
        """
        pass

    @property
    def KilogramsPerHourPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerHourPerSquareMeter"
        """
        pass

    @property
    def KilogramsPerHourPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerHourPerSquareMillimeter"
        """
        pass

    @property
    def KilogramsPerSecondPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerSecondPerSquareCentimeter"
        """
        pass

    @property
    def KilogramsPerSecondPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerSecondPerSquareMeter"
        """
        pass

    @property
    def KilogramsPerSecondPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerSecondPerSquareMillimeter"
        """
        pass

    def __init__(self, value: float, unit: MassFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFluxUnit) -> MassFlux:
        """ Converts this MassFlux to another MassFlux with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassFluxUnit
        :return: A MassFlux with the specified unit.
        :rtype: MassFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFluxUnit, unitConverter: UnitConverter) -> MassFlux:
        """ Converts this "MassFlux" to another "MassFlux" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassFluxUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MassFlux with the specified unit.
        :rtype: MassFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassFlux:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerHourPerSquareCentimeter(gramsperhourpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field GramPerHourPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerHourPerSquareMeter(gramsperhourpersquaremeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field GramPerHourPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerHourPerSquareMillimeter(gramsperhourpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field GramPerHourPerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecondPerSquareCentimeter(gramspersecondpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field GramPerSecondPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecondPerSquareMeter(gramspersecondpersquaremeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field GramPerSecondPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecondPerSquareMillimeter(gramspersecondpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field GramPerSecondPerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHourPerSquareCentimeter(kilogramsperhourpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field KilogramPerHourPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHourPerSquareMeter(kilogramsperhourpersquaremeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field KilogramPerHourPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHourPerSquareMillimeter(kilogramsperhourpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field KilogramPerHourPerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecondPerSquareCentimeter(kilogramspersecondpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field KilogramPerSecondPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecondPerSquareMeter(kilogramspersecondpersquaremeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field KilogramPerSecondPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecondPerSquareMillimeter(kilogramspersecondpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Creates a "MassFlux" from "Field KilogramPerSecondPerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassFluxUnit) -> MassFlux:
        """ Dynamically convert from value and unit enum "MassFluxUnit" to "MassFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassFluxUnit
        :return: MassFlux unit value.
        :rtype: MassFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassFlux) -> typing.Tuple[MassFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassFlux) -> typing.Tuple[MassFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassFluxUnit) -> typing.Tuple[MassFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassFluxUnit) -> typing.Tuple[MassFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class MassFraction(ValueType, IQuantity[MassFractionUnit], IQuantity, IFormattable, IEquatable[MassFraction], IComparable, IComparable[MassFraction], IConvertible):
    """ The mass fraction is defined as the mass of a constituent divided by the total mass of the mixture.
     https://en.wikipedia.org/wiki/Mass_fraction_(chemistry)
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MassFractionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassFractionUnit]

    MaxValue: typing.ClassVar[MassFraction]

    MinValue: typing.ClassVar[MassFraction]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassFractionUnit]]

    Zero: typing.ClassVar[MassFraction]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassFractionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassFractionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerGram"
        """
        pass

    @property
    def CentigramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerKilogram"
        """
        pass

    @property
    def DecagramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecagramPerGram"
        """
        pass

    @property
    def DecagramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecagramPerKilogram"
        """
        pass

    @property
    def DecigramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerGram"
        """
        pass

    @property
    def DecigramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerKilogram"
        """
        pass

    @property
    def DecimalFractions(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimalFraction"
        """
        pass

    @property
    def GramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerGram"
        """
        pass

    @property
    def GramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerKilogram"
        """
        pass

    @property
    def HectogramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectogramPerGram"
        """
        pass

    @property
    def HectogramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectogramPerKilogram"
        """
        pass

    @property
    def KilogramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerGram"
        """
        pass

    @property
    def KilogramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerKilogram"
        """
        pass

    @property
    def MicrogramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerGram"
        """
        pass

    @property
    def MicrogramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerKilogram"
        """
        pass

    @property
    def MilligramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerGram"
        """
        pass

    @property
    def MilligramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerKilogram"
        """
        pass

    @property
    def NanogramsPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerGram"
        """
        pass

    @property
    def NanogramsPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerKilogram"
        """
        pass

    @property
    def PartsPerBillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerBillion"
        """
        pass

    @property
    def PartsPerMillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerMillion"
        """
        pass

    @property
    def PartsPerThousand(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerThousand"
        """
        pass

    @property
    def PartsPerTrillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerTrillion"
        """
        pass

    @property
    def Percent(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Percent"
        """
        pass

    def __init__(self, value: float, unit: MassFractionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassFractionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassFraction:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassFraction:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassFraction) -> typing.Tuple[MassFraction, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFraction
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassFraction) -> typing.Tuple[MassFraction, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFraction
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassFractionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassFractionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassFractionUnit) -> typing.Tuple[MassFractionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassFractionUnit) -> typing.Tuple[MassFractionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassFractionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassFraction) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFraction) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFraction, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassFraction within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassFraction
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassFraction.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassFractionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFractionUnit) -> MassFraction:
        """ Converts this MassFraction to another MassFraction with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassFractionUnit
        :return: A MassFraction with the specified unit.
        :rtype: MassFraction
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFractionUnit, unitConverter: UnitConverter) -> MassFraction:
        """ Converts this "MassFraction" to another "MassFraction" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassFractionUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MassFraction with the specified unit.
        :rtype: MassFraction
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassFraction:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def GetComponentMass(self, totalMass: Mass) -> Mass:
        """Get the "Mass" of the component by multiplying the "Mass" of the mixture and this "MassFraction".

        :param totalMass: The total mass of the mixture
        :type totalMass: Mass
        :return: The actual mass of the component involved in this mixture
        :rtype: Mass
        """
        pass

    def GetTotalMass(self, componentMass: Mass) -> Mass:
        """Get the total "Mass" of the mixture by dividing the "Mass" of the component by this "MassFraction"

        :param componentMass: The actual mass of the component involved in this mixture
        :type componentMass: Mass
        :return: The total mass of the mixture
        :rtype: Mass
        """
        pass

    @staticmethod
    def FromMasses(componentMass: Mass, mixtureMass: Mass) -> MassFraction:
        """ Get "MassFraction" from a component "Mass" and total mixture "Mass" .
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFractionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFractionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFractionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFractionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerGram(centigramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field CentigramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerKilogram(centigramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field CentigramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerGram(decagramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field DecagramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerKilogram(decagramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field DecagramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerGram(decigramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field DecigramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerKilogram(decigramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field DecigramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimalFractions(decimalfractions: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field DecimalFraction".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerGram(gramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field GramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerKilogram(gramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field GramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerGram(hectogramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field HectogramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerKilogram(hectogramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field HectogramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerGram(kilogramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field KilogramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerKilogram(kilogramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field KilogramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerGram(microgramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field MicrogramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerKilogram(microgramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field MicrogramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerGram(milligramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field MilligramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerKilogram(milligramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field MilligramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerGram(nanogramspergram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field NanogramPerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerKilogram(nanogramsperkilogram: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field NanogramPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerBillion(partsperbillion: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field PartPerBillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerMillion(partspermillion: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field PartPerMillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerThousand(partsperthousand: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field PartPerThousand".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerTrillion(partspertrillion: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field PartPerTrillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> MassFraction:
        """ Creates a "MassFraction" from "Field Percent".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassFractionUnit) -> MassFraction:
        """ Dynamically convert from value and unit enum "MassFractionUnit" to "MassFraction".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassFractionUnit
        :return: MassFraction unit value.
        :rtype: MassFraction
        """
        pass


# noinspection PyPep8Naming
class Molarity(ValueType, IQuantity[MolarityUnit], IQuantity, IFormattable, IEquatable[Molarity], IComparable, IComparable[Molarity], IConvertible):
    """ Molar concentration, also called molarity, amount concentration or substance concentration, is a measure of the concentration of a solute in a solution, or of any chemical species, in terms of amount of substance in a given volume.
     https://en.wikipedia.org/wiki/Molar_concentration
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MolarityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarityUnit]

    MaxValue: typing.ClassVar[Molarity]

    MinValue: typing.ClassVar[Molarity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarityUnit]]

    Zero: typing.ClassVar[Molarity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimolePerLiter"
        """
        pass

    @property
    def DecimolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimolePerLiter"
        """
        pass

    @property
    def FemtomolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FemtomolePerLiter"
        """
        pass

    @property
    def MicromolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicromolePerLiter"
        """
        pass

    @property
    def MillimolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimolePerLiter"
        """
        pass

    @property
    def MolesPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MolePerCubicMeter"
        """
        pass

    @property
    def MolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MolePerLiter"
        """
        pass

    @property
    def NanomolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanomolePerLiter"
        """
        pass

    @property
    def PicomolesPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicomolePerLiter"
        """
        pass

    def __init__(self, density: Density, molecularWeight: Mass) -> None:
        """ Construct from "Density" divided by "Mass".
        """
        pass

    def __init__(self, value: float, unit: MolarityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: Molarity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Molarity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Molarity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Molarity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Molarity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MolarityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarityUnit) -> Molarity:
        """ Converts this Molarity to another Molarity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarityUnit
        :return: A Molarity with the specified unit.
        :rtype: Molarity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarityUnit, unitConverter: UnitConverter) -> Molarity:
        """ Converts this "Molarity" to another "Molarity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Molarity with the specified unit.
        :rtype: Molarity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Molarity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToDensity(self, molecularWeight: Mass) -> Density:
        """ Get a "Density" from this "Molarity".

        :param molecularWeight:
        :type molecularWeight: Mass
        """
        pass

    def ToMassConcentration(self, molecularWeight: MolarMass) -> MassConcentration:
        """ Get a "MassConcentration" from this "Molarity".

        :param molecularWeight:
        :type molecularWeight: MolarMass
        """
        pass

    def ToVolumeConcentration(self, componentDensity: Density, componentMass: MolarMass) -> VolumeConcentration:
        """ Get a "MassConcentration" from this "Molarity".

        :param componentDensity:
        :type componentDensity: Density
        :param componentMass:
        :type componentMass: MolarMass
        """
        pass

    @staticmethod
    def FromDensity(density: Density, molecularWeight: Mass) -> Molarity:
        """ Get "Molarity" from "Density".

        :param density:
        :type density: Density
        :param molecularWeight:
        :type molecularWeight: Mass
        """
        pass

    @staticmethod
    def FromVolumeConcentration(volumeConcentration: VolumeConcentration, componentDensity: Density, componentMass: MolarMass) -> Molarity:
        """ Get "Molarity" from "VolumeConcentration" and known component "Density" and "MolarMass".

        :param volumeConcentration:
        :type volumeConcentration: VolumeConcentration
        :param componentDensity:
        :type componentDensity: Density
        :param componentMass:
        :type componentMass: MolarMass
        :return:
        :rtype: Molarity
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimolesPerLiter(centimolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field CentimolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimolesPerLiter(decimolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field DecimolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFemtomolesPerLiter(femtomolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field FemtomolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicromolesPerLiter(micromolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field MicromolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimolesPerLiter(millimolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field MillimolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMolesPerCubicMeter(molespercubicmeter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field MolePerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMolesPerLiter(molesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field MolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanomolesPerLiter(nanomolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field NanomolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicomolesPerLiter(picomolesperliter: QuantityValue) -> Molarity:
        """ Creates a "Molarity" from "Field PicomolePerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarityUnit) -> Molarity:
        """ Dynamically convert from value and unit enum "MolarityUnit" to "Molarity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarityUnit
        :return: Molarity unit value.
        :rtype: Molarity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Molarity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Molarity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Molarity) -> typing.Tuple[Molarity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Molarity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Molarity) -> typing.Tuple[Molarity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Molarity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarityUnit) -> typing.Tuple[MolarityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarityUnit) -> typing.Tuple[MolarityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Molarity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class Moment(ValueType, IQuantity[MomentUnit], IQuantity, IFormattable, IEquatable[Moment], IComparable, IComparable[Moment], IConvertible):
    """ .
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MomentUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MomentUnit]

    MaxValue: typing.ClassVar[Moment]

    MinValue: typing.ClassVar[Moment]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MomentUnit]]

    Zero: typing.ClassVar[Moment]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MomentUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MomentUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramForceCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceCentimeter"
        """
        pass

    @property
    def KilogramForceMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceMeter"
        """
        pass

    @property
    def KilogramForceMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceMillimeter"
        """
        pass

    @property
    def KilonewtonCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonCentimeter"
        """
        pass

    @property
    def KilonewtonMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMeter"
        """
        pass

    @property
    def KilonewtonMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMillimeter"
        """
        pass

    @property
    def KilopoundForceFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceFoot"
        """
        pass

    @property
    def KilopoundForceInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceInch"
        """
        pass

    @property
    def MeganewtonCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonCentimeter"
        """
        pass

    @property
    def MeganewtonMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMeter"
        """
        pass

    @property
    def MeganewtonMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMillimeter"
        """
        pass

    @property
    def MegapoundForceFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForceFoot"
        """
        pass

    @property
    def MegapoundForceInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForceInch"
        """
        pass

    @property
    def NewtonCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonCentimeter"
        """
        pass

    @property
    def NewtonMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMeter"
        """
        pass

    @property
    def NewtonMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMillimeter"
        """
        pass

    @property
    def PoundalFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundalFoot"
        """
        pass

    @property
    def PoundForceFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceFoot"
        """
        pass

    @property
    def PoundForceInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceInch"
        """
        pass

    @property
    def TonneForceCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceCentimeter"
        """
        pass

    @property
    def TonneForceMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceMeter"
        """
        pass

    @property
    def TonneForceMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceMillimeter"
        """
        pass

    def __init__(self, value: float, unit: MomentUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MomentUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MomentUnit) -> typing.Tuple[MomentUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MomentUnit) -> typing.Tuple[MomentUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MomentUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Moment) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Moment) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Moment, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Moment within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Moment
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Moment.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MomentUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MomentUnit) -> Moment:
        """ Converts this Moment to another Moment with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MomentUnit
        :return: A Moment with the specified unit.
        :rtype: Moment
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MomentUnit, unitConverter: UnitConverter) -> Moment:
        """ Converts this "Moment" to another "Moment" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MomentUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Moment with the specified unit.
        :rtype: Moment
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Moment:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MomentUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MomentUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MomentUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MomentUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramForceCentimeters(kilogramforcecentimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilogramForceCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMeters(kilogramforcemeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilogramForceMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMillimeters(kilogramforcemillimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilogramForceMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonCentimeters(kilonewtoncentimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilonewtonCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMeters(kilonewtonmeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilonewtonMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimeters(kilonewtonmillimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilonewtonMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeet(kilopoundforcefeet: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilopoundForceFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceInches(kilopoundforceinches: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field KilopoundForceInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonCentimeters(meganewtoncentimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field MeganewtonCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMeters(meganewtonmeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field MeganewtonMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimeters(meganewtonmillimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field MeganewtonMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceFeet(megapoundforcefeet: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field MegapoundForceFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceInches(megapoundforceinches: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field MegapoundForceInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonCentimeters(newtoncentimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field NewtonCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMeters(newtonmeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field NewtonMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimeters(newtonmillimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field NewtonMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundalFeet(poundalfeet: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field PoundalFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeet(poundforcefeet: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field PoundForceFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceInches(poundforceinches: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field PoundForceInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceCentimeters(tonneforcecentimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field TonneForceCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMeters(tonneforcemeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field TonneForceMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMillimeters(tonneforcemillimeters: QuantityValue) -> Moment:
        """ Creates a "Moment" from "Field TonneForceMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MomentUnit) -> Moment:
        """ Dynamically convert from value and unit enum "MomentUnit" to "Moment".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MomentUnit
        :return: Moment unit value.
        :rtype: Moment
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Moment:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Moment:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Moment) -> typing.Tuple[Moment, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Moment
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Moment) -> typing.Tuple[Moment, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Moment
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MomentUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MomentUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass


# noinspection PyPep8Naming
class Power(ValueType, IQuantity[PowerUnit], IQuantity, IFormattable, IDecimalQuantity, IEquatable[Power], IComparable, IComparable[Power], IConvertible):
    """ In physics, power is the rate of doing work. It is equivalent to an amount of energy consumed per unit time.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PowerUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PowerUnit]

    MaxValue: typing.ClassVar[Power]

    MinValue: typing.ClassVar[Power]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PowerUnit]]

    Zero: typing.ClassVar[Power]

    @property
    def Value(self) -> Decimal:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PowerUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PowerUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BoilerHorsepower(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BoilerHorsepower"
        """
        pass

    @property
    def BritishThermalUnitsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BritishThermalUnitPerHour"
        """
        pass

    @property
    def Decawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decawatt"
        """
        pass

    @property
    def Deciwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Deciwatt"
        """
        pass

    @property
    def ElectricalHorsepower(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ElectricalHorsepower"
        """
        pass

    @property
    def Femtowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Femtowatt"
        """
        pass

    @property
    def GigajoulesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigajoulePerHour"
        """
        pass

    @property
    def Gigawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigawatt"
        """
        pass

    @property
    def HydraulicHorsepower(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HydraulicHorsepower"
        """
        pass

    @property
    def JoulesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerHour"
        """
        pass

    @property
    def KilobritishThermalUnitsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilobritishThermalUnitPerHour"
        """
        pass

    @property
    def KilojoulesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerHour"
        """
        pass

    @property
    def Kilowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilowatt"
        """
        pass

    @property
    def MechanicalHorsepower(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MechanicalHorsepower"
        """
        pass

    @property
    def MegabritishThermalUnitsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegabritishThermalUnitPerHour"
        """
        pass

    @property
    def MegajoulesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerHour"
        """
        pass

    @property
    def Megawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megawatt"
        """
        pass

    @property
    def MetricHorsepower(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MetricHorsepower"
        """
        pass

    @property
    def Microwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microwatt"
        """
        pass

    @property
    def MillijoulesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillijoulePerHour"
        """
        pass

    @property
    def Milliwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milliwatt"
        """
        pass

    @property
    def Nanowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanowatt"
        """
        pass

    @property
    def Petawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Petawatt"
        """
        pass

    @property
    def Picowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Picowatt"
        """
        pass

    @property
    def Terawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Terawatt"
        """
        pass

    @property
    def Watts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Watt"
        """
        pass

    def __init__(self, value: Decimal, unit: PowerUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unit: The unit representation to construct this quantity with.
        :type unit: PowerUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: Decimal, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromJoulesPerHour(joulesperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field JoulePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobritishThermalUnitsPerHour(kilobritishthermalunitsperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field KilobritishThermalUnitPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerHour(kilojoulesperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field KilojoulePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowatts(kilowatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Kilowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMechanicalHorsepower(mechanicalhorsepower: QuantityValue) -> Power:
        """ Creates a "Power" from "Field MechanicalHorsepower".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabritishThermalUnitsPerHour(megabritishthermalunitsperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field MegabritishThermalUnitPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerHour(megajoulesperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field MegajoulePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawatts(megawatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Megawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetricHorsepower(metrichorsepower: QuantityValue) -> Power:
        """ Creates a "Power" from "Field MetricHorsepower".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowatts(microwatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Microwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillijoulesPerHour(millijoulesperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field MillijoulePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwatts(milliwatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Milliwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowatts(nanowatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Nanowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetawatts(petawatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Petawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowatts(picowatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Picowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawatts(terawatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Terawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWatts(watts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Watt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PowerUnit) -> Power:
        """ Dynamically convert from value and unit enum "PowerUnit" to "Power".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PowerUnit
        :return: Power unit value.
        :rtype: Power
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Power:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Power:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Power) -> typing.Tuple[Power, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Power
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Power) -> typing.Tuple[Power, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Power
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PowerUnit) -> typing.Tuple[PowerUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PowerUnit) -> typing.Tuple[PowerUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PowerUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Power) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Power) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Power, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Power within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Power
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Power.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PowerUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerUnit) -> Power:
        """ Converts this Power to another Power with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PowerUnit
        :return: A Power with the specified unit.
        :rtype: Power
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerUnit, unitConverter: UnitConverter) -> Power:
        """ Converts this "Power" to another "Power" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PowerUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Power with the specified unit.
        :rtype: Power
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Power:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToPowerRatio(self) -> PowerRatio:
        """ Gets a "PowerRatio" from this "Power" relative to one watt.
         Provides a nicer syntax for converting a power to a power ratio (relative to 1 watt).
         var powerRatio = power.ToPowerRatio();
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBoilerHorsepower(boilerhorsepower: QuantityValue) -> Power:
        """ Creates a "Power" from "Field BoilerHorsepower".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBritishThermalUnitsPerHour(britishthermalunitsperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field BritishThermalUnitPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawatts(decawatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Decawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwatts(deciwatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Deciwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromElectricalHorsepower(electricalhorsepower: QuantityValue) -> Power:
        """ Creates a "Power" from "Field ElectricalHorsepower".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFemtowatts(femtowatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Femtowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigajoulesPerHour(gigajoulesperhour: QuantityValue) -> Power:
        """ Creates a "Power" from "Field GigajoulePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawatts(gigawatts: QuantityValue) -> Power:
        """ Creates a "Power" from "Field Gigawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHydraulicHorsepower(hydraulichorsepower: QuantityValue) -> Power:
        """ Creates a "Power" from "Field HydraulicHorsepower".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class PowerRatio(ValueType, IQuantity[PowerRatioUnit], IQuantity, IFormattable, IEquatable[PowerRatio], IComparable, IComparable[PowerRatio], IConvertible):
    """ The strength of a signal expressed in decibels (dB) relative to one watt.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PowerRatioUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PowerRatioUnit]

    MaxValue: typing.ClassVar[PowerRatio]

    MinValue: typing.ClassVar[PowerRatio]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PowerRatioUnit]]

    Zero: typing.ClassVar[PowerRatio]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PowerRatioUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PowerRatioUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecibelMilliwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecibelMilliwatt"
        """
        pass

    @property
    def DecibelWatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecibelWatt"
        """
        pass

    def __init__(self, power: Power) -> None:
        """ Initializes a new instance of the "PowerRatio" struct from the specified power referenced to one watt.

        :param power: The power relative to one watt.
        :type power: Power
        """
        pass

    def __init__(self, value: float, unit: PowerRatioUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PowerRatioUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToPower(self) -> Power:
        """ Gets a "Power" from this "PowerRatio" (which is a power level relative to one watt).
         Provides a nicer syntax for converting a power ratio back to a power.
         var power = powerRatio.ToPower();
        """
        pass

    def ToAmplitudeRatio(self, impedance: ElectricResistance) -> AmplitudeRatio:
        """ Gets a "AmplitudeRatio" from this "PowerRatio".

        :param impedance: The input impedance of the load. This is usually 50, 75 or 600 ohms.
        :type impedance: ElectricResistance
        """
        pass

    @staticmethod
    def FromPower(power: Power) -> PowerRatio:
        """ Gets a "PowerRatio" from a "Power" relative to one watt.

        :param power: The power relative to one watt.
        :type power: Power
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerRatioUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerRatioUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerRatioUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerRatioUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecibelMilliwatts(decibelmilliwatts: QuantityValue) -> PowerRatio:
        """ Creates a "PowerRatio" from "Field DecibelMilliwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelWatts(decibelwatts: QuantityValue) -> PowerRatio:
        """ Creates a "PowerRatio" from "Field DecibelWatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PowerRatioUnit) -> PowerRatio:
        """ Dynamically convert from value and unit enum "PowerRatioUnit" to "PowerRatio".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PowerRatioUnit
        :return: PowerRatio unit value.
        :rtype: PowerRatio
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PowerRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PowerRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PowerRatio) -> typing.Tuple[PowerRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerRatio
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PowerRatio) -> typing.Tuple[PowerRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerRatio
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PowerRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PowerRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PowerRatioUnit) -> typing.Tuple[PowerRatioUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PowerRatioUnit) -> typing.Tuple[PowerRatioUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PowerRatioUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PowerRatio) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerRatio) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerRatio, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PowerRatio within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PowerRatio
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PowerRatio.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PowerRatioUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerRatioUnit) -> PowerRatio:
        """ Converts this PowerRatio to another PowerRatio with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PowerRatioUnit
        :return: A PowerRatio with the specified unit.
        :rtype: PowerRatio
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerRatioUnit, unitConverter: UnitConverter) -> PowerRatio:
        """ Converts this "PowerRatio" to another "PowerRatio" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PowerRatioUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A PowerRatio with the specified unit.
        :rtype: PowerRatio
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PowerRatio:
        """
        """
        pass


# noinspection PyPep8Naming
class Pressure(ValueType, IQuantity[PressureUnit], IQuantity, IFormattable, IEquatable[Pressure], IComparable, IComparable[Pressure], IConvertible):
    """ Pressure (symbol: P or p) is the ratio of force to the area over which that force is distributed. Pressure is force per unit area applied in a direction perpendicular to the surface of an object. Gauge pressure (also spelled gage pressure)[a] is the pressure relative to the local atmospheric or ambient pressure. Pressure is measured in any unit of force divided by any unit of area. The SI unit of pressure is the newton per square metre, which is called the pascal (Pa) after the seventeenth-century philosopher and scientist Blaise Pascal. A pressure of 1 Pa is small; it approximately equals the pressure exerted by a dollar bill resting flat on a table. Everyday pressures are often stated in kilopascals (1 kPa = 1000 Pa).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PressureUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PressureUnit]

    MaxValue: typing.ClassVar[Pressure]

    MinValue: typing.ClassVar[Pressure]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PressureUnit]]

    Zero: typing.ClassVar[Pressure]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PressureUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PressureUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Atmospheres(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Atmosphere"
        """
        pass

    @property
    def Bars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Bar"
        """
        pass

    @property
    def Centibars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centibar"
        """
        pass

    @property
    def Decapascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decapascal"
        """
        pass

    @property
    def Decibars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decibar"
        """
        pass

    @property
    def DynesPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DynePerSquareCentimeter"
        """
        pass

    @property
    def FeetOfElevation(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootOfElevation"
        """
        pass

    @property
    def FeetOfHead(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootOfHead"
        """
        pass

    @property
    def Gigapascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigapascal"
        """
        pass

    @property
    def Hectopascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hectopascal"
        """
        pass

    @property
    def InchesOfMercury(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchOfMercury"
        """
        pass

    @property
    def InchesOfWaterColumn(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchOfWaterColumn"
        """
        pass

    @property
    def Kilobars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilobar"
        """
        pass

    @property
    def KilogramsForcePerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerSquareCentimeter"
        """
        pass

    @property
    def KilogramsForcePerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerSquareMeter"
        """
        pass

    @property
    def KilogramsForcePerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerSquareMillimeter"
        """
        pass

    @property
    def KilonewtonsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerSquareCentimeter"
        """
        pass

    @property
    def KilonewtonsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerSquareMeter"
        """
        pass

    @property
    def KilonewtonsPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerSquareMillimeter"
        """
        pass

    @property
    def Kilopascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilopascal"
        """
        pass

    @property
    def KilopoundsForcePerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerSquareFoot"
        """
        pass

    @property
    def KilopoundsForcePerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerSquareInch"
        """
        pass

    @property
    def KilopoundsForcePerSquareMil(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerSquareMil"
        """
        pass

    @property
    def Megabars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megabar"
        """
        pass

    @property
    def MeganewtonsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonPerSquareMeter"
        """
        pass

    @property
    def Megapascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megapascal"
        """
        pass

    @property
    def MetersOfElevation(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterOfElevation"
        """
        pass

    @property
    def MetersOfHead(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterOfHead"
        """
        pass

    @property
    def Microbars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microbar"
        """
        pass

    @property
    def Micropascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Micropascal"
        """
        pass

    @property
    def Millibars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millibar"
        """
        pass

    @property
    def MillimetersOfMercury(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterOfMercury"
        """
        pass

    @property
    def MillimeterOfWaterColumn(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterOfWaterColumn"
        """
        pass

    @property
    def Millipascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millipascal"
        """
        pass

    @property
    def NewtonsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerSquareCentimeter"
        """
        pass

    @property
    def NewtonsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerSquareMeter"
        """
        pass

    @property
    def NewtonsPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerSquareMillimeter"
        """
        pass

    @property
    def Pascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Pascal"
        """
        pass

    @property
    def PoundsForcePerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerSquareFoot"
        """
        pass

    @property
    def PoundsForcePerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerSquareInch"
        """
        pass

    @property
    def PoundsForcePerSquareMil(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerSquareMil"
        """
        pass

    @property
    def PoundsPerInchSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerInchSecondSquared"
        """
        pass

    @property
    def TechnicalAtmospheres(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TechnicalAtmosphere"
        """
        pass

    @property
    def TonnesForcePerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerSquareCentimeter"
        """
        pass

    @property
    def TonnesForcePerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerSquareMeter"
        """
        pass

    @property
    def TonnesForcePerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerSquareMillimeter"
        """
        pass

    @property
    def Torrs(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Torr"
        """
        pass

    def __init__(self, value: float, unit: PressureUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PressureUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Pressure:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentibars(centibars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Centibar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecapascals(decapascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Decapascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibars(decibars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Decibar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDynesPerSquareCentimeter(dynespersquarecentimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field DynePerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetOfElevation(feetofelevation: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field FootOfElevation".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetOfHead(feetofhead: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field FootOfHead".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigapascals(gigapascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Gigapascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectopascals(hectopascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Hectopascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesOfMercury(inchesofmercury: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field InchOfMercury".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesOfWaterColumn(inchesofwatercolumn: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field InchOfWaterColumn".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobars(kilobars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Kilobar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerSquareCentimeter(kilogramsforcepersquarecentimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilogramForcePerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerSquareMeter(kilogramsforcepersquaremeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilogramForcePerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerSquareMillimeter(kilogramsforcepersquaremillimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilogramForcePerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSquareCentimeter(kilonewtonspersquarecentimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilonewtonPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSquareMeter(kilonewtonspersquaremeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilonewtonPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSquareMillimeter(kilonewtonspersquaremillimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilonewtonPerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopascals(kilopascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Kilopascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareFoot(kilopoundsforcepersquarefoot: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilopoundForcePerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareInch(kilopoundsforcepersquareinch: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilopoundForcePerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareMil(kilopoundsforcepersquaremil: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field KilopoundForcePerSquareMil".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabars(megabars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Megabar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerSquareMeter(meganewtonspersquaremeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field MeganewtonPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapascals(megapascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Megapascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersOfElevation(metersofelevation: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field MeterOfElevation".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersOfHead(metersofhead: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field MeterOfHead".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrobars(microbars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Microbar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicropascals(micropascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Micropascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillibars(millibars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Millibar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersOfMercury(millimetersofmercury: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field MillimeterOfMercury".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimeterOfWaterColumn(millimeterofwatercolumn: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field MillimeterOfWaterColumn".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillipascals(millipascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Millipascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSquareCentimeter(newtonspersquarecentimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field NewtonPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSquareMeter(newtonspersquaremeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field NewtonPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSquareMillimeter(newtonspersquaremillimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field NewtonPerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascals(pascals: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Pascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareFoot(poundsforcepersquarefoot: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field PoundForcePerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareInch(poundsforcepersquareinch: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field PoundForcePerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareMil(poundsforcepersquaremil: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field PoundForcePerSquareMil".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerInchSecondSquared(poundsperinchsecondsquared: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field PoundPerInchSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTechnicalAtmospheres(technicalatmospheres: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field TechnicalAtmosphere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerSquareCentimeter(tonnesforcepersquarecentimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field TonneForcePerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerSquareMeter(tonnesforcepersquaremeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field TonneForcePerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerSquareMillimeter(tonnesforcepersquaremillimeter: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field TonneForcePerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTorrs(torrs: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Torr".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PressureUnit) -> Pressure:
        """ Dynamically convert from value and unit enum "PressureUnit" to "Pressure".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PressureUnit
        :return: Pressure unit value.
        :rtype: Pressure
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Pressure:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Pressure:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Pressure) -> typing.Tuple[Pressure, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Pressure
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Pressure) -> typing.Tuple[Pressure, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Pressure
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PressureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PressureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PressureUnit) -> typing.Tuple[PressureUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PressureUnit) -> typing.Tuple[PressureUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PressureUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Pressure) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Pressure) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Pressure, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Pressure within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Pressure
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Pressure.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PressureUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PressureUnit) -> Pressure:
        """ Converts this Pressure to another Pressure with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PressureUnit
        :return: A Pressure with the specified unit.
        :rtype: Pressure
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PressureUnit, unitConverter: UnitConverter) -> Pressure:
        """ Converts this "Pressure" to another "Pressure" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PressureUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Pressure with the specified unit.
        :rtype: Pressure
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAtmospheres(atmospheres: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Atmosphere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBars(bars: QuantityValue) -> Pressure:
        """ Creates a "Pressure" from "Field Bar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class ReciprocalArea(ValueType, IQuantity[ReciprocalAreaUnit], IQuantity, IFormattable, IEquatable[ReciprocalArea], IComparable, IComparable[ReciprocalArea], IConvertible):
    """ Reciprocal area (Inverse-square) quantity is used to specify a physical quantity inversely proportional to the square of the distance.
     https://en.wikipedia.org/wiki/Inverse-square_law
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ReciprocalAreaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ReciprocalAreaUnit]

    MaxValue: typing.ClassVar[ReciprocalArea]

    MinValue: typing.ClassVar[ReciprocalArea]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ReciprocalAreaUnit]]

    Zero: typing.ClassVar[ReciprocalArea]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ReciprocalAreaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ReciprocalAreaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InverseSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareCentimeter"
        """
        pass

    @property
    def InverseSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareDecimeter"
        """
        pass

    @property
    def InverseSquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareFoot"
        """
        pass

    @property
    def InverseSquareInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareInch"
        """
        pass

    @property
    def InverseSquareKilometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareKilometer"
        """
        pass

    @property
    def InverseSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareMeter"
        """
        pass

    @property
    def InverseSquareMicrometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareMicrometer"
        """
        pass

    @property
    def InverseSquareMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareMile"
        """
        pass

    @property
    def InverseSquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareMillimeter"
        """
        pass

    @property
    def InverseSquareYards(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseSquareYard"
        """
        pass

    @property
    def InverseUsSurveySquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseUsSurveySquareFoot"
        """
        pass

    def __init__(self, value: float, unit: ReciprocalAreaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ReciprocalAreaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: ReciprocalArea, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ReciprocalArea within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ReciprocalArea
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ReciprocalArea.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ReciprocalAreaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReciprocalAreaUnit) -> ReciprocalArea:
        """ Converts this ReciprocalArea to another ReciprocalArea with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReciprocalAreaUnit
        :return: A ReciprocalArea with the specified unit.
        :rtype: ReciprocalArea
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReciprocalAreaUnit, unitConverter: UnitConverter) -> ReciprocalArea:
        """ Converts this "ReciprocalArea" to another "ReciprocalArea" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReciprocalAreaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ReciprocalArea with the specified unit.
        :rtype: ReciprocalArea
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ReciprocalArea:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def Inverse(self) -> Area:
        """Calculates the inverse of this quantity.

        :return: The corresponding inverse quantity, "Area".
        :rtype: Area
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReciprocalAreaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReciprocalAreaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReciprocalAreaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReciprocalAreaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInverseSquareCentimeters(inversesquarecentimeters: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareDecimeters(inversesquaredecimeters: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareFeet(inversesquarefeet: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareInches(inversesquareinches: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareKilometers(inversesquarekilometers: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareKilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareMeters(inversesquaremeters: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareMicrometers(inversesquaremicrometers: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareMicrometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareMiles(inversesquaremiles: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareMillimeters(inversesquaremillimeters: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseSquareYards(inversesquareyards: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseSquareYard".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseUsSurveySquareFeet(inverseussurveysquarefeet: QuantityValue) -> ReciprocalArea:
        """ Creates a "ReciprocalArea" from "Field InverseUsSurveySquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ReciprocalAreaUnit) -> ReciprocalArea:
        """ Dynamically convert from value and unit enum "ReciprocalAreaUnit" to "ReciprocalArea".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ReciprocalAreaUnit
        :return: ReciprocalArea unit value.
        :rtype: ReciprocalArea
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ReciprocalArea:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ReciprocalArea:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ReciprocalArea) -> typing.Tuple[ReciprocalArea, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReciprocalArea
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ReciprocalArea) -> typing.Tuple[ReciprocalArea, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReciprocalArea
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ReciprocalAreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ReciprocalAreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ReciprocalAreaUnit) -> typing.Tuple[ReciprocalAreaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ReciprocalAreaUnit) -> typing.Tuple[ReciprocalAreaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ReciprocalAreaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ReciprocalArea) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReciprocalArea) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class ReciprocalLength(ValueType, IQuantity[ReciprocalLengthUnit], IQuantity, IFormattable, IEquatable[ReciprocalLength], IComparable, IComparable[ReciprocalLength], IConvertible):
    """ Reciprocal (Inverse) Length is used in various fields of science and mathematics. It is defined as the inverse value of a length unit.
     https://en.wikipedia.org/wiki/Reciprocal_length
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ReciprocalLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ReciprocalLengthUnit]

    MaxValue: typing.ClassVar[ReciprocalLength]

    MinValue: typing.ClassVar[ReciprocalLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ReciprocalLengthUnit]]

    Zero: typing.ClassVar[ReciprocalLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ReciprocalLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ReciprocalLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InverseCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseCentimeter"
        """
        pass

    @property
    def InverseFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseFoot"
        """
        pass

    @property
    def InverseInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseInch"
        """
        pass

    @property
    def InverseMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMeter"
        """
        pass

    @property
    def InverseMicroinches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMicroinch"
        """
        pass

    @property
    def InverseMils(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMil"
        """
        pass

    @property
    def InverseMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMile"
        """
        pass

    @property
    def InverseMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMillimeter"
        """
        pass

    @property
    def InverseUsSurveyFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseUsSurveyFoot"
        """
        pass

    @property
    def InverseYards(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseYard"
        """
        pass

    def __init__(self, value: float, unit: ReciprocalLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ReciprocalLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ReciprocalLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ReciprocalLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReciprocalLengthUnit) -> ReciprocalLength:
        """ Converts this ReciprocalLength to another ReciprocalLength with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReciprocalLengthUnit
        :return: A ReciprocalLength with the specified unit.
        :rtype: ReciprocalLength
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReciprocalLengthUnit, unitConverter: UnitConverter) -> ReciprocalLength:
        """ Converts this "ReciprocalLength" to another "ReciprocalLength" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReciprocalLengthUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ReciprocalLength with the specified unit.
        :rtype: ReciprocalLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ReciprocalLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def Inverse(self) -> Length:
        """Calculates the inverse of this quantity.

        :return: The corresponding inverse quantity, "Length".
        :rtype: Length
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReciprocalLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReciprocalLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReciprocalLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReciprocalLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInverseCentimeters(inversecentimeters: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseFeet(inversefeet: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseInches(inverseinches: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMeters(inversemeters: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMicroinches(inversemicroinches: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseMicroinch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMils(inversemils: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseMil".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMiles(inversemiles: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMillimeters(inversemillimeters: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseUsSurveyFeet(inverseussurveyfeet: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseUsSurveyFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseYards(inverseyards: QuantityValue) -> ReciprocalLength:
        """ Creates a "ReciprocalLength" from "Field InverseYard".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ReciprocalLengthUnit) -> ReciprocalLength:
        """ Dynamically convert from value and unit enum "ReciprocalLengthUnit" to "ReciprocalLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ReciprocalLengthUnit
        :return: ReciprocalLength unit value.
        :rtype: ReciprocalLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ReciprocalLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ReciprocalLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ReciprocalLength) -> typing.Tuple[ReciprocalLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReciprocalLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ReciprocalLength) -> typing.Tuple[ReciprocalLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReciprocalLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ReciprocalLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ReciprocalLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ReciprocalLengthUnit) -> typing.Tuple[ReciprocalLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ReciprocalLengthUnit) -> typing.Tuple[ReciprocalLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ReciprocalLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ReciprocalLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReciprocalLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReciprocalLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ReciprocalLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ReciprocalLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class RotationalSpeed(ValueType, IQuantity[RotationalSpeedUnit], IQuantity, IFormattable, IEquatable[RotationalSpeed], IComparable, IComparable[RotationalSpeed], IConvertible):
    """ Rotational speed (sometimes called speed of revolution) is the number of complete rotations, revolutions, cycles, or turns per time unit. Rotational speed is a cyclic frequency, measured in radians per second or in hertz in the SI System by scientists, or in revolutions per minute (rpm or min-1) or revolutions per second in everyday life. The symbol for rotational speed is ω (the Greek lowercase letter "omega").
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RotationalSpeedUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalSpeedUnit]

    MaxValue: typing.ClassVar[RotationalSpeed]

    MinValue: typing.ClassVar[RotationalSpeed]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalSpeedUnit]]

    Zero: typing.ClassVar[RotationalSpeed]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalSpeedUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalSpeedUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentiradiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentiradianPerSecond"
        """
        pass

    @property
    def DeciradiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciradianPerSecond"
        """
        pass

    @property
    def DegreesPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreePerMinute"
        """
        pass

    @property
    def DegreesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreePerSecond"
        """
        pass

    @property
    def MicrodegreesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrodegreePerSecond"
        """
        pass

    @property
    def MicroradiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroradianPerSecond"
        """
        pass

    @property
    def MillidegreesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillidegreePerSecond"
        """
        pass

    @property
    def MilliradiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliradianPerSecond"
        """
        pass

    @property
    def NanodegreesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanodegreePerSecond"
        """
        pass

    @property
    def NanoradiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoradianPerSecond"
        """
        pass

    @property
    def RadiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RadianPerSecond"
        """
        pass

    @property
    def RevolutionsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RevolutionPerMinute"
        """
        pass

    @property
    def RevolutionsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RevolutionPerSecond"
        """
        pass

    def __init__(self, value: float, unit: RotationalSpeedUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalSpeedUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalSpeed) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalSpeed, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalSpeed within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalSpeed
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalSpeed.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalSpeedUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalSpeedUnit) -> RotationalSpeed:
        """ Converts this RotationalSpeed to another RotationalSpeed with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalSpeedUnit
        :return: A RotationalSpeed with the specified unit.
        :rtype: RotationalSpeed
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalSpeedUnit, unitConverter: UnitConverter) -> RotationalSpeed:
        """ Converts this "RotationalSpeed" to another "RotationalSpeed" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalSpeedUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A RotationalSpeed with the specified unit.
        :rtype: RotationalSpeed
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalSpeed:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalSpeedUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalSpeedUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalSpeedUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalSpeedUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentiradiansPerSecond(centiradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field CentiradianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciradiansPerSecond(deciradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field DeciradianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesPerMinute(degreesperminute: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field DegreePerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesPerSecond(degreespersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field DegreePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodegreesPerSecond(microdegreespersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field MicrodegreePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroradiansPerSecond(microradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field MicroradianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesPerSecond(millidegreespersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field MillidegreePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliradiansPerSecond(milliradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field MilliradianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanodegreesPerSecond(nanodegreespersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field NanodegreePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoradiansPerSecond(nanoradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field NanoradianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadiansPerSecond(radianspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field RadianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerMinute(revolutionsperminute: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field RevolutionPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerSecond(revolutionspersecond: QuantityValue) -> RotationalSpeed:
        """ Creates a "RotationalSpeed" from "Field RevolutionPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalSpeedUnit) -> RotationalSpeed:
        """ Dynamically convert from value and unit enum "RotationalSpeedUnit" to "RotationalSpeed".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalSpeedUnit
        :return: RotationalSpeed unit value.
        :rtype: RotationalSpeed
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalSpeed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalSpeed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalSpeed) -> typing.Tuple[RotationalSpeed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalSpeed
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalSpeed) -> typing.Tuple[RotationalSpeed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalSpeed
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalSpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalSpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalSpeedUnit) -> typing.Tuple[RotationalSpeedUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalSpeedUnit) -> typing.Tuple[RotationalSpeedUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalSpeedUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalSpeed) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class RotationalStiffness(ValueType, IQuantity[RotationalStiffnessUnit], IQuantity, IFormattable, IEquatable[RotationalStiffness], IComparable, IComparable[RotationalStiffness], IConvertible):
    """ https://en.wikipedia.org/wiki/Stiffness#Rotational_stiffness
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RotationalStiffnessUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalStiffnessUnit]

    MaxValue: typing.ClassVar[RotationalStiffness]

    MinValue: typing.ClassVar[RotationalStiffness]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalStiffnessUnit]]

    Zero: typing.ClassVar[RotationalStiffness]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalStiffnessUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalStiffnessUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentinewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonMeterPerDegree"
        """
        pass

    @property
    def CentinewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonMillimeterPerDegree"
        """
        pass

    @property
    def CentinewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentinewtonMillimeterPerRadian"
        """
        pass

    @property
    def DecanewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonMeterPerDegree"
        """
        pass

    @property
    def DecanewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonMillimeterPerDegree"
        """
        pass

    @property
    def DecanewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecanewtonMillimeterPerRadian"
        """
        pass

    @property
    def DecinewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonMeterPerDegree"
        """
        pass

    @property
    def DecinewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonMillimeterPerDegree"
        """
        pass

    @property
    def DecinewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecinewtonMillimeterPerRadian"
        """
        pass

    @property
    def KilonewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMeterPerDegree"
        """
        pass

    @property
    def KilonewtonMetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMeterPerRadian"
        """
        pass

    @property
    def KilonewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMillimeterPerDegree"
        """
        pass

    @property
    def KilonewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMillimeterPerRadian"
        """
        pass

    @property
    def KilopoundForceFeetPerDegrees(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceFootPerDegrees"
        """
        pass

    @property
    def MeganewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMeterPerDegree"
        """
        pass

    @property
    def MeganewtonMetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMeterPerRadian"
        """
        pass

    @property
    def MeganewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMillimeterPerDegree"
        """
        pass

    @property
    def MeganewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMillimeterPerRadian"
        """
        pass

    @property
    def MicronewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonMeterPerDegree"
        """
        pass

    @property
    def MicronewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonMillimeterPerDegree"
        """
        pass

    @property
    def MicronewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicronewtonMillimeterPerRadian"
        """
        pass

    @property
    def MillinewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonMeterPerDegree"
        """
        pass

    @property
    def MillinewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonMillimeterPerDegree"
        """
        pass

    @property
    def MillinewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillinewtonMillimeterPerRadian"
        """
        pass

    @property
    def NanonewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonMeterPerDegree"
        """
        pass

    @property
    def NanonewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonMillimeterPerDegree"
        """
        pass

    @property
    def NanonewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanonewtonMillimeterPerRadian"
        """
        pass

    @property
    def NewtonMetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMeterPerDegree"
        """
        pass

    @property
    def NewtonMetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMeterPerRadian"
        """
        pass

    @property
    def NewtonMillimetersPerDegree(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMillimeterPerDegree"
        """
        pass

    @property
    def NewtonMillimetersPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMillimeterPerRadian"
        """
        pass

    @property
    def PoundForceFeetPerRadian(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceFeetPerRadian"
        """
        pass

    @property
    def PoundForceFeetPerDegrees(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceFootPerDegrees"
        """
        pass

    def __init__(self, value: float, unit: RotationalStiffnessUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalStiffnessUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromMicronewtonMillimetersPerDegree(micronewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MicronewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonMillimetersPerRadian(micronewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MicronewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonMetersPerDegree(millinewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MillinewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonMillimetersPerDegree(millinewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MillinewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonMillimetersPerRadian(millinewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MillinewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonMetersPerDegree(nanonewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NanonewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonMillimetersPerDegree(nanonewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NanonewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonMillimetersPerRadian(nanonewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NanonewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerDegree(newtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerRadian(newtonmetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NewtonMeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimetersPerDegree(newtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimetersPerRadian(newtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field NewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerRadian(poundforcefeetperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field PoundForceFeetPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerDegrees(poundforcefeetperdegrees: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field PoundForceFootPerDegrees".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalStiffnessUnit) -> RotationalStiffness:
        """ Dynamically convert from value and unit enum "RotationalStiffnessUnit" to "RotationalStiffness".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalStiffnessUnit
        :return: RotationalStiffness unit value.
        :rtype: RotationalStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalStiffness) -> typing.Tuple[RotationalStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalStiffness) -> typing.Tuple[RotationalStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffness
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalStiffnessUnit) -> typing.Tuple[RotationalStiffnessUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalStiffnessUnit) -> typing.Tuple[RotationalStiffnessUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalStiffnessUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalStiffness) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffness) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffness, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalStiffness within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalStiffness
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalStiffness.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalStiffnessUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalStiffnessUnit) -> RotationalStiffness:
        """ Converts this RotationalStiffness to another RotationalStiffness with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalStiffnessUnit
        :return: A RotationalStiffness with the specified unit.
        :rtype: RotationalStiffness
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalStiffnessUnit, unitConverter: UnitConverter) -> RotationalStiffness:
        """ Converts this "RotationalStiffness" to another "RotationalStiffness" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalStiffnessUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A RotationalStiffness with the specified unit.
        :rtype: RotationalStiffness
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalStiffness:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentinewtonMetersPerDegree(centinewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field CentinewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonMillimetersPerDegree(centinewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field CentinewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonMillimetersPerRadian(centinewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field CentinewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonMetersPerDegree(decanewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field DecanewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonMillimetersPerDegree(decanewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field DecanewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonMillimetersPerRadian(decanewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field DecanewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonMetersPerDegree(decinewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field DecinewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonMillimetersPerDegree(decinewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field DecinewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonMillimetersPerRadian(decinewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field DecinewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerDegree(kilonewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field KilonewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerRadian(kilonewtonmetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field KilonewtonMeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimetersPerDegree(kilonewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field KilonewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimetersPerRadian(kilonewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field KilonewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeetPerDegrees(kilopoundforcefeetperdegrees: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field KilopoundForceFootPerDegrees".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerDegree(meganewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MeganewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerRadian(meganewtonmetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MeganewtonMeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimetersPerDegree(meganewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MeganewtonMillimeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimetersPerRadian(meganewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MeganewtonMillimeterPerRadian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonMetersPerDegree(micronewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Creates a "RotationalStiffness" from "Field MicronewtonMeterPerDegree".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class RotationalStiffnessPerLength(ValueType, IQuantity[RotationalStiffnessPerLengthUnit], IQuantity, IFormattable, IEquatable[RotationalStiffnessPerLength], IComparable, IComparable[RotationalStiffnessPerLength], IConvertible):
    """ https://en.wikipedia.org/wiki/Stiffness#Rotational_stiffness
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RotationalStiffnessPerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalStiffnessPerLengthUnit]

    MaxValue: typing.ClassVar[RotationalStiffnessPerLength]

    MinValue: typing.ClassVar[RotationalStiffnessPerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalStiffnessPerLengthUnit]]

    Zero: typing.ClassVar[RotationalStiffnessPerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalStiffnessPerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalStiffnessPerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilonewtonMetersPerRadianPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMeterPerRadianPerMeter"
        """
        pass

    @property
    def KilopoundForceFeetPerDegreesPerFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceFootPerDegreesPerFoot"
        """
        pass

    @property
    def MeganewtonMetersPerRadianPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMeterPerRadianPerMeter"
        """
        pass

    @property
    def NewtonMetersPerRadianPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMeterPerRadianPerMeter"
        """
        pass

    @property
    def PoundForceFeetPerDegreesPerFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceFootPerDegreesPerFoot"
        """
        pass

    def __init__(self, value: float, unit: RotationalStiffnessPerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalStiffnessPerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalStiffnessPerLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessPerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessPerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessPerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessPerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerRadianPerMeter(kilonewtonmetersperradianpermeter: QuantityValue) -> RotationalStiffnessPerLength:
        """ Creates a "RotationalStiffnessPerLength" from "Field KilonewtonMeterPerRadianPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeetPerDegreesPerFeet(kilopoundforcefeetperdegreesperfeet: QuantityValue) -> RotationalStiffnessPerLength:
        """ Creates a "RotationalStiffnessPerLength" from "Field KilopoundForceFootPerDegreesPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerRadianPerMeter(meganewtonmetersperradianpermeter: QuantityValue) -> RotationalStiffnessPerLength:
        """ Creates a "RotationalStiffnessPerLength" from "Field MeganewtonMeterPerRadianPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerRadianPerMeter(newtonmetersperradianpermeter: QuantityValue) -> RotationalStiffnessPerLength:
        """ Creates a "RotationalStiffnessPerLength" from "Field NewtonMeterPerRadianPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerDegreesPerFeet(poundforcefeetperdegreesperfeet: QuantityValue) -> RotationalStiffnessPerLength:
        """ Creates a "RotationalStiffnessPerLength" from "Field PoundForceFootPerDegreesPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalStiffnessPerLengthUnit) -> RotationalStiffnessPerLength:
        """ Dynamically convert from value and unit enum "RotationalStiffnessPerLengthUnit" to "RotationalStiffnessPerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalStiffnessPerLengthUnit
        :return: RotationalStiffnessPerLength unit value.
        :rtype: RotationalStiffnessPerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalStiffnessPerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalStiffnessPerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalStiffnessPerLength) -> typing.Tuple[RotationalStiffnessPerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffnessPerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalStiffnessPerLength) -> typing.Tuple[RotationalStiffnessPerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffnessPerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalStiffnessPerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalStiffnessPerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalStiffnessPerLengthUnit) -> typing.Tuple[RotationalStiffnessPerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalStiffnessPerLengthUnit) -> typing.Tuple[RotationalStiffnessPerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalStiffnessPerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalStiffnessPerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffnessPerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffnessPerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalStiffnessPerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalStiffnessPerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalStiffnessPerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalStiffnessPerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalStiffnessPerLengthUnit) -> RotationalStiffnessPerLength:
        """ Converts this RotationalStiffnessPerLength to another RotationalStiffnessPerLength with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalStiffnessPerLengthUnit
        :return: A RotationalStiffnessPerLength with the specified unit.
        :rtype: RotationalStiffnessPerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalStiffnessPerLengthUnit, unitConverter: UnitConverter) -> RotationalStiffnessPerLength:
        """ Converts this "RotationalStiffnessPerLength" to another "RotationalStiffnessPerLength" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalStiffnessPerLengthUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A RotationalStiffnessPerLength with the specified unit.
        :rtype: RotationalStiffnessPerLength
        """
        pass


# noinspection PyPep8Naming
class SpecificEnergy(ValueType, IQuantity[SpecificEnergyUnit], IQuantity, IFormattable, IEquatable[SpecificEnergy], IComparable, IComparable[SpecificEnergy], IConvertible):
    """ The SpecificEnergy
     https://en.wikipedia.org/wiki/Specific_energy
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SpecificEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificEnergyUnit]

    MaxValue: typing.ClassVar[SpecificEnergy]

    MinValue: typing.ClassVar[SpecificEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificEnergyUnit]]

    Zero: typing.ClassVar[SpecificEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtuPerPound(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerPound"
        """
        pass

    @property
    def CaloriesPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CaloriePerGram"
        """
        pass

    @property
    def GigawattDaysPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattDayPerKilogram"
        """
        pass

    @property
    def GigawattDaysPerShortTon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattDayPerShortTon"
        """
        pass

    @property
    def GigawattDaysPerTonne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattDayPerTonne"
        """
        pass

    @property
    def GigawattHoursPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattHourPerKilogram"
        """
        pass

    @property
    def GigawattHoursPerPound(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattHourPerPound"
        """
        pass

    @property
    def JoulesPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerKilogram"
        """
        pass

    @property
    def KilocaloriesPerGram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocaloriePerGram"
        """
        pass

    @property
    def KilojoulesPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerKilogram"
        """
        pass

    @property
    def KilowattDaysPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattDayPerKilogram"
        """
        pass

    @property
    def KilowattDaysPerShortTon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattDayPerShortTon"
        """
        pass

    @property
    def KilowattDaysPerTonne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattDayPerTonne"
        """
        pass

    @property
    def KilowattHoursPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattHourPerKilogram"
        """
        pass

    @property
    def KilowattHoursPerPound(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattHourPerPound"
        """
        pass

    @property
    def MegajoulesPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerKilogram"
        """
        pass

    @property
    def MegawattDaysPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattDayPerKilogram"
        """
        pass

    @property
    def MegawattDaysPerShortTon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattDayPerShortTon"
        """
        pass

    @property
    def MegawattDaysPerTonne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattDayPerTonne"
        """
        pass

    @property
    def MegawattHoursPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattHourPerKilogram"
        """
        pass

    @property
    def MegawattHoursPerPound(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattHourPerPound"
        """
        pass

    @property
    def TerawattDaysPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattDayPerKilogram"
        """
        pass

    @property
    def TerawattDaysPerShortTon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattDayPerShortTon"
        """
        pass

    @property
    def TerawattDaysPerTonne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattDayPerTonne"
        """
        pass

    @property
    def WattDaysPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattDayPerKilogram"
        """
        pass

    @property
    def WattDaysPerShortTon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattDayPerShortTon"
        """
        pass

    @property
    def WattDaysPerTonne(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattDayPerTonne"
        """
        pass

    @property
    def WattHoursPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattHourPerKilogram"
        """
        pass

    @property
    def WattHoursPerPound(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattHourPerPound"
        """
        pass

    def __init__(self, value: float, unit: SpecificEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromMegawattHoursPerPound(megawatthoursperpound: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field MegawattHourPerPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDaysPerKilogram(terawattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field TerawattDayPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDaysPerShortTon(terawattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field TerawattDayPerShortTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDaysPerTonne(terawattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field TerawattDayPerTonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDaysPerKilogram(wattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field WattDayPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDaysPerShortTon(wattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field WattDayPerShortTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDaysPerTonne(wattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field WattDayPerTonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHoursPerKilogram(watthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field WattHourPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHoursPerPound(watthoursperpound: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field WattHourPerPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificEnergyUnit) -> SpecificEnergy:
        """ Dynamically convert from value and unit enum "SpecificEnergyUnit" to "SpecificEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificEnergyUnit
        :return: SpecificEnergy unit value.
        :rtype: SpecificEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificEnergy) -> typing.Tuple[SpecificEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificEnergy) -> typing.Tuple[SpecificEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificEnergyUnit) -> typing.Tuple[SpecificEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificEnergyUnit) -> typing.Tuple[SpecificEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificEnergyUnit) -> SpecificEnergy:
        """ Converts this SpecificEnergy to another SpecificEnergy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificEnergyUnit
        :return: A SpecificEnergy with the specified unit.
        :rtype: SpecificEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificEnergyUnit, unitConverter: UnitConverter) -> SpecificEnergy:
        """ Converts this "SpecificEnergy" to another "SpecificEnergy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificEnergyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SpecificEnergy with the specified unit.
        :rtype: SpecificEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificEnergy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtuPerPound(btuperpound: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field BtuPerPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerGram(caloriespergram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field CaloriePerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDaysPerKilogram(gigawattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field GigawattDayPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDaysPerShortTon(gigawattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field GigawattDayPerShortTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDaysPerTonne(gigawattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field GigawattDayPerTonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattHoursPerKilogram(gigawatthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field GigawattHourPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattHoursPerPound(gigawatthoursperpound: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field GigawattHourPerPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKilogram(joulesperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field JoulePerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerGram(kilocaloriespergram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilocaloriePerGram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKilogram(kilojoulesperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilojoulePerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDaysPerKilogram(kilowattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilowattDayPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDaysPerShortTon(kilowattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilowattDayPerShortTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDaysPerTonne(kilowattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilowattDayPerTonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHoursPerKilogram(kilowatthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilowattHourPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHoursPerPound(kilowatthoursperpound: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field KilowattHourPerPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKilogram(megajoulesperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field MegajoulePerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDaysPerKilogram(megawattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field MegawattDayPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDaysPerShortTon(megawattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field MegawattDayPerShortTon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDaysPerTonne(megawattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field MegawattDayPerTonne".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattHoursPerKilogram(megawatthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Creates a "SpecificEnergy" from "Field MegawattHourPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class SpecificEntropy(ValueType, IQuantity[SpecificEntropyUnit], IQuantity, IFormattable, IEquatable[SpecificEntropy], IComparable, IComparable[SpecificEntropy], IConvertible):
    """ Specific entropy is an amount of energy required to raise temperature of a substance by 1 Kelvin per unit mass.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SpecificEntropyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificEntropyUnit]

    MaxValue: typing.ClassVar[SpecificEntropy]

    MinValue: typing.ClassVar[SpecificEntropy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificEntropyUnit]]

    Zero: typing.ClassVar[SpecificEntropy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificEntropyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificEntropyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerPoundFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerPoundFahrenheit"
        """
        pass

    @property
    def CaloriesPerGramKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CaloriePerGramKelvin"
        """
        pass

    @property
    def JoulesPerKilogramDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerKilogramDegreeCelsius"
        """
        pass

    @property
    def JoulesPerKilogramKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerKilogramKelvin"
        """
        pass

    @property
    def KilocaloriesPerGramKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocaloriePerGramKelvin"
        """
        pass

    @property
    def KilojoulesPerKilogramDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerKilogramDegreeCelsius"
        """
        pass

    @property
    def KilojoulesPerKilogramKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerKilogramKelvin"
        """
        pass

    @property
    def MegajoulesPerKilogramDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerKilogramDegreeCelsius"
        """
        pass

    @property
    def MegajoulesPerKilogramKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerKilogramKelvin"
        """
        pass

    def __init__(self, value: float, unit: SpecificEntropyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificEntropyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificEntropyUnit) -> SpecificEntropy:
        """ Converts this SpecificEntropy to another SpecificEntropy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificEntropyUnit
        :return: A SpecificEntropy with the specified unit.
        :rtype: SpecificEntropy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificEntropyUnit, unitConverter: UnitConverter) -> SpecificEntropy:
        """ Converts this "SpecificEntropy" to another "SpecificEntropy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificEntropyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SpecificEntropy with the specified unit.
        :rtype: SpecificEntropy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificEntropy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEntropyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEntropyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEntropyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEntropyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerPoundFahrenheit(btusperpoundfahrenheit: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field BtuPerPoundFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerGramKelvin(caloriespergramkelvin: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field CaloriePerGramKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKilogramDegreeCelsius(joulesperkilogramdegreecelsius: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field JoulePerKilogramDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKilogramKelvin(joulesperkilogramkelvin: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field JoulePerKilogramKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerGramKelvin(kilocaloriespergramkelvin: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field KilocaloriePerGramKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKilogramDegreeCelsius(kilojoulesperkilogramdegreecelsius: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field KilojoulePerKilogramDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKilogramKelvin(kilojoulesperkilogramkelvin: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field KilojoulePerKilogramKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKilogramDegreeCelsius(megajoulesperkilogramdegreecelsius: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field MegajoulePerKilogramDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKilogramKelvin(megajoulesperkilogramkelvin: QuantityValue) -> SpecificEntropy:
        """ Creates a "SpecificEntropy" from "Field MegajoulePerKilogramKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificEntropyUnit) -> SpecificEntropy:
        """ Dynamically convert from value and unit enum "SpecificEntropyUnit" to "SpecificEntropy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificEntropyUnit
        :return: SpecificEntropy unit value.
        :rtype: SpecificEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificEntropy) -> typing.Tuple[SpecificEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificEntropy) -> typing.Tuple[SpecificEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEntropy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificEntropyUnit) -> typing.Tuple[SpecificEntropyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificEntropyUnit) -> typing.Tuple[SpecificEntropyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificEntropyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificEntropy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEntropy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEntropy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificEntropy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificEntropy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificEntropy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificEntropyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class SpecificVolume(ValueType, IQuantity[SpecificVolumeUnit], IQuantity, IFormattable, IEquatable[SpecificVolume], IComparable, IComparable[SpecificVolume], IConvertible):
    """ In thermodynamics, the specific volume of a substance is the ratio of the substance's volume to its mass. It is the reciprocal of density and an intrinsic property of matter as well.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SpecificVolumeUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificVolumeUnit]

    MaxValue: typing.ClassVar[SpecificVolume]

    MinValue: typing.ClassVar[SpecificVolume]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificVolumeUnit]]

    Zero: typing.ClassVar[SpecificVolume]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificVolumeUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificVolumeUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CubicFeetPerPound(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFootPerPound"
        """
        pass

    @property
    def CubicMetersPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerKilogram"
        """
        pass

    @property
    def MillicubicMetersPerKilogram(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillicubicMeterPerKilogram"
        """
        pass

    def __init__(self, value: float, unit: SpecificVolumeUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificVolumeUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificVolumeUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificVolumeUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificVolumeUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificVolumeUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCubicFeetPerPound(cubicfeetperpound: QuantityValue) -> SpecificVolume:
        """ Creates a "SpecificVolume" from "Field CubicFootPerPound".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerKilogram(cubicmetersperkilogram: QuantityValue) -> SpecificVolume:
        """ Creates a "SpecificVolume" from "Field CubicMeterPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillicubicMetersPerKilogram(millicubicmetersperkilogram: QuantityValue) -> SpecificVolume:
        """ Creates a "SpecificVolume" from "Field MillicubicMeterPerKilogram".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificVolumeUnit) -> SpecificVolume:
        """ Dynamically convert from value and unit enum "SpecificVolumeUnit" to "SpecificVolume".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificVolumeUnit
        :return: SpecificVolume unit value.
        :rtype: SpecificVolume
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificVolume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificVolume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificVolume) -> typing.Tuple[SpecificVolume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificVolume
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificVolume) -> typing.Tuple[SpecificVolume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificVolume
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificVolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificVolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificVolumeUnit) -> typing.Tuple[SpecificVolumeUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificVolumeUnit) -> typing.Tuple[SpecificVolumeUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificVolumeUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificVolume) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificVolume) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificVolume, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificVolume within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificVolume
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificVolume.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificVolumeUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificVolumeUnit) -> SpecificVolume:
        """ Converts this SpecificVolume to another SpecificVolume with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificVolumeUnit
        :return: A SpecificVolume with the specified unit.
        :rtype: SpecificVolume
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificVolumeUnit, unitConverter: UnitConverter) -> SpecificVolume:
        """ Converts this "SpecificVolume" to another "SpecificVolume" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificVolumeUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SpecificVolume with the specified unit.
        :rtype: SpecificVolume
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificVolume:
        """
        """
        pass


# noinspection PyPep8Naming
class SpecificWeight(ValueType, IQuantity[SpecificWeightUnit], IQuantity, IFormattable, IEquatable[SpecificWeight], IComparable, IComparable[SpecificWeight], IConvertible):
    """ The SpecificWeight, or more precisely, the volumetric weight density, of a substance is its weight per unit volume.
     http://en.wikipedia.org/wiki/Specificweight
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SpecificWeightUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificWeightUnit]

    MaxValue: typing.ClassVar[SpecificWeight]

    MinValue: typing.ClassVar[SpecificWeight]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificWeightUnit]]

    Zero: typing.ClassVar[SpecificWeight]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificWeightUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificWeightUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramsForcePerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerCubicCentimeter"
        """
        pass

    @property
    def KilogramsForcePerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerCubicMeter"
        """
        pass

    @property
    def KilogramsForcePerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForcePerCubicMillimeter"
        """
        pass

    @property
    def KilonewtonsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerCubicCentimeter"
        """
        pass

    @property
    def KilonewtonsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerCubicMeter"
        """
        pass

    @property
    def KilonewtonsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonPerCubicMillimeter"
        """
        pass

    @property
    def KilopoundsForcePerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerCubicFoot"
        """
        pass

    @property
    def KilopoundsForcePerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerCubicInch"
        """
        pass

    @property
    def MeganewtonsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonPerCubicMeter"
        """
        pass

    @property
    def NewtonsPerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerCubicCentimeter"
        """
        pass

    @property
    def NewtonsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerCubicMeter"
        """
        pass

    @property
    def NewtonsPerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonPerCubicMillimeter"
        """
        pass

    @property
    def PoundsForcePerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerCubicFoot"
        """
        pass

    @property
    def PoundsForcePerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerCubicInch"
        """
        pass

    @property
    def TonnesForcePerCubicCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerCubicCentimeter"
        """
        pass

    @property
    def TonnesForcePerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerCubicMeter"
        """
        pass

    @property
    def TonnesForcePerCubicMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForcePerCubicMillimeter"
        """
        pass

    def __init__(self, value: float, unit: SpecificWeightUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificWeightUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificWeight) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificWeight) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificWeight, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificWeight within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificWeight
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificWeight.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificWeightUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificWeightUnit) -> SpecificWeight:
        """ Converts this SpecificWeight to another SpecificWeight with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificWeightUnit
        :return: A SpecificWeight with the specified unit.
        :rtype: SpecificWeight
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificWeightUnit, unitConverter: UnitConverter) -> SpecificWeight:
        """ Converts this "SpecificWeight" to another "SpecificWeight" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificWeightUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SpecificWeight with the specified unit.
        :rtype: SpecificWeight
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificWeight:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificWeightUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificWeightUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificWeightUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificWeightUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCubicCentimeter(kilogramsforcepercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilogramForcePerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCubicMeter(kilogramsforcepercubicmeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilogramForcePerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCubicMillimeter(kilogramsforcepercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilogramForcePerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCubicCentimeter(kilonewtonspercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilonewtonPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCubicMeter(kilonewtonspercubicmeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilonewtonPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCubicMillimeter(kilonewtonspercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilonewtonPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerCubicFoot(kilopoundsforcepercubicfoot: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilopoundForcePerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerCubicInch(kilopoundsforcepercubicinch: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field KilopoundForcePerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerCubicMeter(meganewtonspercubicmeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field MeganewtonPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCubicCentimeter(newtonspercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field NewtonPerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCubicMeter(newtonspercubicmeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field NewtonPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCubicMillimeter(newtonspercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field NewtonPerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerCubicFoot(poundsforcepercubicfoot: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field PoundForcePerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerCubicInch(poundsforcepercubicinch: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field PoundForcePerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCubicCentimeter(tonnesforcepercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field TonneForcePerCubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCubicMeter(tonnesforcepercubicmeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field TonneForcePerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCubicMillimeter(tonnesforcepercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Creates a "SpecificWeight" from "Field TonneForcePerCubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificWeightUnit) -> SpecificWeight:
        """ Dynamically convert from value and unit enum "SpecificWeightUnit" to "SpecificWeight".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificWeightUnit
        :return: SpecificWeight unit value.
        :rtype: SpecificWeight
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificWeight:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificWeight:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificWeight) -> typing.Tuple[SpecificWeight, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificWeight
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificWeight) -> typing.Tuple[SpecificWeight, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificWeight
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificWeightUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificWeightUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificWeightUnit) -> typing.Tuple[SpecificWeightUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificWeightUnit) -> typing.Tuple[SpecificWeightUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificWeightUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Speed(ValueType, IQuantity[SpeedUnit], IQuantity, IFormattable, IEquatable[Speed], IComparable, IComparable[Speed], IConvertible):
    """ In everyday use and in kinematics, the speed of an object is the magnitude of its velocity (the rate of change of its position); it is thus a scalar quantity.[1] The average speed of an object in an interval of time is the distance travelled by the object divided by the duration of the interval;[2] the instantaneous speed is the limit of the average speed as the duration of the time interval approaches zero.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SpeedUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpeedUnit]

    MaxValue: typing.ClassVar[Speed]

    MinValue: typing.ClassVar[Speed]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpeedUnit]]

    Zero: typing.ClassVar[Speed]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpeedUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpeedUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterPerHour"
        """
        pass

    @property
    def CentimetersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterPerMinute"
        """
        pass

    @property
    def CentimetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterPerSecond"
        """
        pass

    @property
    def DecimetersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimeterPerMinute"
        """
        pass

    @property
    def DecimetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimeterPerSecond"
        """
        pass

    @property
    def FeetPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootPerHour"
        """
        pass

    @property
    def FeetPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootPerMinute"
        """
        pass

    @property
    def FeetPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootPerSecond"
        """
        pass

    @property
    def InchesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchPerHour"
        """
        pass

    @property
    def InchesPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchPerMinute"
        """
        pass

    @property
    def InchesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchPerSecond"
        """
        pass

    @property
    def KilometersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilometerPerHour"
        """
        pass

    @property
    def KilometersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilometerPerMinute"
        """
        pass

    @property
    def KilometersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilometerPerSecond"
        """
        pass

    @property
    def Knots(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Knot"
        """
        pass

    @property
    def Mach(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Mach"
        """
        pass

    @property
    def MetersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterPerHour"
        """
        pass

    @property
    def MetersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterPerMinute"
        """
        pass

    @property
    def MetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterPerSecond"
        """
        pass

    @property
    def MicrometersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrometerPerMinute"
        """
        pass

    @property
    def MicrometersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrometerPerSecond"
        """
        pass

    @property
    def MilesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilePerHour"
        """
        pass

    @property
    def MillimetersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterPerHour"
        """
        pass

    @property
    def MillimetersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterPerMinute"
        """
        pass

    @property
    def MillimetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterPerSecond"
        """
        pass

    @property
    def NanometersPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanometerPerMinute"
        """
        pass

    @property
    def NanometersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanometerPerSecond"
        """
        pass

    @property
    def UsSurveyFeetPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsSurveyFootPerHour"
        """
        pass

    @property
    def UsSurveyFeetPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsSurveyFootPerMinute"
        """
        pass

    @property
    def UsSurveyFeetPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsSurveyFootPerSecond"
        """
        pass

    @property
    def YardsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field YardPerHour"
        """
        pass

    @property
    def YardsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field YardPerMinute"
        """
        pass

    @property
    def YardsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field YardPerSecond"
        """
        pass

    def __init__(self, value: float, unit: SpeedUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpeedUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromKilometersPerMinutes(kilometersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field KilometerPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerSecond(kilometerspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field KilometerPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnots(knots: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field Knot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMach(mach: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field Mach".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerHour(metersperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MeterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerMinutes(metersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerSecond(meterspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerMinutes(micrometersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MicrometerPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerSecond(micrometerspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MicrometerPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilesPerHour(milesperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MilePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerHour(millimetersperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MillimeterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerMinutes(millimetersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MillimeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerSecond(millimeterspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field MillimeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerMinutes(nanometersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field NanometerPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerSecond(nanometerspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field NanometerPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeetPerHour(ussurveyfeetperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field UsSurveyFootPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeetPerMinute(ussurveyfeetperminute: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field UsSurveyFootPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeetPerSecond(ussurveyfeetpersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field UsSurveyFootPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYardsPerHour(yardsperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field YardPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYardsPerMinute(yardsperminute: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field YardPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYardsPerSecond(yardspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field YardPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpeedUnit) -> Speed:
        """ Dynamically convert from value and unit enum "SpeedUnit" to "Speed".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpeedUnit
        :return: Speed unit value.
        :rtype: Speed
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Speed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Speed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Speed) -> typing.Tuple[Speed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Speed
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Speed) -> typing.Tuple[Speed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Speed
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpeedUnit) -> typing.Tuple[SpeedUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpeedUnit) -> typing.Tuple[SpeedUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpeedUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Speed) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Speed) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Speed, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Speed within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Speed
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Speed.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpeedUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpeedUnit) -> Speed:
        """ Converts this Speed to another Speed with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpeedUnit
        :return: A Speed with the specified unit.
        :rtype: Speed
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpeedUnit, unitConverter: UnitConverter) -> Speed:
        """ Converts this "Speed" to another "Speed" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpeedUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Speed with the specified unit.
        :rtype: Speed
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Speed:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpeedUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpeedUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpeedUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpeedUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersPerHour(centimetersperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field CentimeterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentimetersPerMinutes(centimetersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field CentimeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentimetersPerSecond(centimeterspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field CentimeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerMinutes(decimetersperminutes: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field DecimeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerSecond(decimeterspersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field DecimeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerHour(feetperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field FootPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerMinute(feetperminute: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field FootPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerSecond(feetpersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field FootPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerHour(inchesperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field InchPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerMinute(inchesperminute: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field InchPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerSecond(inchespersecond: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field InchPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerHour(kilometersperhour: QuantityValue) -> Speed:
        """ Creates a "Speed" from "Field KilometerPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Strain(ValueType, IQuantity[StrainUnit], IQuantity, IFormattable, IEquatable[Strain], IComparable, IComparable[Strain], IConvertible):
    """ .
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[StrainUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[StrainUnit]

    MaxValue: typing.ClassVar[Strain]

    MinValue: typing.ClassVar[Strain]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[StrainUnit]]

    Zero: typing.ClassVar[Strain]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> StrainUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[StrainUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def MicroStrain(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroStrain"
        """
        pass

    @property
    def MilliStrain(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliStrain"
        """
        pass

    @property
    def Percent(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Percent"
        """
        pass

    @property
    def Ratio(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Ratio"
        """
        pass

    def __init__(self, value: float, unit: StrainUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: StrainUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: StrainUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: StrainUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: StrainUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: StrainUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromMicroStrain(microstrain: QuantityValue) -> Strain:
        """ Creates a "Strain" from "Field MicroStrain".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliStrain(millistrain: QuantityValue) -> Strain:
        """ Creates a "Strain" from "Field MilliStrain".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> Strain:
        """ Creates a "Strain" from "Field Percent".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRatio(ratio: QuantityValue) -> Strain:
        """ Creates a "Strain" from "Field Ratio".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: StrainUnit) -> Strain:
        """ Dynamically convert from value and unit enum "StrainUnit" to "Strain".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: StrainUnit
        :return: Strain unit value.
        :rtype: Strain
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Strain:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Strain:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Strain) -> typing.Tuple[Strain, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Strain
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Strain) -> typing.Tuple[Strain, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Strain
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> StrainUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> StrainUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: StrainUnit) -> typing.Tuple[StrainUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: StrainUnit) -> typing.Tuple[StrainUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: StrainUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Strain) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Strain) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Strain, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Strain within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Strain
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Strain.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: StrainUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: StrainUnit) -> Strain:
        """ Converts this Strain to another Strain with the unit representation .

        :param unit: The unit to convert to.
        :type unit: StrainUnit
        :return: A Strain with the specified unit.
        :rtype: Strain
        """
        pass

    @typing.overload
    def ToUnit(self, unit: StrainUnit, unitConverter: UnitConverter) -> Strain:
        """ Converts this "Strain" to another "Strain" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: StrainUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Strain with the specified unit.
        :rtype: Strain
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Strain:
        """
        """
        pass


# noinspection PyPep8Naming
class Temperature(ValueType, IQuantity[TemperatureUnit], IQuantity, IFormattable, IEquatable[Temperature], IComparable, IComparable[Temperature], IConvertible):
    """ A temperature is a numerical measure of hot or cold. Its measurement is by detection of heat radiation or particle velocity or kinetic energy, or by the bulk behavior of a thermometric material. It may be calibrated in any of various temperature scales, Celsius, Fahrenheit, Kelvin, etc. The fundamental physical definition of temperature is provided by thermodynamics.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TemperatureUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureUnit]

    MaxValue: typing.ClassVar[Temperature]

    MinValue: typing.ClassVar[Temperature]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureUnit]]

    Zero: typing.ClassVar[Temperature]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsius"
        """
        pass

    @property
    def DegreesDelisle(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeDelisle"
        """
        pass

    @property
    def DegreesFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeFahrenheit"
        """
        pass

    @property
    def DegreesNewton(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeNewton"
        """
        pass

    @property
    def DegreesRankine(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeRankine"
        """
        pass

    @property
    def DegreesReaumur(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeReaumur"
        """
        pass

    @property
    def DegreesRoemer(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeRoemer"
        """
        pass

    @property
    def Kelvins(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kelvin"
        """
        pass

    @property
    def MillidegreesCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillidegreeCelsius"
        """
        pass

    @property
    def SolarTemperatures(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SolarTemperature"
        """
        pass

    def __init__(self, value: float, unit: TemperatureUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureUnit) -> Temperature:
        """ Converts this Temperature to another Temperature with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureUnit
        :return: A Temperature with the specified unit.
        :rtype: Temperature
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureUnit, unitConverter: UnitConverter) -> Temperature:
        """ Converts this "Temperature" to another "Temperature" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Temperature with the specified unit.
        :rtype: Temperature
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Temperature:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def Multiply(self, factor: float, unit: TemperatureUnit) -> Temperature:
        """ Multiply temperature with a in a given .
         Due to different temperature units having different zero points, we cannot simply
         multiply or divide a temperature by a factor. We must first convert to the desired unit, then perform the
         calculation.

        :param factor: Factor to multiply by.
        :type factor: float
        :param unit: Unit to perform multiplication in.
        :type unit: TemperatureUnit
        :return: The resulting "Temperature".
        :rtype: Temperature
        """
        pass

    def Divide(self, divisor: float, unit: TemperatureUnit) -> Temperature:
        """ Divide temperature by a in a given .
         Due to different temperature units having different zero points, we cannot simply
         multiply or divide a temperature by a factor. We must first convert to the desired unit, then perform the
         calculation.

        :param divisor: Factor to multiply by.
        :type divisor: float
        :param unit: Unit to perform multiplication in.
        :type unit: TemperatureUnit
        :return: The resulting "Temperature".
        :rtype: Temperature
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelsius(degreescelsius: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesDelisle(degreesdelisle: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeDelisle".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesFahrenheit(degreesfahrenheit: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesNewton(degreesnewton: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeNewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRankine(degreesrankine: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeRankine".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesReaumur(degreesreaumur: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeReaumur".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRoemer(degreesroemer: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field DegreeRoemer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKelvins(kelvins: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field Kelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesCelsius(millidegreescelsius: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field MillidegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarTemperatures(solartemperatures: QuantityValue) -> Temperature:
        """ Creates a "Temperature" from "Field SolarTemperature".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureUnit) -> Temperature:
        """ Dynamically convert from value and unit enum "TemperatureUnit" to "Temperature".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureUnit
        :return: Temperature unit value.
        :rtype: Temperature
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Temperature:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Temperature:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Temperature) -> typing.Tuple[Temperature, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Temperature
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Temperature) -> typing.Tuple[Temperature, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Temperature
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureUnit) -> typing.Tuple[TemperatureUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureUnit) -> typing.Tuple[TemperatureUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Temperature) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Temperature) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Temperature, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Temperature within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Temperature
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Temperature.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class TemperatureChangeRate(ValueType, IQuantity[TemperatureChangeRateUnit], IQuantity, IFormattable, IEquatable[TemperatureChangeRate], IComparable, IComparable[TemperatureChangeRate], IConvertible):
    """ Temperature change rate is the ratio of the temperature change to the time during which the change occurred (value of temperature changes per unit time).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TemperatureChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureChangeRateUnit]

    MaxValue: typing.ClassVar[TemperatureChangeRate]

    MinValue: typing.ClassVar[TemperatureChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureChangeRateUnit]]

    Zero: typing.ClassVar[TemperatureChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentidegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentidegreeCelsiusPerSecond"
        """
        pass

    @property
    def DecadegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecadegreeCelsiusPerSecond"
        """
        pass

    @property
    def DecidegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecidegreeCelsiusPerSecond"
        """
        pass

    @property
    def DegreesCelsiusPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsiusPerMinute"
        """
        pass

    @property
    def DegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsiusPerSecond"
        """
        pass

    @property
    def HectodegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectodegreeCelsiusPerSecond"
        """
        pass

    @property
    def KilodegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilodegreeCelsiusPerSecond"
        """
        pass

    @property
    def MicrodegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrodegreeCelsiusPerSecond"
        """
        pass

    @property
    def MillidegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillidegreeCelsiusPerSecond"
        """
        pass

    @property
    def NanodegreesCelsiusPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanodegreeCelsiusPerSecond"
        """
        pass

    def __init__(self, value: float, unit: TemperatureChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureChangeRateUnit) -> TemperatureChangeRate:
        """ Converts this TemperatureChangeRate to another TemperatureChangeRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureChangeRateUnit
        :return: A TemperatureChangeRate with the specified unit.
        :rtype: TemperatureChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureChangeRateUnit, unitConverter: UnitConverter) -> TemperatureChangeRate:
        """ Converts this "TemperatureChangeRate" to another "TemperatureChangeRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureChangeRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A TemperatureChangeRate with the specified unit.
        :rtype: TemperatureChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TemperatureChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentidegreesCelsiusPerSecond(centidegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field CentidegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecadegreesCelsiusPerSecond(decadegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field DecadegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecidegreesCelsiusPerSecond(decidegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field DecidegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesCelsiusPerMinute(degreescelsiusperminute: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field DegreeCelsiusPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesCelsiusPerSecond(degreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field DegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectodegreesCelsiusPerSecond(hectodegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field HectodegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilodegreesCelsiusPerSecond(kilodegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field KilodegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodegreesCelsiusPerSecond(microdegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field MicrodegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesCelsiusPerSecond(millidegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field MillidegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanodegreesCelsiusPerSecond(nanodegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Creates a "TemperatureChangeRate" from "Field NanodegreeCelsiusPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureChangeRateUnit) -> TemperatureChangeRate:
        """ Dynamically convert from value and unit enum "TemperatureChangeRateUnit" to "TemperatureChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureChangeRateUnit
        :return: TemperatureChangeRate unit value.
        :rtype: TemperatureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TemperatureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TemperatureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TemperatureChangeRate) -> typing.Tuple[TemperatureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TemperatureChangeRate) -> typing.Tuple[TemperatureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureChangeRateUnit) -> typing.Tuple[TemperatureChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureChangeRateUnit) -> typing.Tuple[TemperatureChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TemperatureChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TemperatureChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TemperatureChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TemperatureChangeRate.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class TemperatureDelta(ValueType, IQuantity[TemperatureDeltaUnit], IQuantity, IFormattable, IEquatable[TemperatureDelta], IComparable, IComparable[TemperatureDelta], IConvertible):
    """ Difference between two temperatures. The conversions are different than for Temperature.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TemperatureDeltaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureDeltaUnit]

    MaxValue: typing.ClassVar[TemperatureDelta]

    MinValue: typing.ClassVar[TemperatureDelta]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureDeltaUnit]]

    Zero: typing.ClassVar[TemperatureDelta]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureDeltaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureDeltaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsius"
        """
        pass

    @property
    def DegreesDelisle(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeDelisle"
        """
        pass

    @property
    def DegreesFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeFahrenheit"
        """
        pass

    @property
    def DegreesNewton(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeNewton"
        """
        pass

    @property
    def DegreesRankine(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeRankine"
        """
        pass

    @property
    def DegreesReaumur(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeReaumur"
        """
        pass

    @property
    def DegreesRoemer(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeRoemer"
        """
        pass

    @property
    def Kelvins(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kelvin"
        """
        pass

    @property
    def MillidegreesCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillidegreeCelsius"
        """
        pass

    def __init__(self, value: float, unit: TemperatureDeltaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureDeltaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureDeltaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureDeltaUnit) -> TemperatureDelta:
        """ Converts this TemperatureDelta to another TemperatureDelta with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureDeltaUnit
        :return: A TemperatureDelta with the specified unit.
        :rtype: TemperatureDelta
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureDeltaUnit, unitConverter: UnitConverter) -> TemperatureDelta:
        """ Converts this "TemperatureDelta" to another "TemperatureDelta" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureDeltaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A TemperatureDelta with the specified unit.
        :rtype: TemperatureDelta
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TemperatureDelta:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureDeltaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureDeltaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureDeltaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureDeltaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelsius(degreescelsius: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesDelisle(degreesdelisle: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeDelisle".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesFahrenheit(degreesfahrenheit: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesNewton(degreesnewton: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeNewton".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRankine(degreesrankine: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeRankine".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesReaumur(degreesreaumur: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeReaumur".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRoemer(degreesroemer: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field DegreeRoemer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKelvins(kelvins: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field Kelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesCelsius(millidegreescelsius: QuantityValue) -> TemperatureDelta:
        """ Creates a "TemperatureDelta" from "Field MillidegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureDeltaUnit) -> TemperatureDelta:
        """ Dynamically convert from value and unit enum "TemperatureDeltaUnit" to "TemperatureDelta".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureDeltaUnit
        :return: TemperatureDelta unit value.
        :rtype: TemperatureDelta
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TemperatureDelta:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TemperatureDelta:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TemperatureDelta) -> typing.Tuple[TemperatureDelta, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureDelta
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TemperatureDelta) -> typing.Tuple[TemperatureDelta, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureDelta
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureDeltaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureDeltaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureDeltaUnit) -> typing.Tuple[TemperatureDeltaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureDeltaUnit) -> typing.Tuple[TemperatureDeltaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureDeltaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TemperatureDelta) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureDelta) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureDelta, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TemperatureDelta within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TemperatureDelta
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TemperatureDelta.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class TemperatureGradient(ValueType, IQuantity[TemperatureGradientUnit], IQuantity, IFormattable, IEquatable[TemperatureGradient], IComparable, IComparable[TemperatureGradient], IConvertible):
    """ The rate of change of temperature with displacement in a given direction (as with increase of height)
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TemperatureGradientUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureGradientUnit]

    MaxValue: typing.ClassVar[TemperatureGradient]

    MinValue: typing.ClassVar[TemperatureGradient]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureGradientUnit]]

    Zero: typing.ClassVar[TemperatureGradient]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureGradientUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureGradientUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelciusPerKilometer(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsiusPerKilometer"
        """
        pass

    @property
    def DegreesCelciusPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeCelsiusPerMeter"
        """
        pass

    @property
    def DegreesFahrenheitPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreeFahrenheitPerFoot"
        """
        pass

    @property
    def KelvinsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KelvinPerMeter"
        """
        pass

    def __init__(self, value: float, unit: TemperatureGradientUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureGradientUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TemperatureGradient:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureGradientUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureGradientUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureGradientUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureGradientUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelciusPerKilometer(degreescelciusperkilometer: QuantityValue) -> TemperatureGradient:
        """ Creates a "TemperatureGradient" from "Field DegreeCelsiusPerKilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesCelciusPerMeter(degreescelciuspermeter: QuantityValue) -> TemperatureGradient:
        """ Creates a "TemperatureGradient" from "Field DegreeCelsiusPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesFahrenheitPerFoot(degreesfahrenheitperfoot: QuantityValue) -> TemperatureGradient:
        """ Creates a "TemperatureGradient" from "Field DegreeFahrenheitPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKelvinsPerMeter(kelvinspermeter: QuantityValue) -> TemperatureGradient:
        """ Creates a "TemperatureGradient" from "Field KelvinPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureGradientUnit) -> TemperatureGradient:
        """ Dynamically convert from value and unit enum "TemperatureGradientUnit" to "TemperatureGradient".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureGradientUnit
        :return: TemperatureGradient unit value.
        :rtype: TemperatureGradient
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TemperatureGradient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TemperatureGradient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TemperatureGradient) -> typing.Tuple[TemperatureGradient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureGradient
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TemperatureGradient) -> typing.Tuple[TemperatureGradient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureGradient
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureGradientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureGradientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureGradientUnit) -> typing.Tuple[TemperatureGradientUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureGradientUnit) -> typing.Tuple[TemperatureGradientUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureGradientUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TemperatureGradient) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureGradient) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureGradient, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TemperatureGradient within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TemperatureGradient
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TemperatureGradient.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureGradientUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureGradientUnit) -> TemperatureGradient:
        """ Converts this TemperatureGradient to another TemperatureGradient with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureGradientUnit
        :return: A TemperatureGradient with the specified unit.
        :rtype: TemperatureGradient
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureGradientUnit, unitConverter: UnitConverter) -> TemperatureGradient:
        """ Converts this "TemperatureGradient" to another "TemperatureGradient" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TemperatureGradientUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A TemperatureGradient with the specified unit.
        :rtype: TemperatureGradient
        """
        pass


# noinspection PyPep8Naming
class Torque(ValueType, IQuantity[TorqueUnit], IQuantity, IFormattable, IEquatable[Torque], IComparable, IComparable[Torque], IConvertible):
    """ Torque, moment or moment of force (see the terminology below), is the tendency of a force to rotate an object about an axis,[1] fulcrum, or pivot. Just as a force is a push or a pull, a torque can be thought of as a twist to an object. Mathematically, torque is defined as the cross product of the lever-arm distance and force, which tends to produce rotation. Loosely speaking, torque is a measure of the turning force on an object such as a bolt or a flywheel. For example, pushing or pulling the handle of a wrench connected to a nut or bolt produces a torque (turning force) that loosens or tightens the nut or bolt.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TorqueUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TorqueUnit]

    MaxValue: typing.ClassVar[Torque]

    MinValue: typing.ClassVar[Torque]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TorqueUnit]]

    Zero: typing.ClassVar[Torque]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TorqueUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TorqueUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramForceCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramForceCentimeter"
        """
        pass

    @property
    def GramForceMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramForceMeter"
        """
        pass

    @property
    def GramForceMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramForceMillimeter"
        """
        pass

    @property
    def KilogramForceCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceCentimeter"
        """
        pass

    @property
    def KilogramForceMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceMeter"
        """
        pass

    @property
    def KilogramForceMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceMillimeter"
        """
        pass

    @property
    def KilonewtonCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonCentimeter"
        """
        pass

    @property
    def KilonewtonMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMeter"
        """
        pass

    @property
    def KilonewtonMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMillimeter"
        """
        pass

    @property
    def KilopoundForceFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceFoot"
        """
        pass

    @property
    def KilopoundForceInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceInch"
        """
        pass

    @property
    def MeganewtonCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonCentimeter"
        """
        pass

    @property
    def MeganewtonMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMeter"
        """
        pass

    @property
    def MeganewtonMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMillimeter"
        """
        pass

    @property
    def MegapoundForceFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForceFoot"
        """
        pass

    @property
    def MegapoundForceInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForceInch"
        """
        pass

    @property
    def NewtonCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonCentimeter"
        """
        pass

    @property
    def NewtonMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMeter"
        """
        pass

    @property
    def NewtonMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMillimeter"
        """
        pass

    @property
    def PoundalFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundalFoot"
        """
        pass

    @property
    def PoundForceFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceFoot"
        """
        pass

    @property
    def PoundForceInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceInch"
        """
        pass

    @property
    def TonneForceCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceCentimeter"
        """
        pass

    @property
    def TonneForceMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceMeter"
        """
        pass

    @property
    def TonneForceMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceMillimeter"
        """
        pass

    def __init__(self, value: float, unit: TorqueUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TorqueUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Torque:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Torque:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Torque) -> typing.Tuple[Torque, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Torque
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Torque) -> typing.Tuple[Torque, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Torque
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TorqueUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TorqueUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TorqueUnit) -> typing.Tuple[TorqueUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TorqueUnit) -> typing.Tuple[TorqueUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TorqueUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Torque) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Torque) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Torque, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Torque within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Torque
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Torque.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TorqueUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TorqueUnit) -> Torque:
        """ Converts this Torque to another Torque with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TorqueUnit
        :return: A Torque with the specified unit.
        :rtype: Torque
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TorqueUnit, unitConverter: UnitConverter) -> Torque:
        """ Converts this "Torque" to another "Torque" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TorqueUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Torque with the specified unit.
        :rtype: Torque
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Torque:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorqueUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorqueUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorqueUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorqueUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramForceCentimeters(gramforcecentimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field GramForceCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramForceMeters(gramforcemeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field GramForceMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramForceMillimeters(gramforcemillimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field GramForceMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceCentimeters(kilogramforcecentimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilogramForceCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMeters(kilogramforcemeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilogramForceMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMillimeters(kilogramforcemillimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilogramForceMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonCentimeters(kilonewtoncentimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilonewtonCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMeters(kilonewtonmeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilonewtonMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimeters(kilonewtonmillimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilonewtonMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeet(kilopoundforcefeet: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilopoundForceFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceInches(kilopoundforceinches: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field KilopoundForceInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonCentimeters(meganewtoncentimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field MeganewtonCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMeters(meganewtonmeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field MeganewtonMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimeters(meganewtonmillimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field MeganewtonMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceFeet(megapoundforcefeet: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field MegapoundForceFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceInches(megapoundforceinches: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field MegapoundForceInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonCentimeters(newtoncentimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field NewtonCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMeters(newtonmeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field NewtonMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimeters(newtonmillimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field NewtonMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundalFeet(poundalfeet: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field PoundalFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeet(poundforcefeet: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field PoundForceFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceInches(poundforceinches: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field PoundForceInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceCentimeters(tonneforcecentimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field TonneForceCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMeters(tonneforcemeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field TonneForceMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMillimeters(tonneforcemillimeters: QuantityValue) -> Torque:
        """ Creates a "Torque" from "Field TonneForceMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TorqueUnit) -> Torque:
        """ Dynamically convert from value and unit enum "TorqueUnit" to "Torque".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TorqueUnit
        :return: Torque unit value.
        :rtype: Torque
        """
        pass


# noinspection PyPep8Naming
class Volume(ValueType, IQuantity[VolumeUnit], IQuantity, IFormattable, IEquatable[Volume], IComparable, IComparable[Volume], IConvertible):
    """ Volume is the quantity of three-dimensional space enclosed by some closed boundary, for example, the space that a substance (solid, liquid, gas, or plasma) or shape occupies or contains.[1] Volume is often quantified numerically using the SI derived unit, the cubic metre. The volume of a container is generally understood to be the capacity of the container, i. e. the amount of fluid (gas or liquid) that the container could hold, rather than the amount of space the container itself displaces.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VolumeUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeUnit]

    MaxValue: typing.ClassVar[Volume]

    MinValue: typing.ClassVar[Volume]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeUnit]]

    Zero: typing.ClassVar[Volume]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AcreFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AcreFoot"
        """
        pass

    @property
    def AuTablespoons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AuTablespoon"
        """
        pass

    @property
    def BoardFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BoardFoot"
        """
        pass

    @property
    def Centiliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Centiliter"
        """
        pass

    @property
    def CubicCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicCentimeter"
        """
        pass

    @property
    def CubicDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicDecimeter"
        """
        pass

    @property
    def CubicFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFoot"
        """
        pass

    @property
    def CubicHectometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicHectometer"
        """
        pass

    @property
    def CubicInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicInch"
        """
        pass

    @property
    def CubicKilometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicKilometer"
        """
        pass

    @property
    def CubicMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeter"
        """
        pass

    @property
    def CubicMicrometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMicrometer"
        """
        pass

    @property
    def CubicMiles(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMile"
        """
        pass

    @property
    def CubicMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMillimeter"
        """
        pass

    @property
    def CubicYards(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYard"
        """
        pass

    @property
    def Decaliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decaliter"
        """
        pass

    @property
    def DecausGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecausGallon"
        """
        pass

    @property
    def Deciliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Deciliter"
        """
        pass

    @property
    def DeciusGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciusGallon"
        """
        pass

    @property
    def HectocubicFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectocubicFoot"
        """
        pass

    @property
    def HectocubicMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectocubicMeter"
        """
        pass

    @property
    def Hectoliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hectoliter"
        """
        pass

    @property
    def HectousGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectousGallon"
        """
        pass

    @property
    def ImperialBeerBarrels(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ImperialBeerBarrel"
        """
        pass

    @property
    def ImperialGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ImperialGallon"
        """
        pass

    @property
    def ImperialOunces(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ImperialOunce"
        """
        pass

    @property
    def ImperialPints(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ImperialPint"
        """
        pass

    @property
    def KilocubicFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocubicFoot"
        """
        pass

    @property
    def KilocubicMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocubicMeter"
        """
        pass

    @property
    def KiloimperialGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloimperialGallon"
        """
        pass

    @property
    def Kiloliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kiloliter"
        """
        pass

    @property
    def KilousGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilousGallon"
        """
        pass

    @property
    def Liters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Liter"
        """
        pass

    @property
    def MegacubicFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegacubicFoot"
        """
        pass

    @property
    def MegaimperialGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaimperialGallon"
        """
        pass

    @property
    def Megaliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megaliter"
        """
        pass

    @property
    def MegausGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegausGallon"
        """
        pass

    @property
    def MetricCups(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MetricCup"
        """
        pass

    @property
    def MetricTeaspoons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MetricTeaspoon"
        """
        pass

    @property
    def Microliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microliter"
        """
        pass

    @property
    def Milliliters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milliliter"
        """
        pass

    @property
    def OilBarrels(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OilBarrel"
        """
        pass

    @property
    def UkTablespoons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UkTablespoon"
        """
        pass

    @property
    def UsBeerBarrels(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsBeerBarrel"
        """
        pass

    @property
    def UsCustomaryCups(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsCustomaryCup"
        """
        pass

    @property
    def UsGallons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsGallon"
        """
        pass

    @property
    def UsLegalCups(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsLegalCup"
        """
        pass

    @property
    def UsOunces(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsOunce"
        """
        pass

    @property
    def UsPints(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsPint"
        """
        pass

    @property
    def UsQuarts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsQuart"
        """
        pass

    @property
    def UsTablespoons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsTablespoon"
        """
        pass

    @property
    def UsTeaspoons(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsTeaspoon"
        """
        pass

    def __init__(self, value: float, unit: VolumeUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: VolumeUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeUnit) -> Volume:
        """ Converts this Volume to another Volume with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeUnit
        :return: A Volume with the specified unit.
        :rtype: Volume
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeUnit, unitConverter: UnitConverter) -> Volume:
        """ Converts this "Volume" to another "Volume" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Volume with the specified unit.
        :rtype: Volume
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Volume:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAcreFeet(acrefeet: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field AcreFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAuTablespoons(autablespoons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field AuTablespoon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBoardFeet(boardfeet: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field BoardFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiliters(centiliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Centiliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicCentimeters(cubiccentimeters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicDecimeters(cubicdecimeters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeet(cubicfeet: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicHectometers(cubichectometers: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicHectometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicInches(cubicinches: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicKilometers(cubickilometers: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicKilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMeters(cubicmeters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMicrometers(cubicmicrometers: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicMicrometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMiles(cubicmiles: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicMile".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMillimeters(cubicmillimeters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYards(cubicyards: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field CubicYard".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecaliters(decaliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Decaliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecausGallons(decausgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field DecausGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciliters(deciliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Deciliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciusGallons(deciusgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field DeciusGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectocubicFeet(hectocubicfeet: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field HectocubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectocubicMeters(hectocubicmeters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field HectocubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectoliters(hectoliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Hectoliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectousGallons(hectousgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field HectousGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialBeerBarrels(imperialbeerbarrels: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field ImperialBeerBarrel".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialGallons(imperialgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field ImperialGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialOunces(imperialounces: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field ImperialOunce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialPints(imperialpints: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field ImperialPint".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocubicFeet(kilocubicfeet: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field KilocubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocubicMeters(kilocubicmeters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field KilocubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloimperialGallons(kiloimperialgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field KiloimperialGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloliters(kiloliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Kiloliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilousGallons(kilousgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field KilousGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLiters(liters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Liter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegacubicFeet(megacubicfeet: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field MegacubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaimperialGallons(megaimperialgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field MegaimperialGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaliters(megaliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Megaliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegausGallons(megausgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field MegausGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetricCups(metriccups: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field MetricCup".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetricTeaspoons(metricteaspoons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field MetricTeaspoon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroliters(microliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Microliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliliters(milliliters: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field Milliliter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrels(oilbarrels: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field OilBarrel".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkTablespoons(uktablespoons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UkTablespoon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsBeerBarrels(usbeerbarrels: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsBeerBarrel".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsCustomaryCups(uscustomarycups: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsCustomaryCup".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallons(usgallons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsLegalCups(uslegalcups: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsLegalCup".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsOunces(usounces: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsOunce".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsPints(uspints: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsPint".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsQuarts(usquarts: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsQuart".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsTablespoons(ustablespoons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsTablespoon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsTeaspoons(usteaspoons: QuantityValue) -> Volume:
        """ Creates a "Volume" from "Field UsTeaspoon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeUnit) -> Volume:
        """ Dynamically convert from value and unit enum "VolumeUnit" to "Volume".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeUnit
        :return: Volume unit value.
        :rtype: Volume
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Volume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Volume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Volume) -> typing.Tuple[Volume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Volume
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Volume) -> typing.Tuple[Volume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Volume
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeUnit) -> typing.Tuple[VolumeUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeUnit) -> typing.Tuple[VolumeUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Volume) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Volume) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Volume, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Volume within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Volume
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Volume.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class VolumeConcentration(ValueType, IQuantity[VolumeConcentrationUnit], IQuantity, IFormattable, IEquatable[VolumeConcentration], IComparable, IComparable[VolumeConcentration], IConvertible):
    """ The volume concentration (not to be confused with volume fraction) is defined as the volume of a constituent divided by the total volume of the mixture.
     https://en.wikipedia.org/wiki/Concentration#Volume_concentration
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VolumeConcentrationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeConcentrationUnit]

    MaxValue: typing.ClassVar[VolumeConcentration]

    MinValue: typing.ClassVar[VolumeConcentration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeConcentrationUnit]]

    Zero: typing.ClassVar[VolumeConcentration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeConcentrationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeConcentrationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentilitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentilitersPerLiter"
        """
        pass

    @property
    def CentilitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentilitersPerMililiter"
        """
        pass

    @property
    def DecilitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecilitersPerLiter"
        """
        pass

    @property
    def DecilitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecilitersPerMililiter"
        """
        pass

    @property
    def DecimalFractions(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimalFraction"
        """
        pass

    @property
    def LitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LitersPerLiter"
        """
        pass

    @property
    def LitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LitersPerMililiter"
        """
        pass

    @property
    def MicrolitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrolitersPerLiter"
        """
        pass

    @property
    def MicrolitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrolitersPerMililiter"
        """
        pass

    @property
    def MillilitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillilitersPerLiter"
        """
        pass

    @property
    def MillilitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillilitersPerMililiter"
        """
        pass

    @property
    def NanolitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanolitersPerLiter"
        """
        pass

    @property
    def NanolitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanolitersPerMililiter"
        """
        pass

    @property
    def PartsPerBillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerBillion"
        """
        pass

    @property
    def PartsPerMillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerMillion"
        """
        pass

    @property
    def PartsPerThousand(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerThousand"
        """
        pass

    @property
    def PartsPerTrillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerTrillion"
        """
        pass

    @property
    def Percent(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Percent"
        """
        pass

    @property
    def PicolitersPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicolitersPerLiter"
        """
        pass

    @property
    def PicolitersPerMililiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicolitersPerMililiter"
        """
        pass

    def __init__(self, value: float, unit: VolumeConcentrationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeConcentrationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumeConcentration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeConcentration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeConcentration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumeConcentration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumeConcentration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumeConcentration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumeConcentrationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeConcentrationUnit) -> VolumeConcentration:
        """ Converts this VolumeConcentration to another VolumeConcentration with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeConcentrationUnit
        :return: A VolumeConcentration with the specified unit.
        :rtype: VolumeConcentration
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeConcentrationUnit, unitConverter: UnitConverter) -> VolumeConcentration:
        """ Converts this "VolumeConcentration" to another "VolumeConcentration" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeConcentrationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A VolumeConcentration with the specified unit.
        :rtype: VolumeConcentration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumeConcentration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToMassConcentration(self, componentDensity: Density) -> MassConcentration:
        """Get "MassConcentration" from this "VolumeConcentration" and component "Density" .

        :param componentDensity:
        :type componentDensity: Density
        :return:
        :rtype: MassConcentration
        """
        pass

    def ToMolarity(self, componentDensity: Density, compontMolarMass: MolarMass) -> Molarity:
        """Get "Molarity" from this "VolumeConcentration" and component "Density" and "MolarMass" .

        :param componentDensity:
        :type componentDensity: Density
        :param compontMolarMass:
        :type compontMolarMass: MolarMass
        :return:
        :rtype: Molarity
        """
        pass

    @staticmethod
    def FromVolumes(componentVolume: Volume, mixtureMass: Volume) -> VolumeConcentration:
        """ Get "VolumeConcentration" from a component "Volume" and total mixture "Volume" .
        """
        pass

    @staticmethod
    def FromMolarity(molarity: Molarity, componentDensity: Density, componentMolarMass: MolarMass) -> VolumeConcentration:
        """ Get a "VolumeConcentration" from "Molarity" and a component "Density" and "MolarMass".

        :param molarity:
        :type molarity: Molarity
        :param componentDensity:
        :type componentDensity: Density
        :param componentMolarMass:
        :type componentMolarMass: MolarMass
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeConcentrationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeConcentrationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeConcentrationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeConcentrationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentilitersPerLiter(centilitersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field CentilitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerMililiter(centiliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field CentilitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerLiter(decilitersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field DecilitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerMililiter(deciliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field DecilitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimalFractions(decimalfractions: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field DecimalFraction".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerLiter(litersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field LitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMililiter(literspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field LitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerLiter(microlitersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field MicrolitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerMililiter(microliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field MicrolitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerLiter(millilitersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field MillilitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerMililiter(milliliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field MillilitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerLiter(nanolitersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field NanolitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerMililiter(nanoliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field NanolitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerBillion(partsperbillion: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field PartPerBillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerMillion(partspermillion: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field PartPerMillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerThousand(partsperthousand: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field PartPerThousand".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerTrillion(partspertrillion: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field PartPerTrillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field Percent".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicolitersPerLiter(picolitersperliter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field PicolitersPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicolitersPerMililiter(picoliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Creates a "VolumeConcentration" from "Field PicolitersPerMililiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeConcentrationUnit) -> VolumeConcentration:
        """ Dynamically convert from value and unit enum "VolumeConcentrationUnit" to "VolumeConcentration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeConcentrationUnit
        :return: VolumeConcentration unit value.
        :rtype: VolumeConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumeConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumeConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumeConcentration) -> typing.Tuple[VolumeConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumeConcentration) -> typing.Tuple[VolumeConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeConcentration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeConcentrationUnit) -> typing.Tuple[VolumeConcentrationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeConcentrationUnit) -> typing.Tuple[VolumeConcentrationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeConcentrationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class VolumeFlow(ValueType, IQuantity[VolumeFlowUnit], IQuantity, IFormattable, IEquatable[VolumeFlow], IComparable, IComparable[VolumeFlow], IConvertible):
    """ In physics and engineering, in particular fluid dynamics and hydrometry, the volumetric flow rate, (also known as volume flow rate, rate of fluid flow or volume velocity) is the volume of fluid which passes through a given surface per unit time. The SI unit is m³/s (cubic meters per second). In US Customary Units and British Imperial Units, volumetric flow rate is often expressed as ft³/s (cubic feet per second). It is usually represented by the symbol Q.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VolumeFlowUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeFlowUnit]

    MaxValue: typing.ClassVar[VolumeFlow]

    MinValue: typing.ClassVar[VolumeFlow]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeFlowUnit]]

    Zero: typing.ClassVar[VolumeFlow]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeFlowUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeFlowUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AcreFeetPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AcreFootPerDay"
        """
        pass

    @property
    def AcreFeetPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AcreFootPerHour"
        """
        pass

    @property
    def AcreFeetPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AcreFootPerMinute"
        """
        pass

    @property
    def AcreFeetPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AcreFootPerSecond"
        """
        pass

    @property
    def CentilitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentiliterPerDay"
        """
        pass

    @property
    def CentilitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentiliterPerHour"
        """
        pass

    @property
    def CentilitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentiliterPerMinute"
        """
        pass

    @property
    def CentilitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentiliterPerSecond"
        """
        pass

    @property
    def CubicCentimetersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicCentimeterPerMinute"
        """
        pass

    @property
    def CubicDecimetersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicDecimeterPerMinute"
        """
        pass

    @property
    def CubicFeetPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFootPerHour"
        """
        pass

    @property
    def CubicFeetPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFootPerMinute"
        """
        pass

    @property
    def CubicFeetPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFootPerSecond"
        """
        pass

    @property
    def CubicMetersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerDay"
        """
        pass

    @property
    def CubicMetersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerHour"
        """
        pass

    @property
    def CubicMetersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerMinute"
        """
        pass

    @property
    def CubicMetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerSecond"
        """
        pass

    @property
    def CubicMillimetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMillimeterPerSecond"
        """
        pass

    @property
    def CubicYardsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYardPerDay"
        """
        pass

    @property
    def CubicYardsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYardPerHour"
        """
        pass

    @property
    def CubicYardsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYardPerMinute"
        """
        pass

    @property
    def CubicYardsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYardPerSecond"
        """
        pass

    @property
    def DecilitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciliterPerDay"
        """
        pass

    @property
    def DecilitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciliterPerHour"
        """
        pass

    @property
    def DecilitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciliterPerMinute"
        """
        pass

    @property
    def DecilitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciliterPerSecond"
        """
        pass

    @property
    def KilolitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloliterPerDay"
        """
        pass

    @property
    def KilolitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloliterPerHour"
        """
        pass

    @property
    def KilolitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloliterPerMinute"
        """
        pass

    @property
    def KilolitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KiloliterPerSecond"
        """
        pass

    @property
    def KilousGallonsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilousGallonPerMinute"
        """
        pass

    @property
    def LitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerDay"
        """
        pass

    @property
    def LitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerHour"
        """
        pass

    @property
    def LitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerMinute"
        """
        pass

    @property
    def LitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerSecond"
        """
        pass

    @property
    def MegalitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaliterPerDay"
        """
        pass

    @property
    def MegaukGallonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegaukGallonPerSecond"
        """
        pass

    @property
    def MicrolitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroliterPerDay"
        """
        pass

    @property
    def MicrolitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroliterPerHour"
        """
        pass

    @property
    def MicrolitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroliterPerMinute"
        """
        pass

    @property
    def MicrolitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicroliterPerSecond"
        """
        pass

    @property
    def MillilitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliliterPerDay"
        """
        pass

    @property
    def MillilitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliliterPerHour"
        """
        pass

    @property
    def MillilitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliliterPerMinute"
        """
        pass

    @property
    def MillilitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliliterPerSecond"
        """
        pass

    @property
    def MillionUsGallonsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillionUsGallonsPerDay"
        """
        pass

    @property
    def NanolitersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoliterPerDay"
        """
        pass

    @property
    def NanolitersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoliterPerHour"
        """
        pass

    @property
    def NanolitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoliterPerMinute"
        """
        pass

    @property
    def NanolitersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanoliterPerSecond"
        """
        pass

    @property
    def OilBarrelsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OilBarrelPerDay"
        """
        pass

    @property
    def OilBarrelsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OilBarrelPerHour"
        """
        pass

    @property
    def OilBarrelsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OilBarrelPerMinute"
        """
        pass

    @property
    def OilBarrelsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OilBarrelPerSecond"
        """
        pass

    @property
    def UkGallonsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UkGallonPerDay"
        """
        pass

    @property
    def UkGallonsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UkGallonPerHour"
        """
        pass

    @property
    def UkGallonsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UkGallonPerMinute"
        """
        pass

    @property
    def UkGallonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UkGallonPerSecond"
        """
        pass

    @property
    def UsGallonsPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsGallonPerDay"
        """
        pass

    @property
    def UsGallonsPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsGallonPerHour"
        """
        pass

    @property
    def UsGallonsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsGallonPerMinute"
        """
        pass

    @property
    def UsGallonsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field UsGallonPerSecond"
        """
        pass

    def __init__(self, value: float, unit: VolumeFlowUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeFlowUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumeFlow) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeFlow) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeFlow, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumeFlow within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumeFlow
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumeFlow.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumeFlowUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeFlowUnit) -> VolumeFlow:
        """ Converts this VolumeFlow to another VolumeFlow with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeFlowUnit
        :return: A VolumeFlow with the specified unit.
        :rtype: VolumeFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeFlowUnit, unitConverter: UnitConverter) -> VolumeFlow:
        """ Converts this "VolumeFlow" to another "VolumeFlow" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeFlowUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A VolumeFlow with the specified unit.
        :rtype: VolumeFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumeFlow:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeFlowUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeFlowUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeFlowUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeFlowUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAcreFeetPerDay(acrefeetperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field AcreFootPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAcreFeetPerHour(acrefeetperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field AcreFootPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAcreFeetPerMinute(acrefeetperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field AcreFootPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAcreFeetPerSecond(acrefeetpersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field AcreFootPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerDay(centilitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CentiliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerHour(centilitersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CentiliterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerMinute(centilitersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CentiliterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerSecond(centiliterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CentiliterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicCentimetersPerMinute(cubiccentimetersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicCentimeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicDecimetersPerMinute(cubicdecimetersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicDecimeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeetPerHour(cubicfeetperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicFootPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeetPerMinute(cubicfeetperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicFootPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeetPerSecond(cubicfeetpersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicFootPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerDay(cubicmetersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicMeterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerHour(cubicmetersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicMeterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerMinute(cubicmetersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicMeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerSecond(cubicmeterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicMeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMillimetersPerSecond(cubicmillimeterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicMillimeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerDay(cubicyardsperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicYardPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerHour(cubicyardsperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicYardPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerMinute(cubicyardsperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicYardPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerSecond(cubicyardspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field CubicYardPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerDay(decilitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field DeciliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerHour(decilitersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field DeciliterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerMinute(decilitersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field DeciliterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerSecond(deciliterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field DeciliterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerDay(kilolitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field KiloliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerHour(kilolitersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field KiloliterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerMinute(kilolitersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field KiloliterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerSecond(kiloliterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field KiloliterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilousGallonsPerMinute(kilousgallonsperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field KilousGallonPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerDay(litersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field LiterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerHour(litersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field LiterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMinute(litersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field LiterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerSecond(literspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field LiterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegalitersPerDay(megalitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MegaliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaukGallonsPerSecond(megaukgallonspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MegaukGallonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerDay(microlitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MicroliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerHour(microlitersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MicroliterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerMinute(microlitersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MicroliterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerSecond(microliterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MicroliterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerDay(millilitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MilliliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerHour(millilitersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MilliliterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerMinute(millilitersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MilliliterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerSecond(milliliterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MilliliterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillionUsGallonsPerDay(millionusgallonsperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field MillionUsGallonsPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerDay(nanolitersperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field NanoliterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerHour(nanolitersperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field NanoliterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerMinute(nanolitersperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field NanoliterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerSecond(nanoliterspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field NanoliterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerDay(oilbarrelsperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field OilBarrelPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerHour(oilbarrelsperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field OilBarrelPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerMinute(oilbarrelsperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field OilBarrelPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerSecond(oilbarrelspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field OilBarrelPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerDay(ukgallonsperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UkGallonPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerHour(ukgallonsperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UkGallonPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerMinute(ukgallonsperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UkGallonPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerSecond(ukgallonspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UkGallonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerDay(usgallonsperday: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UsGallonPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerHour(usgallonsperhour: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UsGallonPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerMinute(usgallonsperminute: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UsGallonPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerSecond(usgallonspersecond: QuantityValue) -> VolumeFlow:
        """ Creates a "VolumeFlow" from "Field UsGallonPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeFlowUnit) -> VolumeFlow:
        """ Dynamically convert from value and unit enum "VolumeFlowUnit" to "VolumeFlow".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeFlowUnit
        :return: VolumeFlow unit value.
        :rtype: VolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumeFlow) -> typing.Tuple[VolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumeFlow) -> typing.Tuple[VolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeFlow
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeFlowUnit) -> typing.Tuple[VolumeFlowUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeFlowUnit) -> typing.Tuple[VolumeFlowUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeFlowUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Quantity(metaclass=ABCMeta):
    """ Dynamically parse or construct quantities when types are only known at runtime.
    """

    ByName: IDictionary[str, QuantityInfo] = ...
    """All QuantityInfo instances mapped by quantity name that are present in OasysUnits by default.
    """

    Types: typing.ClassVar[Array[QuantityType]]

    Names: typing.ClassVar[Array[str]]

    Infos: typing.ClassVar[Array[QuantityInfo]]

    @staticmethod
    def GetUnitInfo(unitEnum: Enum) -> UnitInfo:
        """Get "UnitInfo" for a given unit enum value.
        """
        pass

    @staticmethod
    def TryGetUnitInfo(unitEnum: Enum, unitInfo: UnitInfo) -> typing.Tuple[UnitInfo, bool]:
        """Try to get "UnitInfo" for a given unit enum value.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, unit: Enum) -> IQuantity:
        """ Dynamically construct a quantity.

        :param value: Numeric value.
        :type value: QuantityValue
        :param unit: Unit enum value.
        :type unit: Enum
        :return: An "IQuantity" object.
        :rtype: IQuantity

        :exception ArgumentException: Unit value is not a know unit enum type.
        """
        pass

    @staticmethod
    @typing.overload
    def TryFrom(value: float, unit: Enum, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(quantityType: Type, quantityString: str) -> IQuantity:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(formatProvider: IFormatProvider, quantityType: Type, quantityString: str) -> IQuantity:
        """ Dynamically parse a quantity string representation.

        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param quantityType: Type of quantity, such as "Length".
        :type quantityType: Type
        :param quantityString: Quantity string representation, such as "1.5 kg". Must be compatible with given quantity type.
        :type quantityString: str
        :return: The parsed quantity.
        :rtype: IQuantity

        :exception ArgumentException: Type must be of type OasysUnits.IQuantity -or- Type is not a known quantity type.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(quantityType: Type, quantityString: str, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """
        """
        pass

    @staticmethod
    def GetInfo(quantityType: QuantityType) -> QuantityInfo:
        """ Get information about the given quantity type.

        :param quantityType: The quantity type enum value.
        :type quantityType: QuantityType
        :return: Information about the quantity and its units.
        :rtype: QuantityInfo
        """
        pass

    @staticmethod
    def GetQuantitiesWithBaseDimensions(baseDimensions: BaseDimensions) -> IEnumerable[QuantityInfo]:
        """ Get a list of quantities that has the given base dimensions.

        :param baseDimensions: The base dimensions to match.
        :type baseDimensions: BaseDimensions
        """
        pass

    @staticmethod
    def FromQuantityType(quantityType: QuantityType, value: QuantityValue) -> IQuantity:
        """Dynamically constructs a quantity of the given "QuantityType" with the value in the quantity's base units.

        :param quantityType: The "QuantityType" of the quantity to create.
        :type quantityType: QuantityType
        :param value: The value to construct the quantity with.
        :type value: QuantityValue
        :return: The created quantity.
        :rtype: IQuantity
        """
        pass

    @staticmethod
    def FromQuantityInfo(quantityInfo: QuantityInfo, value: QuantityValue) -> IQuantity:
        """Dynamically constructs a quantity of the given "QuantityInfo" with the value in the quantity's base units.

        :param quantityInfo: The "QuantityInfo" of the quantity to create.
        :type quantityInfo: QuantityInfo
        :param value: The value to construct the quantity with.
        :type value: QuantityValue
        :return: The created quantity.
        :rtype: IQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def TryFrom(value: QuantityValue, unit: Enum, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """ Try to dynamically construct a quantity.

        :param value: Numeric value.
        :type value: QuantityValue
        :param unit: Unit enum value.
        :type unit: Enum
        :param quantity: The resulting quantity if successful, otherwise default.
        :type quantity: IQuantity
        :return: True if successful with assigned the value, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(formatProvider: IFormatProvider, quantityType: Type, quantityString: str, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """ Try to dynamically parse a quantity string representation.

        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param quantityType: Type of quantity, such as "Length".
        :type quantityType: Type
        :param quantityString: Quantity string representation, such as "1.5 kg". Must be compatible with given quantity type.
        :type quantityString: str
        :param quantity: The resulting quantity if successful, otherwise default.
        :type quantity: IQuantity
        :return: The parsed quantity.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class UnitAbbreviationsCache:
    """ Cache of the mapping between unit enum values and unit abbreviation strings for one or more cultures.
     A static instance "Property Default" is used internally for ToString() and Parse() of quantities and units.
    """

    Default: typing.ClassVar[UnitAbbreviationsCache]

    def __init__(self) -> None:
        """ Create an instance of the cache and load all the abbreviations defined in the library.
        """
        pass

    @typing.overload
    def MapUnitToAbbreviation(self, unit: TUnitType, abbreviations: Array[str]) -> None:
        """Adds one or more unit abbreviation for the given unit enum value.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param abbreviations: Unit abbreviations to add.
        :type abbreviations: Array[str]
        """
        pass

    @typing.overload
    def MapUnitToDefaultAbbreviation(self, unit: TUnitType, abbreviation: str) -> None:
        """Adds a unit abbreviation for the given unit enum value and sets it as the default.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param abbreviation: Unit abbreviations to add as default.
        :type abbreviation: str
        """
        pass

    @typing.overload
    def MapUnitToAbbreviation(self, unit: TUnitType, formatProvider: IFormatProvider, abbreviations: Array[str]) -> None:
        """Adds one or more unit abbreviation for the given unit enum value.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviations: Unit abbreviations to add.
        :type abbreviations: Array[str]
        """
        pass

    @typing.overload
    def MapUnitToDefaultAbbreviation(self, unit: TUnitType, formatProvider: IFormatProvider, abbreviation: str) -> None:
        """Adds a unit abbreviation for the given unit enum value and sets it as the default.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviation: Unit abbreviation to add as default.
        :type abbreviation: str
        """
        pass

    @typing.overload
    def MapUnitToAbbreviation(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider, abbreviations: Array[str]) -> None:
        """Adds one or more unit abbreviation for the given unit enum value.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        :param unitType: The unit enum type.
        :type unitType: Type
        :param unitValue: The unit enum value.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviations: Unit abbreviations to add.
        :type abbreviations: Array[str]
        """
        pass

    @typing.overload
    def MapUnitToDefaultAbbreviation(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider, abbreviation: str) -> None:
        """Adds a unit abbreviation for the given unit enum value and sets it as the default.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        :param unitType: The unit enum type.
        :type unitType: Type
        :param unitValue: The unit enum value.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviation: Unit abbreviation to add as default.
        :type abbreviation: str
        """
        pass

    @typing.overload
    def GetDefaultAbbreviation(self, unit: TUnitType, formatProvider: IFormatProvider) -> str:
        """Gets the default abbreviation for a given unit. If a unit has more than one abbreviation defined, then it returns the first one.
        Example: GetDefaultAbbreviation<LengthUnit>(LengthUnit.Kilometer) => "km"

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: The default unit abbreviation string.
        :rtype: str
        """
        pass

    @typing.overload
    def GetDefaultAbbreviation(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider) -> str:
        """Gets the default abbreviation for a given unit type and its numeric enum value.
        If a unit has more than one abbreviation defined, then it returns the first one.
        Example: GetDefaultAbbreviation<LengthUnit>(typeof(LengthUnit), 1) => "cm"

        :param unitType: The unit enum type.
        :type unitType: Type
        :param unitValue: The unit enum value.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: The default unit abbreviation string.
        :rtype: str
        """
        pass

    @typing.overload
    def GetUnitAbbreviations(self, unit: TUnitType, formatProvider: IFormatProvider) -> Array[str]:
        """ Get all abbreviations for unit.

        TUnitType: Enum type for units.

        :param unit: Enum value for unit.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit abbreviations associated with unit.
        :rtype: Array[str]
        """
        pass

    @typing.overload
    def GetUnitAbbreviations(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider) -> Array[str]:
        """ Get all abbreviations for unit.

        :param unitType: Enum type for unit.
        :type unitType: Type
        :param unitValue: Enum value for unit.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit abbreviations associated with unit.
        :rtype: Array[str]
        """
        pass

    def GetAllUnitAbbreviationsForQuantity(self, unitEnumType: Type, formatProvider: IFormatProvider) -> Array[str]:
        """ Get all abbreviations for all units of a quantity.

        :param unitEnumType: Enum type for unit.
        :type unitEnumType: Type
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit abbreviations associated with unit.
        :rtype: Array[str]
        """
        pass


# noinspection PyPep8Naming
class UnitParser:
    """ Parses units given a unit abbreviations cache.
     The static instance "Property Default" is used internally to parse quantities and units using the
     default abbreviations cache for all units and abbreviations defined in the library.
    """

    Default: typing.ClassVar[UnitParser]

    def __init__(self, unitAbbreviationsCache: UnitAbbreviationsCache) -> None:
        """ Create a parser using the given unit abbreviations cache.

        :param unitAbbreviationsCache:
        :type unitAbbreviationsCache: UnitAbbreviationsCache
        """
        pass

    @typing.overload
    def Parse(self, unitAbbreviation: str, formatProvider: IFormatProvider) -> TUnitType:
        """Parses a unit abbreviation for a given unit enumeration type.
        Example: Parse<LengthUnit>("km") => LengthUnit.Kilometer

        TUnitType:

        :param unitAbbreviation:
        :type unitAbbreviation: str
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return:
        :rtype: TUnitType
        """
        pass

    @typing.overload
    def Parse(self, unitAbbreviation: str, unitType: Type, formatProvider: IFormatProvider) -> Enum:
        """ Parse a unit abbreviation, such as "kg" or "m", to the unit enum value of the enum type
         .

        :param unitAbbreviation: Unit abbreviation, such as "kg" or "m" for "Field Kilogram" and
        "Field Meter" respectively.
        :type unitAbbreviation: str
        :param unitType: Unit enum type, such as "MassUnit" and "LengthUnit".
        :type unitType: Type
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit enum value, such as "Field Kilogram".
        :rtype: Enum

        :exception UnitNotFoundException: No units match the abbreviation.
        :exception AmbiguousUnitParseException: More than one unit matches the abbreviation.
        """
        pass

    @typing.overload
    def TryParse(self, unitAbbreviation: str, unit: TUnitType) -> typing.Tuple[TUnitType, bool]: ...

    @typing.overload
    def TryParse(self, unitAbbreviation: str, formatProvider: IFormatProvider, unit: TUnitType) -> typing.Tuple[TUnitType, bool]: ...

    @typing.overload
    def TryParse(self, unitAbbreviation: str, unitType: Type, unit: Enum) -> typing.Tuple[Enum, bool]:
        """Try to parse a unit abbreviation.

        :param unitAbbreviation: The string value.
        :type unitAbbreviation: str
        :param unitType: Type of unit enum.
        :type unitType: Type
        :param unit: The unit enum value as out result.
        :type unit: Enum
        :return: True if successful.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryParse(self, unitAbbreviation: str, unitType: Type, formatProvider: IFormatProvider, unit: Enum) -> typing.Tuple[Enum, bool]:
        """Try to parse a unit abbreviation.

        :param unitAbbreviation: The string value.
        :type unitAbbreviation: str
        :param unitType: Type of unit enum.
        :type unitType: Type
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param unit: The unit enum value as out result.
        :type unit: Enum
        :return: True if successful.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ApparentEnergy(ValueType, IQuantity[ApparentEnergyUnit], IQuantity, IFormattable, IEquatable[ApparentEnergy], IComparable, IComparable[ApparentEnergy], IConvertible):
    """ A unit for expressing the integral of apparent power over time, equal to the product of 1 volt-ampere and 1 hour, or to 3600 joules.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ApparentEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ApparentEnergyUnit]

    MaxValue: typing.ClassVar[ApparentEnergy]

    MinValue: typing.ClassVar[ApparentEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ApparentEnergyUnit]]

    Zero: typing.ClassVar[ApparentEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ApparentEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ApparentEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltampereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltampereHour"
        """
        pass

    @property
    def MegavoltampereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltampereHour"
        """
        pass

    @property
    def VoltampereHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltampereHour"
        """
        pass

    def __init__(self, value: float, unit: ApparentEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ApparentEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltampereHours(kilovoltamperehours: QuantityValue) -> ApparentEnergy:
        """ Creates a "ApparentEnergy" from "Field KilovoltampereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltampereHours(megavoltamperehours: QuantityValue) -> ApparentEnergy:
        """ Creates a "ApparentEnergy" from "Field MegavoltampereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltampereHours(voltamperehours: QuantityValue) -> ApparentEnergy:
        """ Creates a "ApparentEnergy" from "Field VoltampereHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ApparentEnergyUnit) -> ApparentEnergy:
        """ Dynamically convert from value and unit enum "ApparentEnergyUnit" to "ApparentEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ApparentEnergyUnit
        :return: ApparentEnergy unit value.
        :rtype: ApparentEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ApparentEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ApparentEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ApparentEnergy) -> typing.Tuple[ApparentEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ApparentEnergy) -> typing.Tuple[ApparentEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ApparentEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ApparentEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ApparentEnergyUnit) -> typing.Tuple[ApparentEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ApparentEnergyUnit) -> typing.Tuple[ApparentEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ApparentEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ApparentEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ApparentEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ApparentEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ApparentEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ApparentEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ApparentEnergyUnit) -> ApparentEnergy:
        """ Converts this ApparentEnergy to another ApparentEnergy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ApparentEnergyUnit
        :return: A ApparentEnergy with the specified unit.
        :rtype: ApparentEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ApparentEnergyUnit, unitConverter: UnitConverter) -> ApparentEnergy:
        """ Converts this "ApparentEnergy" to another "ApparentEnergy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ApparentEnergyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ApparentEnergy with the specified unit.
        :rtype: ApparentEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ApparentEnergy:
        """
        """
        pass


# noinspection PyPep8Naming
class ApparentPower(ValueType, IQuantity[ApparentPowerUnit], IQuantity, IFormattable, IEquatable[ApparentPower], IComparable, IComparable[ApparentPower], IConvertible):
    """ Power engineers measure apparent power as the magnitude of the vector sum of active and reactive power. Apparent power is the product of the root-mean-square of voltage and current.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ApparentPowerUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ApparentPowerUnit]

    MaxValue: typing.ClassVar[ApparentPower]

    MinValue: typing.ClassVar[ApparentPower]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ApparentPowerUnit]]

    Zero: typing.ClassVar[ApparentPower]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ApparentPowerUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ApparentPowerUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Gigavoltamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigavoltampere"
        """
        pass

    @property
    def Kilovoltamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilovoltampere"
        """
        pass

    @property
    def Megavoltamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megavoltampere"
        """
        pass

    @property
    def Voltamperes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Voltampere"
        """
        pass

    def __init__(self, value: float, unit: ApparentPowerUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ApparentPowerUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentPowerUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentPowerUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentPowerUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentPowerUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigavoltamperes(gigavoltamperes: QuantityValue) -> ApparentPower:
        """ Creates a "ApparentPower" from "Field Gigavoltampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltamperes(kilovoltamperes: QuantityValue) -> ApparentPower:
        """ Creates a "ApparentPower" from "Field Kilovoltampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltamperes(megavoltamperes: QuantityValue) -> ApparentPower:
        """ Creates a "ApparentPower" from "Field Megavoltampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltamperes(voltamperes: QuantityValue) -> ApparentPower:
        """ Creates a "ApparentPower" from "Field Voltampere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ApparentPowerUnit) -> ApparentPower:
        """ Dynamically convert from value and unit enum "ApparentPowerUnit" to "ApparentPower".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ApparentPowerUnit
        :return: ApparentPower unit value.
        :rtype: ApparentPower
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ApparentPower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ApparentPower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ApparentPower) -> typing.Tuple[ApparentPower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentPower
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ApparentPower) -> typing.Tuple[ApparentPower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentPower
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ApparentPowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ApparentPowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ApparentPowerUnit) -> typing.Tuple[ApparentPowerUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ApparentPowerUnit) -> typing.Tuple[ApparentPowerUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ApparentPowerUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ApparentPower) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentPower) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentPower, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ApparentPower within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ApparentPower
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ApparentPower.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ApparentPowerUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ApparentPowerUnit) -> ApparentPower:
        """ Converts this ApparentPower to another ApparentPower with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ApparentPowerUnit
        :return: A ApparentPower with the specified unit.
        :rtype: ApparentPower
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ApparentPowerUnit, unitConverter: UnitConverter) -> ApparentPower:
        """ Converts this "ApparentPower" to another "ApparentPower" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ApparentPowerUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ApparentPower with the specified unit.
        :rtype: ApparentPower
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ApparentPower:
        """
        """
        pass


# noinspection PyPep8Naming
class AreaDensity(ValueType, IQuantity[AreaDensityUnit], IQuantity, IFormattable, IEquatable[AreaDensity], IComparable, IComparable[AreaDensity], IConvertible):
    """ The area density of a two-dimensional object is calculated as the mass per unit area.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[AreaDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AreaDensityUnit]

    MaxValue: typing.ClassVar[AreaDensity]

    MinValue: typing.ClassVar[AreaDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AreaDensityUnit]]

    Zero: typing.ClassVar[AreaDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AreaDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AreaDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: AreaDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AreaDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramsPerSquareMeter(kilogramspersquaremeter: QuantityValue) -> AreaDensity:
        """ Creates a "AreaDensity" from "Field KilogramPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AreaDensityUnit) -> AreaDensity:
        """ Dynamically convert from value and unit enum "AreaDensityUnit" to "AreaDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AreaDensityUnit
        :return: AreaDensity unit value.
        :rtype: AreaDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AreaDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AreaDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AreaDensity) -> typing.Tuple[AreaDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AreaDensity) -> typing.Tuple[AreaDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AreaDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AreaDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AreaDensityUnit) -> typing.Tuple[AreaDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AreaDensityUnit) -> typing.Tuple[AreaDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AreaDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AreaDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AreaDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AreaDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AreaDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AreaDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaDensityUnit) -> AreaDensity:
        """ Converts this AreaDensity to another AreaDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AreaDensityUnit
        :return: A AreaDensity with the specified unit.
        :rtype: AreaDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaDensityUnit, unitConverter: UnitConverter) -> AreaDensity:
        """ Converts this "AreaDensity" to another "AreaDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: AreaDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A AreaDensity with the specified unit.
        :rtype: AreaDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AreaDensity:
        """
        """
        pass


# noinspection PyPep8Naming
class BitRate(ValueType, IQuantity[BitRateUnit], IQuantity, IFormattable, IDecimalQuantity, IEquatable[BitRate], IComparable, IComparable[BitRate], IConvertible):
    """ In telecommunications and computing, bit rate is the number of bits that are conveyed or processed per unit of time.
     https://en.wikipedia.org/wiki/Bit_rate
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[BitRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[BitRateUnit]

    MaxValue: typing.ClassVar[BitRate]

    MinValue: typing.ClassVar[BitRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[BitRateUnit]]

    Zero: typing.ClassVar[BitRate]

    @property
    def Value(self) -> Decimal:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> BitRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[BitRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BitPerSecond"
        """
        pass

    @property
    def BytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BytePerSecond"
        """
        pass

    @property
    def ExabitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ExabitPerSecond"
        """
        pass

    @property
    def ExabytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ExabytePerSecond"
        """
        pass

    @property
    def ExbibitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ExbibitPerSecond"
        """
        pass

    @property
    def ExbibytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field ExbibytePerSecond"
        """
        pass

    @property
    def GibibitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GibibitPerSecond"
        """
        pass

    @property
    def GibibytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GibibytePerSecond"
        """
        pass

    @property
    def GigabitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigabitPerSecond"
        """
        pass

    @property
    def GigabytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigabytePerSecond"
        """
        pass

    @property
    def KibibitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KibibitPerSecond"
        """
        pass

    @property
    def KibibytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KibibytePerSecond"
        """
        pass

    @property
    def KilobitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilobitPerSecond"
        """
        pass

    @property
    def KilobytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilobytePerSecond"
        """
        pass

    @property
    def MebibitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MebibitPerSecond"
        """
        pass

    @property
    def MebibytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MebibytePerSecond"
        """
        pass

    @property
    def MegabitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegabitPerSecond"
        """
        pass

    @property
    def MegabytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegabytePerSecond"
        """
        pass

    @property
    def PebibitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PebibitPerSecond"
        """
        pass

    @property
    def PebibytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PebibytePerSecond"
        """
        pass

    @property
    def PetabitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PetabitPerSecond"
        """
        pass

    @property
    def PetabytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PetabytePerSecond"
        """
        pass

    @property
    def TebibitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TebibitPerSecond"
        """
        pass

    @property
    def TebibytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TebibytePerSecond"
        """
        pass

    @property
    def TerabitsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerabitPerSecond"
        """
        pass

    @property
    def TerabytesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerabytePerSecond"
        """
        pass

    def __init__(self, value: Decimal, unit: BitRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unit: The unit representation to construct this quantity with.
        :type unit: BitRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: Decimal, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromTerabitsPerSecond(terabitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field TerabitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerabytesPerSecond(terabytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field TerabytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: BitRateUnit) -> BitRate:
        """ Dynamically convert from value and unit enum "BitRateUnit" to "BitRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: BitRateUnit
        :return: BitRate unit value.
        :rtype: BitRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> BitRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> BitRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: BitRate) -> typing.Tuple[BitRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BitRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: BitRate) -> typing.Tuple[BitRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BitRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> BitRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> BitRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: BitRateUnit) -> typing.Tuple[BitRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: BitRateUnit) -> typing.Tuple[BitRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: BitRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: BitRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BitRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BitRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another BitRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: BitRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current BitRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: BitRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BitRateUnit) -> BitRate:
        """ Converts this BitRate to another BitRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: BitRateUnit
        :return: A BitRate with the specified unit.
        :rtype: BitRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BitRateUnit, unitConverter: UnitConverter) -> BitRate:
        """ Converts this "BitRate" to another "BitRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: BitRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A BitRate with the specified unit.
        :rtype: BitRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> BitRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BitRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BitRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BitRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BitRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBitsPerSecond(bitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field BitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBytesPerSecond(bytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field BytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabitsPerSecond(exabitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field ExabitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabytesPerSecond(exabytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field ExabytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibitsPerSecond(exbibitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field ExbibitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibytesPerSecond(exbibytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field ExbibytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibitsPerSecond(gibibitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field GibibitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibytesPerSecond(gibibytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field GibibytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabitsPerSecond(gigabitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field GigabitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabytesPerSecond(gigabytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field GigabytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibitsPerSecond(kibibitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field KibibitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibytesPerSecond(kibibytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field KibibytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobitsPerSecond(kilobitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field KilobitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobytesPerSecond(kilobytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field KilobytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibitsPerSecond(mebibitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field MebibitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibytesPerSecond(mebibytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field MebibytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabitsPerSecond(megabitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field MegabitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabytesPerSecond(megabytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field MegabytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibitsPerSecond(pebibitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field PebibitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibytesPerSecond(pebibytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field PebibytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabitsPerSecond(petabitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field PetabitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabytesPerSecond(petabytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field PetabytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibitsPerSecond(tebibitspersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field TebibitPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibytesPerSecond(tebibytespersecond: QuantityValue) -> BitRate:
        """ Creates a "BitRate" from "Field TebibytePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Capacitance(ValueType, IQuantity[CapacitanceUnit], IQuantity, IFormattable, IEquatable[Capacitance], IComparable, IComparable[Capacitance], IConvertible):
    """ Capacitance is the ability of a body to store an electric charge.
     https://en.wikipedia.org/wiki/Capacitance
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[CapacitanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[CapacitanceUnit]

    MaxValue: typing.ClassVar[Capacitance]

    MinValue: typing.ClassVar[Capacitance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[CapacitanceUnit]]

    Zero: typing.ClassVar[Capacitance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> CapacitanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[CapacitanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Farads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Farad"
        """
        pass

    @property
    def Kilofarads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilofarad"
        """
        pass

    @property
    def Megafarads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megafarad"
        """
        pass

    @property
    def Microfarads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microfarad"
        """
        pass

    @property
    def Millifarads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millifarad"
        """
        pass

    @property
    def Nanofarads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanofarad"
        """
        pass

    @property
    def Picofarads(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Picofarad"
        """
        pass

    def __init__(self, value: float, unit: CapacitanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: CapacitanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Capacitance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CapacitanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CapacitanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CapacitanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CapacitanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromFarads(farads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Farad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilofarads(kilofarads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Kilofarad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegafarads(megafarads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Megafarad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrofarads(microfarads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Microfarad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillifarads(millifarads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Millifarad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanofarads(nanofarads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Nanofarad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicofarads(picofarads: QuantityValue) -> Capacitance:
        """ Creates a "Capacitance" from "Field Picofarad".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: CapacitanceUnit) -> Capacitance:
        """ Dynamically convert from value and unit enum "CapacitanceUnit" to "Capacitance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: CapacitanceUnit
        :return: Capacitance unit value.
        :rtype: Capacitance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Capacitance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Capacitance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Capacitance) -> typing.Tuple[Capacitance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Capacitance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Capacitance) -> typing.Tuple[Capacitance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Capacitance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> CapacitanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> CapacitanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: CapacitanceUnit) -> typing.Tuple[CapacitanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: CapacitanceUnit) -> typing.Tuple[CapacitanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: CapacitanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Capacitance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Capacitance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Capacitance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Capacitance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Capacitance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Capacitance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: CapacitanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CapacitanceUnit) -> Capacitance:
        """ Converts this Capacitance to another Capacitance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CapacitanceUnit
        :return: A Capacitance with the specified unit.
        :rtype: Capacitance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CapacitanceUnit, unitConverter: UnitConverter) -> Capacitance:
        """ Converts this "Capacitance" to another "Capacitance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CapacitanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Capacitance with the specified unit.
        :rtype: Capacitance
        """
        pass


# noinspection PyPep8Naming
class CoefficientOfThermalExpansion(ValueType, IQuantity[CoefficientOfThermalExpansionUnit], IQuantity, IFormattable, IEquatable[CoefficientOfThermalExpansion], IComparable, IComparable[CoefficientOfThermalExpansion], IConvertible):
    """ A unit that represents a fractional change in size in response to a change in temperature.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[CoefficientOfThermalExpansionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[CoefficientOfThermalExpansionUnit]

    MaxValue: typing.ClassVar[CoefficientOfThermalExpansion]

    MinValue: typing.ClassVar[CoefficientOfThermalExpansion]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[CoefficientOfThermalExpansionUnit]]

    Zero: typing.ClassVar[CoefficientOfThermalExpansion]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> CoefficientOfThermalExpansionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[CoefficientOfThermalExpansionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InverseDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseDegreeCelsius"
        """
        pass

    @property
    def InverseDegreeFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseDegreeFahrenheit"
        """
        pass

    @property
    def InverseKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseKelvin"
        """
        pass

    def __init__(self, value: float, unit: CoefficientOfThermalExpansionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: CoefficientOfThermalExpansionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CoefficientOfThermalExpansionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CoefficientOfThermalExpansionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CoefficientOfThermalExpansionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CoefficientOfThermalExpansionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInverseDegreeCelsius(inversedegreecelsius: QuantityValue) -> CoefficientOfThermalExpansion:
        """ Creates a "CoefficientOfThermalExpansion" from "Field InverseDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseDegreeFahrenheit(inversedegreefahrenheit: QuantityValue) -> CoefficientOfThermalExpansion:
        """ Creates a "CoefficientOfThermalExpansion" from "Field InverseDegreeFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseKelvin(inversekelvin: QuantityValue) -> CoefficientOfThermalExpansion:
        """ Creates a "CoefficientOfThermalExpansion" from "Field InverseKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: CoefficientOfThermalExpansionUnit) -> CoefficientOfThermalExpansion:
        """ Dynamically convert from value and unit enum "CoefficientOfThermalExpansionUnit" to "CoefficientOfThermalExpansion".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: CoefficientOfThermalExpansionUnit
        :return: CoefficientOfThermalExpansion unit value.
        :rtype: CoefficientOfThermalExpansion
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> CoefficientOfThermalExpansion:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> CoefficientOfThermalExpansion:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: CoefficientOfThermalExpansion) -> typing.Tuple[CoefficientOfThermalExpansion, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: CoefficientOfThermalExpansion
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: CoefficientOfThermalExpansion) -> typing.Tuple[CoefficientOfThermalExpansion, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: CoefficientOfThermalExpansion
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> CoefficientOfThermalExpansionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> CoefficientOfThermalExpansionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: CoefficientOfThermalExpansionUnit) -> typing.Tuple[CoefficientOfThermalExpansionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: CoefficientOfThermalExpansionUnit) -> typing.Tuple[CoefficientOfThermalExpansionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: CoefficientOfThermalExpansionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: CoefficientOfThermalExpansion) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: CoefficientOfThermalExpansion) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: CoefficientOfThermalExpansion, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another CoefficientOfThermalExpansion within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: CoefficientOfThermalExpansion
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current CoefficientOfThermalExpansion.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: CoefficientOfThermalExpansionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CoefficientOfThermalExpansionUnit) -> CoefficientOfThermalExpansion:
        """ Converts this CoefficientOfThermalExpansion to another CoefficientOfThermalExpansion with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CoefficientOfThermalExpansionUnit
        :return: A CoefficientOfThermalExpansion with the specified unit.
        :rtype: CoefficientOfThermalExpansion
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CoefficientOfThermalExpansionUnit, unitConverter: UnitConverter) -> CoefficientOfThermalExpansion:
        """ Converts this "CoefficientOfThermalExpansion" to another "CoefficientOfThermalExpansion" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CoefficientOfThermalExpansionUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A CoefficientOfThermalExpansion with the specified unit.
        :rtype: CoefficientOfThermalExpansion
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> CoefficientOfThermalExpansion:
        """
        """
        pass


# noinspection PyPep8Naming
class Compressibility(ValueType, IQuantity[CompressibilityUnit], IQuantity, IFormattable, IEquatable[Compressibility], IComparable, IComparable[Compressibility], IConvertible):
    """ Compressibility is the measure of the relative volume change of a fluid or solid in response to pressure changes.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[CompressibilityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[CompressibilityUnit]

    MaxValue: typing.ClassVar[Compressibility]

    MinValue: typing.ClassVar[Compressibility]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[CompressibilityUnit]]

    Zero: typing.ClassVar[Compressibility]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> CompressibilityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[CompressibilityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InverseAtmospheres(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseAtmosphere"
        """
        pass

    @property
    def InverseBars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseBar"
        """
        pass

    @property
    def InverseKilopascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseKilopascal"
        """
        pass

    @property
    def InverseMegapascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMegapascal"
        """
        pass

    @property
    def InverseMillibars(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InverseMillibar"
        """
        pass

    @property
    def InversePascals(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InversePascal"
        """
        pass

    @property
    def InversePoundsForcePerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InversePoundForcePerSquareInch"
        """
        pass

    def __init__(self, value: float, unit: CompressibilityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: CompressibilityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Compressibility:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CompressibilityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CompressibilityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CompressibilityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CompressibilityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInverseAtmospheres(inverseatmospheres: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InverseAtmosphere".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseBars(inversebars: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InverseBar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseKilopascals(inversekilopascals: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InverseKilopascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMegapascals(inversemegapascals: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InverseMegapascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseMillibars(inversemillibars: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InverseMillibar".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInversePascals(inversepascals: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InversePascal".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInversePoundsForcePerSquareInch(inversepoundsforcepersquareinch: QuantityValue) -> Compressibility:
        """ Creates a "Compressibility" from "Field InversePoundForcePerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: CompressibilityUnit) -> Compressibility:
        """ Dynamically convert from value and unit enum "CompressibilityUnit" to "Compressibility".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: CompressibilityUnit
        :return: Compressibility unit value.
        :rtype: Compressibility
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Compressibility:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Compressibility:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Compressibility) -> typing.Tuple[Compressibility, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Compressibility
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Compressibility) -> typing.Tuple[Compressibility, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Compressibility
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> CompressibilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> CompressibilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: CompressibilityUnit) -> typing.Tuple[CompressibilityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: CompressibilityUnit) -> typing.Tuple[CompressibilityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: CompressibilityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Compressibility) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Compressibility) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Compressibility, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Compressibility within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Compressibility
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Compressibility.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: CompressibilityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CompressibilityUnit) -> Compressibility:
        """ Converts this Compressibility to another Compressibility with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CompressibilityUnit
        :return: A Compressibility with the specified unit.
        :rtype: Compressibility
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CompressibilityUnit, unitConverter: UnitConverter) -> Compressibility:
        """ Converts this "Compressibility" to another "Compressibility" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CompressibilityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Compressibility with the specified unit.
        :rtype: Compressibility
        """
        pass


# noinspection PyPep8Naming
class Curvature(ValueType, IQuantity[CurvatureUnit], IQuantity, IFormattable, IEquatable[Curvature], IComparable, IComparable[Curvature], IConvertible):
    """ .
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[CurvatureUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[CurvatureUnit]

    MaxValue: typing.ClassVar[Curvature]

    MinValue: typing.ClassVar[Curvature]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[CurvatureUnit]]

    Zero: typing.ClassVar[Curvature]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> CurvatureUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[CurvatureUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def PerCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PerCentimeter"
        """
        pass

    @property
    def PerFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PerFoot"
        """
        pass

    @property
    def PerInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PerInch"
        """
        pass

    @property
    def PerMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PerMeter"
        """
        pass

    @property
    def PerMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PerMillimeter"
        """
        pass

    def __init__(self, value: float, unit: CurvatureUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: CurvatureUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CurvatureUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CurvatureUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CurvatureUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CurvatureUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromPerCentimeters(percentimeters: QuantityValue) -> Curvature:
        """ Creates a "Curvature" from "Field PerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPerFeet(perfeet: QuantityValue) -> Curvature:
        """ Creates a "Curvature" from "Field PerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPerInches(perinches: QuantityValue) -> Curvature:
        """ Creates a "Curvature" from "Field PerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPerMeters(permeters: QuantityValue) -> Curvature:
        """ Creates a "Curvature" from "Field PerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPerMillimeters(permillimeters: QuantityValue) -> Curvature:
        """ Creates a "Curvature" from "Field PerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: CurvatureUnit) -> Curvature:
        """ Dynamically convert from value and unit enum "CurvatureUnit" to "Curvature".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: CurvatureUnit
        :return: Curvature unit value.
        :rtype: Curvature
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Curvature:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Curvature:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Curvature) -> typing.Tuple[Curvature, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Curvature
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Curvature) -> typing.Tuple[Curvature, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Curvature
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> CurvatureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> CurvatureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: CurvatureUnit) -> typing.Tuple[CurvatureUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: CurvatureUnit) -> typing.Tuple[CurvatureUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: CurvatureUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Curvature) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Curvature) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Curvature, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Curvature within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Curvature
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Curvature.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: CurvatureUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CurvatureUnit) -> Curvature:
        """ Converts this Curvature to another Curvature with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CurvatureUnit
        :return: A Curvature with the specified unit.
        :rtype: Curvature
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CurvatureUnit, unitConverter: UnitConverter) -> Curvature:
        """ Converts this "Curvature" to another "Curvature" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: CurvatureUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Curvature with the specified unit.
        :rtype: Curvature
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Curvature:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricAdmittance(ValueType, IQuantity[ElectricAdmittanceUnit], IQuantity, IFormattable, IEquatable[ElectricAdmittance], IComparable, IComparable[ElectricAdmittance], IConvertible):
    """ Electric admittance is a measure of how easily a circuit or device will allow a current to flow. It is defined as the inverse of impedance. The SI unit of admittance is the siemens (symbol S).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricAdmittanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricAdmittanceUnit]

    MaxValue: typing.ClassVar[ElectricAdmittance]

    MinValue: typing.ClassVar[ElectricAdmittance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricAdmittanceUnit]]

    Zero: typing.ClassVar[ElectricAdmittance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricAdmittanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricAdmittanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Microsiemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microsiemens"
        """
        pass

    @property
    def Millisiemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millisiemens"
        """
        pass

    @property
    def Nanosiemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanosiemens"
        """
        pass

    @property
    def Siemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Siemens"
        """
        pass

    def __init__(self, value: float, unit: ElectricAdmittanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricAdmittanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricAdmittanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricAdmittanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricAdmittanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricAdmittanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromMicrosiemens(microsiemens: QuantityValue) -> ElectricAdmittance:
        """ Creates a "ElectricAdmittance" from "Field Microsiemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillisiemens(millisiemens: QuantityValue) -> ElectricAdmittance:
        """ Creates a "ElectricAdmittance" from "Field Millisiemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanosiemens(nanosiemens: QuantityValue) -> ElectricAdmittance:
        """ Creates a "ElectricAdmittance" from "Field Nanosiemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemens(siemens: QuantityValue) -> ElectricAdmittance:
        """ Creates a "ElectricAdmittance" from "Field Siemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricAdmittanceUnit) -> ElectricAdmittance:
        """ Dynamically convert from value and unit enum "ElectricAdmittanceUnit" to "ElectricAdmittance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricAdmittanceUnit
        :return: ElectricAdmittance unit value.
        :rtype: ElectricAdmittance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricAdmittance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricAdmittance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricAdmittance) -> typing.Tuple[ElectricAdmittance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricAdmittance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricAdmittance) -> typing.Tuple[ElectricAdmittance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricAdmittance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricAdmittanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricAdmittanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricAdmittanceUnit) -> typing.Tuple[ElectricAdmittanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricAdmittanceUnit) -> typing.Tuple[ElectricAdmittanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricAdmittanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricAdmittance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricAdmittance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricAdmittance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricAdmittance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricAdmittance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricAdmittance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricAdmittanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricAdmittanceUnit) -> ElectricAdmittance:
        """ Converts this ElectricAdmittance to another ElectricAdmittance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricAdmittanceUnit
        :return: A ElectricAdmittance with the specified unit.
        :rtype: ElectricAdmittance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricAdmittanceUnit, unitConverter: UnitConverter) -> ElectricAdmittance:
        """ Converts this "ElectricAdmittance" to another "ElectricAdmittance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricAdmittanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricAdmittance with the specified unit.
        :rtype: ElectricAdmittance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricAdmittance:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricChargeDensity(ValueType, IQuantity[ElectricChargeDensityUnit], IQuantity, IFormattable, IEquatable[ElectricChargeDensity], IComparable, IComparable[ElectricChargeDensity], IConvertible):
    """ In electromagnetism, charge density is a measure of the amount of electric charge per volume.
     https://en.wikipedia.org/wiki/Charge_density
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricChargeDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricChargeDensityUnit]

    MaxValue: typing.ClassVar[ElectricChargeDensity]

    MinValue: typing.ClassVar[ElectricChargeDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricChargeDensityUnit]]

    Zero: typing.ClassVar[ElectricChargeDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricChargeDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricChargeDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CoulombsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CoulombPerCubicMeter"
        """
        pass

    def __init__(self, value: float, unit: ElectricChargeDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricChargeDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCoulombsPerCubicMeter(coulombspercubicmeter: QuantityValue) -> ElectricChargeDensity:
        """ Creates a "ElectricChargeDensity" from "Field CoulombPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricChargeDensityUnit) -> ElectricChargeDensity:
        """ Dynamically convert from value and unit enum "ElectricChargeDensityUnit" to "ElectricChargeDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricChargeDensityUnit
        :return: ElectricChargeDensity unit value.
        :rtype: ElectricChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricChargeDensity) -> typing.Tuple[ElectricChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricChargeDensity) -> typing.Tuple[ElectricChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricChargeDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricChargeDensityUnit) -> typing.Tuple[ElectricChargeDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricChargeDensityUnit) -> typing.Tuple[ElectricChargeDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricChargeDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricChargeDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricChargeDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricChargeDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricChargeDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricChargeDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricChargeDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricChargeDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricChargeDensityUnit) -> ElectricChargeDensity:
        """ Converts this ElectricChargeDensity to another ElectricChargeDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricChargeDensityUnit
        :return: A ElectricChargeDensity with the specified unit.
        :rtype: ElectricChargeDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricChargeDensityUnit, unitConverter: UnitConverter) -> ElectricChargeDensity:
        """ Converts this "ElectricChargeDensity" to another "ElectricChargeDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricChargeDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricChargeDensity with the specified unit.
        :rtype: ElectricChargeDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricChargeDensity:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricConductance(ValueType, IQuantity[ElectricConductanceUnit], IQuantity, IFormattable, IEquatable[ElectricConductance], IComparable, IComparable[ElectricConductance], IConvertible):
    """ The electrical conductance of an electrical conductor is a measure of the easeness to pass an electric current through that conductor.
     https://en.wikipedia.org/wiki/Electrical_resistance_and_conductance
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricConductanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricConductanceUnit]

    MaxValue: typing.ClassVar[ElectricConductance]

    MinValue: typing.ClassVar[ElectricConductance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricConductanceUnit]]

    Zero: typing.ClassVar[ElectricConductance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricConductanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricConductanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Microsiemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microsiemens"
        """
        pass

    @property
    def Millisiemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millisiemens"
        """
        pass

    @property
    def Siemens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Siemens"
        """
        pass

    def __init__(self, value: float, unit: ElectricConductanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricConductanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromMicrosiemens(microsiemens: QuantityValue) -> ElectricConductance:
        """ Creates a "ElectricConductance" from "Field Microsiemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillisiemens(millisiemens: QuantityValue) -> ElectricConductance:
        """ Creates a "ElectricConductance" from "Field Millisiemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemens(siemens: QuantityValue) -> ElectricConductance:
        """ Creates a "ElectricConductance" from "Field Siemens".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricConductanceUnit) -> ElectricConductance:
        """ Dynamically convert from value and unit enum "ElectricConductanceUnit" to "ElectricConductance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricConductanceUnit
        :return: ElectricConductance unit value.
        :rtype: ElectricConductance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricConductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricConductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricConductance) -> typing.Tuple[ElectricConductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricConductance) -> typing.Tuple[ElectricConductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricConductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricConductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricConductanceUnit) -> typing.Tuple[ElectricConductanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricConductanceUnit) -> typing.Tuple[ElectricConductanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricConductanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricConductance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricConductance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricConductance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricConductance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricConductanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricConductanceUnit) -> ElectricConductance:
        """ Converts this ElectricConductance to another ElectricConductance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricConductanceUnit
        :return: A ElectricConductance with the specified unit.
        :rtype: ElectricConductance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricConductanceUnit, unitConverter: UnitConverter) -> ElectricConductance:
        """ Converts this "ElectricConductance" to another "ElectricConductance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricConductanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricConductance with the specified unit.
        :rtype: ElectricConductance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricConductance:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricCurrentDensity(ValueType, IQuantity[ElectricCurrentDensityUnit], IQuantity, IFormattable, IEquatable[ElectricCurrentDensity], IComparable, IComparable[ElectricCurrentDensity], IConvertible):
    """ In electromagnetism, current density is the electric current per unit area of cross section.
     https://en.wikipedia.org/wiki/Current_density
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricCurrentDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricCurrentDensityUnit]

    MaxValue: typing.ClassVar[ElectricCurrentDensity]

    MinValue: typing.ClassVar[ElectricCurrentDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricCurrentDensityUnit]]

    Zero: typing.ClassVar[ElectricCurrentDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricCurrentDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricCurrentDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmperesPerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerSquareFoot"
        """
        pass

    @property
    def AmperesPerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerSquareInch"
        """
        pass

    @property
    def AmperesPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: ElectricCurrentDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricCurrentDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperesPerSquareFoot(amperespersquarefoot: QuantityValue) -> ElectricCurrentDensity:
        """ Creates a "ElectricCurrentDensity" from "Field AmperePerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerSquareInch(amperespersquareinch: QuantityValue) -> ElectricCurrentDensity:
        """ Creates a "ElectricCurrentDensity" from "Field AmperePerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerSquareMeter(amperespersquaremeter: QuantityValue) -> ElectricCurrentDensity:
        """ Creates a "ElectricCurrentDensity" from "Field AmperePerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricCurrentDensityUnit) -> ElectricCurrentDensity:
        """ Dynamically convert from value and unit enum "ElectricCurrentDensityUnit" to "ElectricCurrentDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricCurrentDensityUnit
        :return: ElectricCurrentDensity unit value.
        :rtype: ElectricCurrentDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCurrentDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCurrentDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCurrentDensity) -> typing.Tuple[ElectricCurrentDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCurrentDensity) -> typing.Tuple[ElectricCurrentDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricCurrentDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricCurrentDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricCurrentDensityUnit) -> typing.Tuple[ElectricCurrentDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricCurrentDensityUnit) -> typing.Tuple[ElectricCurrentDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricCurrentDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCurrentDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCurrentDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCurrentDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCurrentDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricCurrentDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentDensityUnit) -> ElectricCurrentDensity:
        """ Converts this ElectricCurrentDensity to another ElectricCurrentDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricCurrentDensityUnit
        :return: A ElectricCurrentDensity with the specified unit.
        :rtype: ElectricCurrentDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentDensityUnit, unitConverter: UnitConverter) -> ElectricCurrentDensity:
        """ Converts this "ElectricCurrentDensity" to another "ElectricCurrentDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricCurrentDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricCurrentDensity with the specified unit.
        :rtype: ElectricCurrentDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCurrentDensity:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricCurrentGradient(ValueType, IQuantity[ElectricCurrentGradientUnit], IQuantity, IFormattable, IEquatable[ElectricCurrentGradient], IComparable, IComparable[ElectricCurrentGradient], IConvertible):
    """ In electromagnetism, the current gradient describes how the current changes in time.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricCurrentGradientUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricCurrentGradientUnit]

    MaxValue: typing.ClassVar[ElectricCurrentGradient]

    MinValue: typing.ClassVar[ElectricCurrentGradient]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricCurrentGradientUnit]]

    Zero: typing.ClassVar[ElectricCurrentGradient]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricCurrentGradientUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricCurrentGradientUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmperesPerMicrosecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerMicrosecond"
        """
        pass

    @property
    def AmperesPerMillisecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerMillisecond"
        """
        pass

    @property
    def AmperesPerNanosecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerNanosecond"
        """
        pass

    @property
    def AmperesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerSecond"
        """
        pass

    def __init__(self, value: float, unit: ElectricCurrentGradientUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricCurrentGradientUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentGradientUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentGradientUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentGradientUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentGradientUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperesPerMicrosecond(amperespermicrosecond: QuantityValue) -> ElectricCurrentGradient:
        """ Creates a "ElectricCurrentGradient" from "Field AmperePerMicrosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerMillisecond(amperespermillisecond: QuantityValue) -> ElectricCurrentGradient:
        """ Creates a "ElectricCurrentGradient" from "Field AmperePerMillisecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerNanosecond(amperespernanosecond: QuantityValue) -> ElectricCurrentGradient:
        """ Creates a "ElectricCurrentGradient" from "Field AmperePerNanosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerSecond(amperespersecond: QuantityValue) -> ElectricCurrentGradient:
        """ Creates a "ElectricCurrentGradient" from "Field AmperePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricCurrentGradientUnit) -> ElectricCurrentGradient:
        """ Dynamically convert from value and unit enum "ElectricCurrentGradientUnit" to "ElectricCurrentGradient".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricCurrentGradientUnit
        :return: ElectricCurrentGradient unit value.
        :rtype: ElectricCurrentGradient
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCurrentGradient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCurrentGradient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCurrentGradient) -> typing.Tuple[ElectricCurrentGradient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentGradient
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCurrentGradient) -> typing.Tuple[ElectricCurrentGradient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentGradient
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricCurrentGradientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricCurrentGradientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricCurrentGradientUnit) -> typing.Tuple[ElectricCurrentGradientUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricCurrentGradientUnit) -> typing.Tuple[ElectricCurrentGradientUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricCurrentGradientUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCurrentGradient) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentGradient) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentGradient, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCurrentGradient within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCurrentGradient
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCurrentGradient.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricCurrentGradientUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentGradientUnit) -> ElectricCurrentGradient:
        """ Converts this ElectricCurrentGradient to another ElectricCurrentGradient with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricCurrentGradientUnit
        :return: A ElectricCurrentGradient with the specified unit.
        :rtype: ElectricCurrentGradient
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentGradientUnit, unitConverter: UnitConverter) -> ElectricCurrentGradient:
        """ Converts this "ElectricCurrentGradient" to another "ElectricCurrentGradient" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricCurrentGradientUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricCurrentGradient with the specified unit.
        :rtype: ElectricCurrentGradient
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCurrentGradient:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricField(ValueType, IQuantity[ElectricFieldUnit], IQuantity, IFormattable, IEquatable[ElectricField], IComparable, IComparable[ElectricField], IConvertible):
    """ An electric field is a force field that surrounds electric charges that attracts or repels other electric charges.
     https://en.wikipedia.org/wiki/Electric_field
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricFieldUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricFieldUnit]

    MaxValue: typing.ClassVar[ElectricField]

    MinValue: typing.ClassVar[ElectricField]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricFieldUnit]]

    Zero: typing.ClassVar[ElectricField]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricFieldUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricFieldUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def VoltsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltPerMeter"
        """
        pass

    def __init__(self, value: float, unit: ElectricFieldUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricFieldUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricFieldUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricFieldUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricFieldUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricFieldUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromVoltsPerMeter(voltspermeter: QuantityValue) -> ElectricField:
        """ Creates a "ElectricField" from "Field VoltPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricFieldUnit) -> ElectricField:
        """ Dynamically convert from value and unit enum "ElectricFieldUnit" to "ElectricField".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricFieldUnit
        :return: ElectricField unit value.
        :rtype: ElectricField
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricField) -> typing.Tuple[ElectricField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricField
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricField) -> typing.Tuple[ElectricField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricField
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricFieldUnit) -> typing.Tuple[ElectricFieldUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricFieldUnit) -> typing.Tuple[ElectricFieldUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricFieldUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricField) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricField) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricField, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricField within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricField
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricField.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricFieldUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricFieldUnit) -> ElectricField:
        """ Converts this ElectricField to another ElectricField with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricFieldUnit
        :return: A ElectricField with the specified unit.
        :rtype: ElectricField
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricFieldUnit, unitConverter: UnitConverter) -> ElectricField:
        """ Converts this "ElectricField" to another "ElectricField" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricFieldUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricField with the specified unit.
        :rtype: ElectricField
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricField:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricInductance(ValueType, IQuantity[ElectricInductanceUnit], IQuantity, IFormattable, IEquatable[ElectricInductance], IComparable, IComparable[ElectricInductance], IConvertible):
    """ Inductance is a property of an electrical conductor which opposes a change in current.
     https://en.wikipedia.org/wiki/Inductance
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricInductanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricInductanceUnit]

    MaxValue: typing.ClassVar[ElectricInductance]

    MinValue: typing.ClassVar[ElectricInductance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricInductanceUnit]]

    Zero: typing.ClassVar[ElectricInductance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricInductanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricInductanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Henries(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Henry"
        """
        pass

    @property
    def Microhenries(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microhenry"
        """
        pass

    @property
    def Millihenries(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millihenry"
        """
        pass

    @property
    def Nanohenries(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanohenry"
        """
        pass

    def __init__(self, value: float, unit: ElectricInductanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricInductanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricInductanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricInductanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricInductanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricInductanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromHenries(henries: QuantityValue) -> ElectricInductance:
        """ Creates a "ElectricInductance" from "Field Henry".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrohenries(microhenries: QuantityValue) -> ElectricInductance:
        """ Creates a "ElectricInductance" from "Field Microhenry".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillihenries(millihenries: QuantityValue) -> ElectricInductance:
        """ Creates a "ElectricInductance" from "Field Millihenry".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanohenries(nanohenries: QuantityValue) -> ElectricInductance:
        """ Creates a "ElectricInductance" from "Field Nanohenry".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricInductanceUnit) -> ElectricInductance:
        """ Dynamically convert from value and unit enum "ElectricInductanceUnit" to "ElectricInductance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricInductanceUnit
        :return: ElectricInductance unit value.
        :rtype: ElectricInductance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricInductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricInductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricInductance) -> typing.Tuple[ElectricInductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricInductance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricInductance) -> typing.Tuple[ElectricInductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricInductance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricInductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricInductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricInductanceUnit) -> typing.Tuple[ElectricInductanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricInductanceUnit) -> typing.Tuple[ElectricInductanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricInductanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricInductance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricInductance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricInductance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricInductance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricInductance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricInductance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricInductanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricInductanceUnit) -> ElectricInductance:
        """ Converts this ElectricInductance to another ElectricInductance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricInductanceUnit
        :return: A ElectricInductance with the specified unit.
        :rtype: ElectricInductance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricInductanceUnit, unitConverter: UnitConverter) -> ElectricInductance:
        """ Converts this "ElectricInductance" to another "ElectricInductance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricInductanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricInductance with the specified unit.
        :rtype: ElectricInductance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricInductance:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricPotentialAc(ValueType, IQuantity[ElectricPotentialAcUnit], IQuantity, IFormattable, IEquatable[ElectricPotentialAc], IComparable, IComparable[ElectricPotentialAc], IConvertible):
    """ The Electric Potential of a system known to use Alternating Current.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialAcUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialAcUnit]

    MaxValue: typing.ClassVar[ElectricPotentialAc]

    MinValue: typing.ClassVar[ElectricPotentialAc]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialAcUnit]]

    Zero: typing.ClassVar[ElectricPotentialAc]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialAcUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialAcUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltsAc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltAc"
        """
        pass

    @property
    def MegavoltsAc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltAc"
        """
        pass

    @property
    def MicrovoltsAc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrovoltAc"
        """
        pass

    @property
    def MillivoltsAc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillivoltAc"
        """
        pass

    @property
    def VoltsAc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltAc"
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialAcUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialAcUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialAcUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialAcUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialAcUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialAcUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltsAc(kilovoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Creates a "ElectricPotentialAc" from "Field KilovoltAc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsAc(megavoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Creates a "ElectricPotentialAc" from "Field MegavoltAc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsAc(microvoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Creates a "ElectricPotentialAc" from "Field MicrovoltAc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsAc(millivoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Creates a "ElectricPotentialAc" from "Field MillivoltAc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsAc(voltsac: QuantityValue) -> ElectricPotentialAc:
        """ Creates a "ElectricPotentialAc" from "Field VoltAc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialAcUnit) -> ElectricPotentialAc:
        """ Dynamically convert from value and unit enum "ElectricPotentialAcUnit" to "ElectricPotentialAc".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialAcUnit
        :return: ElectricPotentialAc unit value.
        :rtype: ElectricPotentialAc
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotentialAc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotentialAc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotentialAc) -> typing.Tuple[ElectricPotentialAc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialAc
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotentialAc) -> typing.Tuple[ElectricPotentialAc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialAc
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialAcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialAcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialAcUnit) -> typing.Tuple[ElectricPotentialAcUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialAcUnit) -> typing.Tuple[ElectricPotentialAcUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialAcUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotentialAc) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialAc) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialAc, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotentialAc within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotentialAc
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotentialAc.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialAcUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialAcUnit) -> ElectricPotentialAc:
        """ Converts this ElectricPotentialAc to another ElectricPotentialAc with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialAcUnit
        :return: A ElectricPotentialAc with the specified unit.
        :rtype: ElectricPotentialAc
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialAcUnit, unitConverter: UnitConverter) -> ElectricPotentialAc:
        """ Converts this "ElectricPotentialAc" to another "ElectricPotentialAc" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialAcUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricPotentialAc with the specified unit.
        :rtype: ElectricPotentialAc
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotentialAc:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricPotentialChangeRate(ValueType, IQuantity[ElectricPotentialChangeRateUnit], IQuantity, IFormattable, IEquatable[ElectricPotentialChangeRate], IComparable, IComparable[ElectricPotentialChangeRate], IConvertible):
    """ ElectricPotential change rate is the ratio of the electric potential change to the time during which the change occurred (value of electric potential changes per unit time).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialChangeRateUnit]

    MaxValue: typing.ClassVar[ElectricPotentialChangeRate]

    MinValue: typing.ClassVar[ElectricPotentialChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialChangeRateUnit]]

    Zero: typing.ClassVar[ElectricPotentialChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltsPerHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltPerHour"
        """
        pass

    @property
    def KilovoltsPerMicroseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltPerMicrosecond"
        """
        pass

    @property
    def KilovoltsPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltPerMinute"
        """
        pass

    @property
    def KilovoltsPerSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltPerSecond"
        """
        pass

    @property
    def MegavoltsPerHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltPerHour"
        """
        pass

    @property
    def MegavoltsPerMicroseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltPerMicrosecond"
        """
        pass

    @property
    def MegavoltsPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltPerMinute"
        """
        pass

    @property
    def MegavoltsPerSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltPerSecond"
        """
        pass

    @property
    def MicrovoltsPerHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrovoltPerHour"
        """
        pass

    @property
    def MicrovoltsPerMicroseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrovoltPerMicrosecond"
        """
        pass

    @property
    def MicrovoltsPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrovoltPerMinute"
        """
        pass

    @property
    def MicrovoltsPerSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrovoltPerSecond"
        """
        pass

    @property
    def MillivoltsPerHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillivoltPerHour"
        """
        pass

    @property
    def MillivoltsPerMicroseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillivoltPerMicrosecond"
        """
        pass

    @property
    def MillivoltsPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillivoltPerMinute"
        """
        pass

    @property
    def MillivoltsPerSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillivoltPerSecond"
        """
        pass

    @property
    def VoltsPerHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltPerHour"
        """
        pass

    @property
    def VoltsPerMicroseconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltPerMicrosecond"
        """
        pass

    @property
    def VoltsPerMinutes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltPerMinute"
        """
        pass

    @property
    def VoltsPerSeconds(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltPerSecond"
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotentialChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotentialChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotentialChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotentialChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialChangeRateUnit) -> ElectricPotentialChangeRate:
        """ Converts this ElectricPotentialChangeRate to another ElectricPotentialChangeRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialChangeRateUnit
        :return: A ElectricPotentialChangeRate with the specified unit.
        :rtype: ElectricPotentialChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialChangeRateUnit, unitConverter: UnitConverter) -> ElectricPotentialChangeRate:
        """ Converts this "ElectricPotentialChangeRate" to another "ElectricPotentialChangeRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialChangeRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricPotentialChangeRate with the specified unit.
        :rtype: ElectricPotentialChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotentialChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltsPerHours(kilovoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field KilovoltPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltsPerMicroseconds(kilovoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field KilovoltPerMicrosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltsPerMinutes(kilovoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field KilovoltPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltsPerSeconds(kilovoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field KilovoltPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerHours(megavoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MegavoltPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerMicroseconds(megavoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MegavoltPerMicrosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerMinutes(megavoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MegavoltPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerSeconds(megavoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MegavoltPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerHours(microvoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MicrovoltPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerMicroseconds(microvoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MicrovoltPerMicrosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerMinutes(microvoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MicrovoltPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerSeconds(microvoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MicrovoltPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerHours(millivoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MillivoltPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerMicroseconds(millivoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MillivoltPerMicrosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerMinutes(millivoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MillivoltPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerSeconds(millivoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field MillivoltPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerHours(voltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field VoltPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerMicroseconds(voltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field VoltPerMicrosecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerMinutes(voltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field VoltPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerSeconds(voltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Creates a "ElectricPotentialChangeRate" from "Field VoltPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialChangeRateUnit) -> ElectricPotentialChangeRate:
        """ Dynamically convert from value and unit enum "ElectricPotentialChangeRateUnit" to "ElectricPotentialChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialChangeRateUnit
        :return: ElectricPotentialChangeRate unit value.
        :rtype: ElectricPotentialChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotentialChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotentialChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotentialChangeRate) -> typing.Tuple[ElectricPotentialChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotentialChangeRate) -> typing.Tuple[ElectricPotentialChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialChangeRateUnit) -> typing.Tuple[ElectricPotentialChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialChangeRateUnit) -> typing.Tuple[ElectricPotentialChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ElectricPotentialDc(ValueType, IQuantity[ElectricPotentialDcUnit], IQuantity, IFormattable, IEquatable[ElectricPotentialDc], IComparable, IComparable[ElectricPotentialDc], IConvertible):
    """ The Electric Potential of a system known to use Direct Current.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialDcUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialDcUnit]

    MaxValue: typing.ClassVar[ElectricPotentialDc]

    MinValue: typing.ClassVar[ElectricPotentialDc]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialDcUnit]]

    Zero: typing.ClassVar[ElectricPotentialDc]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialDcUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialDcUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltsDc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltDc"
        """
        pass

    @property
    def MegavoltsDc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltDc"
        """
        pass

    @property
    def MicrovoltsDc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrovoltDc"
        """
        pass

    @property
    def MillivoltsDc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillivoltDc"
        """
        pass

    @property
    def VoltsDc(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltDc"
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialDcUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialDcUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialDcUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialDcUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialDcUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialDcUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltsDc(kilovoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Creates a "ElectricPotentialDc" from "Field KilovoltDc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsDc(megavoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Creates a "ElectricPotentialDc" from "Field MegavoltDc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsDc(microvoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Creates a "ElectricPotentialDc" from "Field MicrovoltDc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsDc(millivoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Creates a "ElectricPotentialDc" from "Field MillivoltDc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsDc(voltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Creates a "ElectricPotentialDc" from "Field VoltDc".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialDcUnit) -> ElectricPotentialDc:
        """ Dynamically convert from value and unit enum "ElectricPotentialDcUnit" to "ElectricPotentialDc".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialDcUnit
        :return: ElectricPotentialDc unit value.
        :rtype: ElectricPotentialDc
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotentialDc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotentialDc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotentialDc) -> typing.Tuple[ElectricPotentialDc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialDc
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotentialDc) -> typing.Tuple[ElectricPotentialDc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialDc
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialDcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialDcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialDcUnit) -> typing.Tuple[ElectricPotentialDcUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialDcUnit) -> typing.Tuple[ElectricPotentialDcUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialDcUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotentialDc) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialDc) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialDc, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotentialDc within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotentialDc
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotentialDc.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialDcUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialDcUnit) -> ElectricPotentialDc:
        """ Converts this ElectricPotentialDc to another ElectricPotentialDc with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialDcUnit
        :return: A ElectricPotentialDc with the specified unit.
        :rtype: ElectricPotentialDc
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialDcUnit, unitConverter: UnitConverter) -> ElectricPotentialDc:
        """ Converts this "ElectricPotentialDc" to another "ElectricPotentialDc" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricPotentialDcUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricPotentialDc with the specified unit.
        :rtype: ElectricPotentialDc
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotentialDc:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricSurfaceChargeDensity(ValueType, IQuantity[ElectricSurfaceChargeDensityUnit], IQuantity, IFormattable, IEquatable[ElectricSurfaceChargeDensity], IComparable, IComparable[ElectricSurfaceChargeDensity], IConvertible):
    """ In electromagnetism, surface charge density is a measure of the amount of electric charge per surface area.
     https://en.wikipedia.org/wiki/Charge_density
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ElectricSurfaceChargeDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricSurfaceChargeDensityUnit]

    MaxValue: typing.ClassVar[ElectricSurfaceChargeDensity]

    MinValue: typing.ClassVar[ElectricSurfaceChargeDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricSurfaceChargeDensityUnit]]

    Zero: typing.ClassVar[ElectricSurfaceChargeDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricSurfaceChargeDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricSurfaceChargeDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CoulombsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CoulombPerSquareCentimeter"
        """
        pass

    @property
    def CoulombsPerSquareInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CoulombPerSquareInch"
        """
        pass

    @property
    def CoulombsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CoulombPerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: ElectricSurfaceChargeDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricSurfaceChargeDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricSurfaceChargeDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricSurfaceChargeDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricSurfaceChargeDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricSurfaceChargeDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCoulombsPerSquareCentimeter(coulombspersquarecentimeter: QuantityValue) -> ElectricSurfaceChargeDensity:
        """ Creates a "ElectricSurfaceChargeDensity" from "Field CoulombPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCoulombsPerSquareInch(coulombspersquareinch: QuantityValue) -> ElectricSurfaceChargeDensity:
        """ Creates a "ElectricSurfaceChargeDensity" from "Field CoulombPerSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCoulombsPerSquareMeter(coulombspersquaremeter: QuantityValue) -> ElectricSurfaceChargeDensity:
        """ Creates a "ElectricSurfaceChargeDensity" from "Field CoulombPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricSurfaceChargeDensityUnit) -> ElectricSurfaceChargeDensity:
        """ Dynamically convert from value and unit enum "ElectricSurfaceChargeDensityUnit" to "ElectricSurfaceChargeDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricSurfaceChargeDensityUnit
        :return: ElectricSurfaceChargeDensity unit value.
        :rtype: ElectricSurfaceChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricSurfaceChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricSurfaceChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricSurfaceChargeDensity) -> typing.Tuple[ElectricSurfaceChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricSurfaceChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricSurfaceChargeDensity) -> typing.Tuple[ElectricSurfaceChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricSurfaceChargeDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricSurfaceChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricSurfaceChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricSurfaceChargeDensityUnit) -> typing.Tuple[ElectricSurfaceChargeDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricSurfaceChargeDensityUnit) -> typing.Tuple[ElectricSurfaceChargeDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricSurfaceChargeDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricSurfaceChargeDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricSurfaceChargeDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricSurfaceChargeDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricSurfaceChargeDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricSurfaceChargeDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricSurfaceChargeDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricSurfaceChargeDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricSurfaceChargeDensityUnit) -> ElectricSurfaceChargeDensity:
        """ Converts this ElectricSurfaceChargeDensity to another ElectricSurfaceChargeDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricSurfaceChargeDensityUnit
        :return: A ElectricSurfaceChargeDensity with the specified unit.
        :rtype: ElectricSurfaceChargeDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricSurfaceChargeDensityUnit, unitConverter: UnitConverter) -> ElectricSurfaceChargeDensity:
        """ Converts this "ElectricSurfaceChargeDensity" to another "ElectricSurfaceChargeDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ElectricSurfaceChargeDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ElectricSurfaceChargeDensity with the specified unit.
        :rtype: ElectricSurfaceChargeDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricSurfaceChargeDensity:
        """
        """
        pass


# noinspection PyPep8Naming
class Frequency(ValueType, IQuantity[FrequencyUnit], IQuantity, IFormattable, IEquatable[Frequency], IComparable, IComparable[Frequency], IConvertible):
    """ The number of occurrences of a repeating event per unit time.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[FrequencyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[FrequencyUnit]

    MaxValue: typing.ClassVar[Frequency]

    MinValue: typing.ClassVar[Frequency]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[FrequencyUnit]]

    Zero: typing.ClassVar[Frequency]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> FrequencyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[FrequencyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BeatsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BeatPerMinute"
        """
        pass

    @property
    def BUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BUnit"
        """
        pass

    @property
    def CyclesPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CyclePerHour"
        """
        pass

    @property
    def CyclesPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CyclePerMinute"
        """
        pass

    @property
    def Gigahertz(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigahertz"
        """
        pass

    @property
    def Hertz(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Hertz"
        """
        pass

    @property
    def Kilohertz(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilohertz"
        """
        pass

    @property
    def Megahertz(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megahertz"
        """
        pass

    @property
    def PerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PerSecond"
        """
        pass

    @property
    def RadiansPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RadianPerSecond"
        """
        pass

    @property
    def Terahertz(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Terahertz"
        """
        pass

    def __init__(self, value: float, unit: FrequencyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: FrequencyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: FrequencyUnit) -> Frequency:
        """ Converts this Frequency to another Frequency with the unit representation .

        :param unit: The unit to convert to.
        :type unit: FrequencyUnit
        :return: A Frequency with the specified unit.
        :rtype: Frequency
        """
        pass

    @typing.overload
    def ToUnit(self, unit: FrequencyUnit, unitConverter: UnitConverter) -> Frequency:
        """ Converts this "Frequency" to another "Frequency" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: FrequencyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Frequency with the specified unit.
        :rtype: Frequency
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Frequency:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FrequencyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FrequencyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FrequencyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FrequencyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBeatsPerMinute(beatsperminute: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field BeatPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBUnits(bunits: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field BUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCyclesPerHour(cyclesperhour: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field CyclePerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCyclesPerMinute(cyclesperminute: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field CyclePerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigahertz(gigahertz: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field Gigahertz".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHertz(hertz: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field Hertz".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilohertz(kilohertz: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field Kilohertz".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegahertz(megahertz: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field Megahertz".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPerSecond(persecond: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field PerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadiansPerSecond(radianspersecond: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field RadianPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerahertz(terahertz: QuantityValue) -> Frequency:
        """ Creates a "Frequency" from "Field Terahertz".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: FrequencyUnit) -> Frequency:
        """ Dynamically convert from value and unit enum "FrequencyUnit" to "Frequency".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: FrequencyUnit
        :return: Frequency unit value.
        :rtype: Frequency
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Frequency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Frequency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Frequency) -> typing.Tuple[Frequency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Frequency
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Frequency) -> typing.Tuple[Frequency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Frequency
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> FrequencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> FrequencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: FrequencyUnit) -> typing.Tuple[FrequencyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: FrequencyUnit) -> typing.Tuple[FrequencyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: FrequencyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Frequency) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Frequency) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Frequency, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Frequency within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Frequency
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Frequency.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: FrequencyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass


# noinspection PyPep8Naming
class FuelEfficiency(ValueType, IQuantity[FuelEfficiencyUnit], IQuantity, IFormattable, IEquatable[FuelEfficiency], IComparable, IComparable[FuelEfficiency], IConvertible):
    """ Fuel efficiency is a form of thermal efficiency, meaning the ratio from effort to result of a process that converts chemical potential energy contained in a carrier (fuel) into kinetic energy or work. Fuel economy is stated as "fuel consumption" in liters per 100 kilometers (L/100 km). In countries using non-metric system, fuel economy is expressed in miles per gallon (mpg) (imperial galon or US galon).
     https://en.wikipedia.org/wiki/Fuel_efficiency
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[FuelEfficiencyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[FuelEfficiencyUnit]

    MaxValue: typing.ClassVar[FuelEfficiency]

    MinValue: typing.ClassVar[FuelEfficiency]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[FuelEfficiencyUnit]]

    Zero: typing.ClassVar[FuelEfficiency]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> FuelEfficiencyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[FuelEfficiencyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilometersPerLiters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilometerPerLiter"
        """
        pass

    @property
    def LitersPer100Kilometers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPer100Kilometers"
        """
        pass

    @property
    def MilesPerUkGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilePerUkGallon"
        """
        pass

    @property
    def MilesPerUsGallon(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilePerUsGallon"
        """
        pass

    def __init__(self, value: float, unit: FuelEfficiencyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: FuelEfficiencyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FuelEfficiencyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FuelEfficiencyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FuelEfficiencyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FuelEfficiencyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilometersPerLiters(kilometersperliters: QuantityValue) -> FuelEfficiency:
        """ Creates a "FuelEfficiency" from "Field KilometerPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPer100Kilometers(litersper100kilometers: QuantityValue) -> FuelEfficiency:
        """ Creates a "FuelEfficiency" from "Field LiterPer100Kilometers".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilesPerUkGallon(milesperukgallon: QuantityValue) -> FuelEfficiency:
        """ Creates a "FuelEfficiency" from "Field MilePerUkGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilesPerUsGallon(milesperusgallon: QuantityValue) -> FuelEfficiency:
        """ Creates a "FuelEfficiency" from "Field MilePerUsGallon".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: FuelEfficiencyUnit) -> FuelEfficiency:
        """ Dynamically convert from value and unit enum "FuelEfficiencyUnit" to "FuelEfficiency".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: FuelEfficiencyUnit
        :return: FuelEfficiency unit value.
        :rtype: FuelEfficiency
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> FuelEfficiency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> FuelEfficiency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: FuelEfficiency) -> typing.Tuple[FuelEfficiency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: FuelEfficiency
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: FuelEfficiency) -> typing.Tuple[FuelEfficiency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: FuelEfficiency
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> FuelEfficiencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> FuelEfficiencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: FuelEfficiencyUnit) -> typing.Tuple[FuelEfficiencyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: FuelEfficiencyUnit) -> typing.Tuple[FuelEfficiencyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: FuelEfficiencyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: FuelEfficiency) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: FuelEfficiency) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: FuelEfficiency, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another FuelEfficiency within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: FuelEfficiency
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current FuelEfficiency.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: FuelEfficiencyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: FuelEfficiencyUnit) -> FuelEfficiency:
        """ Converts this FuelEfficiency to another FuelEfficiency with the unit representation .

        :param unit: The unit to convert to.
        :type unit: FuelEfficiencyUnit
        :return: A FuelEfficiency with the specified unit.
        :rtype: FuelEfficiency
        """
        pass

    @typing.overload
    def ToUnit(self, unit: FuelEfficiencyUnit, unitConverter: UnitConverter) -> FuelEfficiency:
        """ Converts this "FuelEfficiency" to another "FuelEfficiency" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: FuelEfficiencyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A FuelEfficiency with the specified unit.
        :rtype: FuelEfficiency
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> FuelEfficiency:
        """
        """
        pass


# noinspection PyPep8Naming
class HeatTransferCoefficient(ValueType, IQuantity[HeatTransferCoefficientUnit], IQuantity, IFormattable, IEquatable[HeatTransferCoefficient], IComparable, IComparable[HeatTransferCoefficient], IConvertible):
    """ The heat transfer coefficient or film coefficient, or film effectiveness, in thermodynamics and in mechanics is the proportionality constant between the heat flux and the thermodynamic driving force for the flow of heat (i.e., the temperature difference, ΔT)
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[HeatTransferCoefficientUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[HeatTransferCoefficientUnit]

    MaxValue: typing.ClassVar[HeatTransferCoefficient]

    MinValue: typing.ClassVar[HeatTransferCoefficient]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[HeatTransferCoefficientUnit]]

    Zero: typing.ClassVar[HeatTransferCoefficient]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> HeatTransferCoefficientUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[HeatTransferCoefficientUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerSquareFootDegreeFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerSquareFootDegreeFahrenheit"
        """
        pass

    @property
    def WattsPerSquareMeterCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareMeterCelsius"
        """
        pass

    @property
    def WattsPerSquareMeterKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareMeterKelvin"
        """
        pass

    def __init__(self, value: float, unit: HeatTransferCoefficientUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: HeatTransferCoefficientUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatTransferCoefficientUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatTransferCoefficientUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatTransferCoefficientUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatTransferCoefficientUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerSquareFootDegreeFahrenheit(btuspersquarefootdegreefahrenheit: QuantityValue) -> HeatTransferCoefficient:
        """ Creates a "HeatTransferCoefficient" from "Field BtuPerSquareFootDegreeFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeterCelsius(wattspersquaremetercelsius: QuantityValue) -> HeatTransferCoefficient:
        """ Creates a "HeatTransferCoefficient" from "Field WattPerSquareMeterCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeterKelvin(wattspersquaremeterkelvin: QuantityValue) -> HeatTransferCoefficient:
        """ Creates a "HeatTransferCoefficient" from "Field WattPerSquareMeterKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: HeatTransferCoefficientUnit) -> HeatTransferCoefficient:
        """ Dynamically convert from value and unit enum "HeatTransferCoefficientUnit" to "HeatTransferCoefficient".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: HeatTransferCoefficientUnit
        :return: HeatTransferCoefficient unit value.
        :rtype: HeatTransferCoefficient
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> HeatTransferCoefficient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> HeatTransferCoefficient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: HeatTransferCoefficient) -> typing.Tuple[HeatTransferCoefficient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatTransferCoefficient
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: HeatTransferCoefficient) -> typing.Tuple[HeatTransferCoefficient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatTransferCoefficient
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> HeatTransferCoefficientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> HeatTransferCoefficientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: HeatTransferCoefficientUnit) -> typing.Tuple[HeatTransferCoefficientUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: HeatTransferCoefficientUnit) -> typing.Tuple[HeatTransferCoefficientUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: HeatTransferCoefficientUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: HeatTransferCoefficient) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatTransferCoefficient) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatTransferCoefficient, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another HeatTransferCoefficient within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: HeatTransferCoefficient
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current HeatTransferCoefficient.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: HeatTransferCoefficientUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: HeatTransferCoefficientUnit) -> HeatTransferCoefficient:
        """ Converts this HeatTransferCoefficient to another HeatTransferCoefficient with the unit representation .

        :param unit: The unit to convert to.
        :type unit: HeatTransferCoefficientUnit
        :return: A HeatTransferCoefficient with the specified unit.
        :rtype: HeatTransferCoefficient
        """
        pass

    @typing.overload
    def ToUnit(self, unit: HeatTransferCoefficientUnit, unitConverter: UnitConverter) -> HeatTransferCoefficient:
        """ Converts this "HeatTransferCoefficient" to another "HeatTransferCoefficient" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: HeatTransferCoefficientUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A HeatTransferCoefficient with the specified unit.
        :rtype: HeatTransferCoefficient
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> HeatTransferCoefficient:
        """
        """
        pass


# noinspection PyPep8Naming
class Illuminance(ValueType, IQuantity[IlluminanceUnit], IQuantity, IFormattable, IEquatable[Illuminance], IComparable, IComparable[Illuminance], IConvertible):
    """ In photometry, illuminance is the total luminous flux incident on a surface, per unit area.
     https://en.wikipedia.org/wiki/Illuminance
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[IlluminanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[IlluminanceUnit]

    MaxValue: typing.ClassVar[Illuminance]

    MinValue: typing.ClassVar[Illuminance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[IlluminanceUnit]]

    Zero: typing.ClassVar[Illuminance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> IlluminanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[IlluminanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Kilolux(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilolux"
        """
        pass

    @property
    def Lux(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Lux"
        """
        pass

    @property
    def Megalux(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megalux"
        """
        pass

    @property
    def Millilux(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millilux"
        """
        pass

    def __init__(self, value: float, unit: IlluminanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: IlluminanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IlluminanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IlluminanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IlluminanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IlluminanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilolux(kilolux: QuantityValue) -> Illuminance:
        """ Creates a "Illuminance" from "Field Kilolux".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLux(lux: QuantityValue) -> Illuminance:
        """ Creates a "Illuminance" from "Field Lux".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegalux(megalux: QuantityValue) -> Illuminance:
        """ Creates a "Illuminance" from "Field Megalux".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilux(millilux: QuantityValue) -> Illuminance:
        """ Creates a "Illuminance" from "Field Millilux".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: IlluminanceUnit) -> Illuminance:
        """ Dynamically convert from value and unit enum "IlluminanceUnit" to "Illuminance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: IlluminanceUnit
        :return: Illuminance unit value.
        :rtype: Illuminance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Illuminance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Illuminance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Illuminance) -> typing.Tuple[Illuminance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Illuminance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Illuminance) -> typing.Tuple[Illuminance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Illuminance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> IlluminanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> IlluminanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: IlluminanceUnit) -> typing.Tuple[IlluminanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: IlluminanceUnit) -> typing.Tuple[IlluminanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: IlluminanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Illuminance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Illuminance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Illuminance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Illuminance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Illuminance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Illuminance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: IlluminanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IlluminanceUnit) -> Illuminance:
        """ Converts this Illuminance to another Illuminance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: IlluminanceUnit
        :return: A Illuminance with the specified unit.
        :rtype: Illuminance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IlluminanceUnit, unitConverter: UnitConverter) -> Illuminance:
        """ Converts this "Illuminance" to another "Illuminance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: IlluminanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Illuminance with the specified unit.
        :rtype: Illuminance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Illuminance:
        """
        """
        pass


# noinspection PyPep8Naming
class Information(ValueType, IQuantity[InformationUnit], IQuantity, IFormattable, IDecimalQuantity, IEquatable[Information], IComparable, IComparable[Information], IConvertible):
    """ In computing and telecommunications, a unit of information is the capacity of some standard data storage system or communication channel, used to measure the capacities of other systems and channels. In information theory, units of information are also used to measure the information contents or entropy of random variables.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[InformationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[InformationUnit]

    MaxValue: typing.ClassVar[Information]

    MinValue: typing.ClassVar[Information]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[InformationUnit]]

    Zero: typing.ClassVar[Information]

    @property
    def Value(self) -> Decimal:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> InformationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[InformationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Bits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Bit"
        """
        pass

    @property
    def Bytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Byte"
        """
        pass

    @property
    def Exabits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Exabit"
        """
        pass

    @property
    def Exabytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Exabyte"
        """
        pass

    @property
    def Exbibits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Exbibit"
        """
        pass

    @property
    def Exbibytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Exbibyte"
        """
        pass

    @property
    def Gibibits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gibibit"
        """
        pass

    @property
    def Gibibytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gibibyte"
        """
        pass

    @property
    def Gigabits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigabit"
        """
        pass

    @property
    def Gigabytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigabyte"
        """
        pass

    @property
    def Kibibits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kibibit"
        """
        pass

    @property
    def Kibibytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kibibyte"
        """
        pass

    @property
    def Kilobits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilobit"
        """
        pass

    @property
    def Kilobytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilobyte"
        """
        pass

    @property
    def Mebibits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Mebibit"
        """
        pass

    @property
    def Mebibytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Mebibyte"
        """
        pass

    @property
    def Megabits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megabit"
        """
        pass

    @property
    def Megabytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megabyte"
        """
        pass

    @property
    def Pebibits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Pebibit"
        """
        pass

    @property
    def Pebibytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Pebibyte"
        """
        pass

    @property
    def Petabits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Petabit"
        """
        pass

    @property
    def Petabytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Petabyte"
        """
        pass

    @property
    def Tebibits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Tebibit"
        """
        pass

    @property
    def Tebibytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Tebibyte"
        """
        pass

    @property
    def Terabits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Terabit"
        """
        pass

    @property
    def Terabytes(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Terabyte"
        """
        pass

    def __init__(self, value: Decimal, unit: InformationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unit: The unit representation to construct this quantity with.
        :type unit: InformationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: Decimal, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromTerabits(terabits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Terabit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerabytes(terabytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Terabyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: InformationUnit) -> Information:
        """ Dynamically convert from value and unit enum "InformationUnit" to "Information".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: InformationUnit
        :return: Information unit value.
        :rtype: Information
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Information:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Information:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Information) -> typing.Tuple[Information, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Information
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Information) -> typing.Tuple[Information, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Information
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> InformationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> InformationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: InformationUnit) -> typing.Tuple[InformationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: InformationUnit) -> typing.Tuple[InformationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: InformationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Information) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Information) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Information, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Information within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Information
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Information.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: InformationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: InformationUnit) -> Information:
        """ Converts this Information to another Information with the unit representation .

        :param unit: The unit to convert to.
        :type unit: InformationUnit
        :return: A Information with the specified unit.
        :rtype: Information
        """
        pass

    @typing.overload
    def ToUnit(self, unit: InformationUnit, unitConverter: UnitConverter) -> Information:
        """ Converts this "Information" to another "Information" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: InformationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Information with the specified unit.
        :rtype: Information
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Information:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: InformationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: InformationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: InformationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: InformationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBits(bits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Bit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBytes(bytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Byte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabits(exabits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Exabit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabytes(exabytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Exabyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibits(exbibits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Exbibit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibytes(exbibytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Exbibyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibits(gibibits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Gibibit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibytes(gibibytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Gibibyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabits(gigabits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Gigabit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabytes(gigabytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Gigabyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibits(kibibits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Kibibit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibytes(kibibytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Kibibyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobits(kilobits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Kilobit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobytes(kilobytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Kilobyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibits(mebibits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Mebibit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibytes(mebibytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Mebibyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabits(megabits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Megabit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabytes(megabytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Megabyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibits(pebibits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Pebibit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibytes(pebibytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Pebibyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabits(petabits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Petabit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabytes(petabytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Petabyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibits(tebibits: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Tebibit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibytes(tebibytes: QuantityValue) -> Information:
        """ Creates a "Information" from "Field Tebibyte".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Irradiance(ValueType, IQuantity[IrradianceUnit], IQuantity, IFormattable, IEquatable[Irradiance], IComparable, IComparable[Irradiance], IConvertible):
    """ Irradiance is the intensity of ultraviolet (UV) or visible light incident on a surface.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[IrradianceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[IrradianceUnit]

    MaxValue: typing.ClassVar[Irradiance]

    MinValue: typing.ClassVar[Irradiance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[IrradianceUnit]]

    Zero: typing.ClassVar[Irradiance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> IrradianceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[IrradianceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilowattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerSquareCentimeter"
        """
        pass

    @property
    def KilowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerSquareMeter"
        """
        pass

    @property
    def MegawattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerSquareCentimeter"
        """
        pass

    @property
    def MegawattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerSquareMeter"
        """
        pass

    @property
    def MicrowattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerSquareCentimeter"
        """
        pass

    @property
    def MicrowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerSquareMeter"
        """
        pass

    @property
    def MilliwattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerSquareCentimeter"
        """
        pass

    @property
    def MilliwattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerSquareMeter"
        """
        pass

    @property
    def NanowattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerSquareCentimeter"
        """
        pass

    @property
    def NanowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerSquareMeter"
        """
        pass

    @property
    def PicowattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicowattPerSquareCentimeter"
        """
        pass

    @property
    def PicowattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicowattPerSquareMeter"
        """
        pass

    @property
    def WattsPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareCentimeter"
        """
        pass

    @property
    def WattsPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: IrradianceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: IrradianceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Irradiance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Irradiance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Irradiance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: IrradianceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IrradianceUnit) -> Irradiance:
        """ Converts this Irradiance to another Irradiance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: IrradianceUnit
        :return: A Irradiance with the specified unit.
        :rtype: Irradiance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IrradianceUnit, unitConverter: UnitConverter) -> Irradiance:
        """ Converts this "Irradiance" to another "Irradiance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: IrradianceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Irradiance with the specified unit.
        :rtype: Irradiance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Irradiance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradianceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradianceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradianceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradianceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilowattsPerSquareCentimeter(kilowattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field KilowattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerSquareMeter(kilowattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field KilowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerSquareCentimeter(megawattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field MegawattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerSquareMeter(megawattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field MegawattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerSquareCentimeter(microwattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field MicrowattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerSquareMeter(microwattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field MicrowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerSquareCentimeter(milliwattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field MilliwattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerSquareMeter(milliwattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field MilliwattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerSquareCentimeter(nanowattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field NanowattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerSquareMeter(nanowattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field NanowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerSquareCentimeter(picowattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field PicowattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerSquareMeter(picowattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field PicowattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareCentimeter(wattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field WattPerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeter(wattspersquaremeter: QuantityValue) -> Irradiance:
        """ Creates a "Irradiance" from "Field WattPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: IrradianceUnit) -> Irradiance:
        """ Dynamically convert from value and unit enum "IrradianceUnit" to "Irradiance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: IrradianceUnit
        :return: Irradiance unit value.
        :rtype: Irradiance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Irradiance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Irradiance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Irradiance) -> typing.Tuple[Irradiance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Irradiance) -> typing.Tuple[Irradiance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> IrradianceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> IrradianceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: IrradianceUnit) -> typing.Tuple[IrradianceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: IrradianceUnit) -> typing.Tuple[IrradianceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: IrradianceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Irradiance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class Irradiation(ValueType, IQuantity[IrradiationUnit], IQuantity, IFormattable, IEquatable[Irradiation], IComparable, IComparable[Irradiation], IConvertible):
    """ Irradiation is the process by which an object is exposed to radiation. The exposure can originate from various sources, including natural sources.
     https://en.wikipedia.org/wiki/Irradiation
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[IrradiationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[IrradiationUnit]

    MaxValue: typing.ClassVar[Irradiation]

    MinValue: typing.ClassVar[Irradiation]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[IrradiationUnit]]

    Zero: typing.ClassVar[Irradiation]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> IrradiationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[IrradiationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def JoulesPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerSquareCentimeter"
        """
        pass

    @property
    def JoulesPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerSquareMeter"
        """
        pass

    @property
    def JoulesPerSquareMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerSquareMillimeter"
        """
        pass

    @property
    def KilojoulesPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerSquareMeter"
        """
        pass

    @property
    def KilowattHoursPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattHourPerSquareMeter"
        """
        pass

    @property
    def MillijoulesPerSquareCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillijoulePerSquareCentimeter"
        """
        pass

    @property
    def WattHoursPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattHourPerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: IrradiationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: IrradiationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Irradiation:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradiationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradiationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradiationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradiationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromJoulesPerSquareCentimeter(joulespersquarecentimeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field JoulePerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerSquareMeter(joulespersquaremeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field JoulePerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerSquareMillimeter(joulespersquaremillimeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field JoulePerSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerSquareMeter(kilojoulespersquaremeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field KilojoulePerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHoursPerSquareMeter(kilowatthourspersquaremeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field KilowattHourPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillijoulesPerSquareCentimeter(millijoulespersquarecentimeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field MillijoulePerSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHoursPerSquareMeter(watthourspersquaremeter: QuantityValue) -> Irradiation:
        """ Creates a "Irradiation" from "Field WattHourPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: IrradiationUnit) -> Irradiation:
        """ Dynamically convert from value and unit enum "IrradiationUnit" to "Irradiation".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: IrradiationUnit
        :return: Irradiation unit value.
        :rtype: Irradiation
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Irradiation:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Irradiation:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Irradiation) -> typing.Tuple[Irradiation, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiation
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Irradiation) -> typing.Tuple[Irradiation, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiation
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> IrradiationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> IrradiationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: IrradiationUnit) -> typing.Tuple[IrradiationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: IrradiationUnit) -> typing.Tuple[IrradiationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: IrradiationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Irradiation) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiation) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiation, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Irradiation within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Irradiation
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Irradiation.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: IrradiationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IrradiationUnit) -> Irradiation:
        """ Converts this Irradiation to another Irradiation with the unit representation .

        :param unit: The unit to convert to.
        :type unit: IrradiationUnit
        :return: A Irradiation with the specified unit.
        :rtype: Irradiation
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IrradiationUnit, unitConverter: UnitConverter) -> Irradiation:
        """ Converts this "Irradiation" to another "Irradiation" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: IrradiationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Irradiation with the specified unit.
        :rtype: Irradiation
        """
        pass


# noinspection PyPep8Naming
class Jerk(ValueType, IQuantity[JerkUnit], IQuantity, IFormattable, IEquatable[Jerk], IComparable, IComparable[Jerk], IConvertible):
    """ Jerk or Jolt, in physics, is the rate at which the acceleration of an object changes over time. The SI unit for jerk is the Meter per second cubed (m/s³). Jerks are vector quantities (they have magnitude and direction) and add according to the parallelogram law.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[JerkUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[JerkUnit]

    MaxValue: typing.ClassVar[Jerk]

    MinValue: typing.ClassVar[Jerk]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[JerkUnit]]

    Zero: typing.ClassVar[Jerk]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> JerkUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[JerkUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterPerSecondCubed"
        """
        pass

    @property
    def DecimetersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimeterPerSecondCubed"
        """
        pass

    @property
    def FeetPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootPerSecondCubed"
        """
        pass

    @property
    def InchesPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchPerSecondCubed"
        """
        pass

    @property
    def KilometersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilometerPerSecondCubed"
        """
        pass

    @property
    def MetersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterPerSecondCubed"
        """
        pass

    @property
    def MicrometersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrometerPerSecondCubed"
        """
        pass

    @property
    def MillimetersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterPerSecondCubed"
        """
        pass

    @property
    def MillistandardGravitiesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillistandardGravitiesPerSecond"
        """
        pass

    @property
    def NanometersPerSecondCubed(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanometerPerSecondCubed"
        """
        pass

    @property
    def StandardGravitiesPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardGravitiesPerSecond"
        """
        pass

    def __init__(self, value: float, unit: JerkUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: JerkUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: JerkUnit) -> Jerk:
        """ Converts this Jerk to another Jerk with the unit representation .

        :param unit: The unit to convert to.
        :type unit: JerkUnit
        :return: A Jerk with the specified unit.
        :rtype: Jerk
        """
        pass

    @typing.overload
    def ToUnit(self, unit: JerkUnit, unitConverter: UnitConverter) -> Jerk:
        """ Converts this "Jerk" to another "Jerk" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: JerkUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Jerk with the specified unit.
        :rtype: Jerk
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Jerk:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: JerkUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: JerkUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: JerkUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: JerkUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersPerSecondCubed(centimeterspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field CentimeterPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerSecondCubed(decimeterspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field DecimeterPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerSecondCubed(feetpersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field FootPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerSecondCubed(inchespersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field InchPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerSecondCubed(kilometerspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field KilometerPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerSecondCubed(meterspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field MeterPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerSecondCubed(micrometerspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field MicrometerPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerSecondCubed(millimeterspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field MillimeterPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillistandardGravitiesPerSecond(millistandardgravitiespersecond: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field MillistandardGravitiesPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerSecondCubed(nanometerspersecondcubed: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field NanometerPerSecondCubed".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardGravitiesPerSecond(standardgravitiespersecond: QuantityValue) -> Jerk:
        """ Creates a "Jerk" from "Field StandardGravitiesPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: JerkUnit) -> Jerk:
        """ Dynamically convert from value and unit enum "JerkUnit" to "Jerk".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: JerkUnit
        :return: Jerk unit value.
        :rtype: Jerk
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Jerk:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Jerk:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Jerk) -> typing.Tuple[Jerk, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Jerk
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Jerk) -> typing.Tuple[Jerk, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Jerk
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> JerkUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> JerkUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: JerkUnit) -> typing.Tuple[JerkUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: JerkUnit) -> typing.Tuple[JerkUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: JerkUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Jerk) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Jerk) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Jerk, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Jerk within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Jerk
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Jerk.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: JerkUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass


# noinspection PyPep8Naming
class LinearPowerDensity(ValueType, IQuantity[LinearPowerDensityUnit], IQuantity, IFormattable, IEquatable[LinearPowerDensity], IComparable, IComparable[LinearPowerDensity], IConvertible):
    """ The Linear Power Density of a substance is its power per unit length. The term linear density is most often used when describing the characteristics of one-dimensional objects, although linear density can also be used to describe the density of a three-dimensional quantity along one particular dimension.
     http://en.wikipedia.org/wiki/Linear_density
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LinearPowerDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LinearPowerDensityUnit]

    MaxValue: typing.ClassVar[LinearPowerDensity]

    MinValue: typing.ClassVar[LinearPowerDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LinearPowerDensityUnit]]

    Zero: typing.ClassVar[LinearPowerDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LinearPowerDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LinearPowerDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GigawattsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerCentimeter"
        """
        pass

    @property
    def GigawattsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerFoot"
        """
        pass

    @property
    def GigawattsPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerInch"
        """
        pass

    @property
    def GigawattsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerMeter"
        """
        pass

    @property
    def GigawattsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerMillimeter"
        """
        pass

    @property
    def KilowattsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerCentimeter"
        """
        pass

    @property
    def KilowattsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerFoot"
        """
        pass

    @property
    def KilowattsPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerInch"
        """
        pass

    @property
    def KilowattsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerMeter"
        """
        pass

    @property
    def KilowattsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerMillimeter"
        """
        pass

    @property
    def MegawattsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerCentimeter"
        """
        pass

    @property
    def MegawattsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerFoot"
        """
        pass

    @property
    def MegawattsPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerInch"
        """
        pass

    @property
    def MegawattsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerMeter"
        """
        pass

    @property
    def MegawattsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerMillimeter"
        """
        pass

    @property
    def MilliwattsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerCentimeter"
        """
        pass

    @property
    def MilliwattsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerFoot"
        """
        pass

    @property
    def MilliwattsPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerInch"
        """
        pass

    @property
    def MilliwattsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerMeter"
        """
        pass

    @property
    def MilliwattsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerMillimeter"
        """
        pass

    @property
    def WattsPerCentimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerCentimeter"
        """
        pass

    @property
    def WattsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerFoot"
        """
        pass

    @property
    def WattsPerInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerInch"
        """
        pass

    @property
    def WattsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerMeter"
        """
        pass

    @property
    def WattsPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerMillimeter"
        """
        pass

    def __init__(self, value: float, unit: LinearPowerDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LinearPowerDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LinearPowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LinearPowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LinearPowerDensityUnit) -> typing.Tuple[LinearPowerDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LinearPowerDensityUnit) -> typing.Tuple[LinearPowerDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LinearPowerDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LinearPowerDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearPowerDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearPowerDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LinearPowerDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LinearPowerDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LinearPowerDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LinearPowerDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LinearPowerDensityUnit) -> LinearPowerDensity:
        """ Converts this LinearPowerDensity to another LinearPowerDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LinearPowerDensityUnit
        :return: A LinearPowerDensity with the specified unit.
        :rtype: LinearPowerDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LinearPowerDensityUnit, unitConverter: UnitConverter) -> LinearPowerDensity:
        """ Converts this "LinearPowerDensity" to another "LinearPowerDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LinearPowerDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A LinearPowerDensity with the specified unit.
        :rtype: LinearPowerDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LinearPowerDensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearPowerDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearPowerDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearPowerDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearPowerDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigawattsPerCentimeter(gigawattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field GigawattPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerFoot(gigawattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field GigawattPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerInch(gigawattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field GigawattPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerMeter(gigawattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field GigawattPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerMillimeter(gigawattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field GigawattPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCentimeter(kilowattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field KilowattPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerFoot(kilowattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field KilowattPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerInch(kilowattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field KilowattPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerMeter(kilowattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field KilowattPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerMillimeter(kilowattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field KilowattPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCentimeter(megawattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MegawattPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerFoot(megawattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MegawattPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerInch(megawattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MegawattPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerMeter(megawattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MegawattPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerMillimeter(megawattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MegawattPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCentimeter(milliwattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MilliwattPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerFoot(milliwattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MilliwattPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerInch(milliwattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MilliwattPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerMeter(milliwattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MilliwattPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerMillimeter(milliwattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field MilliwattPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCentimeter(wattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field WattPerCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerFoot(wattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field WattPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerInch(wattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field WattPerInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerMeter(wattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field WattPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerMillimeter(wattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Creates a "LinearPowerDensity" from "Field WattPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LinearPowerDensityUnit) -> LinearPowerDensity:
        """ Dynamically convert from value and unit enum "LinearPowerDensityUnit" to "LinearPowerDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LinearPowerDensityUnit
        :return: LinearPowerDensity unit value.
        :rtype: LinearPowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LinearPowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LinearPowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LinearPowerDensity) -> typing.Tuple[LinearPowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearPowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LinearPowerDensity) -> typing.Tuple[LinearPowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearPowerDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Luminosity(ValueType, IQuantity[LuminosityUnit], IQuantity, IFormattable, IEquatable[Luminosity], IComparable, IComparable[Luminosity], IConvertible):
    """ Luminosity is an absolute measure of radiated electromagnetic power (light), the radiant power emitted by a light-emitting object.
     https://en.wikipedia.org/wiki/Luminosity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LuminosityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminosityUnit]

    MaxValue: typing.ClassVar[Luminosity]

    MinValue: typing.ClassVar[Luminosity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminosityUnit]]

    Zero: typing.ClassVar[Luminosity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminosityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminosityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Decawatt"
        """
        pass

    @property
    def Deciwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Deciwatt"
        """
        pass

    @property
    def Femtowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Femtowatt"
        """
        pass

    @property
    def Gigawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gigawatt"
        """
        pass

    @property
    def Kilowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Kilowatt"
        """
        pass

    @property
    def Megawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Megawatt"
        """
        pass

    @property
    def Microwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microwatt"
        """
        pass

    @property
    def Milliwatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milliwatt"
        """
        pass

    @property
    def Nanowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanowatt"
        """
        pass

    @property
    def Petawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Petawatt"
        """
        pass

    @property
    def Picowatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Picowatt"
        """
        pass

    @property
    def SolarLuminosities(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SolarLuminosity"
        """
        pass

    @property
    def Terawatts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Terawatt"
        """
        pass

    @property
    def Watts(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Watt"
        """
        pass

    def __init__(self, value: float, unit: LuminosityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminosityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: Luminosity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Luminosity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Luminosity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Luminosity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Luminosity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminosityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminosityUnit) -> Luminosity:
        """ Converts this Luminosity to another Luminosity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminosityUnit
        :return: A Luminosity with the specified unit.
        :rtype: Luminosity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminosityUnit, unitConverter: UnitConverter) -> Luminosity:
        """ Converts this "Luminosity" to another "Luminosity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminosityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Luminosity with the specified unit.
        :rtype: Luminosity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Luminosity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminosityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminosityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminosityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminosityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecawatts(decawatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Decawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwatts(deciwatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Deciwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFemtowatts(femtowatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Femtowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawatts(gigawatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Gigawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowatts(kilowatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Kilowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawatts(megawatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Megawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowatts(microwatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Microwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwatts(milliwatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Milliwatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowatts(nanowatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Nanowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetawatts(petawatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Petawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowatts(picowatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Picowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarLuminosities(solarluminosities: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field SolarLuminosity".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawatts(terawatts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Terawatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWatts(watts: QuantityValue) -> Luminosity:
        """ Creates a "Luminosity" from "Field Watt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminosityUnit) -> Luminosity:
        """ Dynamically convert from value and unit enum "LuminosityUnit" to "Luminosity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminosityUnit
        :return: Luminosity unit value.
        :rtype: Luminosity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Luminosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Luminosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Luminosity) -> typing.Tuple[Luminosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Luminosity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Luminosity) -> typing.Tuple[Luminosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Luminosity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminosityUnit) -> typing.Tuple[LuminosityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminosityUnit) -> typing.Tuple[LuminosityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminosityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Luminosity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class LuminousFlux(ValueType, IQuantity[LuminousFluxUnit], IQuantity, IFormattable, IEquatable[LuminousFlux], IComparable, IComparable[LuminousFlux], IConvertible):
    """ In photometry, luminous flux or luminous power is the measure of the perceived power of light.
     https://en.wikipedia.org/wiki/Luminous_flux
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[LuminousFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminousFluxUnit]

    MaxValue: typing.ClassVar[LuminousFlux]

    MinValue: typing.ClassVar[LuminousFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminousFluxUnit]]

    Zero: typing.ClassVar[LuminousFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminousFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminousFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Lumens(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Lumen"
        """
        pass

    def __init__(self, value: float, unit: LuminousFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminousFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromLumens(lumens: QuantityValue) -> LuminousFlux:
        """ Creates a "LuminousFlux" from "Field Lumen".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminousFluxUnit) -> LuminousFlux:
        """ Dynamically convert from value and unit enum "LuminousFluxUnit" to "LuminousFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminousFluxUnit
        :return: LuminousFlux unit value.
        :rtype: LuminousFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LuminousFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LuminousFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LuminousFlux) -> typing.Tuple[LuminousFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LuminousFlux) -> typing.Tuple[LuminousFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminousFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminousFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminousFluxUnit) -> typing.Tuple[LuminousFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminousFluxUnit) -> typing.Tuple[LuminousFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminousFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LuminousFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LuminousFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LuminousFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LuminousFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminousFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminousFluxUnit) -> LuminousFlux:
        """ Converts this LuminousFlux to another LuminousFlux with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminousFluxUnit
        :return: A LuminousFlux with the specified unit.
        :rtype: LuminousFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminousFluxUnit, unitConverter: UnitConverter) -> LuminousFlux:
        """ Converts this "LuminousFlux" to another "LuminousFlux" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: LuminousFluxUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A LuminousFlux with the specified unit.
        :rtype: LuminousFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LuminousFlux:
        """
        """
        pass


# noinspection PyPep8Naming
class MagneticField(ValueType, IQuantity[MagneticFieldUnit], IQuantity, IFormattable, IEquatable[MagneticField], IComparable, IComparable[MagneticField], IConvertible):
    """ A magnetic field is a force field that is created by moving electric charges (electric currents) and magnetic dipoles, and exerts a force on other nearby moving charges and magnetic dipoles.
     https://en.wikipedia.org/wiki/Magnetic_field
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MagneticFieldUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MagneticFieldUnit]

    MaxValue: typing.ClassVar[MagneticField]

    MinValue: typing.ClassVar[MagneticField]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MagneticFieldUnit]]

    Zero: typing.ClassVar[MagneticField]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MagneticFieldUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MagneticFieldUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Gausses(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Gauss"
        """
        pass

    @property
    def Microteslas(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microtesla"
        """
        pass

    @property
    def Milligausses(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Milligauss"
        """
        pass

    @property
    def Milliteslas(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millitesla"
        """
        pass

    @property
    def Nanoteslas(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Nanotesla"
        """
        pass

    @property
    def Teslas(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Tesla"
        """
        pass

    def __init__(self, value: float, unit: MagneticFieldUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MagneticFieldUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MagneticField:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFieldUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFieldUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFieldUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFieldUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGausses(gausses: QuantityValue) -> MagneticField:
        """ Creates a "MagneticField" from "Field Gauss".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroteslas(microteslas: QuantityValue) -> MagneticField:
        """ Creates a "MagneticField" from "Field Microtesla".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligausses(milligausses: QuantityValue) -> MagneticField:
        """ Creates a "MagneticField" from "Field Milligauss".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliteslas(milliteslas: QuantityValue) -> MagneticField:
        """ Creates a "MagneticField" from "Field Millitesla".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoteslas(nanoteslas: QuantityValue) -> MagneticField:
        """ Creates a "MagneticField" from "Field Nanotesla".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTeslas(teslas: QuantityValue) -> MagneticField:
        """ Creates a "MagneticField" from "Field Tesla".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MagneticFieldUnit) -> MagneticField:
        """ Dynamically convert from value and unit enum "MagneticFieldUnit" to "MagneticField".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MagneticFieldUnit
        :return: MagneticField unit value.
        :rtype: MagneticField
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MagneticField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MagneticField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MagneticField) -> typing.Tuple[MagneticField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticField
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MagneticField) -> typing.Tuple[MagneticField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticField
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MagneticFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MagneticFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MagneticFieldUnit) -> typing.Tuple[MagneticFieldUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MagneticFieldUnit) -> typing.Tuple[MagneticFieldUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MagneticFieldUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MagneticField) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticField) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticField, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MagneticField within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MagneticField
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MagneticField.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MagneticFieldUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagneticFieldUnit) -> MagneticField:
        """ Converts this MagneticField to another MagneticField with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MagneticFieldUnit
        :return: A MagneticField with the specified unit.
        :rtype: MagneticField
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagneticFieldUnit, unitConverter: UnitConverter) -> MagneticField:
        """ Converts this "MagneticField" to another "MagneticField" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MagneticFieldUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MagneticField with the specified unit.
        :rtype: MagneticField
        """
        pass


# noinspection PyPep8Naming
class MagneticFlux(ValueType, IQuantity[MagneticFluxUnit], IQuantity, IFormattable, IEquatable[MagneticFlux], IComparable, IComparable[MagneticFlux], IConvertible):
    """ In physics, specifically electromagnetism, the magnetic flux through a surface is the surface integral of the normal component of the magnetic field B passing through that surface.
     https://en.wikipedia.org/wiki/Magnetic_flux
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MagneticFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MagneticFluxUnit]

    MaxValue: typing.ClassVar[MagneticFlux]

    MinValue: typing.ClassVar[MagneticFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MagneticFluxUnit]]

    Zero: typing.ClassVar[MagneticFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MagneticFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MagneticFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Webers(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Weber"
        """
        pass

    def __init__(self, value: float, unit: MagneticFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MagneticFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromWebers(webers: QuantityValue) -> MagneticFlux:
        """ Creates a "MagneticFlux" from "Field Weber".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MagneticFluxUnit) -> MagneticFlux:
        """ Dynamically convert from value and unit enum "MagneticFluxUnit" to "MagneticFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MagneticFluxUnit
        :return: MagneticFlux unit value.
        :rtype: MagneticFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MagneticFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MagneticFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MagneticFlux) -> typing.Tuple[MagneticFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MagneticFlux) -> typing.Tuple[MagneticFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MagneticFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MagneticFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MagneticFluxUnit) -> typing.Tuple[MagneticFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MagneticFluxUnit) -> typing.Tuple[MagneticFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MagneticFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MagneticFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MagneticFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MagneticFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MagneticFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MagneticFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagneticFluxUnit) -> MagneticFlux:
        """ Converts this MagneticFlux to another MagneticFlux with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MagneticFluxUnit
        :return: A MagneticFlux with the specified unit.
        :rtype: MagneticFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagneticFluxUnit, unitConverter: UnitConverter) -> MagneticFlux:
        """ Converts this "MagneticFlux" to another "MagneticFlux" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MagneticFluxUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MagneticFlux with the specified unit.
        :rtype: MagneticFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MagneticFlux:
        """
        """
        pass


# noinspection PyPep8Naming
class Magnetization(ValueType, IQuantity[MagnetizationUnit], IQuantity, IFormattable, IEquatable[Magnetization], IComparable, IComparable[Magnetization], IConvertible):
    """ In classical electromagnetism, magnetization is the vector field that expresses the density of permanent or induced magnetic dipole moments in a magnetic material.
     https://en.wikipedia.org/wiki/Magnetization
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MagnetizationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MagnetizationUnit]

    MaxValue: typing.ClassVar[Magnetization]

    MinValue: typing.ClassVar[Magnetization]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MagnetizationUnit]]

    Zero: typing.ClassVar[Magnetization]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MagnetizationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MagnetizationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmperesPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AmperePerMeter"
        """
        pass

    def __init__(self, value: float, unit: MagnetizationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MagnetizationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagnetizationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagnetizationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagnetizationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagnetizationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperesPerMeter(amperespermeter: QuantityValue) -> Magnetization:
        """ Creates a "Magnetization" from "Field AmperePerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MagnetizationUnit) -> Magnetization:
        """ Dynamically convert from value and unit enum "MagnetizationUnit" to "Magnetization".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MagnetizationUnit
        :return: Magnetization unit value.
        :rtype: Magnetization
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Magnetization:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Magnetization:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Magnetization) -> typing.Tuple[Magnetization, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Magnetization
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Magnetization) -> typing.Tuple[Magnetization, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Magnetization
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MagnetizationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MagnetizationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MagnetizationUnit) -> typing.Tuple[MagnetizationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MagnetizationUnit) -> typing.Tuple[MagnetizationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MagnetizationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Magnetization) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Magnetization) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Magnetization, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Magnetization within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Magnetization
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Magnetization.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MagnetizationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagnetizationUnit) -> Magnetization:
        """ Converts this Magnetization to another Magnetization with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MagnetizationUnit
        :return: A Magnetization with the specified unit.
        :rtype: Magnetization
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagnetizationUnit, unitConverter: UnitConverter) -> Magnetization:
        """ Converts this "Magnetization" to another "Magnetization" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MagnetizationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Magnetization with the specified unit.
        :rtype: Magnetization
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Magnetization:
        """
        """
        pass


# noinspection PyPep8Naming
class MassMomentOfInertia(ValueType, IQuantity[MassMomentOfInertiaUnit], IQuantity, IFormattable, IEquatable[MassMomentOfInertia], IComparable, IComparable[MassMomentOfInertia], IConvertible):
    """ A property of body reflects how its mass is distributed with regard to an axis.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MassMomentOfInertiaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassMomentOfInertiaUnit]

    MaxValue: typing.ClassVar[MassMomentOfInertia]

    MinValue: typing.ClassVar[MassMomentOfInertia]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassMomentOfInertiaUnit]]

    Zero: typing.ClassVar[MassMomentOfInertia]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassMomentOfInertiaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassMomentOfInertiaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramSquareCentimeter"
        """
        pass

    @property
    def GramSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramSquareDecimeter"
        """
        pass

    @property
    def GramSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramSquareMeter"
        """
        pass

    @property
    def GramSquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramSquareMillimeter"
        """
        pass

    @property
    def KilogramSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramSquareCentimeter"
        """
        pass

    @property
    def KilogramSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramSquareDecimeter"
        """
        pass

    @property
    def KilogramSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramSquareMeter"
        """
        pass

    @property
    def KilogramSquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramSquareMillimeter"
        """
        pass

    @property
    def KilotonneSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilotonneSquareCentimeter"
        """
        pass

    @property
    def KilotonneSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilotonneSquareDecimeter"
        """
        pass

    @property
    def KilotonneSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilotonneSquareMeter"
        """
        pass

    @property
    def KilotonneSquareMilimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilotonneSquareMilimeter"
        """
        pass

    @property
    def MegatonneSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegatonneSquareCentimeter"
        """
        pass

    @property
    def MegatonneSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegatonneSquareDecimeter"
        """
        pass

    @property
    def MegatonneSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegatonneSquareMeter"
        """
        pass

    @property
    def MegatonneSquareMilimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegatonneSquareMilimeter"
        """
        pass

    @property
    def MilligramSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramSquareCentimeter"
        """
        pass

    @property
    def MilligramSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramSquareDecimeter"
        """
        pass

    @property
    def MilligramSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramSquareMeter"
        """
        pass

    @property
    def MilligramSquareMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramSquareMillimeter"
        """
        pass

    @property
    def PoundSquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundSquareFoot"
        """
        pass

    @property
    def PoundSquareInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundSquareInch"
        """
        pass

    @property
    def SlugSquareFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugSquareFoot"
        """
        pass

    @property
    def SlugSquareInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SlugSquareInch"
        """
        pass

    @property
    def TonneSquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneSquareCentimeter"
        """
        pass

    @property
    def TonneSquareDecimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneSquareDecimeter"
        """
        pass

    @property
    def TonneSquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneSquareMeter"
        """
        pass

    @property
    def TonneSquareMilimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneSquareMilimeter"
        """
        pass

    def __init__(self, value: float, unit: MassMomentOfInertiaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassMomentOfInertiaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromTonneSquareMilimeters(tonnesquaremilimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field TonneSquareMilimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassMomentOfInertiaUnit) -> MassMomentOfInertia:
        """ Dynamically convert from value and unit enum "MassMomentOfInertiaUnit" to "MassMomentOfInertia".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassMomentOfInertiaUnit
        :return: MassMomentOfInertia unit value.
        :rtype: MassMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassMomentOfInertia) -> typing.Tuple[MassMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassMomentOfInertia) -> typing.Tuple[MassMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassMomentOfInertia
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassMomentOfInertiaUnit) -> typing.Tuple[MassMomentOfInertiaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassMomentOfInertiaUnit) -> typing.Tuple[MassMomentOfInertiaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassMomentOfInertiaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassMomentOfInertia) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassMomentOfInertia) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassMomentOfInertia, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassMomentOfInertia within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassMomentOfInertia
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassMomentOfInertia.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassMomentOfInertiaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassMomentOfInertiaUnit) -> MassMomentOfInertia:
        """ Converts this MassMomentOfInertia to another MassMomentOfInertia with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassMomentOfInertiaUnit
        :return: A MassMomentOfInertia with the specified unit.
        :rtype: MassMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassMomentOfInertiaUnit, unitConverter: UnitConverter) -> MassMomentOfInertia:
        """ Converts this "MassMomentOfInertia" to another "MassMomentOfInertia" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MassMomentOfInertiaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MassMomentOfInertia with the specified unit.
        :rtype: MassMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassMomentOfInertia:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassMomentOfInertiaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassMomentOfInertiaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassMomentOfInertiaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassMomentOfInertiaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramSquareCentimeters(gramsquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field GramSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramSquareDecimeters(gramsquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field GramSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramSquareMeters(gramsquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field GramSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramSquareMillimeters(gramsquaremillimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field GramSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareCentimeters(kilogramsquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilogramSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareDecimeters(kilogramsquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilogramSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareMeters(kilogramsquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilogramSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareMillimeters(kilogramsquaremillimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilogramSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareCentimeters(kilotonnesquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilotonneSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareDecimeters(kilotonnesquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilotonneSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareMeters(kilotonnesquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilotonneSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareMilimeters(kilotonnesquaremilimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field KilotonneSquareMilimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareCentimeters(megatonnesquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MegatonneSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareDecimeters(megatonnesquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MegatonneSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareMeters(megatonnesquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MegatonneSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareMilimeters(megatonnesquaremilimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MegatonneSquareMilimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareCentimeters(milligramsquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MilligramSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareDecimeters(milligramsquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MilligramSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareMeters(milligramsquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MilligramSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareMillimeters(milligramsquaremillimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field MilligramSquareMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundSquareFeet(poundsquarefeet: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field PoundSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundSquareInches(poundsquareinches: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field PoundSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugSquareFeet(slugsquarefeet: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field SlugSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugSquareInches(slugsquareinches: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field SlugSquareInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareCentimeters(tonnesquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field TonneSquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareDecimeters(tonnesquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field TonneSquareDecimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareMeters(tonnesquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Creates a "MassMomentOfInertia" from "Field TonneSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class MolarEnergy(ValueType, IQuantity[MolarEnergyUnit], IQuantity, IFormattable, IEquatable[MolarEnergy], IComparable, IComparable[MolarEnergy], IConvertible):
    """ Molar energy is the amount of energy stored in 1 mole of a substance.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MolarEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarEnergyUnit]

    MaxValue: typing.ClassVar[MolarEnergy]

    MinValue: typing.ClassVar[MolarEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarEnergyUnit]]

    Zero: typing.ClassVar[MolarEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def JoulesPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerMole"
        """
        pass

    @property
    def KilojoulesPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerMole"
        """
        pass

    @property
    def MegajoulesPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerMole"
        """
        pass

    def __init__(self, value: float, unit: MolarEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromJoulesPerMole(joulespermole: QuantityValue) -> MolarEnergy:
        """ Creates a "MolarEnergy" from "Field JoulePerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerMole(kilojoulespermole: QuantityValue) -> MolarEnergy:
        """ Creates a "MolarEnergy" from "Field KilojoulePerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerMole(megajoulespermole: QuantityValue) -> MolarEnergy:
        """ Creates a "MolarEnergy" from "Field MegajoulePerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarEnergyUnit) -> MolarEnergy:
        """ Dynamically convert from value and unit enum "MolarEnergyUnit" to "MolarEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarEnergyUnit
        :return: MolarEnergy unit value.
        :rtype: MolarEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MolarEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MolarEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MolarEnergy) -> typing.Tuple[MolarEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MolarEnergy) -> typing.Tuple[MolarEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarEnergyUnit) -> typing.Tuple[MolarEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarEnergyUnit) -> typing.Tuple[MolarEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MolarEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MolarEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MolarEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MolarEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MolarEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarEnergyUnit) -> MolarEnergy:
        """ Converts this MolarEnergy to another MolarEnergy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarEnergyUnit
        :return: A MolarEnergy with the specified unit.
        :rtype: MolarEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarEnergyUnit, unitConverter: UnitConverter) -> MolarEnergy:
        """ Converts this "MolarEnergy" to another "MolarEnergy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarEnergyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MolarEnergy with the specified unit.
        :rtype: MolarEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MolarEnergy:
        """
        """
        pass


# noinspection PyPep8Naming
class MolarEntropy(ValueType, IQuantity[MolarEntropyUnit], IQuantity, IFormattable, IEquatable[MolarEntropy], IComparable, IComparable[MolarEntropy], IConvertible):
    """ Molar entropy is amount of energy required to increase temperature of 1 mole substance by 1 Kelvin.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MolarEntropyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarEntropyUnit]

    MaxValue: typing.ClassVar[MolarEntropy]

    MinValue: typing.ClassVar[MolarEntropy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarEntropyUnit]]

    Zero: typing.ClassVar[MolarEntropy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarEntropyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarEntropyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def JoulesPerMoleKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerMoleKelvin"
        """
        pass

    @property
    def KilojoulesPerMoleKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerMoleKelvin"
        """
        pass

    @property
    def MegajoulesPerMoleKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerMoleKelvin"
        """
        pass

    def __init__(self, value: float, unit: MolarEntropyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarEntropyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEntropyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEntropyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEntropyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEntropyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromJoulesPerMoleKelvin(joulespermolekelvin: QuantityValue) -> MolarEntropy:
        """ Creates a "MolarEntropy" from "Field JoulePerMoleKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerMoleKelvin(kilojoulespermolekelvin: QuantityValue) -> MolarEntropy:
        """ Creates a "MolarEntropy" from "Field KilojoulePerMoleKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerMoleKelvin(megajoulespermolekelvin: QuantityValue) -> MolarEntropy:
        """ Creates a "MolarEntropy" from "Field MegajoulePerMoleKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarEntropyUnit) -> MolarEntropy:
        """ Dynamically convert from value and unit enum "MolarEntropyUnit" to "MolarEntropy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarEntropyUnit
        :return: MolarEntropy unit value.
        :rtype: MolarEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MolarEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MolarEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MolarEntropy) -> typing.Tuple[MolarEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MolarEntropy) -> typing.Tuple[MolarEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEntropy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarEntropyUnit) -> typing.Tuple[MolarEntropyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarEntropyUnit) -> typing.Tuple[MolarEntropyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarEntropyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MolarEntropy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEntropy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEntropy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MolarEntropy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MolarEntropy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MolarEntropy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MolarEntropyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarEntropyUnit) -> MolarEntropy:
        """ Converts this MolarEntropy to another MolarEntropy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarEntropyUnit
        :return: A MolarEntropy with the specified unit.
        :rtype: MolarEntropy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarEntropyUnit, unitConverter: UnitConverter) -> MolarEntropy:
        """ Converts this "MolarEntropy" to another "MolarEntropy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarEntropyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MolarEntropy with the specified unit.
        :rtype: MolarEntropy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MolarEntropy:
        """
        """
        pass


# noinspection PyPep8Naming
class MolarMass(ValueType, IQuantity[MolarMassUnit], IQuantity, IFormattable, IEquatable[MolarMass], IComparable, IComparable[MolarMass], IConvertible):
    """ In chemistry, the molar mass M is a physical property defined as the mass of a given substance (chemical element or chemical compound) divided by the amount of substance.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[MolarMassUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarMassUnit]

    MaxValue: typing.ClassVar[MolarMass]

    MinValue: typing.ClassVar[MolarMass]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarMassUnit]]

    Zero: typing.ClassVar[MolarMass]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarMassUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarMassUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentigramPerMole"
        """
        pass

    @property
    def DecagramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecagramPerMole"
        """
        pass

    @property
    def DecigramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecigramPerMole"
        """
        pass

    @property
    def GramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerMole"
        """
        pass

    @property
    def HectogramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HectogramPerMole"
        """
        pass

    @property
    def KilogramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerMole"
        """
        pass

    @property
    def KilopoundsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundPerMole"
        """
        pass

    @property
    def MegapoundsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundPerMole"
        """
        pass

    @property
    def MicrogramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrogramPerMole"
        """
        pass

    @property
    def MilligramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilligramPerMole"
        """
        pass

    @property
    def NanogramsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanogramPerMole"
        """
        pass

    @property
    def PoundsPerMole(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundPerMole"
        """
        pass

    def __init__(self, value: float, unit: MolarMassUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarMassUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: MolarMassUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarMassUnit) -> MolarMass:
        """ Converts this MolarMass to another MolarMass with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarMassUnit
        :return: A MolarMass with the specified unit.
        :rtype: MolarMass
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarMassUnit, unitConverter: UnitConverter) -> MolarMass:
        """ Converts this "MolarMass" to another "MolarMass" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: MolarMassUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A MolarMass with the specified unit.
        :rtype: MolarMass
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MolarMass:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarMassUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarMassUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarMassUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarMassUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerMole(centigramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field CentigramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerMole(decagramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field DecagramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMole(decigramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field DecigramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMole(gramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field GramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerMole(hectogramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field HectogramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMole(kilogramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field KilogramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerMole(kilopoundspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field KilopoundPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerMole(megapoundspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field MegapoundPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMole(microgramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field MicrogramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMole(milligramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field MilligramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMole(nanogramspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field NanogramPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerMole(poundspermole: QuantityValue) -> MolarMass:
        """ Creates a "MolarMass" from "Field PoundPerMole".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarMassUnit) -> MolarMass:
        """ Dynamically convert from value and unit enum "MolarMassUnit" to "MolarMass".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarMassUnit
        :return: MolarMass unit value.
        :rtype: MolarMass
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MolarMass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MolarMass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MolarMass) -> typing.Tuple[MolarMass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarMass
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MolarMass) -> typing.Tuple[MolarMass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarMass
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarMassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarMassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarMassUnit) -> typing.Tuple[MolarMassUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarMassUnit) -> typing.Tuple[MolarMassUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarMassUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MolarMass) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarMass) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarMass, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MolarMass within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MolarMass
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MolarMass.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class Permeability(ValueType, IQuantity[PermeabilityUnit], IQuantity, IFormattable, IEquatable[Permeability], IComparable, IComparable[Permeability], IConvertible):
    """ In electromagnetism, permeability is the measure of the ability of a material to support the formation of a magnetic field within itself.
     https://en.wikipedia.org/wiki/Permeability_(electromagnetism)
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PermeabilityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PermeabilityUnit]

    MaxValue: typing.ClassVar[Permeability]

    MinValue: typing.ClassVar[Permeability]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PermeabilityUnit]]

    Zero: typing.ClassVar[Permeability]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PermeabilityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PermeabilityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def HenriesPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HenryPerMeter"
        """
        pass

    def __init__(self, value: float, unit: PermeabilityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PermeabilityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermeabilityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermeabilityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermeabilityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermeabilityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromHenriesPerMeter(henriespermeter: QuantityValue) -> Permeability:
        """ Creates a "Permeability" from "Field HenryPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PermeabilityUnit) -> Permeability:
        """ Dynamically convert from value and unit enum "PermeabilityUnit" to "Permeability".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PermeabilityUnit
        :return: Permeability unit value.
        :rtype: Permeability
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Permeability:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Permeability:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Permeability) -> typing.Tuple[Permeability, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permeability
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Permeability) -> typing.Tuple[Permeability, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permeability
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PermeabilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PermeabilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PermeabilityUnit) -> typing.Tuple[PermeabilityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PermeabilityUnit) -> typing.Tuple[PermeabilityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PermeabilityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Permeability) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permeability) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permeability, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Permeability within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Permeability
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Permeability.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PermeabilityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PermeabilityUnit) -> Permeability:
        """ Converts this Permeability to another Permeability with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PermeabilityUnit
        :return: A Permeability with the specified unit.
        :rtype: Permeability
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PermeabilityUnit, unitConverter: UnitConverter) -> Permeability:
        """ Converts this "Permeability" to another "Permeability" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PermeabilityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Permeability with the specified unit.
        :rtype: Permeability
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Permeability:
        """
        """
        pass


# noinspection PyPep8Naming
class Permittivity(ValueType, IQuantity[PermittivityUnit], IQuantity, IFormattable, IEquatable[Permittivity], IComparable, IComparable[Permittivity], IConvertible):
    """ In electromagnetism, permittivity is the measure of resistance that is encountered when forming an electric field in a particular medium.
     https://en.wikipedia.org/wiki/Permittivity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PermittivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PermittivityUnit]

    MaxValue: typing.ClassVar[Permittivity]

    MinValue: typing.ClassVar[Permittivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PermittivityUnit]]

    Zero: typing.ClassVar[Permittivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PermittivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PermittivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def FaradsPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FaradPerMeter"
        """
        pass

    def __init__(self, value: float, unit: PermittivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PermittivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermittivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermittivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermittivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermittivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromFaradsPerMeter(faradspermeter: QuantityValue) -> Permittivity:
        """ Creates a "Permittivity" from "Field FaradPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PermittivityUnit) -> Permittivity:
        """ Dynamically convert from value and unit enum "PermittivityUnit" to "Permittivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PermittivityUnit
        :return: Permittivity unit value.
        :rtype: Permittivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Permittivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Permittivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Permittivity) -> typing.Tuple[Permittivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permittivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Permittivity) -> typing.Tuple[Permittivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permittivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PermittivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PermittivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PermittivityUnit) -> typing.Tuple[PermittivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PermittivityUnit) -> typing.Tuple[PermittivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PermittivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Permittivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permittivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permittivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Permittivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Permittivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Permittivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PermittivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PermittivityUnit) -> Permittivity:
        """ Converts this Permittivity to another Permittivity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PermittivityUnit
        :return: A Permittivity with the specified unit.
        :rtype: Permittivity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PermittivityUnit, unitConverter: UnitConverter) -> Permittivity:
        """ Converts this "Permittivity" to another "Permittivity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PermittivityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Permittivity with the specified unit.
        :rtype: Permittivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Permittivity:
        """
        """
        pass


# noinspection PyPep8Naming
class PorousMediumPermeability(ValueType, IQuantity[PorousMediumPermeabilityUnit], IQuantity, IFormattable, IEquatable[PorousMediumPermeability], IComparable, IComparable[PorousMediumPermeability], IConvertible):
    """ In fluid mechanics, permeability is the measure of the ability of a porous material to allow fluids to pass through it.
     https://en.wikipedia.org/wiki/Permeability_(Earth_sciences)
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PorousMediumPermeabilityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PorousMediumPermeabilityUnit]

    MaxValue: typing.ClassVar[PorousMediumPermeability]

    MinValue: typing.ClassVar[PorousMediumPermeability]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PorousMediumPermeabilityUnit]]

    Zero: typing.ClassVar[PorousMediumPermeability]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PorousMediumPermeabilityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PorousMediumPermeabilityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Darcys(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Darcy"
        """
        pass

    @property
    def Microdarcys(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Microdarcy"
        """
        pass

    @property
    def Millidarcys(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Millidarcy"
        """
        pass

    @property
    def SquareCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareCentimeter"
        """
        pass

    @property
    def SquareMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMeter"
        """
        pass

    def __init__(self, value: float, unit: PorousMediumPermeabilityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PorousMediumPermeabilityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PorousMediumPermeabilityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PorousMediumPermeabilityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PorousMediumPermeabilityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PorousMediumPermeabilityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDarcys(darcys: QuantityValue) -> PorousMediumPermeability:
        """ Creates a "PorousMediumPermeability" from "Field Darcy".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodarcys(microdarcys: QuantityValue) -> PorousMediumPermeability:
        """ Creates a "PorousMediumPermeability" from "Field Microdarcy".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidarcys(millidarcys: QuantityValue) -> PorousMediumPermeability:
        """ Creates a "PorousMediumPermeability" from "Field Millidarcy".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeters(squarecentimeters: QuantityValue) -> PorousMediumPermeability:
        """ Creates a "PorousMediumPermeability" from "Field SquareCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeters(squaremeters: QuantityValue) -> PorousMediumPermeability:
        """ Creates a "PorousMediumPermeability" from "Field SquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PorousMediumPermeabilityUnit) -> PorousMediumPermeability:
        """ Dynamically convert from value and unit enum "PorousMediumPermeabilityUnit" to "PorousMediumPermeability".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PorousMediumPermeabilityUnit
        :return: PorousMediumPermeability unit value.
        :rtype: PorousMediumPermeability
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PorousMediumPermeability:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PorousMediumPermeability:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PorousMediumPermeability) -> typing.Tuple[PorousMediumPermeability, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PorousMediumPermeability
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PorousMediumPermeability) -> typing.Tuple[PorousMediumPermeability, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PorousMediumPermeability
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PorousMediumPermeabilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PorousMediumPermeabilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PorousMediumPermeabilityUnit) -> typing.Tuple[PorousMediumPermeabilityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PorousMediumPermeabilityUnit) -> typing.Tuple[PorousMediumPermeabilityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PorousMediumPermeabilityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PorousMediumPermeability) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PorousMediumPermeability) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PorousMediumPermeability, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PorousMediumPermeability within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PorousMediumPermeability
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PorousMediumPermeability.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PorousMediumPermeabilityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PorousMediumPermeabilityUnit) -> PorousMediumPermeability:
        """ Converts this PorousMediumPermeability to another PorousMediumPermeability with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PorousMediumPermeabilityUnit
        :return: A PorousMediumPermeability with the specified unit.
        :rtype: PorousMediumPermeability
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PorousMediumPermeabilityUnit, unitConverter: UnitConverter) -> PorousMediumPermeability:
        """ Converts this "PorousMediumPermeability" to another "PorousMediumPermeability" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PorousMediumPermeabilityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A PorousMediumPermeability with the specified unit.
        :rtype: PorousMediumPermeability
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PorousMediumPermeability:
        """
        """
        pass


# noinspection PyPep8Naming
class PowerDensity(ValueType, IQuantity[PowerDensityUnit], IQuantity, IFormattable, IEquatable[PowerDensity], IComparable, IComparable[PowerDensity], IConvertible):
    """ The amount of power in a volume.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PowerDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PowerDensityUnit]

    MaxValue: typing.ClassVar[PowerDensity]

    MinValue: typing.ClassVar[PowerDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PowerDensityUnit]]

    Zero: typing.ClassVar[PowerDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PowerDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PowerDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecawattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecawattPerCubicFoot"
        """
        pass

    @property
    def DecawattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecawattPerCubicInch"
        """
        pass

    @property
    def DecawattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecawattPerCubicMeter"
        """
        pass

    @property
    def DecawattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecawattPerLiter"
        """
        pass

    @property
    def DeciwattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciwattPerCubicFoot"
        """
        pass

    @property
    def DeciwattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciwattPerCubicInch"
        """
        pass

    @property
    def DeciwattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciwattPerCubicMeter"
        """
        pass

    @property
    def DeciwattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DeciwattPerLiter"
        """
        pass

    @property
    def GigawattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerCubicFoot"
        """
        pass

    @property
    def GigawattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerCubicInch"
        """
        pass

    @property
    def GigawattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerCubicMeter"
        """
        pass

    @property
    def GigawattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigawattPerLiter"
        """
        pass

    @property
    def KilowattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerCubicFoot"
        """
        pass

    @property
    def KilowattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerCubicInch"
        """
        pass

    @property
    def KilowattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerCubicMeter"
        """
        pass

    @property
    def KilowattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilowattPerLiter"
        """
        pass

    @property
    def MegawattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerCubicFoot"
        """
        pass

    @property
    def MegawattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerCubicInch"
        """
        pass

    @property
    def MegawattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerCubicMeter"
        """
        pass

    @property
    def MegawattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegawattPerLiter"
        """
        pass

    @property
    def MicrowattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerCubicFoot"
        """
        pass

    @property
    def MicrowattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerCubicInch"
        """
        pass

    @property
    def MicrowattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerCubicMeter"
        """
        pass

    @property
    def MicrowattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MicrowattPerLiter"
        """
        pass

    @property
    def MilliwattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerCubicFoot"
        """
        pass

    @property
    def MilliwattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerCubicInch"
        """
        pass

    @property
    def MilliwattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerCubicMeter"
        """
        pass

    @property
    def MilliwattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MilliwattPerLiter"
        """
        pass

    @property
    def NanowattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerCubicFoot"
        """
        pass

    @property
    def NanowattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerCubicInch"
        """
        pass

    @property
    def NanowattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerCubicMeter"
        """
        pass

    @property
    def NanowattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NanowattPerLiter"
        """
        pass

    @property
    def PicowattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicowattPerCubicFoot"
        """
        pass

    @property
    def PicowattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicowattPerCubicInch"
        """
        pass

    @property
    def PicowattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicowattPerCubicMeter"
        """
        pass

    @property
    def PicowattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PicowattPerLiter"
        """
        pass

    @property
    def TerawattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattPerCubicFoot"
        """
        pass

    @property
    def TerawattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattPerCubicInch"
        """
        pass

    @property
    def TerawattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattPerCubicMeter"
        """
        pass

    @property
    def TerawattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TerawattPerLiter"
        """
        pass

    @property
    def WattsPerCubicFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerCubicFoot"
        """
        pass

    @property
    def WattsPerCubicInch(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerCubicInch"
        """
        pass

    @property
    def WattsPerCubicMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerCubicMeter"
        """
        pass

    @property
    def WattsPerLiter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerLiter"
        """
        pass

    def __init__(self, value: float, unit: PowerDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PowerDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigawattsPerLiter(gigawattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field GigawattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCubicFoot(kilowattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field KilowattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCubicInch(kilowattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field KilowattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCubicMeter(kilowattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field KilowattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerLiter(kilowattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field KilowattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCubicFoot(megawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MegawattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCubicInch(megawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MegawattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCubicMeter(megawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MegawattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerLiter(megawattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MegawattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerCubicFoot(microwattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MicrowattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerCubicInch(microwattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MicrowattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerCubicMeter(microwattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MicrowattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerLiter(microwattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MicrowattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCubicFoot(milliwattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MilliwattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCubicInch(milliwattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MilliwattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCubicMeter(milliwattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MilliwattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerLiter(milliwattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field MilliwattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerCubicFoot(nanowattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field NanowattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerCubicInch(nanowattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field NanowattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerCubicMeter(nanowattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field NanowattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerLiter(nanowattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field NanowattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerCubicFoot(picowattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field PicowattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerCubicInch(picowattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field PicowattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerCubicMeter(picowattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field PicowattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerLiter(picowattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field PicowattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerCubicFoot(terawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field TerawattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerCubicInch(terawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field TerawattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerCubicMeter(terawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field TerawattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerLiter(terawattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field TerawattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCubicFoot(wattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field WattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCubicInch(wattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field WattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCubicMeter(wattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field WattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerLiter(wattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field WattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PowerDensityUnit) -> PowerDensity:
        """ Dynamically convert from value and unit enum "PowerDensityUnit" to "PowerDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PowerDensityUnit
        :return: PowerDensity unit value.
        :rtype: PowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PowerDensity) -> typing.Tuple[PowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PowerDensity) -> typing.Tuple[PowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PowerDensityUnit) -> typing.Tuple[PowerDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PowerDensityUnit) -> typing.Tuple[PowerDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PowerDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PowerDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PowerDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PowerDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PowerDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PowerDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerDensityUnit) -> PowerDensity:
        """ Converts this PowerDensity to another PowerDensity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PowerDensityUnit
        :return: A PowerDensity with the specified unit.
        :rtype: PowerDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerDensityUnit, unitConverter: UnitConverter) -> PowerDensity:
        """ Converts this "PowerDensity" to another "PowerDensity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PowerDensityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A PowerDensity with the specified unit.
        :rtype: PowerDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PowerDensity:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecawattsPerCubicFoot(decawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DecawattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawattsPerCubicInch(decawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DecawattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawattsPerCubicMeter(decawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DecawattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawattsPerLiter(decawattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DecawattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerCubicFoot(deciwattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DeciwattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerCubicInch(deciwattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DeciwattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerCubicMeter(deciwattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DeciwattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerLiter(deciwattsperliter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field DeciwattPerLiter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerCubicFoot(gigawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field GigawattPerCubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerCubicInch(gigawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field GigawattPerCubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerCubicMeter(gigawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Creates a "PowerDensity" from "Field GigawattPerCubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class PressureChangeRate(ValueType, IQuantity[PressureChangeRateUnit], IQuantity, IFormattable, IEquatable[PressureChangeRate], IComparable, IComparable[PressureChangeRate], IConvertible):
    """ Pressure change rate is the ratio of the pressure change to the time during which the change occurred (value of pressure changes per unit time).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[PressureChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PressureChangeRateUnit]

    MaxValue: typing.ClassVar[PressureChangeRate]

    MinValue: typing.ClassVar[PressureChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PressureChangeRateUnit]]

    Zero: typing.ClassVar[PressureChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PressureChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PressureChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AtmospheresPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field AtmospherePerSecond"
        """
        pass

    @property
    def KilopascalsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopascalPerMinute"
        """
        pass

    @property
    def KilopascalsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopascalPerSecond"
        """
        pass

    @property
    def KilopoundsForcePerSquareInchPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerSquareInchPerMinute"
        """
        pass

    @property
    def KilopoundsForcePerSquareInchPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForcePerSquareInchPerSecond"
        """
        pass

    @property
    def MegapascalsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapascalPerMinute"
        """
        pass

    @property
    def MegapascalsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapascalPerSecond"
        """
        pass

    @property
    def MegapoundsForcePerSquareInchPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForcePerSquareInchPerMinute"
        """
        pass

    @property
    def MegapoundsForcePerSquareInchPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForcePerSquareInchPerSecond"
        """
        pass

    @property
    def MillimetersOfMercuryPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterOfMercuryPerSecond"
        """
        pass

    @property
    def PascalsPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PascalPerMinute"
        """
        pass

    @property
    def PascalsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PascalPerSecond"
        """
        pass

    @property
    def PoundsForcePerSquareInchPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerSquareInchPerMinute"
        """
        pass

    @property
    def PoundsForcePerSquareInchPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForcePerSquareInchPerSecond"
        """
        pass

    def __init__(self, value: float, unit: PressureChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PressureChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: PressureChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PressureChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PressureChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PressureChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PressureChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PressureChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PressureChangeRateUnit) -> PressureChangeRate:
        """ Converts this PressureChangeRate to another PressureChangeRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PressureChangeRateUnit
        :return: A PressureChangeRate with the specified unit.
        :rtype: PressureChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PressureChangeRateUnit, unitConverter: UnitConverter) -> PressureChangeRate:
        """ Converts this "PressureChangeRate" to another "PressureChangeRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: PressureChangeRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A PressureChangeRate with the specified unit.
        :rtype: PressureChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PressureChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAtmospheresPerSecond(atmospherespersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field AtmospherePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopascalsPerMinute(kilopascalsperminute: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field KilopascalPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopascalsPerSecond(kilopascalspersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field KilopascalPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareInchPerMinute(kilopoundsforcepersquareinchperminute: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field KilopoundForcePerSquareInchPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareInchPerSecond(kilopoundsforcepersquareinchpersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field KilopoundForcePerSquareInchPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapascalsPerMinute(megapascalsperminute: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field MegapascalPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapascalsPerSecond(megapascalspersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field MegapascalPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsForcePerSquareInchPerMinute(megapoundsforcepersquareinchperminute: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field MegapoundForcePerSquareInchPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsForcePerSquareInchPerSecond(megapoundsforcepersquareinchpersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field MegapoundForcePerSquareInchPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersOfMercuryPerSecond(millimetersofmercurypersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field MillimeterOfMercuryPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascalsPerMinute(pascalsperminute: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field PascalPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascalsPerSecond(pascalspersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field PascalPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareInchPerMinute(poundsforcepersquareinchperminute: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field PoundForcePerSquareInchPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareInchPerSecond(poundsforcepersquareinchpersecond: QuantityValue) -> PressureChangeRate:
        """ Creates a "PressureChangeRate" from "Field PoundForcePerSquareInchPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PressureChangeRateUnit) -> PressureChangeRate:
        """ Dynamically convert from value and unit enum "PressureChangeRateUnit" to "PressureChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PressureChangeRateUnit
        :return: PressureChangeRate unit value.
        :rtype: PressureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PressureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PressureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PressureChangeRate) -> typing.Tuple[PressureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PressureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PressureChangeRate) -> typing.Tuple[PressureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PressureChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PressureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PressureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PressureChangeRateUnit) -> typing.Tuple[PressureChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PressureChangeRateUnit) -> typing.Tuple[PressureChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PressureChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PressureChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class Ratio(ValueType, IQuantity[RatioUnit], IQuantity, IFormattable, IEquatable[Ratio], IComparable, IComparable[Ratio], IConvertible):
    """ In mathematics, a ratio is a relationship between two numbers of the same kind (e.g., objects, persons, students, spoonfuls, units of whatever identical dimension), usually expressed as "a to b" or a:b, sometimes expressed arithmetically as a dimensionless quotient of the two that explicitly indicates how many times the first number contains the second (not necessarily an integer).
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RatioUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RatioUnit]

    MaxValue: typing.ClassVar[Ratio]

    MinValue: typing.ClassVar[Ratio]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RatioUnit]]

    Zero: typing.ClassVar[Ratio]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RatioUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RatioUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecimalFractions(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimalFraction"
        """
        pass

    @property
    def PartsPerBillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerBillion"
        """
        pass

    @property
    def PartsPerMillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerMillion"
        """
        pass

    @property
    def PartsPerThousand(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerThousand"
        """
        pass

    @property
    def PartsPerTrillion(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PartPerTrillion"
        """
        pass

    @property
    def Percent(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Percent"
        """
        pass

    def __init__(self, value: float, unit: RatioUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RatioUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Ratio:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecimalFractions(decimalfractions: QuantityValue) -> Ratio:
        """ Creates a "Ratio" from "Field DecimalFraction".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerBillion(partsperbillion: QuantityValue) -> Ratio:
        """ Creates a "Ratio" from "Field PartPerBillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerMillion(partspermillion: QuantityValue) -> Ratio:
        """ Creates a "Ratio" from "Field PartPerMillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerThousand(partsperthousand: QuantityValue) -> Ratio:
        """ Creates a "Ratio" from "Field PartPerThousand".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerTrillion(partspertrillion: QuantityValue) -> Ratio:
        """ Creates a "Ratio" from "Field PartPerTrillion".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> Ratio:
        """ Creates a "Ratio" from "Field Percent".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RatioUnit) -> Ratio:
        """ Dynamically convert from value and unit enum "RatioUnit" to "Ratio".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RatioUnit
        :return: Ratio unit value.
        :rtype: Ratio
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Ratio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Ratio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Ratio) -> typing.Tuple[Ratio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Ratio
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Ratio) -> typing.Tuple[Ratio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Ratio
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RatioUnit) -> typing.Tuple[RatioUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RatioUnit) -> typing.Tuple[RatioUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RatioUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Ratio) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Ratio) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Ratio, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Ratio within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Ratio
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Ratio.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RatioUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RatioUnit) -> Ratio:
        """ Converts this Ratio to another Ratio with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RatioUnit
        :return: A Ratio with the specified unit.
        :rtype: Ratio
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RatioUnit, unitConverter: UnitConverter) -> Ratio:
        """ Converts this "Ratio" to another "Ratio" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RatioUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Ratio with the specified unit.
        :rtype: Ratio
        """
        pass


# noinspection PyPep8Naming
class RatioChangeRate(ValueType, IQuantity[RatioChangeRateUnit], IQuantity, IFormattable, IEquatable[RatioChangeRate], IComparable, IComparable[RatioChangeRate], IConvertible):
    """ The change in ratio per unit of time.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RatioChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RatioChangeRateUnit]

    MaxValue: typing.ClassVar[RatioChangeRate]

    MinValue: typing.ClassVar[RatioChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RatioChangeRateUnit]]

    Zero: typing.ClassVar[RatioChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RatioChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RatioChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecimalFractionsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimalFractionPerSecond"
        """
        pass

    @property
    def PercentsPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PercentPerSecond"
        """
        pass

    def __init__(self, value: float, unit: RatioChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RatioChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecimalFractionsPerSecond(decimalfractionspersecond: QuantityValue) -> RatioChangeRate:
        """ Creates a "RatioChangeRate" from "Field DecimalFractionPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercentsPerSecond(percentspersecond: QuantityValue) -> RatioChangeRate:
        """ Creates a "RatioChangeRate" from "Field PercentPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RatioChangeRateUnit) -> RatioChangeRate:
        """ Dynamically convert from value and unit enum "RatioChangeRateUnit" to "RatioChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RatioChangeRateUnit
        :return: RatioChangeRate unit value.
        :rtype: RatioChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RatioChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RatioChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RatioChangeRate) -> typing.Tuple[RatioChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RatioChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RatioChangeRate) -> typing.Tuple[RatioChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RatioChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RatioChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RatioChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RatioChangeRateUnit) -> typing.Tuple[RatioChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RatioChangeRateUnit) -> typing.Tuple[RatioChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RatioChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RatioChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RatioChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RatioChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RatioChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RatioChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RatioChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RatioChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RatioChangeRateUnit) -> RatioChangeRate:
        """ Converts this RatioChangeRate to another RatioChangeRate with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RatioChangeRateUnit
        :return: A RatioChangeRate with the specified unit.
        :rtype: RatioChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RatioChangeRateUnit, unitConverter: UnitConverter) -> RatioChangeRate:
        """ Converts this "RatioChangeRate" to another "RatioChangeRate" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RatioChangeRateUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A RatioChangeRate with the specified unit.
        :rtype: RatioChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RatioChangeRate:
        """
        """
        pass


# noinspection PyPep8Naming
class ReactiveEnergy(ValueType, IQuantity[ReactiveEnergyUnit], IQuantity, IFormattable, IEquatable[ReactiveEnergy], IComparable, IComparable[ReactiveEnergy], IConvertible):
    """ The Volt-ampere reactive hour (expressed as varh) is the reactive power of one Volt-ampere reactive produced in one hour.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ReactiveEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ReactiveEnergyUnit]

    MaxValue: typing.ClassVar[ReactiveEnergy]

    MinValue: typing.ClassVar[ReactiveEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ReactiveEnergyUnit]]

    Zero: typing.ClassVar[ReactiveEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ReactiveEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ReactiveEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltampereReactiveHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltampereReactiveHour"
        """
        pass

    @property
    def MegavoltampereReactiveHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltampereReactiveHour"
        """
        pass

    @property
    def VoltampereReactiveHours(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltampereReactiveHour"
        """
        pass

    def __init__(self, value: float, unit: ReactiveEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ReactiveEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactiveEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactiveEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactiveEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactiveEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltampereReactiveHours(kilovoltamperereactivehours: QuantityValue) -> ReactiveEnergy:
        """ Creates a "ReactiveEnergy" from "Field KilovoltampereReactiveHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltampereReactiveHours(megavoltamperereactivehours: QuantityValue) -> ReactiveEnergy:
        """ Creates a "ReactiveEnergy" from "Field MegavoltampereReactiveHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltampereReactiveHours(voltamperereactivehours: QuantityValue) -> ReactiveEnergy:
        """ Creates a "ReactiveEnergy" from "Field VoltampereReactiveHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ReactiveEnergyUnit) -> ReactiveEnergy:
        """ Dynamically convert from value and unit enum "ReactiveEnergyUnit" to "ReactiveEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ReactiveEnergyUnit
        :return: ReactiveEnergy unit value.
        :rtype: ReactiveEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ReactiveEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ReactiveEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ReactiveEnergy) -> typing.Tuple[ReactiveEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactiveEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ReactiveEnergy) -> typing.Tuple[ReactiveEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactiveEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ReactiveEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ReactiveEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ReactiveEnergyUnit) -> typing.Tuple[ReactiveEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ReactiveEnergyUnit) -> typing.Tuple[ReactiveEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ReactiveEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ReactiveEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactiveEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactiveEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ReactiveEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ReactiveEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ReactiveEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ReactiveEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReactiveEnergyUnit) -> ReactiveEnergy:
        """ Converts this ReactiveEnergy to another ReactiveEnergy with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReactiveEnergyUnit
        :return: A ReactiveEnergy with the specified unit.
        :rtype: ReactiveEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReactiveEnergyUnit, unitConverter: UnitConverter) -> ReactiveEnergy:
        """ Converts this "ReactiveEnergy" to another "ReactiveEnergy" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReactiveEnergyUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ReactiveEnergy with the specified unit.
        :rtype: ReactiveEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ReactiveEnergy:
        """
        """
        pass


# noinspection PyPep8Naming
class ReactivePower(ValueType, IQuantity[ReactivePowerUnit], IQuantity, IFormattable, IEquatable[ReactivePower], IComparable, IComparable[ReactivePower], IConvertible):
    """ Volt-ampere reactive (var) is a unit by which reactive power is expressed in an AC electric power system. Reactive power exists in an AC circuit when the current and voltage are not in phase.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ReactivePowerUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ReactivePowerUnit]

    MaxValue: typing.ClassVar[ReactivePower]

    MinValue: typing.ClassVar[ReactivePower]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ReactivePowerUnit]]

    Zero: typing.ClassVar[ReactivePower]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ReactivePowerUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ReactivePowerUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GigavoltamperesReactive(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GigavoltampereReactive"
        """
        pass

    @property
    def KilovoltamperesReactive(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilovoltampereReactive"
        """
        pass

    @property
    def MegavoltamperesReactive(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegavoltampereReactive"
        """
        pass

    @property
    def VoltamperesReactive(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field VoltampereReactive"
        """
        pass

    def __init__(self, value: float, unit: ReactivePowerUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ReactivePowerUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactivePowerUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactivePowerUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactivePowerUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactivePowerUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigavoltamperesReactive(gigavoltamperesreactive: QuantityValue) -> ReactivePower:
        """ Creates a "ReactivePower" from "Field GigavoltampereReactive".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltamperesReactive(kilovoltamperesreactive: QuantityValue) -> ReactivePower:
        """ Creates a "ReactivePower" from "Field KilovoltampereReactive".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltamperesReactive(megavoltamperesreactive: QuantityValue) -> ReactivePower:
        """ Creates a "ReactivePower" from "Field MegavoltampereReactive".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltamperesReactive(voltamperesreactive: QuantityValue) -> ReactivePower:
        """ Creates a "ReactivePower" from "Field VoltampereReactive".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ReactivePowerUnit) -> ReactivePower:
        """ Dynamically convert from value and unit enum "ReactivePowerUnit" to "ReactivePower".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ReactivePowerUnit
        :return: ReactivePower unit value.
        :rtype: ReactivePower
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ReactivePower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ReactivePower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ReactivePower) -> typing.Tuple[ReactivePower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactivePower
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ReactivePower) -> typing.Tuple[ReactivePower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactivePower
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ReactivePowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ReactivePowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ReactivePowerUnit) -> typing.Tuple[ReactivePowerUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ReactivePowerUnit) -> typing.Tuple[ReactivePowerUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ReactivePowerUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ReactivePower) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactivePower) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactivePower, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ReactivePower within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ReactivePower
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ReactivePower.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ReactivePowerUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReactivePowerUnit) -> ReactivePower:
        """ Converts this ReactivePower to another ReactivePower with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReactivePowerUnit
        :return: A ReactivePower with the specified unit.
        :rtype: ReactivePower
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReactivePowerUnit, unitConverter: UnitConverter) -> ReactivePower:
        """ Converts this "ReactivePower" to another "ReactivePower" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ReactivePowerUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ReactivePower with the specified unit.
        :rtype: ReactivePower
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ReactivePower:
        """
        """
        pass


# noinspection PyPep8Naming
class RelativeHumidity(ValueType, IQuantity[RelativeHumidityUnit], IQuantity, IFormattable, IEquatable[RelativeHumidity], IComparable, IComparable[RelativeHumidity], IConvertible):
    """ Relative humidity is a ratio of the actual water vapor present in the air to the maximum water vapor in the air at the given temperature.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RelativeHumidityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RelativeHumidityUnit]

    MaxValue: typing.ClassVar[RelativeHumidity]

    MinValue: typing.ClassVar[RelativeHumidity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RelativeHumidityUnit]]

    Zero: typing.ClassVar[RelativeHumidity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RelativeHumidityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RelativeHumidityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Percent(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Percent"
        """
        pass

    def __init__(self, value: float, unit: RelativeHumidityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RelativeHumidityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RelativeHumidityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RelativeHumidityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RelativeHumidityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RelativeHumidityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> RelativeHumidity:
        """ Creates a "RelativeHumidity" from "Field Percent".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RelativeHumidityUnit) -> RelativeHumidity:
        """ Dynamically convert from value and unit enum "RelativeHumidityUnit" to "RelativeHumidity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RelativeHumidityUnit
        :return: RelativeHumidity unit value.
        :rtype: RelativeHumidity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RelativeHumidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RelativeHumidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RelativeHumidity) -> typing.Tuple[RelativeHumidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RelativeHumidity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RelativeHumidity) -> typing.Tuple[RelativeHumidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RelativeHumidity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RelativeHumidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RelativeHumidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RelativeHumidityUnit) -> typing.Tuple[RelativeHumidityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RelativeHumidityUnit) -> typing.Tuple[RelativeHumidityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RelativeHumidityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RelativeHumidity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RelativeHumidity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RelativeHumidity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RelativeHumidity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RelativeHumidity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RelativeHumidity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RelativeHumidityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RelativeHumidityUnit) -> RelativeHumidity:
        """ Converts this RelativeHumidity to another RelativeHumidity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RelativeHumidityUnit
        :return: A RelativeHumidity with the specified unit.
        :rtype: RelativeHumidity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RelativeHumidityUnit, unitConverter: UnitConverter) -> RelativeHumidity:
        """ Converts this "RelativeHumidity" to another "RelativeHumidity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RelativeHumidityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A RelativeHumidity with the specified unit.
        :rtype: RelativeHumidity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RelativeHumidity:
        """
        """
        pass


# noinspection PyPep8Naming
class RotationalAcceleration(ValueType, IQuantity[RotationalAccelerationUnit], IQuantity, IFormattable, IEquatable[RotationalAcceleration], IComparable, IComparable[RotationalAcceleration], IConvertible):
    """ Angular acceleration is the rate of change of rotational speed.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[RotationalAccelerationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalAccelerationUnit]

    MaxValue: typing.ClassVar[RotationalAcceleration]

    MinValue: typing.ClassVar[RotationalAcceleration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalAccelerationUnit]]

    Zero: typing.ClassVar[RotationalAcceleration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalAccelerationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalAccelerationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DegreePerSecondSquared"
        """
        pass

    @property
    def RadiansPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RadianPerSecondSquared"
        """
        pass

    @property
    def RevolutionsPerMinutePerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RevolutionPerMinutePerSecond"
        """
        pass

    @property
    def RevolutionsPerSecondSquared(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field RevolutionPerSecondSquared"
        """
        pass

    def __init__(self, value: float, unit: RotationalAccelerationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalAccelerationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalAccelerationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalAccelerationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalAccelerationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalAccelerationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesPerSecondSquared(degreespersecondsquared: QuantityValue) -> RotationalAcceleration:
        """ Creates a "RotationalAcceleration" from "Field DegreePerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadiansPerSecondSquared(radianspersecondsquared: QuantityValue) -> RotationalAcceleration:
        """ Creates a "RotationalAcceleration" from "Field RadianPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerMinutePerSecond(revolutionsperminutepersecond: QuantityValue) -> RotationalAcceleration:
        """ Creates a "RotationalAcceleration" from "Field RevolutionPerMinutePerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerSecondSquared(revolutionspersecondsquared: QuantityValue) -> RotationalAcceleration:
        """ Creates a "RotationalAcceleration" from "Field RevolutionPerSecondSquared".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalAccelerationUnit) -> RotationalAcceleration:
        """ Dynamically convert from value and unit enum "RotationalAccelerationUnit" to "RotationalAcceleration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalAccelerationUnit
        :return: RotationalAcceleration unit value.
        :rtype: RotationalAcceleration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalAcceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalAcceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalAcceleration) -> typing.Tuple[RotationalAcceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalAcceleration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalAcceleration) -> typing.Tuple[RotationalAcceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalAcceleration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalAccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalAccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalAccelerationUnit) -> typing.Tuple[RotationalAccelerationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalAccelerationUnit) -> typing.Tuple[RotationalAccelerationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalAccelerationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalAcceleration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalAcceleration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalAcceleration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalAcceleration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalAcceleration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalAcceleration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalAccelerationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalAccelerationUnit) -> RotationalAcceleration:
        """ Converts this RotationalAcceleration to another RotationalAcceleration with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalAccelerationUnit
        :return: A RotationalAcceleration with the specified unit.
        :rtype: RotationalAcceleration
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalAccelerationUnit, unitConverter: UnitConverter) -> RotationalAcceleration:
        """ Converts this "RotationalAcceleration" to another "RotationalAcceleration" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: RotationalAccelerationUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A RotationalAcceleration with the specified unit.
        :rtype: RotationalAcceleration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalAcceleration:
        """
        """
        pass


# noinspection PyPep8Naming
class Scalar(ValueType, IQuantity[ScalarUnit], IQuantity, IFormattable, IEquatable[Scalar], IComparable, IComparable[Scalar], IConvertible):
    """ A way of representing a number of items.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ScalarUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ScalarUnit]

    MaxValue: typing.ClassVar[Scalar]

    MinValue: typing.ClassVar[Scalar]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ScalarUnit]]

    Zero: typing.ClassVar[Scalar]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ScalarUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ScalarUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Amount(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Amount"
        """
        pass

    def __init__(self, value: float, unit: ScalarUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ScalarUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ScalarUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ScalarUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ScalarUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ScalarUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmount(amount: QuantityValue) -> Scalar:
        """ Creates a "Scalar" from "Field Amount".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ScalarUnit) -> Scalar:
        """ Dynamically convert from value and unit enum "ScalarUnit" to "Scalar".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ScalarUnit
        :return: Scalar unit value.
        :rtype: Scalar
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Scalar:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Scalar:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Scalar) -> typing.Tuple[Scalar, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Scalar
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Scalar) -> typing.Tuple[Scalar, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Scalar
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ScalarUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ScalarUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ScalarUnit) -> typing.Tuple[ScalarUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ScalarUnit) -> typing.Tuple[ScalarUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ScalarUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Scalar) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Scalar) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Scalar, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Scalar within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Scalar
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Scalar.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ScalarUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ScalarUnit) -> Scalar:
        """ Converts this Scalar to another Scalar with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ScalarUnit
        :return: A Scalar with the specified unit.
        :rtype: Scalar
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ScalarUnit, unitConverter: UnitConverter) -> Scalar:
        """ Converts this "Scalar" to another "Scalar" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ScalarUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Scalar with the specified unit.
        :rtype: Scalar
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Scalar:
        """
        """
        pass


# noinspection PyPep8Naming
class SectionModulus(ValueType, IQuantity[SectionModulusUnit], IQuantity, IFormattable, IEquatable[SectionModulus], IComparable, IComparable[SectionModulus], IConvertible):
    """ Section modulus is a geometric property for a given cross-section used in the design of beams or flexural members.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SectionModulusUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SectionModulusUnit]

    MaxValue: typing.ClassVar[SectionModulus]

    MinValue: typing.ClassVar[SectionModulus]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SectionModulusUnit]]

    Zero: typing.ClassVar[SectionModulus]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SectionModulusUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SectionModulusUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CubicCentimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicCentimeter"
        """
        pass

    @property
    def CubicFeet(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFoot"
        """
        pass

    @property
    def CubicInches(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicInch"
        """
        pass

    @property
    def CubicMeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeter"
        """
        pass

    @property
    def CubicMillimeters(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMillimeter"
        """
        pass

    def __init__(self, value: float, unit: SectionModulusUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SectionModulusUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SectionModulusUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SectionModulusUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SectionModulusUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SectionModulusUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCubicCentimeters(cubiccentimeters: QuantityValue) -> SectionModulus:
        """ Creates a "SectionModulus" from "Field CubicCentimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeet(cubicfeet: QuantityValue) -> SectionModulus:
        """ Creates a "SectionModulus" from "Field CubicFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicInches(cubicinches: QuantityValue) -> SectionModulus:
        """ Creates a "SectionModulus" from "Field CubicInch".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMeters(cubicmeters: QuantityValue) -> SectionModulus:
        """ Creates a "SectionModulus" from "Field CubicMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMillimeters(cubicmillimeters: QuantityValue) -> SectionModulus:
        """ Creates a "SectionModulus" from "Field CubicMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SectionModulusUnit) -> SectionModulus:
        """ Dynamically convert from value and unit enum "SectionModulusUnit" to "SectionModulus".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SectionModulusUnit
        :return: SectionModulus unit value.
        :rtype: SectionModulus
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SectionModulus:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SectionModulus:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SectionModulus) -> typing.Tuple[SectionModulus, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SectionModulus
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SectionModulus) -> typing.Tuple[SectionModulus, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SectionModulus
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SectionModulusUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SectionModulusUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SectionModulusUnit) -> typing.Tuple[SectionModulusUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SectionModulusUnit) -> typing.Tuple[SectionModulusUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SectionModulusUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SectionModulus) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SectionModulus) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SectionModulus, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SectionModulus within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SectionModulus
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SectionModulus.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SectionModulusUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SectionModulusUnit) -> SectionModulus:
        """ Converts this SectionModulus to another SectionModulus with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SectionModulusUnit
        :return: A SectionModulus with the specified unit.
        :rtype: SectionModulus
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SectionModulusUnit, unitConverter: UnitConverter) -> SectionModulus:
        """ Converts this "SectionModulus" to another "SectionModulus" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SectionModulusUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SectionModulus with the specified unit.
        :rtype: SectionModulus
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SectionModulus:
        """
        """
        pass


# noinspection PyPep8Naming
class SolidAngle(ValueType, IQuantity[SolidAngleUnit], IQuantity, IFormattable, IEquatable[SolidAngle], IComparable, IComparable[SolidAngle], IConvertible):
    """ In geometry, a solid angle is the two-dimensional angle in three-dimensional space that an object subtends at a point.
     https://en.wikipedia.org/wiki/Solid_angle
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SolidAngleUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SolidAngleUnit]

    MaxValue: typing.ClassVar[SolidAngle]

    MinValue: typing.ClassVar[SolidAngle]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SolidAngleUnit]]

    Zero: typing.ClassVar[SolidAngle]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SolidAngleUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SolidAngleUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Steradians(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field Steradian"
        """
        pass

    def __init__(self, value: float, unit: SolidAngleUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SolidAngleUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SolidAngleUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SolidAngleUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SolidAngleUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SolidAngleUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromSteradians(steradians: QuantityValue) -> SolidAngle:
        """ Creates a "SolidAngle" from "Field Steradian".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SolidAngleUnit) -> SolidAngle:
        """ Dynamically convert from value and unit enum "SolidAngleUnit" to "SolidAngle".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SolidAngleUnit
        :return: SolidAngle unit value.
        :rtype: SolidAngle
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SolidAngle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SolidAngle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SolidAngle) -> typing.Tuple[SolidAngle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SolidAngle
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SolidAngle) -> typing.Tuple[SolidAngle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SolidAngle
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SolidAngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SolidAngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SolidAngleUnit) -> typing.Tuple[SolidAngleUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SolidAngleUnit) -> typing.Tuple[SolidAngleUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SolidAngleUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SolidAngle) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SolidAngle) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SolidAngle, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SolidAngle within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SolidAngle
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SolidAngle.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SolidAngleUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SolidAngleUnit) -> SolidAngle:
        """ Converts this SolidAngle to another SolidAngle with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SolidAngleUnit
        :return: A SolidAngle with the specified unit.
        :rtype: SolidAngle
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SolidAngleUnit, unitConverter: UnitConverter) -> SolidAngle:
        """ Converts this "SolidAngle" to another "SolidAngle" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SolidAngleUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SolidAngle with the specified unit.
        :rtype: SolidAngle
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SolidAngle:
        """
        """
        pass


# noinspection PyPep8Naming
class SpecificFuelConsumption(ValueType, IQuantity[SpecificFuelConsumptionUnit], IQuantity, IFormattable, IEquatable[SpecificFuelConsumption], IComparable, IComparable[SpecificFuelConsumption], IConvertible):
    """ SFC is the fuel efficiency of an engine design with respect to thrust output
     https://en.wikipedia.org/wiki/Thrust-specific_fuel_consumption
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[SpecificFuelConsumptionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificFuelConsumptionUnit]

    MaxValue: typing.ClassVar[SpecificFuelConsumption]

    MinValue: typing.ClassVar[SpecificFuelConsumption]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificFuelConsumptionUnit]]

    Zero: typing.ClassVar[SpecificFuelConsumption]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificFuelConsumptionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificFuelConsumptionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerKiloNewtonSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field GramPerKiloNewtonSecond"
        """
        pass

    @property
    def KilogramsPerKilogramForceHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerKilogramForceHour"
        """
        pass

    @property
    def KilogramsPerKiloNewtonSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramPerKiloNewtonSecond"
        """
        pass

    @property
    def PoundsMassPerPoundForceHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundMassPerPoundForceHour"
        """
        pass

    def __init__(self, value: float, unit: SpecificFuelConsumptionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificFuelConsumptionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificFuelConsumptionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificFuelConsumptionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificFuelConsumptionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificFuelConsumptionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerKiloNewtonSecond(gramsperkilonewtonsecond: QuantityValue) -> SpecificFuelConsumption:
        """ Creates a "SpecificFuelConsumption" from "Field GramPerKiloNewtonSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerKilogramForceHour(kilogramsperkilogramforcehour: QuantityValue) -> SpecificFuelConsumption:
        """ Creates a "SpecificFuelConsumption" from "Field KilogramPerKilogramForceHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerKiloNewtonSecond(kilogramsperkilonewtonsecond: QuantityValue) -> SpecificFuelConsumption:
        """ Creates a "SpecificFuelConsumption" from "Field KilogramPerKiloNewtonSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsMassPerPoundForceHour(poundsmassperpoundforcehour: QuantityValue) -> SpecificFuelConsumption:
        """ Creates a "SpecificFuelConsumption" from "Field PoundMassPerPoundForceHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificFuelConsumptionUnit) -> SpecificFuelConsumption:
        """ Dynamically convert from value and unit enum "SpecificFuelConsumptionUnit" to "SpecificFuelConsumption".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificFuelConsumptionUnit
        :return: SpecificFuelConsumption unit value.
        :rtype: SpecificFuelConsumption
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificFuelConsumption:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificFuelConsumption:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificFuelConsumption) -> typing.Tuple[SpecificFuelConsumption, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificFuelConsumption
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificFuelConsumption) -> typing.Tuple[SpecificFuelConsumption, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificFuelConsumption
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificFuelConsumptionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificFuelConsumptionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificFuelConsumptionUnit) -> typing.Tuple[SpecificFuelConsumptionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificFuelConsumptionUnit) -> typing.Tuple[SpecificFuelConsumptionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificFuelConsumptionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificFuelConsumption) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificFuelConsumption) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificFuelConsumption, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificFuelConsumption within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificFuelConsumption
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificFuelConsumption.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificFuelConsumptionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificFuelConsumptionUnit) -> SpecificFuelConsumption:
        """ Converts this SpecificFuelConsumption to another SpecificFuelConsumption with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificFuelConsumptionUnit
        :return: A SpecificFuelConsumption with the specified unit.
        :rtype: SpecificFuelConsumption
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificFuelConsumptionUnit, unitConverter: UnitConverter) -> SpecificFuelConsumption:
        """ Converts this "SpecificFuelConsumption" to another "SpecificFuelConsumption" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: SpecificFuelConsumptionUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A SpecificFuelConsumption with the specified unit.
        :rtype: SpecificFuelConsumption
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificFuelConsumption:
        """
        """
        pass


# noinspection PyPep8Naming
class StandardVolumeFlow(ValueType, IQuantity[StandardVolumeFlowUnit], IQuantity, IFormattable, IEquatable[StandardVolumeFlow], IComparable, IComparable[StandardVolumeFlow], IConvertible):
    """ The molar flow rate of a gas corrected to standardized conditions of temperature and pressure thus representing a fixed number of moles of gas regardless of composition and actual flow conditions.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[StandardVolumeFlowUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[StandardVolumeFlowUnit]

    MaxValue: typing.ClassVar[StandardVolumeFlow]

    MinValue: typing.ClassVar[StandardVolumeFlow]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[StandardVolumeFlowUnit]]

    Zero: typing.ClassVar[StandardVolumeFlow]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> StandardVolumeFlowUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[StandardVolumeFlowUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def StandardCubicCentimetersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicCentimeterPerMinute"
        """
        pass

    @property
    def StandardCubicFeetPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicFootPerHour"
        """
        pass

    @property
    def StandardCubicFeetPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicFootPerMinute"
        """
        pass

    @property
    def StandardCubicFeetPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicFootPerSecond"
        """
        pass

    @property
    def StandardCubicMetersPerDay(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicMeterPerDay"
        """
        pass

    @property
    def StandardCubicMetersPerHour(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicMeterPerHour"
        """
        pass

    @property
    def StandardCubicMetersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicMeterPerMinute"
        """
        pass

    @property
    def StandardCubicMetersPerSecond(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardCubicMeterPerSecond"
        """
        pass

    @property
    def StandardLitersPerMinute(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field StandardLiterPerMinute"
        """
        pass

    def __init__(self, value: float, unit: StandardVolumeFlowUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: StandardVolumeFlowUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: StandardVolumeFlowUnit) -> StandardVolumeFlow:
        """ Converts this StandardVolumeFlow to another StandardVolumeFlow with the unit representation .

        :param unit: The unit to convert to.
        :type unit: StandardVolumeFlowUnit
        :return: A StandardVolumeFlow with the specified unit.
        :rtype: StandardVolumeFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unit: StandardVolumeFlowUnit, unitConverter: UnitConverter) -> StandardVolumeFlow:
        """ Converts this "StandardVolumeFlow" to another "StandardVolumeFlow" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: StandardVolumeFlowUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A StandardVolumeFlow with the specified unit.
        :rtype: StandardVolumeFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> StandardVolumeFlow:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: StandardVolumeFlowUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: StandardVolumeFlowUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: StandardVolumeFlowUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: StandardVolumeFlowUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromStandardCubicCentimetersPerMinute(standardcubiccentimetersperminute: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicCentimeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicFeetPerHour(standardcubicfeetperhour: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicFootPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicFeetPerMinute(standardcubicfeetperminute: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicFootPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicFeetPerSecond(standardcubicfeetpersecond: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicFootPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerDay(standardcubicmetersperday: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicMeterPerDay".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerHour(standardcubicmetersperhour: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicMeterPerHour".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerMinute(standardcubicmetersperminute: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicMeterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerSecond(standardcubicmeterspersecond: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardCubicMeterPerSecond".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardLitersPerMinute(standardlitersperminute: QuantityValue) -> StandardVolumeFlow:
        """ Creates a "StandardVolumeFlow" from "Field StandardLiterPerMinute".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: StandardVolumeFlowUnit) -> StandardVolumeFlow:
        """ Dynamically convert from value and unit enum "StandardVolumeFlowUnit" to "StandardVolumeFlow".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: StandardVolumeFlowUnit
        :return: StandardVolumeFlow unit value.
        :rtype: StandardVolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> StandardVolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> StandardVolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: StandardVolumeFlow) -> typing.Tuple[StandardVolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: StandardVolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: StandardVolumeFlow) -> typing.Tuple[StandardVolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: StandardVolumeFlow
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> StandardVolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> StandardVolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: StandardVolumeFlowUnit) -> typing.Tuple[StandardVolumeFlowUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: StandardVolumeFlowUnit) -> typing.Tuple[StandardVolumeFlowUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: StandardVolumeFlowUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: StandardVolumeFlow) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: StandardVolumeFlow) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: StandardVolumeFlow, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another StandardVolumeFlow within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: StandardVolumeFlow
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current StandardVolumeFlow.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: StandardVolumeFlowUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class ThermalConductivity(ValueType, IQuantity[ThermalConductivityUnit], IQuantity, IFormattable, IEquatable[ThermalConductivity], IComparable, IComparable[ThermalConductivity], IConvertible):
    """ Thermal conductivity is the property of a material to conduct heat.
     https://en.wikipedia.org/wiki/Thermal_Conductivity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ThermalConductivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ThermalConductivityUnit]

    MaxValue: typing.ClassVar[ThermalConductivity]

    MinValue: typing.ClassVar[ThermalConductivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ThermalConductivityUnit]]

    Zero: typing.ClassVar[ThermalConductivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ThermalConductivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ThermalConductivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerHourFootFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerHourFootFahrenheit"
        """
        pass

    @property
    def WattsPerMeterKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field WattPerMeterKelvin"
        """
        pass

    def __init__(self, value: float, unit: ThermalConductivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ThermalConductivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalConductivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalConductivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalConductivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalConductivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerHourFootFahrenheit(btusperhourfootfahrenheit: QuantityValue) -> ThermalConductivity:
        """ Creates a "ThermalConductivity" from "Field BtuPerHourFootFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerMeterKelvin(wattspermeterkelvin: QuantityValue) -> ThermalConductivity:
        """ Creates a "ThermalConductivity" from "Field WattPerMeterKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ThermalConductivityUnit) -> ThermalConductivity:
        """ Dynamically convert from value and unit enum "ThermalConductivityUnit" to "ThermalConductivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ThermalConductivityUnit
        :return: ThermalConductivity unit value.
        :rtype: ThermalConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ThermalConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ThermalConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ThermalConductivity) -> typing.Tuple[ThermalConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ThermalConductivity) -> typing.Tuple[ThermalConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalConductivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ThermalConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ThermalConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ThermalConductivityUnit) -> typing.Tuple[ThermalConductivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ThermalConductivityUnit) -> typing.Tuple[ThermalConductivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ThermalConductivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ThermalConductivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalConductivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalConductivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ThermalConductivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ThermalConductivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ThermalConductivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ThermalConductivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ThermalConductivityUnit) -> ThermalConductivity:
        """ Converts this ThermalConductivity to another ThermalConductivity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ThermalConductivityUnit
        :return: A ThermalConductivity with the specified unit.
        :rtype: ThermalConductivity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ThermalConductivityUnit, unitConverter: UnitConverter) -> ThermalConductivity:
        """ Converts this "ThermalConductivity" to another "ThermalConductivity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ThermalConductivityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ThermalConductivity with the specified unit.
        :rtype: ThermalConductivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ThermalConductivity:
        """
        """
        pass


# noinspection PyPep8Naming
class ThermalResistance(ValueType, IQuantity[ThermalResistanceUnit], IQuantity, IFormattable, IEquatable[ThermalResistance], IComparable, IComparable[ThermalResistance], IConvertible):
    """ Heat Transfer Coefficient or Thermal conductivity - indicates a materials ability to conduct heat.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[ThermalResistanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ThermalResistanceUnit]

    MaxValue: typing.ClassVar[ThermalResistance]

    MinValue: typing.ClassVar[ThermalResistance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ThermalResistanceUnit]]

    Zero: typing.ClassVar[ThermalResistance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ThermalResistanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ThermalResistanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def HourSquareFeetDegreesFahrenheitPerBtu(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field HourSquareFeetDegreeFahrenheitPerBtu"
        """
        pass

    @property
    def SquareCentimeterHourDegreesCelsiusPerKilocalorie(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareCentimeterHourDegreeCelsiusPerKilocalorie"
        """
        pass

    @property
    def SquareCentimeterKelvinsPerWatt(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareCentimeterKelvinPerWatt"
        """
        pass

    @property
    def SquareMeterDegreesCelsiusPerWatt(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMeterDegreeCelsiusPerWatt"
        """
        pass

    @property
    def SquareMeterKelvinsPerKilowatt(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMeterKelvinPerKilowatt"
        """
        pass

    @property
    def SquareMeterKelvinsPerWatt(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field SquareMeterKelvinPerWatt"
        """
        pass

    def __init__(self, value: float, unit: ThermalResistanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ThermalResistanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ThermalResistance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalResistanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalResistanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalResistanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalResistanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromHourSquareFeetDegreesFahrenheitPerBtu(hoursquarefeetdegreesfahrenheitperbtu: QuantityValue) -> ThermalResistance:
        """ Creates a "ThermalResistance" from "Field HourSquareFeetDegreeFahrenheitPerBtu".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeterHourDegreesCelsiusPerKilocalorie(squarecentimeterhourdegreescelsiusperkilocalorie: QuantityValue) -> ThermalResistance:
        """ Creates a "ThermalResistance" from "Field SquareCentimeterHourDegreeCelsiusPerKilocalorie".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeterKelvinsPerWatt(squarecentimeterkelvinsperwatt: QuantityValue) -> ThermalResistance:
        """ Creates a "ThermalResistance" from "Field SquareCentimeterKelvinPerWatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeterDegreesCelsiusPerWatt(squaremeterdegreescelsiusperwatt: QuantityValue) -> ThermalResistance:
        """ Creates a "ThermalResistance" from "Field SquareMeterDegreeCelsiusPerWatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeterKelvinsPerKilowatt(squaremeterkelvinsperkilowatt: QuantityValue) -> ThermalResistance:
        """ Creates a "ThermalResistance" from "Field SquareMeterKelvinPerKilowatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeterKelvinsPerWatt(squaremeterkelvinsperwatt: QuantityValue) -> ThermalResistance:
        """ Creates a "ThermalResistance" from "Field SquareMeterKelvinPerWatt".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ThermalResistanceUnit) -> ThermalResistance:
        """ Dynamically convert from value and unit enum "ThermalResistanceUnit" to "ThermalResistance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ThermalResistanceUnit
        :return: ThermalResistance unit value.
        :rtype: ThermalResistance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ThermalResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ThermalResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ThermalResistance) -> typing.Tuple[ThermalResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalResistance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ThermalResistance) -> typing.Tuple[ThermalResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalResistance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ThermalResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ThermalResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ThermalResistanceUnit) -> typing.Tuple[ThermalResistanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ThermalResistanceUnit) -> typing.Tuple[ThermalResistanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ThermalResistanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ThermalResistance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalResistance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalResistance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ThermalResistance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ThermalResistance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ThermalResistance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ThermalResistanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ThermalResistanceUnit) -> ThermalResistance:
        """ Converts this ThermalResistance to another ThermalResistance with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ThermalResistanceUnit
        :return: A ThermalResistance with the specified unit.
        :rtype: ThermalResistance
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ThermalResistanceUnit, unitConverter: UnitConverter) -> ThermalResistance:
        """ Converts this "ThermalResistance" to another "ThermalResistance" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: ThermalResistanceUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A ThermalResistance with the specified unit.
        :rtype: ThermalResistance
        """
        pass


# noinspection PyPep8Naming
class TorquePerLength(ValueType, IQuantity[TorquePerLengthUnit], IQuantity, IFormattable, IEquatable[TorquePerLength], IComparable, IComparable[TorquePerLength], IConvertible):
    """ The magnitude of torque per unit length.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TorquePerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TorquePerLengthUnit]

    MaxValue: typing.ClassVar[TorquePerLength]

    MinValue: typing.ClassVar[TorquePerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TorquePerLengthUnit]]

    Zero: typing.ClassVar[TorquePerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TorquePerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TorquePerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramForceCentimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceCentimeterPerMeter"
        """
        pass

    @property
    def KilogramForceMetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceMeterPerMeter"
        """
        pass

    @property
    def KilogramForceMillimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilogramForceMillimeterPerMeter"
        """
        pass

    @property
    def KilonewtonCentimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonCentimeterPerMeter"
        """
        pass

    @property
    def KilonewtonMetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMeterPerMeter"
        """
        pass

    @property
    def KilonewtonMillimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilonewtonMillimeterPerMeter"
        """
        pass

    @property
    def KilopoundForceFeetPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceFootPerFoot"
        """
        pass

    @property
    def KilopoundForceInchesPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilopoundForceInchPerFoot"
        """
        pass

    @property
    def MeganewtonCentimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonCentimeterPerMeter"
        """
        pass

    @property
    def MeganewtonMetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMeterPerMeter"
        """
        pass

    @property
    def MeganewtonMillimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeganewtonMillimeterPerMeter"
        """
        pass

    @property
    def MegapoundForceFeetPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForceFootPerFoot"
        """
        pass

    @property
    def MegapoundForceInchesPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegapoundForceInchPerFoot"
        """
        pass

    @property
    def NewtonCentimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonCentimeterPerMeter"
        """
        pass

    @property
    def NewtonMetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMeterPerMeter"
        """
        pass

    @property
    def NewtonMillimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NewtonMillimeterPerMeter"
        """
        pass

    @property
    def PoundForceFeetPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceFootPerFoot"
        """
        pass

    @property
    def PoundForceInchesPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field PoundForceInchPerFoot"
        """
        pass

    @property
    def TonneForceCentimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceCentimeterPerMeter"
        """
        pass

    @property
    def TonneForceMetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceMeterPerMeter"
        """
        pass

    @property
    def TonneForceMillimetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field TonneForceMillimeterPerMeter"
        """
        pass

    def __init__(self, value: float, unit: TorquePerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TorquePerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TorquePerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TorquePerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TorquePerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TorquePerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TorquePerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TorquePerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TorquePerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TorquePerLengthUnit) -> TorquePerLength:
        """ Converts this TorquePerLength to another TorquePerLength with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TorquePerLengthUnit
        :return: A TorquePerLength with the specified unit.
        :rtype: TorquePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TorquePerLengthUnit, unitConverter: UnitConverter) -> TorquePerLength:
        """ Converts this "TorquePerLength" to another "TorquePerLength" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TorquePerLengthUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A TorquePerLength with the specified unit.
        :rtype: TorquePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TorquePerLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorquePerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorquePerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorquePerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorquePerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramForceCentimetersPerMeter(kilogramforcecentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilogramForceCentimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMetersPerMeter(kilogramforcemeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilogramForceMeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMillimetersPerMeter(kilogramforcemillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilogramForceMillimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonCentimetersPerMeter(kilonewtoncentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilonewtonCentimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerMeter(kilonewtonmeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilonewtonMeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimetersPerMeter(kilonewtonmillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilonewtonMillimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeetPerFoot(kilopoundforcefeetperfoot: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilopoundForceFootPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceInchesPerFoot(kilopoundforceinchesperfoot: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field KilopoundForceInchPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonCentimetersPerMeter(meganewtoncentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field MeganewtonCentimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerMeter(meganewtonmeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field MeganewtonMeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimetersPerMeter(meganewtonmillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field MeganewtonMillimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceFeetPerFoot(megapoundforcefeetperfoot: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field MegapoundForceFootPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceInchesPerFoot(megapoundforceinchesperfoot: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field MegapoundForceInchPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonCentimetersPerMeter(newtoncentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field NewtonCentimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerMeter(newtonmeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field NewtonMeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimetersPerMeter(newtonmillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field NewtonMillimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerFoot(poundforcefeetperfoot: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field PoundForceFootPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceInchesPerFoot(poundforceinchesperfoot: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field PoundForceInchPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceCentimetersPerMeter(tonneforcecentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field TonneForceCentimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMetersPerMeter(tonneforcemeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field TonneForceMeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMillimetersPerMeter(tonneforcemillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Creates a "TorquePerLength" from "Field TonneForceMillimeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TorquePerLengthUnit) -> TorquePerLength:
        """ Dynamically convert from value and unit enum "TorquePerLengthUnit" to "TorquePerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TorquePerLengthUnit
        :return: TorquePerLength unit value.
        :rtype: TorquePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TorquePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TorquePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TorquePerLength) -> typing.Tuple[TorquePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TorquePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TorquePerLength) -> typing.Tuple[TorquePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TorquePerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TorquePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TorquePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TorquePerLengthUnit) -> typing.Tuple[TorquePerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TorquePerLengthUnit) -> typing.Tuple[TorquePerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TorquePerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Turbidity(ValueType, IQuantity[TurbidityUnit], IQuantity, IFormattable, IEquatable[Turbidity], IComparable, IComparable[Turbidity], IConvertible):
    """ Turbidity is the cloudiness or haziness of a fluid caused by large numbers of individual particles that are generally invisible to the naked eye, similar to smoke in air. The measurement of turbidity is a key test of water quality.
     https://en.wikipedia.org/wiki/Turbidity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[TurbidityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TurbidityUnit]

    MaxValue: typing.ClassVar[Turbidity]

    MinValue: typing.ClassVar[Turbidity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TurbidityUnit]]

    Zero: typing.ClassVar[Turbidity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TurbidityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TurbidityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def NTU(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field NTU"
        """
        pass

    def __init__(self, value: float, unit: TurbidityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TurbidityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TurbidityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TurbidityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TurbidityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TurbidityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromNTU(ntu: QuantityValue) -> Turbidity:
        """ Creates a "Turbidity" from "Field NTU".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TurbidityUnit) -> Turbidity:
        """ Dynamically convert from value and unit enum "TurbidityUnit" to "Turbidity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TurbidityUnit
        :return: Turbidity unit value.
        :rtype: Turbidity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Turbidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Turbidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Turbidity) -> typing.Tuple[Turbidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Turbidity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Turbidity) -> typing.Tuple[Turbidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Turbidity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TurbidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TurbidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TurbidityUnit) -> typing.Tuple[TurbidityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TurbidityUnit) -> typing.Tuple[TurbidityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TurbidityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Turbidity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Turbidity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Turbidity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Turbidity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Turbidity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Turbidity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TurbidityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TurbidityUnit) -> Turbidity:
        """ Converts this Turbidity to another Turbidity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TurbidityUnit
        :return: A Turbidity with the specified unit.
        :rtype: Turbidity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TurbidityUnit, unitConverter: UnitConverter) -> Turbidity:
        """ Converts this "Turbidity" to another "Turbidity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: TurbidityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A Turbidity with the specified unit.
        :rtype: Turbidity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Turbidity:
        """
        """
        pass


# noinspection PyPep8Naming
class VitaminA(ValueType, IQuantity[VitaminAUnit], IQuantity, IFormattable, IEquatable[VitaminA], IComparable, IComparable[VitaminA], IConvertible):
    """ Vitamin A: 1 IU is the biological equivalent of 0.3 µg retinol, or of 0.6 µg beta-carotene.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VitaminAUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VitaminAUnit]

    MaxValue: typing.ClassVar[VitaminA]

    MinValue: typing.ClassVar[VitaminA]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VitaminAUnit]]

    Zero: typing.ClassVar[VitaminA]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VitaminAUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VitaminAUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InternationalUnits(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InternationalUnit"
        """
        pass

    def __init__(self, value: float, unit: VitaminAUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VitaminAUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VitaminAUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VitaminAUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VitaminAUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VitaminAUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInternationalUnits(internationalunits: QuantityValue) -> VitaminA:
        """ Creates a "VitaminA" from "Field InternationalUnit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VitaminAUnit) -> VitaminA:
        """ Dynamically convert from value and unit enum "VitaminAUnit" to "VitaminA".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VitaminAUnit
        :return: VitaminA unit value.
        :rtype: VitaminA
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VitaminA:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VitaminA:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VitaminA) -> typing.Tuple[VitaminA, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VitaminA
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VitaminA) -> typing.Tuple[VitaminA, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VitaminA
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VitaminAUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VitaminAUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VitaminAUnit) -> typing.Tuple[VitaminAUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VitaminAUnit) -> typing.Tuple[VitaminAUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VitaminAUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VitaminA) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VitaminA) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VitaminA, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VitaminA within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VitaminA
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VitaminA.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VitaminAUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VitaminAUnit) -> VitaminA:
        """ Converts this VitaminA to another VitaminA with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VitaminAUnit
        :return: A VitaminA with the specified unit.
        :rtype: VitaminA
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VitaminAUnit, unitConverter: UnitConverter) -> VitaminA:
        """ Converts this "VitaminA" to another "VitaminA" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VitaminAUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A VitaminA with the specified unit.
        :rtype: VitaminA
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VitaminA:
        """
        """
        pass


# noinspection PyPep8Naming
class VolumeFlowPerArea(ValueType, IQuantity[VolumeFlowPerAreaUnit], IQuantity, IFormattable, IEquatable[VolumeFlowPerArea], IComparable, IComparable[VolumeFlowPerArea], IConvertible):
    """ The volumetric flow rate per area is the volume of fluid which passes through a given unit surface area per unit time.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VolumeFlowPerAreaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeFlowPerAreaUnit]

    MaxValue: typing.ClassVar[VolumeFlowPerArea]

    MinValue: typing.ClassVar[VolumeFlowPerArea]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeFlowPerAreaUnit]]

    Zero: typing.ClassVar[VolumeFlowPerArea]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeFlowPerAreaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeFlowPerAreaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CubicFeetPerMinutePerSquareFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicFootPerMinutePerSquareFoot"
        """
        pass

    @property
    def CubicMetersPerSecondPerSquareMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerSecondPerSquareMeter"
        """
        pass

    def __init__(self, value: float, unit: VolumeFlowPerAreaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeFlowPerAreaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeFlowPerAreaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeFlowPerAreaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeFlowPerAreaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeFlowPerAreaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCubicFeetPerMinutePerSquareFoot(cubicfeetperminutepersquarefoot: QuantityValue) -> VolumeFlowPerArea:
        """ Creates a "VolumeFlowPerArea" from "Field CubicFootPerMinutePerSquareFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerSecondPerSquareMeter(cubicmeterspersecondpersquaremeter: QuantityValue) -> VolumeFlowPerArea:
        """ Creates a "VolumeFlowPerArea" from "Field CubicMeterPerSecondPerSquareMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeFlowPerAreaUnit) -> VolumeFlowPerArea:
        """ Dynamically convert from value and unit enum "VolumeFlowPerAreaUnit" to "VolumeFlowPerArea".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeFlowPerAreaUnit
        :return: VolumeFlowPerArea unit value.
        :rtype: VolumeFlowPerArea
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumeFlowPerArea:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumeFlowPerArea:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumeFlowPerArea) -> typing.Tuple[VolumeFlowPerArea, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeFlowPerArea
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumeFlowPerArea) -> typing.Tuple[VolumeFlowPerArea, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeFlowPerArea
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeFlowPerAreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeFlowPerAreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeFlowPerAreaUnit) -> typing.Tuple[VolumeFlowPerAreaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeFlowPerAreaUnit) -> typing.Tuple[VolumeFlowPerAreaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeFlowPerAreaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumeFlowPerArea) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeFlowPerArea) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeFlowPerArea, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumeFlowPerArea within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumeFlowPerArea
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumeFlowPerArea.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumeFlowPerAreaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeFlowPerAreaUnit) -> VolumeFlowPerArea:
        """ Converts this VolumeFlowPerArea to another VolumeFlowPerArea with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeFlowPerAreaUnit
        :return: A VolumeFlowPerArea with the specified unit.
        :rtype: VolumeFlowPerArea
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeFlowPerAreaUnit, unitConverter: UnitConverter) -> VolumeFlowPerArea:
        """ Converts this "VolumeFlowPerArea" to another "VolumeFlowPerArea" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumeFlowPerAreaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A VolumeFlowPerArea with the specified unit.
        :rtype: VolumeFlowPerArea
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumeFlowPerArea:
        """
        """
        pass


# noinspection PyPep8Naming
class VolumePerLength(ValueType, IQuantity[VolumePerLengthUnit], IQuantity, IFormattable, IEquatable[VolumePerLength], IComparable, IComparable[VolumePerLength], IConvertible):
    """ Volume, typically of fluid, that a container can hold within a unit of length.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VolumePerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumePerLengthUnit]

    MaxValue: typing.ClassVar[VolumePerLength]

    MinValue: typing.ClassVar[VolumePerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumePerLengthUnit]]

    Zero: typing.ClassVar[VolumePerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumePerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumePerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CubicMetersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicMeterPerMeter"
        """
        pass

    @property
    def CubicYardsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYardPerFoot"
        """
        pass

    @property
    def CubicYardsPerUsSurveyFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CubicYardPerUsSurveyFoot"
        """
        pass

    @property
    def LitersPerKilometer(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerKilometer"
        """
        pass

    @property
    def LitersPerMeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerMeter"
        """
        pass

    @property
    def LitersPerMillimeter(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field LiterPerMillimeter"
        """
        pass

    @property
    def OilBarrelsPerFoot(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field OilBarrelPerFoot"
        """
        pass

    def __init__(self, value: float, unit: VolumePerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumePerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumePerLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumePerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumePerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumePerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumePerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCubicMetersPerMeter(cubicmeterspermeter: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field CubicMeterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerFoot(cubicyardsperfoot: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field CubicYardPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerUsSurveyFoot(cubicyardsperussurveyfoot: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field CubicYardPerUsSurveyFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerKilometer(litersperkilometer: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field LiterPerKilometer".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMeter(literspermeter: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field LiterPerMeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMillimeter(literspermillimeter: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field LiterPerMillimeter".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerFoot(oilbarrelsperfoot: QuantityValue) -> VolumePerLength:
        """ Creates a "VolumePerLength" from "Field OilBarrelPerFoot".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumePerLengthUnit) -> VolumePerLength:
        """ Dynamically convert from value and unit enum "VolumePerLengthUnit" to "VolumePerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumePerLengthUnit
        :return: VolumePerLength unit value.
        :rtype: VolumePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumePerLength) -> typing.Tuple[VolumePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumePerLength) -> typing.Tuple[VolumePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumePerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumePerLengthUnit) -> typing.Tuple[VolumePerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumePerLengthUnit) -> typing.Tuple[VolumePerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumePerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumePerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumePerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumePerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumePerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumePerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumePerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumePerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumePerLengthUnit) -> VolumePerLength:
        """ Converts this VolumePerLength to another VolumePerLength with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumePerLengthUnit
        :return: A VolumePerLength with the specified unit.
        :rtype: VolumePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumePerLengthUnit, unitConverter: UnitConverter) -> VolumePerLength:
        """ Converts this "VolumePerLength" to another "VolumePerLength" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumePerLengthUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A VolumePerLength with the specified unit.
        :rtype: VolumePerLength
        """
        pass


# noinspection PyPep8Naming
class VolumetricHeatCapacity(ValueType, IQuantity[VolumetricHeatCapacityUnit], IQuantity, IFormattable, IEquatable[VolumetricHeatCapacity], IComparable, IComparable[VolumetricHeatCapacity], IConvertible):
    """ The volumetric heat capacity is the amount of energy that must be added, in the form of heat, to one unit of volume of the material in order to cause an increase of one unit in its temperature.
     https://en.wikipedia.org/wiki/Volumetric_heat_capacity
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[VolumetricHeatCapacityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumetricHeatCapacityUnit]

    MaxValue: typing.ClassVar[VolumetricHeatCapacity]

    MinValue: typing.ClassVar[VolumetricHeatCapacity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumetricHeatCapacityUnit]]

    Zero: typing.ClassVar[VolumetricHeatCapacity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumetricHeatCapacityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumetricHeatCapacityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerCubicFootDegreeFahrenheit(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field BtuPerCubicFootDegreeFahrenheit"
        """
        pass

    @property
    def CaloriesPerCubicCentimeterDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CaloriePerCubicCentimeterDegreeCelsius"
        """
        pass

    @property
    def JoulesPerCubicMeterDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerCubicMeterDegreeCelsius"
        """
        pass

    @property
    def JoulesPerCubicMeterKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field JoulePerCubicMeterKelvin"
        """
        pass

    @property
    def KilocaloriesPerCubicCentimeterDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilocaloriePerCubicCentimeterDegreeCelsius"
        """
        pass

    @property
    def KilojoulesPerCubicMeterDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerCubicMeterDegreeCelsius"
        """
        pass

    @property
    def KilojoulesPerCubicMeterKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field KilojoulePerCubicMeterKelvin"
        """
        pass

    @property
    def MegajoulesPerCubicMeterDegreeCelsius(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerCubicMeterDegreeCelsius"
        """
        pass

    @property
    def MegajoulesPerCubicMeterKelvin(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MegajoulePerCubicMeterKelvin"
        """
        pass

    def __init__(self, value: float, unit: VolumetricHeatCapacityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumetricHeatCapacityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumetricHeatCapacityUnit) -> VolumetricHeatCapacity:
        """ Converts this VolumetricHeatCapacity to another VolumetricHeatCapacity with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumetricHeatCapacityUnit
        :return: A VolumetricHeatCapacity with the specified unit.
        :rtype: VolumetricHeatCapacity
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumetricHeatCapacityUnit, unitConverter: UnitConverter) -> VolumetricHeatCapacity:
        """ Converts this "VolumetricHeatCapacity" to another "VolumetricHeatCapacity" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: VolumetricHeatCapacityUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A VolumetricHeatCapacity with the specified unit.
        :rtype: VolumetricHeatCapacity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumetricHeatCapacity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumetricHeatCapacityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumetricHeatCapacityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumetricHeatCapacityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumetricHeatCapacityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerCubicFootDegreeFahrenheit(btuspercubicfootdegreefahrenheit: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field BtuPerCubicFootDegreeFahrenheit".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerCubicCentimeterDegreeCelsius(caloriespercubiccentimeterdegreecelsius: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field CaloriePerCubicCentimeterDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerCubicMeterDegreeCelsius(joulespercubicmeterdegreecelsius: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field JoulePerCubicMeterDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerCubicMeterKelvin(joulespercubicmeterkelvin: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field JoulePerCubicMeterKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerCubicCentimeterDegreeCelsius(kilocaloriespercubiccentimeterdegreecelsius: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field KilocaloriePerCubicCentimeterDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerCubicMeterDegreeCelsius(kilojoulespercubicmeterdegreecelsius: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field KilojoulePerCubicMeterDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerCubicMeterKelvin(kilojoulespercubicmeterkelvin: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field KilojoulePerCubicMeterKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerCubicMeterDegreeCelsius(megajoulespercubicmeterdegreecelsius: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field MegajoulePerCubicMeterDegreeCelsius".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerCubicMeterKelvin(megajoulespercubicmeterkelvin: QuantityValue) -> VolumetricHeatCapacity:
        """ Creates a "VolumetricHeatCapacity" from "Field MegajoulePerCubicMeterKelvin".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumetricHeatCapacityUnit) -> VolumetricHeatCapacity:
        """ Dynamically convert from value and unit enum "VolumetricHeatCapacityUnit" to "VolumetricHeatCapacity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumetricHeatCapacityUnit
        :return: VolumetricHeatCapacity unit value.
        :rtype: VolumetricHeatCapacity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumetricHeatCapacity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumetricHeatCapacity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumetricHeatCapacity) -> typing.Tuple[VolumetricHeatCapacity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumetricHeatCapacity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumetricHeatCapacity) -> typing.Tuple[VolumetricHeatCapacity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumetricHeatCapacity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumetricHeatCapacityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumetricHeatCapacityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumetricHeatCapacityUnit) -> typing.Tuple[VolumetricHeatCapacityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumetricHeatCapacityUnit) -> typing.Tuple[VolumetricHeatCapacityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumetricHeatCapacityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumetricHeatCapacity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumetricHeatCapacity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumetricHeatCapacity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumetricHeatCapacity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumetricHeatCapacity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumetricHeatCapacity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumetricHeatCapacityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class WarpingMomentOfInertia(ValueType, IQuantity[WarpingMomentOfInertiaUnit], IQuantity, IFormattable, IEquatable[WarpingMomentOfInertia], IComparable, IComparable[WarpingMomentOfInertia], IConvertible):
    """ A geometric property of an area that is used to determine the warping stress.
    """

    DefaultConversionFunctions: typing.ClassVar[UnitConverter]

    Info: typing.ClassVar[QuantityInfo[WarpingMomentOfInertiaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[WarpingMomentOfInertiaUnit]

    MaxValue: typing.ClassVar[WarpingMomentOfInertia]

    MinValue: typing.ClassVar[WarpingMomentOfInertia]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[WarpingMomentOfInertiaUnit]]

    Zero: typing.ClassVar[WarpingMomentOfInertia]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> WarpingMomentOfInertiaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[WarpingMomentOfInertiaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersToTheSixth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field CentimeterToTheSixth"
        """
        pass

    @property
    def DecimetersToTheSixth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field DecimeterToTheSixth"
        """
        pass

    @property
    def FeetToTheSixth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field FootToTheSixth"
        """
        pass

    @property
    def InchesToTheSixth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field InchToTheSixth"
        """
        pass

    @property
    def MetersToTheSixth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MeterToTheSixth"
        """
        pass

    @property
    def MillimetersToTheSixth(self) -> float:
        """ Gets a "float" value of this quantity converted into "Field MillimeterToTheSixth"
        """
        pass

    def __init__(self, value: float, unit: WarpingMomentOfInertiaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: WarpingMomentOfInertiaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> WarpingMomentOfInertia:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: WarpingMomentOfInertiaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: WarpingMomentOfInertiaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: WarpingMomentOfInertiaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: WarpingMomentOfInertiaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersToTheSixth(centimeterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Creates a "WarpingMomentOfInertia" from "Field CentimeterToTheSixth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersToTheSixth(decimeterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Creates a "WarpingMomentOfInertia" from "Field DecimeterToTheSixth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetToTheSixth(feettothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Creates a "WarpingMomentOfInertia" from "Field FootToTheSixth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesToTheSixth(inchestothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Creates a "WarpingMomentOfInertia" from "Field InchToTheSixth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersToTheSixth(meterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Creates a "WarpingMomentOfInertia" from "Field MeterToTheSixth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersToTheSixth(millimeterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Creates a "WarpingMomentOfInertia" from "Field MillimeterToTheSixth".

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: WarpingMomentOfInertiaUnit) -> WarpingMomentOfInertia:
        """ Dynamically convert from value and unit enum "WarpingMomentOfInertiaUnit" to "WarpingMomentOfInertia".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: WarpingMomentOfInertiaUnit
        :return: WarpingMomentOfInertia unit value.
        :rtype: WarpingMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> WarpingMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> WarpingMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception OasysUnitsException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "OasysUnitsException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: WarpingMomentOfInertia) -> typing.Tuple[WarpingMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: WarpingMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: WarpingMomentOfInertia) -> typing.Tuple[WarpingMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: WarpingMomentOfInertia
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> WarpingMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> WarpingMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception OasysUnitsException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: WarpingMomentOfInertiaUnit) -> typing.Tuple[WarpingMomentOfInertiaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: WarpingMomentOfInertiaUnit) -> typing.Tuple[WarpingMomentOfInertiaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: WarpingMomentOfInertiaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: WarpingMomentOfInertia) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: WarpingMomentOfInertia) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: WarpingMomentOfInertia, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another WarpingMomentOfInertia within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: WarpingMomentOfInertia
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current WarpingMomentOfInertia.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: WarpingMomentOfInertiaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: WarpingMomentOfInertiaUnit) -> WarpingMomentOfInertia:
        """ Converts this WarpingMomentOfInertia to another WarpingMomentOfInertia with the unit representation .

        :param unit: The unit to convert to.
        :type unit: WarpingMomentOfInertiaUnit
        :return: A WarpingMomentOfInertia with the specified unit.
        :rtype: WarpingMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unit: WarpingMomentOfInertiaUnit, unitConverter: UnitConverter) -> WarpingMomentOfInertia:
        """ Converts this "WarpingMomentOfInertia" to another "WarpingMomentOfInertia" using the given with the unit representation .

        :param unit: The unit to convert to.
        :type unit: WarpingMomentOfInertiaUnit
        :param unitConverter: The "UnitConverter" to use for the conversion.
        :type unitConverter: UnitConverter
        :return: A WarpingMomentOfInertia with the specified unit.
        :rtype: WarpingMomentOfInertia
        """
        pass


# noinspection PyPep8Naming
class QuantityType(Enum, IComparable, IFormattable, IConvertible):
    """ Lists all generated quantities with the same name as the quantity struct type,
     such as Length, Mass, Force etc.
     This is useful for populating options in the UI, such as creating a generic conversion
     tool with inputValue, quantityName, fromUnit and toUnit selectors.
    """

    value__: int = ...

    Undefined: QuantityType = ...

    Acceleration: QuantityType = ...

    AmountOfSubstance: QuantityType = ...

    AmplitudeRatio: QuantityType = ...

    Angle: QuantityType = ...

    ApparentEnergy: QuantityType = ...

    ApparentPower: QuantityType = ...

    Area: QuantityType = ...

    AreaDensity: QuantityType = ...

    AreaMomentOfInertia: QuantityType = ...

    AxialStiffness: QuantityType = ...

    BendingStiffness: QuantityType = ...

    BitRate: QuantityType = ...

    BrakeSpecificFuelConsumption: QuantityType = ...

    Capacitance: QuantityType = ...

    CoefficientOfThermalExpansion: QuantityType = ...

    Compressibility: QuantityType = ...

    Curvature: QuantityType = ...

    Density: QuantityType = ...

    Duration: QuantityType = ...

    DynamicViscosity: QuantityType = ...

    ElectricAdmittance: QuantityType = ...

    ElectricCharge: QuantityType = ...

    ElectricChargeDensity: QuantityType = ...

    ElectricConductance: QuantityType = ...

    ElectricConductivity: QuantityType = ...

    ElectricCurrent: QuantityType = ...

    ElectricCurrentDensity: QuantityType = ...

    ElectricCurrentGradient: QuantityType = ...

    ElectricField: QuantityType = ...

    ElectricInductance: QuantityType = ...

    ElectricPotential: QuantityType = ...

    ElectricPotentialAc: QuantityType = ...

    ElectricPotentialChangeRate: QuantityType = ...

    ElectricPotentialDc: QuantityType = ...

    ElectricResistance: QuantityType = ...

    ElectricResistivity: QuantityType = ...

    ElectricSurfaceChargeDensity: QuantityType = ...

    Energy: QuantityType = ...

    Entropy: QuantityType = ...

    Force: QuantityType = ...

    ForceChangeRate: QuantityType = ...

    ForcePerLength: QuantityType = ...

    Frequency: QuantityType = ...

    FuelEfficiency: QuantityType = ...

    HeatFlux: QuantityType = ...

    HeatTransferCoefficient: QuantityType = ...

    Illuminance: QuantityType = ...

    Information: QuantityType = ...

    Irradiance: QuantityType = ...

    Irradiation: QuantityType = ...

    Jerk: QuantityType = ...

    KinematicViscosity: QuantityType = ...

    LapseRate: QuantityType = ...

    Length: QuantityType = ...

    Level: QuantityType = ...

    LinearDensity: QuantityType = ...

    LinearPowerDensity: QuantityType = ...

    Luminance: QuantityType = ...

    Luminosity: QuantityType = ...

    LuminousFlux: QuantityType = ...

    LuminousIntensity: QuantityType = ...

    MagneticField: QuantityType = ...

    MagneticFlux: QuantityType = ...

    Magnetization: QuantityType = ...

    Mass: QuantityType = ...

    MassConcentration: QuantityType = ...

    MassFlow: QuantityType = ...

    MassFlux: QuantityType = ...

    MassFraction: QuantityType = ...

    MassMomentOfInertia: QuantityType = ...

    MolarEnergy: QuantityType = ...

    MolarEntropy: QuantityType = ...

    Molarity: QuantityType = ...

    MolarMass: QuantityType = ...

    Moment: QuantityType = ...

    Permeability: QuantityType = ...

    Permittivity: QuantityType = ...

    PorousMediumPermeability: QuantityType = ...

    Power: QuantityType = ...

    PowerDensity: QuantityType = ...

    PowerRatio: QuantityType = ...

    Pressure: QuantityType = ...

    PressureChangeRate: QuantityType = ...

    Ratio: QuantityType = ...

    RatioChangeRate: QuantityType = ...

    ReactiveEnergy: QuantityType = ...

    ReactivePower: QuantityType = ...

    ReciprocalArea: QuantityType = ...

    ReciprocalLength: QuantityType = ...

    RelativeHumidity: QuantityType = ...

    RotationalAcceleration: QuantityType = ...

    RotationalSpeed: QuantityType = ...

    RotationalStiffness: QuantityType = ...

    RotationalStiffnessPerLength: QuantityType = ...

    Scalar: QuantityType = ...

    SectionModulus: QuantityType = ...

    SolidAngle: QuantityType = ...

    SpecificEnergy: QuantityType = ...

    SpecificEntropy: QuantityType = ...

    SpecificFuelConsumption: QuantityType = ...

    SpecificVolume: QuantityType = ...

    SpecificWeight: QuantityType = ...

    Speed: QuantityType = ...

    StandardVolumeFlow: QuantityType = ...

    Strain: QuantityType = ...

    Temperature: QuantityType = ...

    TemperatureChangeRate: QuantityType = ...

    TemperatureDelta: QuantityType = ...

    TemperatureGradient: QuantityType = ...

    ThermalConductivity: QuantityType = ...

    ThermalResistance: QuantityType = ...

    Torque: QuantityType = ...

    TorquePerLength: QuantityType = ...

    Turbidity: QuantityType = ...

    VitaminA: QuantityType = ...

    Volume: QuantityType = ...

    VolumeConcentration: QuantityType = ...

    VolumeFlow: QuantityType = ...

    VolumeFlowPerArea: QuantityType = ...

    VolumePerLength: QuantityType = ...

    VolumetricHeatCapacity: QuantityType = ...

    WarpingMomentOfInertia: QuantityType = ...


# noinspection PyPep8Naming
class IDecimalQuantity(metaclass=ABCMeta):
    """ Represents a quantity with a decimal value.
    """

    @property
    def Value(self) -> Decimal:
        """ The decimal value this quantity was constructed with.
        """
        pass


# noinspection PyPep8Naming
class IQuantity(IFormattable, metaclass=ABCMeta):
    """ Represents a quantity.
    """

    @property
    def Type(self) -> QuantityType:
        """ The "QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "BaseDimensions" of this quantity.
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo:
        """ Information about the quantity type, such as unit values and names.
        """
        pass

    @property
    def Unit(self) -> Enum:
        """ The unit this quantity was constructed with -or- BaseUnit if default ctor was used.
        """
        pass

    @property
    def Value(self) -> float:
        """ The value this quantity was constructed with. See also "Property Unit".
        """
        pass

    @abstractmethod
    @typing.overload
    def As(self, unit: Enum) -> float:
        """ Gets the value in the given unit.

        :param unit: The unit enum value. The unit must be compatible, so for "Length" you should provide a "LengthUnit" value.
        :type unit: Enum
        :return: Value converted to the specified unit.
        :rtype: float

        :exception InvalidCastException: Wrong unit enum type was given.
        """
        pass

    @abstractmethod
    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """ Gets the value in the unit determined by the given "UnitSystem". If multiple units were found for the given "UnitSystem",
         the first match will be used.

        :param unitSystem: The "UnitSystem" to convert the quantity value to.
        :type unitSystem: UnitSystem
        :return: The converted value.
        :rtype: float
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unit: Enum) -> IQuantity:
        """ Converts this "IQuantity" to an "IQuantity" in the given .

        :param unit: The unit "Enum" value. The "Enum" must be compatible with the units of the "IQuantity".
        For example, if the "IQuantity" is a "Length", you should provide a "LengthUnit" value.
        :type unit: Enum
        :return: A new "IQuantity" in the given .
        :rtype: IQuantity

        :exception NotImplementedException: Conversion was not possible from this "IQuantity" to .
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> IQuantity:
        """ Converts to a quantity with a unit determined by the given "UnitSystem", which affects things like "Function IFormatProvider)".
         If multiple units were found for the given "UnitSystem", the first match will be used.

        :param unitSystem: The "UnitSystem" to convert the quantity to.
        :type unitSystem: UnitSystem
        :return: A new quantity with the determined unit.
        :rtype: IQuantity
        """
        pass

    @abstractmethod
    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the string representation of value and unit. Uses two significant digits after radix.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @abstractmethod
    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @abstractmethod
    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implictly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class IQuantity(IQuantity, IFormattable, typing.Generic[TUnitType], metaclass=ABCMeta):
    """ A stronger typed interface where the unit enum type is known, to avoid passing in the
     wrong unit enum type and not having to cast from "Enum".
    """

    @property
    def Unit(self) -> TUnitType:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TUnitType]:
        """
        """
        pass

    @abstractmethod
    def As(self, unit: TUnitType) -> float:
        """ Convert to a unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unit: TUnitType) -> IQuantity[TUnitType]:
        """ Converts this "IQuantity[TUnitType]" to an "IQuantity[TUnitType]" in the given .

        :param unit: The unit value.
        :type unit: TUnitType
        :return: A new "IQuantity[TUnitType]" in the given .
        :rtype: IQuantity[TUnitType]

        :exception NotImplementedException: Conversion was not possible from this "IQuantity" to .
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> IQuantity[TUnitType]:
        """ Converts to a quantity with a unit determined by the given "UnitSystem", which affects things like "Function IFormatProvider)".
         If multiple units were found for the given "UnitSystem", the first match will be used.

        :param unitSystem: The "UnitSystem" to convert the quantity to.
        :type unitSystem: UnitSystem
        :return: A new quantity with the determined unit.
        :rtype: IQuantity[TUnitType]
        """
        pass


# noinspection PyPep8Naming
class QuantityFormatter:
    """The QuantityFormatter class is responsible for formatting a quantity using the given format string.
    """

    def __init__(self) -> None: ...

    @staticmethod
    @typing.overload
    def Format(quantity: IQuantity[TUnitType], format: str) -> str:
        """Formats a quantity using the given format string and format provider.
        The valid format strings are as follows:
        A standard numeric format string.Any of the standard numeric format for "Property Value" except for "G" or "g". "C" or "c", "E" or "e", "F" or "f", "N" or "n", "P" or "p", "R" or "r" are all accepted. "G" or "g".The value with 2 significant digits after the radix followed by the unit abbreviation, such as "1.23 m"."A" or "a".The default unit abbreviation for "Property Unit", such as "m"."A0", "A1", ..., "An" or "a0", "a1", ..., "an".The n-th unit abbreviation for "Property Unit". "a0" is the same as "a". A "FormatException" will be thrown if the requested abbreviation index does not exist."V" or "v".The string representation of "Property Value" using the default ToString method."U" or "u".The enum name of "Property Unit", such as "Meter"."Q" or "q".The quantity name, such as "Length"."S1", "S2", ..., "Sn" or "s1", "s2", ..., "sn".The value with n significant digits after the radix followed by the unit abbreviation. For example, "s4" would return "1.2345 m" if "Property Value" is 1.2345678. Trailing zeros are omitted.

        TUnitType: The quantity's unit type, for example "LengthUnit".

        :param quantity: The quantity to format.
        :type quantity: IQuantity[TUnitType]
        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def Format(quantity: IQuantity[TUnitType], format: str, formatProvider: IFormatProvider) -> str:
        """Formats a quantity using the given format string and format provider.
        The valid format strings are as follows:
        A standard numeric format string.Any of the standard numeric format for "Property Value" except for "G" or "g". "C" or "c", "E" or "e", "F" or "f", "N" or "n", "P" or "p", "R" or "r" are all accepted. "G" or "g".The value with 2 significant digits after the radix followed by the unit abbreviation, such as "1.23 m"."A" or "a".The default unit abbreviation for "Property Unit", such as "m"."A0", "A1", ..., "An" or "a0", "a1", ..., "an".The n-th unit abbreviation for "Property Unit". "a0" is the same as "a". A "FormatException" will be thrown if the requested abbreviation index does not exist."V" or "v".The string representation of "Property Value" using the default ToString method."U" or "u".The enum name of "Property Unit", such as "Meter"."Q" or "q".The quantity name, such as "Length"."S1", "S2", ..., "Sn" or "s1", "s2", ..., "sn".The value with n significant digits after the radix followed by the unit abbreviation. For example, "s4" would return "1.2345 m" if "Property Value" is 1.2345678. Trailing zeros are omitted.

        TUnitType: The quantity's unit type, for example "LengthUnit".

        :param quantity: The quantity to format.
        :type quantity: IQuantity[TUnitType]
        :param format: The format string.
        :type format: str
        :param formatProvider: The format provider to use for localization and number formatting. Defaults to
        "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class QuantityInfo:
    """ Information about the quantity, such as names, unit values and zero quantity.
     This is useful to enumerate units and present names with quantities and units
     chose dynamically at runtime, such as unit conversion apps or allowing the user to change the
     unit representation.
     Typically you obtain this by looking it up via "Property QuantityInfo".
    """

    @property
    def Name(self) -> str:
        """ Quantity name, such as "Length" or "Mass".
        """
        pass

    @property
    def QuantityType(self) -> QuantityType:
        """ Quantity type, such as "Field Length" or "Field Mass".
        """
        pass

    @property
    def UnitInfos(self) -> Array[UnitInfo]:
        """ The units for this quantity.
        """
        pass

    @property
    def UnitNames(self) -> Array[str]:
        """ All unit names for the quantity, such as ["Centimeter", "Decimeter", "Meter", ...].
        """
        pass

    @property
    def Units(self) -> Array[Enum]:
        """ All unit enum values for the quantity, such as [ "Field Centimeter",
         "Field Decimeter", "Field Meter", ...].
        """
        pass

    @property
    def BaseUnitInfo(self) -> UnitInfo:
        """ The base unit of this quantity.
        """
        pass

    @property
    def BaseUnit(self) -> Enum:
        """ The base unit for the quantity, such as "Field Meter".
        """
        pass

    @property
    def Zero(self) -> IQuantity:
        """ Zero value of quantity, such as "Property Zero".
        """
        pass

    @property
    def UnitType(self) -> Type:
        """ Unit enum type, such as "LengthUnit" or "MassUnit".
        """
        pass

    @property
    def ValueType(self) -> Type:
        """ Quantity value type, such as "Length" or "Mass".
        """
        pass

    @property
    def BaseDimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" for a quantity.
        """
        pass

    def __init__(self, quantityType: QuantityType, unitInfos: Array[UnitInfo], baseUnit: Enum, zero: IQuantity, baseDimensions: BaseDimensions) -> None:
        """ Constructs an instance.

        :param quantityType: The quantity enum value.
        :type quantityType: QuantityType
        :param unitInfos: The information about the units for this quantity.
        :type unitInfos: Array[UnitInfo]
        :param baseUnit: The base unit enum value.
        :type baseUnit: Enum
        :param zero: The zero quantity.
        :type zero: IQuantity
        :param baseDimensions: The base dimensions of the quantity.
        :type baseDimensions: BaseDimensions

        :exception ArgumentException: Quantity type can not be undefined.
        :exception ArgumentNullException: If units -or- baseUnit -or- zero -or- baseDimensions is null.
        """
        pass

    def __init__(self, name: str, unitType: Type, unitInfos: Array[UnitInfo], baseUnit: Enum, zero: IQuantity, baseDimensions: BaseDimensions, quantityType: QuantityType) -> None:
        """ Constructs an instance.

        :param name: Name of the quantity.
        :type name: str
        :param unitType: The unit enum type, such as "LengthUnit".
        :type unitType: Type
        :param unitInfos: The information about the units for this quantity.
        :type unitInfos: Array[UnitInfo]
        :param baseUnit: The base unit enum value.
        :type baseUnit: Enum
        :param zero: The zero quantity.
        :type zero: IQuantity
        :param baseDimensions: The base dimensions of the quantity.
        :type baseDimensions: BaseDimensions
        :param quantityType: The the quantity type. Defaults to Undefined.
        :type quantityType: QuantityType

        :exception ArgumentException: Quantity type can not be undefined.
        :exception ArgumentNullException: If units -or- baseUnit -or- zero -or- baseDimensions is null.
        """
        pass

    def GetUnitInfoFor(self, baseUnits: BaseUnits) -> UnitInfo:
        """Gets the "UnitInfo" whose "BaseUnits" is a subset of .

        :param baseUnits: The "BaseUnits" to check against.
        :type baseUnits: BaseUnits
        :return: The "UnitInfo" that has "BaseUnits" that is a subset of .
        :rtype: UnitInfo

        :exception ArgumentNullException: is null.
        :exception InvalidOperationException: No unit was found that is a subset of .
        :exception InvalidOperationException: More than one unit was found that is a subset of .
        """
        pass

    def GetUnitInfosFor(self, baseUnits: BaseUnits) -> IEnumerable[UnitInfo]:
        """Gets an "IEnumerable[T]" of "UnitInfo" that have "BaseUnits" that is a subset of .

        :param baseUnits: The "BaseUnits" to check against.
        :type baseUnits: BaseUnits
        :return: An "IEnumerable[T]" of "UnitInfo" that have "BaseUnits" that is a subset of .
        :rtype: IEnumerable[UnitInfo]

        :exception ArgumentNullException: is null.
        """
        pass


# noinspection PyPep8Naming
class QuantityInfo(QuantityInfo, typing.Generic[TUnit]):
    """ This is a specialization of "QuantityInfo", for when the unit type is known.
     Typically you obtain this by looking it up statically from "Property Info" or
     "Property QuantityInfo", or dynamically via "Property QuantityInfo".

    TUnit: The unit enum type, such as "LengthUnit".
    """

    @property
    def UnitInfos(self) -> Array[UnitInfo[TUnit]]:
        """
        """
        pass

    @property
    def Units(self) -> Array[TUnit]:
        """
        """
        pass

    @property
    def BaseUnitInfo(self) -> UnitInfo[TUnit]:
        """
        """
        pass

    @property
    def BaseUnit(self) -> TUnit:
        """
        """
        pass

    @property
    def Zero(self) -> IQuantity[TUnit]:
        """
        """
        pass

    @property
    def UnitType(self) -> TUnit:
        """
        """
        pass

    def __init__(self, quantityType: QuantityType, unitInfos: Array[UnitInfo[TUnit]], baseUnit: TUnit, zero: IQuantity[TUnit], baseDimensions: BaseDimensions) -> None:
        """
        """
        pass

    def __init__(self, name: str, unitInfos: Array[UnitInfo[TUnit]], baseUnit: TUnit, zero: IQuantity[TUnit], baseDimensions: BaseDimensions, quantityType: QuantityType) -> None:
        """
        """
        pass

    def GetUnitInfoFor(self, baseUnits: BaseUnits) -> UnitInfo[TUnit]:
        """
        """
        pass

    def GetUnitInfosFor(self, baseUnits: BaseUnits) -> IEnumerable[UnitInfo[TUnit]]:
        """
        """
        pass


# noinspection PyPep8Naming
class QuantityNotFoundException(OasysUnitsException, ISerializable):
    """ Quantity type was not found. This is typically thrown for dynamic conversions,
     such as "Function String)".
    """

    def __init__(self) -> None:
        """
        """
        pass

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitAttributeBase(Attribute, metaclass=ABCMeta):
    """Is the base class for all attributes that are related to "QuantityTypeConverter[TQuantity]"
    """

    @property
    def UnitType(self) -> Enum:
        """The unit enum type, such as "LengthUnit"
        """
        pass

    @UnitType.setter
    def UnitType(self, value: Enum) -> None: ...

    def __init__(self, unitType: typing.Any) -> None:
        """Initializes a new instance of the "UnitAttributeBase" class.

        :param unitType:
        :type unitType: typing.Any
        """
        pass


# noinspection PyPep8Naming
class DefaultUnitAttribute(UnitAttributeBase):
    """This attribute defines the default Unit to use if the string to convert only consists of digits
    """

    def __init__(self, unitType: typing.Any) -> None:
        """Initializes a new instance of the "DefaultUnitAttribute" class.

        :param unitType: The unit the quantity gets when the string parsing dose only consist of digits
        :type unitType: typing.Any
        """
        pass


# noinspection PyPep8Naming
class ConvertToUnitAttribute(DefaultUnitAttribute):
    """This attribute defines the Unit the quantity is converted to after it has been parsed.
    """

    def __init__(self, unitType: typing.Any) -> None:
        """Initializes a new instance of the "ConvertToUnitAttribute" class.

        :param unitType: The unit the quantity is converted to when parsing from string
        :type unitType: typing.Any
        """
        pass


# noinspection PyPep8Naming
class DisplayAsUnitAttribute(DefaultUnitAttribute):
    """This attribute defines the unit the quantity has when converting to string
    """

    @property
    def Format(self) -> str:
        """The formating used when the quantity is converted to string. See "Function IFormatProvider)"
        """
        pass

    @Format.setter
    def Format(self, value: str) -> None: ...

    def __init__(self, unitType: typing.Any, format: str) -> None:
        """Initializes a new instance of the "DisplayAsUnitAttribute" class.

        :param unitType: The unit the quantity should be displayed in
        :type unitType: typing.Any
        :param format: Formating string "Function IFormatProvider)"
        :type format: str
        """
        pass


# noinspection PyPep8Naming
class QuantityTypeConverter(TypeConverter, typing.Generic[TQuantity]):
    """ Converts between IQuantity and string. Implements a TypeConverter for IQuantitys. This allows eg the PropertyGrid to read and write properties of type IQuantity.

    For basic understanding of TypeConverters consult the .NET documentation.
     When a string is converted a Quantity the unit given by the string is used. When no unit is given by the string the base unit is used. The base unit can be overwritten by use of the "DefaultUnitAttribute". The converted Quantity can be forced to be in a certain unit by use of the "ConvertToUnitAttribute".

     The displayed unit can be forced to a certain unit by use of the "DisplayAsUnitAttribute". The "DisplayAsUnitAttribute" provides the possibility to format the displayed Quantity.

    TQuantity: Quantity value type, such as "Length" or "Mass".
    """

    def __init__(self) -> None: ...

    def CanConvertFrom(self, context: ITypeDescriptorContext, sourceType: Type) -> bool:
        """ Returns true if sourceType if of type "str"

        :param context: An "ITypeDescriptorContext" that provides a format context.
        :type context: ITypeDescriptorContext
        :param sourceType: A "Type" that represents the type you want to convert from.
        :type sourceType: Type
        :return: true if this converter can perform the conversion; otherwise, false.
        :rtype: bool
        """
        pass

    def ConvertFrom(self, context: ITypeDescriptorContext, culture: CultureInfo, value: typing.Any) -> typing.Any:
        """ Converts the given object, when it is of type "str" to the type of this converter, using the specified context and culture information.

        :param context: An System.ComponentModel.ITypeDescriptorContext that provides a format context.
        :type context: ITypeDescriptorContext
        :param culture: The System.Globalization.CultureInfo to use as the current culture.
        :type culture: CultureInfo
        :param value: The System.Object to convert.
        :type value: typing.Any
        :return: An "IQuantity" object.
        :rtype: typing.Any

        :exception NotSupportedException: The conversion cannot be performed.
        :exception ArgumentException: Unit value is not a know unit enum type.
        """
        pass

    def CanConvertTo(self, context: ITypeDescriptorContext, destinationType: Type) -> bool:
        """Returns true whether this converter can convert the "IQuantity" to string, using the specified context.

        :param context: An "ITypeDescriptorContext" that provides a format context.
        :type context: ITypeDescriptorContext
        :param destinationType: A "Type" that represents the type you want to convert to.
        :type destinationType: Type
        :return: true if this converter can perform the conversion; otherwise, false.
        :rtype: bool
        """
        pass

    def ConvertTo(self, context: ITypeDescriptorContext, culture: CultureInfo, value: typing.Any, destinationType: Type) -> typing.Any:
        """Converts the given "IQuantity" object to "str", using the specified context and culture information.

        :param context: An "ITypeDescriptorContext" that provides a format context.
        :type context: ITypeDescriptorContext
        :param culture: A "CultureInfo". If null is passed, the current culture is assumed.
        :type culture: CultureInfo
        :param value: The "typing.Any" to convert.
        :type value: typing.Any
        :param destinationType: The "Type" to convert the parameter to.
        :type destinationType: Type
        :return: An "typing.Any" that represents the converted value.
        :rtype: typing.Any

        :exception ArgumentNullException: The parameter is null.
        :exception NotSupportedException: The conversion cannot be performed.
        """
        pass


# noinspection PyPep8Naming
class QuantityValue(ValueType):
    """ A type that supports implicit cast from all .NET numeric types, in order to avoid a large number of overloads
     and binary size for all From(value, unit) factory methods, for each of the 700+ units in the library.
     "QuantityValue" stores the value internally with the proper type to preserve the range or precision of the original value:
     "float" for [byte, short, int, long, float, double] "Decimal" for [decimal] to preserve the 128-bit precision
     At the time of this writing, this reduces the number of From(value, unit) overloads to 1/4th:
     From 8 (int, long, double, decimal + each nullable) down to 2 (QuantityValue and QuantityValue?).
     This also adds more numeric types with no extra overhead, such as float, short and byte.
    """

    def ToString(self) -> str:
        """Returns the string representation of the numeric value.
        """
        pass


# noinspection PyPep8Naming
class ConversionFunction(MulticastDelegate, ICloneable, ISerializable):

    def __init__(self, object: typing.Any, method: IntPtr) -> None: ...

    def Invoke(self, inputValue: IQuantity) -> IQuantity: ...

    def BeginInvoke(self, inputValue: IQuantity, callback: AsyncCallback, object: typing.Any) -> IAsyncResult: ...

    def EndInvoke(self, result: IAsyncResult) -> IQuantity: ...


# noinspection PyPep8Naming
class ConversionFunction(MulticastDelegate, ICloneable, ISerializable, typing.Generic[TQuantity]):
    """

    TQuantity:
    """

    def __init__(self, object: typing.Any, method: IntPtr) -> None: ...

    def Invoke(self, inputValue: TQuantity) -> TQuantity: ...

    def BeginInvoke(self, inputValue: TQuantity, callback: AsyncCallback, object: typing.Any) -> IAsyncResult: ...

    def EndInvoke(self, result: IAsyncResult) -> TQuantity: ...


# noinspection PyPep8Naming
class UnitConverter:
    """ Convert between units of a quantity, such as converting from meters to centimeters of a given length.
    """

    Default: typing.ClassVar[UnitConverter]

    def __init__(self) -> None:
        """Creates a new "UnitConverter" instance.
        """
        pass

    def __init__(self, other: UnitConverter) -> None:
        """Creates a new "UnitConverter" instance with the "ConversionFunction" copied from .

        :param other: The "UnitConverter" to copy from.
        :type other: UnitConverter
        """
        pass

    @staticmethod
    def RegisterDefaultConversions(unitConverter: UnitConverter) -> None:
        """Registers the default conversion functions in the given "UnitConverter" instance.

        :param unitConverter: The "UnitConverter" to register the default conversion functions in.
        :type unitConverter: UnitConverter
        """
        pass

    @typing.overload
    def SetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction[TQuantity]) -> None:
        """Sets the conversion function from two units of the same quantity type.

        TQuantity: The type of quantity, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction[TQuantity]
        """
        pass

    @typing.overload
    def SetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction) -> None:
        """Sets the conversion function from two units of different quantity types.

        TQuantityFrom: From quantity type, must implement "IQuantity".
        TQuantityTo: To quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        """
        pass

    @typing.overload
    def SetConversionFunction(self, fromType: Type, from: Enum, toType: Type, to: Enum, conversionFunction: ConversionFunction) -> None:
        """Sets the conversion function from two units of different quantity types.

        :param fromType: From quantity type, must implement "IQuantity".
        :type fromType: Type
        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param toType: To quantity type, must implement "IQuantity".
        :type toType: Type
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        """
        pass

    @typing.overload
    def GetConversionFunction(self, from: Enum, to: Enum) -> ConversionFunction:
        """Gets the conversion function from two units of the same quantity type.

        TQuantity: The quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :return:
        :rtype: ConversionFunction
        """
        pass

    @typing.overload
    def GetConversionFunction(self, from: Enum, to: Enum) -> ConversionFunction:
        """Gets the conversion function from two units of different quantity types.

        TQuantityFrom: From quantity type, must implement "IQuantity".
        TQuantityTo: To quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :return:
        :rtype: ConversionFunction
        """
        pass

    @typing.overload
    def GetConversionFunction(self, fromType: Type, from: Enum, toType: Type, to: Enum) -> ConversionFunction:
        """Gets the conversion function from two units of different quantity types.

        :param fromType: From quantity type, must implement "IQuantity".
        :type fromType: Type
        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param toType: To quantity type, must implement "IQuantity".
        :type toType: Type
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """Gets the conversion function for two units of the same quantity type.

        TQuantity: The quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """Gets the conversion function for two units of different quantity types.

        TQuantityFrom: From quantity type, must implement "IQuantity".
        TQuantityTo: To quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, fromType: Type, from: Enum, toType: Type, to: Enum, conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """Try to get the conversion function for two units of the same quantity type.

        :param fromType: From quantity type, must implement "IQuantity".
        :type fromType: Type
        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param toType: To quantity type, must implement "IQuantity".
        :type toType: Type
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, lookupKey: ValueTuple[Type, Enum, Type, Enum], conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """

        :param lookupKey:
        :type lookupKey: ValueTuple[Type, Enum, Type, Enum]
        :param conversionFunction:
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @staticmethod
    def Convert(fromValue: QuantityValue, fromUnitValue: Enum, toUnitValue: Enum) -> float:
        """ Convert between any two quantity units given a numeric value and two unit enum values.

        :param fromValue: Numeric value.
        :type fromValue: QuantityValue
        :param fromUnitValue: From unit enum value.
        :type fromUnitValue: Enum
        :param toUnitValue: To unit enum value, must be compatible with .
        :type toUnitValue: Enum
        :return: The converted value in the new unit representation.
        :rtype: float
        """
        pass

    @staticmethod
    def TryConvert(fromValue: QuantityValue, fromUnitValue: Enum, toUnitValue: Enum, convertedValue: float) -> typing.Tuple[float, bool]:
        """ Try to convert between any two quantity units given a numeric value and two unit enum values.

        :param fromValue: Numeric value.
        :type fromValue: QuantityValue
        :param fromUnitValue: From unit enum value.
        :type fromUnitValue: Enum
        :param toUnitValue: To unit enum value, must be compatible with .
        :type toUnitValue: Enum
        :param convertedValue: The converted value, if successful. Otherwise default.
        :type convertedValue: float
        :return: True if successful.
        :rtype: bool
        """
        pass

    @staticmethod
    def ConvertByName(fromValue: QuantityValue, quantityName: str, fromUnit: str, toUnit: str) -> float:
        """ Convert between any two quantity units by their names, such as converting a "Length" of N "Meter" to "Centimeter".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: The name of the quantity, such as "Length" or "Mass". See "Property Infos" for all
        types generated by OasysUnits and use "Property Name".
        :type quantityName: str
        :param fromUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnit: str
        :param toUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnit: str
        :return: Output value as the result of converting to .
        :rtype: float

        :exception UnitNotFoundException: No units match the abbreviation.
        :exception AmbiguousUnitParseException: More than one unit matches the abbreviation.
        """
        pass

    @staticmethod
    def TryConvertByName(inputValue: QuantityValue, quantityName: str, fromUnit: str, toUnit: str, result: float) -> typing.Tuple[float, bool]:
        """ Convert between any two quantity units by their names, such as converting a "Length" of N "Meter" to "Centimeter".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param inputValue: Input value, which together with represents the quantity to
        convert from.
        :type inputValue: QuantityValue
        :param quantityName: The name of the quantity, such as "Length" or "Mass". See "Property Infos" for all
        types generated by OasysUnits and use "Property Name".
        :type quantityName: str
        :param fromUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnit: str
        :param toUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnit: str
        :param result: Result if conversion was successful, 0 if not.
        :type result: float
        :return: True if conversion was successful.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str) -> float:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityInfo" for all
        values.
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :return: Output value as the result of converting to .
        :rtype: float
        """
        pass

    @staticmethod
    @typing.overload
    def ConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str, culture: str) -> float:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: The name of the quantity, such as "Length" or "Mass". See "Property Infos" for all
        types generated by OasysUnits and use "Property Name".
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :param culture: Culture to parse abbreviations with.
        :type culture: str
        :return: Output value as the result of converting to .
        :rtype: float

        :exception UnitNotFoundException: No unit types match the prefix of or no units
        are mapped to the abbreviation.
        :exception AmbiguousUnitParseException: More than one unit matches the abbreviation.
        """
        pass

    @staticmethod
    @typing.overload
    def TryConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str, result: float) -> typing.Tuple[float, bool]:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: The name of the quantity, such as "Length" or "Mass". See "Property Infos" for all
        types generated by OasysUnits and use "Property Name".
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :param result: Result if conversion was successful, 0 if not.
        :type result: float
        :return: True if conversion was successful.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def TryConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str, result: float, culture: str) -> typing.Tuple[float, bool]:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: The name of the quantity, such as "Length" or "Mass". See "Property Infos" for all
        types generated by OasysUnits and use "Property Name".
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :param culture: Culture to parse abbreviations with.
        :type culture: str
        :param result: Result if conversion was successful, 0 if not.
        :type result: float
        :return: True if conversion was successful.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class UnitInfo:
    """ Information about the unit, such as its name and value.
     This is useful to enumerate units and present names with quantities and units
     chosen dynamically at runtime, such as unit conversion apps or allowing the user to change the
     unit representation.
     Typically you obtain this by looking it up via "Property UnitInfos".
    """

    @property
    def Value(self) -> Enum:
        """The enum value of the unit, such as "Field Centimeter".
        """
        pass

    @property
    def Name(self) -> str:
        """The singular name of the unit, such as "Centimeter".
        """
        pass

    @property
    def PluralName(self) -> str:
        """The plural name of the unit, such as "Centimeters".
        """
        pass

    @property
    def BaseUnits(self) -> BaseUnits:
        """Gets the "Property BaseUnits" for this unit.
        """
        pass

    def __init__(self, value: Enum, pluralName: str, baseUnits: BaseUnits) -> None:
        """Creates an instance of the UnitInfo class.

        :param value: The enum value for this class, for example "Field Meter".
        :type value: Enum
        :param pluralName: The plural name of the unit, such as "Centimeters".
        :type pluralName: str
        :param baseUnits: The "Property BaseUnits" for this unit.
        :type baseUnits: BaseUnits
        """
        pass


# noinspection PyPep8Naming
class UnitInfo(UnitInfo, typing.Generic[TUnit]):
    """ This is a specialization of "UnitInfo", for when the unit type is known.
     Typically you obtain this by looking it up statically from "Property UnitInfos" or
     or dynamically via "Property QuantityInfo".

    TUnit: The unit enum type, such as "LengthUnit".
    """

    @property
    def Value(self) -> TUnit:
        """
        """
        pass

    def __init__(self, value: TUnit, pluralName: str, baseUnits: BaseUnits) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitMath(metaclass=ABCMeta):
    """ A set of extension methods for some of the most common Math operations, such as Min, Max, Sum and Average
    """

    @staticmethod
    def Abs(value: TQuantity) -> TQuantity:
        """Returns the absolute value of a .

        :param value: A quantity with a value that is greater than or equal to "Field MinValue",
        but less than or equal to "Field MaxValue".
        :type value: TQuantity
        :return: A quantity with a value, such that 0 ≤ value ≤ "Field MaxValue".
        :rtype: TQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def Sum(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the sum of a sequence of values.

        :param source: A sequence of values to calculate the sum of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The sum of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Sum(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the sum of the sequence of values that are obtained by invoking a
         transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate a sum.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The sum of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Min(val1: TQuantity, val2: TQuantity) -> TQuantity:
        """Returns the smaller of two values.

        TQuantity: The type of quantities to compare.

        :param val1: The first of two values to compare.
        :type val1: TQuantity
        :param val2: The second of two values to compare.
        :type val2: TQuantity
        :return: Parameter or , whichever is smaller.
        :rtype: TQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def Min(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the min of a sequence of values.

        :param source: A sequence of values to calculate the min of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The min of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Min(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the min of the sequence of values that are obtained by invoking a
         transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate a min.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The min of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Max(val1: TQuantity, val2: TQuantity) -> TQuantity:
        """Returns the larger of two values.

        TQuantity: The type of quantities to compare.

        :param val1: The first of two values to compare.
        :type val1: TQuantity
        :param val2: The second of two values to compare.
        :type val2: TQuantity
        :return: Parameter or , whichever is larger.
        :rtype: TQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def Max(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the max of a sequence of values.

        :param source: A sequence of values to calculate the max of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The max of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Max(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the max of the sequence of values that are obtained by invoking a
         transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate a max.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The max of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Average(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the average of a sequence of values.

        :param source: A sequence of values to calculate the average of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The average of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Average(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the average of the sequence of values that are obtained by invoking
         a transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate an average.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The average of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass


# noinspection PyPep8Naming
class UnitNotFoundException(OasysUnitsException, ISerializable):
    """ Unit was not found. This is typically thrown for dynamic conversions,
     such as "Function String)".
    """

    def __init__(self) -> None:
        """
        """
        pass

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class OasysUnitsException(Exception, ISerializable):
    """ The base type for OasysUnits exceptions.
    """

    def __init__(self) -> None:
        """
        """
        pass

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitSystem(IEquatable[UnitSystem]):
    """ A unit system defined by a combination of base units.
     This is typically used to define the "working units" for consistently creating and presenting quantities in the selected base units,
     such as "Property SI" to use SI base units such as meters, kilograms and seconds.
    """

    @property
    def BaseUnits(self) -> BaseUnits:
        """ The base units of this unit system.
        """
        pass

    SI: typing.ClassVar[UnitSystem]

    def __init__(self, baseUnits: BaseUnits) -> None:
        """Creates an instance of a unit system with the specified base units.

        :param baseUnits: The base units for the unit system.
        :type baseUnits: BaseUnits
        """
        pass

    @typing.overload
    def Equals(self, other: typing.Any) -> bool:
        """
        """
        pass

    @typing.overload
    def Equals(self, other: UnitSystem) -> bool:
        """
        """
        pass

    def GetHashCode(self) -> int:
        """
        """
        pass
